rem From image %1 that contains a 24-colour card,
rem make image files %2, must contain XX.
rem %3 if 1, debug mode.
rem %4 "tryRot" or "notTryRot" [default "notTryRot"]
rem 
@rem
@rem Updated:
@rem   22-August-2022 Upgraded for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 24c

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set DEBUG=%3
if "%DEBUG%"=="." set DEBUG=
if "%DEBUG%"=="" set DEBUG=0

set sTryRot=%~4
if "%sTryRot%"=="." set sTryRot=
if "%sTryRot%"=="" set sTryRot=notTryRot

if /I %sTryRot%==tryRot (
  set TRY_ROT=1
) else if /I %sTryRot%==notTryRot (
  set TRY_ROT=0
) else (
  echo Bad parameter: [%sTryRot%] should be tryRot or notTryRot
  exit /B 1
)


set OUTEXT=%OUTFILE:*.=%
echo OUTEXT=%OUTEXT%

set OUT_MAT=%OUTFILE:XX=mat%
set OUT_SCL=%OUTFILE:XX=scl%
set OUT_DBG=%OUTFILE:XX=dbg%

if "%OUT_MAT%"=="%OUTFILE%" (
  echo Outfile needs XX
  exit /B 1
)

set TMPDIR=\temp\

set FIND0=%TMPDIR%24c_f0.png
set FIND1=%TMPDIR%24c_f1.png
set FIND2=%TMPDIR%24c_f2.png
set FIND3=%TMPDIR%24c_f3.png

set /A COLS=15
set COLSIZ=-size %COLS%x%COLS%

set SEMI_SP=1
set /A SPL_DIM=2*%SEMI_SP%+1

set SPLIC=-background Black -gravity Center -splice %SPL_DIM%x%SPL_DIM% -gravity None

:: To be really cute,
:: we could adjust the following colours according
:: to the recorded white balance.

:: Four subimages to search for, clockwise, starting at top-left.

%IMG7%magick ^
  %COLSIZ% ^
  ( xc:srgb(45%%,30%%,25%%) ^
    xc:srgb(75%%,60%%,50%%) ^
    +append +repage ^
  ) ^
  ( xc:srgb(90%%,50%%,20%%) ^
    xc:srgb(30%%,35%%,65%%) ^
    +append +repage ^
  ) ^
  -append +repage ^
  %SPLIC% ^
  %FIND0%

%IMG7%magick ^
  %COLSIZ% ^
  ( xc:srgb(50%%,50%%,70%%) ^
    xc:srgb(40%%,75%%,65%%) ^
    +append +repage ^
  ) ^
  ( xc:srgb(65%%,75%%,25%%) ^
    xc:srgb(90%%,65%%,15%%) ^
    +append +repage ^
  ) ^
  -append +repage ^
  %SPLIC% ^
  %FIND1%

%IMG7%magick ^
  %COLSIZ% ^
  ( xc:srgb(75%%,35%%,60%%) ^
    xc:srgb(0%%,55%%,65%%) ^
    +append +repage ^
  ) ^
  ( xc:srgb(35%%,35%%,35%%) ^
    xc:srgb(20%%,20%%,20%%) ^
    +append +repage ^
  ) ^
  -append +repage ^
  %SPLIC% ^
  %FIND2%

%IMG7%magick ^
  %COLSIZ% ^
  ( xc:srgb(15%%,25%%,60%%) ^
    xc:srgb(30%%,60%%,30%%) ^
    +append +repage ^
  ) ^
  ( xc:srgb(95%%,95%%,95%%) ^
    xc:srgb(80%%,80%%,80%%) ^
    +append +repage ^
  ) ^
  -append +repage ^
  %SPLIC% ^
  %FIND3%


set EXSTAT=

call %PICTBAT%24cardOneSize %1 %OUTFILE% %DEBUG% 500
if ERRORLEVEL 1 (
  set EXSTAT=1
) else if !OKAY24c!==1 (
  set EXSTAT=0
)

if "%EXSTAT%"=="" (
  call %PICTBAT%24cardOneSize %1 %OUTFILE% %DEBUG% 1000
  if ERRORLEVEL 1 (
    set EXSTAT=1
  ) else if !OKAY24c!==1 (
    set EXSTAT=0
  )
)

if "%EXSTAT%"=="" (
  call %PICTBAT%24cardOneSize %1 %OUTFILE% %DEBUG% 2000
  if ERRORLEVEL 1 (
    set EXSTAT=1
  ) else if !OKAY24c!==1 (
    set EXSTAT=0
  )
)

if "%EXSTAT%"=="" (
  call %PICTBAT%24cardOneSize %1 %OUTFILE% %DEBUG% 0
  if ERRORLEVEL 1 (
    set EXSTAT=1
  ) else if !OKAY24c!==1 (
    set EXSTAT=0
  )
)

if "%EXSTAT%"=="" set EXSTAT=1

if %EXSTAT%==1 (
  echo %0: no solution found
)

call echoRestore

endlocal & set OUTFILE24c=%OUTFILE%& set EXSTAT=%EXSTAT%& set sTRANS24c=%sTRANS24c%& set EIGHTNUM24c=%EIGHTNUM24c%

exit /B %EXSTAT%
