@rem From image %1, where bottom line should be gray.
@rem finds 6x6 colour matrix that most closely makes it gray,
@rem and the RMSE score.
@rem %2 optional method
@rem
@rem Updated:
@rem   22-August-2022 Upgraded for IM v7.
@rem

@set m=%~2
@if "%m%"=="" set m=NoCross

@%IM7DEV%magick ^
  %1 ^
  -gravity South ^
  -crop x1+0+0 +repage ^
  ( +clone ^
    -colorspace Gray ^
  ) ^
  ( -clone 0-1 ^
    -process 'cols2mat method %m% f stdout' ^
  ) ^
  -delete 0 ^
  -metric RMSE ^
  -format "%%[distortion]\n" ^
  -compare ^
  info:

