rem From image %1,
rem writes output %2
rem with mean to %3 (a number 0.0 to 1.0, or "pin")
rem and SD to %4 (a number 0.0 to 1.0, or "pin")
rem by gain-and-bias method. All channels shifted by same amount.
@rem
@rem Updated:
@rem   7-August-2022 for IM v7
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 msg

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set GOAL_MN=%3
if "%GOAL_MN%"=="." set GOAL_MN=
if "%GOAL_MN%"=="" set GOAL_MN=0.5

set GOAL_SD=%4
if "%GOAL_SD%"=="." set GOAL_SD=
if "%GOAL_SD%"=="" set GOAL_SD=0.16667


for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 19 ^
  -format "CUR_MN=%%[fx:mean]\nCUR_SD=%%[fx:standard_deviation]" ^
  %INFILE%`) do set %%L

if /I "%GOAL_SD%" EQU "pin" (
  set GAIN=1
) else (
  for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -precision 19 ^
    -format "GAIN=%%[fx:%GOAL_SD%/%CUR_SD%]" ^
    xc:`) do set %%L
)

if /I "%GOAL_MN%" EQU "pin" set GOAL_MN=%CUR_MN%

  for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -precision 19 ^
    -format "BIAS=%%[fx:%GOAL_MN%-%CUR_MN%*%GAIN%]" ^
    xc:`) do set %%L

%IMG7%magick ^
  %INFILE% ^
  -function Polynomial %GAIN%,%BIAS% ^
  %OUTFILE%

call echoRestore

@endlocal & set msgOUTFILE=%OUTFILE%
