rem %1 input image (linear, grayscale).
rem %2 output image
rem %3 Lwhite as factor of QuantumRange eg 1 or 23, or "infinity" or "max"
@rem
@rem Reference: http://im.snibgo.com/tonemap.htm
@rem

setlocal enabledelayedexpansion

set INFILE=%1
set OUTFILE=%2

set Lwhite=%3
if "%Lwhite%"=="." set Lwhite=
if "%Lwhite%"=="" set Lwhite=max

if /I %Lwhite%==infinity (
  set "sFx=u/(1+u)"
) else if /I %Lwhite%==max (
  set "sFx=u*(1+u/%%[fx:maxima*maxima])/(1+u)"
) else (
  set "sFx=u*(1+u/%%[fx:%Lwhite%*%Lwhite%])/(1+u)"
)

echo %0: sFx=%sFx%

%IMG7%magick ^
  %INFILE% ^
  -fx "%sFx%" ^
  %OUTFILE%

if ERRORLEVEL 1 exit /B 1

endlocal