rem Given large image %1 and very small image %2,
rem searches for small in large, via a resize of the large image, integer factor %3 (eg 2, 20).
rem Writes to environment prefix %4:
rem   .x .y .score .bad
rem %5 is threshold RMSE for badness. Default 0.1
@rem
@rem Updated:
@rem   25-August-2022 for IM v7.
@rem


@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 ssf

set ENV_PREF=%4
if "%ENV_PREF%"=="." set ENV_PREF=
if "%ENV_PREF%"=="" set ENV_PREF=ssfENV

set SML_FILE=%2

set FACT=%3
if "%FACT%"=="." set FACT=
if "%FACT%"=="" set FACT=10

set THRESH_BAD=%5
if "%THRESH_BAD%"=="." set THRESH_BAD=
if "%THRESH_BAD%"=="" set THRESH_BAD=0.1

set TMP_LRG=%BASENAME%_ssf.miff
set TMP_LRG2=%BASENAME%_ssf2.miff

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "FACT_PC=%%[fx:100/%FACT%]" ^
  xc:`) do set %%L

%IMG7%magick ^
  %INFILE% ^
  +repage ^
  -resize %FACT_PC%%% ^
  %TMP_LRG%


goto skip
%IMG7%magick compare ^
  -metric RMSE ^
  %TMP_LRG% ^
  %SML_FILE% ^
  -similarity-threshold 0 ^
  -dissimilarity-threshold 1 ^
  -subimage-search ^
  NULL:
:skip

for /F "usebackq tokens=1-4 delims=()@, " %%A in (`%IMG7%magick compare ^
  -metric RMSE ^
  %TMP_LRG% ^
  %SML_FILE% ^
  -similarity-threshold 0 ^
  -dissimilarity-threshold 1 ^
  -subimage-search ^
  NULL: 2^>^&1`) do (
  set score=%%B
  set fndX=%%C
  set fndY=%%D
)
echo %0: fndX=%fndX% fndY=%fndY% score=%score%

set CALC_SUB=^
crpX=%%[fx:int((%fndX%-2)*%FACT%+0.5)]\n^
crpY=%%[fx:int((%fndY%-2)*%FACT%+0.5)]\n^
crpH=%%[fx:int(5*%FACT%+w+1+0.5)]\n^
crpW=%%[fx:int(5*%FACT%+h+1+0.5)]

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "%CALC_SUB%" ^
  %SML_FILE%`) do set %%L

set BAD=
if %crpX% LSS 0 set BAD=1
if %crpY% LSS 0 set BAD=1

echo %0: CROP=-crop %crpW%x%crpH%+%crpX%+%crpY% +repage

%IMG7%magick ^
  %INFILE% ^
  +repage ^
  -crop %crpW%x%crpH%+%crpX%+%crpY% +repage ^
  %TMP_LRG2%

for /F "usebackq tokens=1-4 delims=()@, " %%A in (`%IMG7%magick compare ^
  -metric RMSE ^
  %TMP_LRG2% ^
  %SML_FILE% ^
  -similarity-threshold 0 ^
  -dissimilarity-threshold 1 ^
  -subimage-search ^
  NULL: 2^>^&1`) do (
  set fndScore=%%B
  set /A fndX=%%C+%crpX%
  set /A fndY=%%D+%crpY%
)
echo %0: fndX=%fndX% fndY=%fndY% fndScore=%fndScore%

if not "%BAD%"=="1" for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "BAD=%%[fx:%fndScore%>%THRESH_BAD%?1:0]" ^
  xc:`) do (
  set %%L
  if "!BAD!"=="0" set BAD=
)



call echoRestore

endlocal & set %ENV_PREF%.x=%fndX%& set %ENV_PREF%.y=%fndY%& set %ENV_PREF%.score=fndScore& set %ENV_PREF%.BAD=%BAD%
