rem From %1 image of white lines on black background, fully opaque,
rem writes output %2
rem by joining line-ends with other lines that are within proximity threshold %3.
rem
rem Also uses:
rem   skelLineEnds if 1, skeletonises the output.
@rem
@rem Updated:
@rem   6-August-2022 for IM v7
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 tjle

set TMP_IN=%BASENAME%_tjle_in.miff
set LINE_SCR=%BASENAME%_tjle.scr

del %LINE_SCR% 2>nul

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set PROX_THRESH=%3
if "%PROX_THRESH%"=="." set PROX_THRESH=
if "%PROX_THRESH%"=="" set PROX_THRESH=10

%IMG7%magick %INFILE% %TMP_IN%

call %PICTBAT%skelPS ^
  %TMP_IN% %BASENAME%_%sioCODE%.png
if ERRORLEVEL 1 exit /B 1

set II=0
set /A CRP_WH=2*%PROX_THRESH%+1
for /F "tokens=1,2 delims=, " %%X in (%spsCSVFILE%) do (
  rem echo %0: %%X,%%Y

  set LE_X=%%X
  set LE_Y=%%Y

  set /A CRP_L=!LE_X!-%PROX_THRESH%
  set /A CRP_T=!LE_Y!-%PROX_THRESH%

  set nwCX=%PROX_THRESH%
  set nwCY=%PROX_THRESH%
  set CRP_W=%CRP_WH%
  set CRP_H=%CRP_WH%

  if !CRP_L! LSS 0 (
    set /A nwCX+=!CRP_L!
    set /A CRP_W+=!CRP_L!
    set CRP_L=0
  )

  if !CRP_T! LSS 0 (
    set /A nwCY+=!CRP_T!
    set /A CRP_H+=!CRP_T!
    set CRP_T=0
  )

  for /F "usebackq tokens=1-3 delims=, " %%A in (`%IM7DEV%magick ^
    %TMP_IN% ^
    -fill Black +opaque White ^
    -crop !CRP_W!x!CRP_H!+!CRP_L!+!CRP_T! +repage ^
    -draw "color !nwCX!,!nwCY! floodfill" ^
    -process 'nearestwhite cx !nwCX! cy !nwCY!' ^
    NULL: 2^>^&1`) do (
    if "%%A"=="nearestwhite:" (
      set ncCST_X=%%B
      if not "%%B"=="none" (
        set ncCST_Y=%%C
        set /A ML_X=!CRP_L!+%%B
        set /A ML_Y=!CRP_T!+%%C
      )
    )
  )

  rem echo %0: ncCST_X=!ncCST_X! ncCST_Y=!ncCST_Y!

  if not "!ncCST_X!"=="none" (

    rem FIXME: check hypot

    echo line !LE_X!,!LE_Y! !ML_X!,!ML_Y!

    echo line !LE_X!,!LE_Y! !ML_X!,!ML_Y! >>!LINE_SCR!
  )

  set /A II+=1
)
if ERRORLEVEL 1 exit /B 1


if "%skelLineEnds%"=="1" (
  set sSKEL=-morphology Thinning:-1 skeleton -clamp
) else (
  set sSKEL=
)

if exist %LINE_SCR% (
  rem type %LINE_SCR%

  %IMG7%magick ^
    %INFILE% ^
    +antialias ^
    -stroke White ^
    -strokewidth %spsLINE_THK_INT% ^
    -draw "@%LINE_SCR%" ^
    %sSKEL% ^
    -alpha off ^
    %OUTFILE%
) else (
  %IMG7%magick ^
    %INFILE% ^
    %sSKEL% ^
    -alpha off ^
    %OUTFILE%
)

call echoRestore

endlocal & set %sioCODE%OUTFILE=%OUTFILE%
