rem From image %1,
rem makes output %2 with grain.
rem %3 noise type: random, Gaussian, fractal
rem %4 whether noise is "col" (colour) or "gray" (monochrome)
rem %5 sigma for noise blur
@rem
@rem Also uses:
@rem   agSEED eg "-seed 1234"  seed for random generator.
@rem
@rem Updated:
@rem   11-August-2022 for IM v7
@rem


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

rem @call echoOffSave

call %PICTBAT%setInOut %1 ag

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set NSE_TYPE=Gaussian
set NSE_TYPE=Random

set NSE_TYPE=%3
if "%NSE_TYPE%"=="." set NSE_TYPE=
if "%NSE_TYPE%"=="" set NSE_TYPE=Gaussian

set NSE_COL=%4
if "%NSE_COL%"=="." set NSE_COL=
if "%NSE_COL%"=="" set NSE_COL=gray

set NSE_SIG=%5
if "%NSE_SIG%"=="." set NSE_SIG=
if "%NSE_SIG%"=="" set NSE_SIG=0

if /I %NSE_COL% NEQ gray if /I %NSE_COL% NEQ col (
  echo Bad value NSE_COL [%NSE_COL%] expected [col] or [gray]
  exit /B 1
)

set TMP_NSE=\temp\ag_nse.miff


set WW=
for /F "usebackq" %%L in (`%IMG7%magick ^
  %INFILE% -format "WW=%%[fx:w]\nHH=%%[fx:h]" ^
  info:`) do set %%L
if "%WW%"=="" exit /B 1

if /I "%NSE_COL%" EQU "gray" (
  set MONO_NSE=-channel R -separate +channel
) else if /I "%NSE_COL%" EQU "col" (
  set MONO_NSE=
) else (
  echo Bad NSE_COL [%NSE_COL%]
)


if %NSE_SIG%==0 (
  set BLR_NSE=-auto-level
) else (
  set BLR_NSE=-virtual-pixel Tile -blur 0x%NSE_SIG% -auto-level
)

set LEV_NSE=+level 25%%,75%%
set LEV_NSE=+sigmoidal-contrast 3,50%%
set LEV_NSE=


if /I "%NSE_TYPE%" EQU "fractal" (

  set fnGRAY=

  call %PICTBAT%fractNoise ^
    %WW% %HH% 1 10 . . %TMP_NSE%

  %IMG7%magick ^
    %TMP_NSE% ^
    %MONO_NSE% ^
    %BLR_NSE% ^
    %LEV_NSE% ^
    %TMP_NSE%

  set fnGRAY=
) else (

  %IMG7%magick ^
    -size %WW%x%HH% xc:gray^(50%%^) ^
    -set colorspace sRGB ^
    %agSEED% ^
    +noise %NSE_TYPE% ^
    -type TrueColor ^
    %MONO_NSE% ^
    %BLR_NSE% ^
    %LEV_NSE% ^
    %TMP_NSE%
)


%IMG7%magick ^
  %INFILE% ^
  %TMP_NSE% ^
  -compose Hard_Light -composite ^
  %OUTFILE%



call echoRestore

endlocal & set agOUTFILE=%OUTFILE%
