rem Given image %1 in linear colorspace, floating-point,
rem makes output %2 by multiplying colour channels.
rem %3 is assumed input exposure value.
rem %4 is target exposure value.
rem If %4 greater than %3, exposure is increased (output is lighter).
@rem
@rem Updated:
@rem   24-August-2022 for IM v7. Assumes magick is HDRI.
@rem

@if "%4"=="" findstr /B "rem @rem" %~f0 & exit /B 1

goto skip

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "FMULT=%%[fx:pow(2,%4-(%3))]" ^
  xc:`) do set %%L

echo FMULT=%FMULT%

:skip

%IMG7%magick ^
  %1 ^
  -channel RGB ^
  -evaluate Multiply %%[fx:pow(2,%4-(%3))] ^
  +channel ^
  -define quantum:format=floating-point ^
  -depth 32 ^
  %2
