rem Analyses image %1 into grid files, using data from a block list file.

@rem Companion script to fractNoise.bat

@rem Also uses:
@rem
@rem   agrDEBUG if 1, creates other image files (full and diff).
@rem   agrHTM if 1, creates HTM file
@rem
@rem   fnIM location of IM's convert to be used. [%IMG7%]
@rem   fnPREFIX prefix for working files. [fn_]
@rem   fnNG_EXT extension for noise grid files. [.miff]
@rem   fnTXT_OUT if 1, writes some text data.

if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

rem @call echoOffSave

call %PICTBAT%setInOut %1 agr

call %PICTBAT%mkPyrComm

if "%fnIM%"=="" set fnIM=%IMG7%

for /L %%N in (%LAST_OCT%,-1,0) do (

  set NG_FILE=%fnPREFIX%grd_%%N%fnNG_EXT%

  rem echo N_BLK_W.%%N=!N_BLK_W.%%N! N_BLK_H.%%N=!N_BLK_H.%%N! AMP.%%N=!AMP.%%N! M1AMP.%%N=!M1AMP.%%N!

  if !M1AMP.%%N!==1 (
    set sLEVEL=
  ) else (
    for /F "usebackq" %%L in (`%IMG7%magick identify ^
      -format "LO=%%[fx:50*(1-!M1AMP.%%N!)]\nHI=%%[fx:50*(1+!M1AMP.%%N!)]" ^
      xc:`) do set %%L

    set sLEVEL=+level !LO!%%,!HI!%%
  )

  set DO_RES=1
  if !N_BLK_W.%%N!==%WW% if !N_BLK_H.%%N!==%HH% set DO_RES=0

  set WRDIFF=1
  if not %%N==0 if not "%agrDEBUG%"=="1" set WRDIFF=0

  ( if !DO_RES!==1 echo -resize "!N_BLK_W.%%N!x!N_BLK_H.%%N!^!"
    echo +write !NG_FILE!
    echo +write mpr:GRD%%N
    if !DO_RES!==1 echo -resize "%WW%x%HH%^!"
    if "%agrDEBUG%"=="1" echo +write %fnPREFIX%full_%%N%fnNG_EXT% !sLEVEL!
    echo mpr:!PREV_DIFF!
    echo -compose Mathematics -define compose:args=0,1,-1,0.5 -composite
    set PREV_DIFF=DIFF%%N
    if "!WRDIFF!"=="1" echo +write %fnPREFIX%diff_%%N%fnNG_EXT%
    echo +write mpr:!PREV_DIFF!
  )>>%MK_SCR%

  ( echo ^( %PYR_FILE%[%%N]
    if !DO_RES!==1 echo -resize "%WW%x%HH%^!"
    echo !sLEVEL! ^)

    if !DONE_FIRST!==0 (
      set DONE_FIRST=1
    ) else (
      echo -compose Mathematics -define compose:args=0,1,1,-0.5 -composite
    )
  )>>%RECON_SCR%

  if "%agrHTM%"=="1" (
    echo ^<tr^>
    echo ^<td^>%%N^</td^>
    echo ^<td^>^<img src="!NG_FILE!%EXTEXT%" /^>^</td^>
    echo ^<td^>^<img src="%fnPREFIX%full_%%N%fnNG_EXT%%EXTEXT%" /^>^</td^>
    echo ^<td^>^<img src="%fnPREFIX%full_%%N_h_glc.png" /^>^</td^>
    echo ^<td^>^<img src="%fnPREFIX%diff_%%N%fnNG_EXT%%EXTEXT%" /^>^</td^>
    echo ^</tr^>
  )>>%HTM_TAB%
)

:: List the MPRs, read to write to a tiff.
( echo +delete
  for /L %%N in (0,1,%LAST_OCT%) do @(
    @echo mpr:GRD%%N
  )
  echo mpr:DIFF0
  echo -write %PYR_FILE%
  echo -exit
)>>%MK_SCR%

:: Add final difference to reconstruction.
(
  echo %PYR_FILE%[%NUM_OCTAVES%]
  echo -compose Mathematics -define compose:args=0,1,1,-0.5 -composite
  echo -write %RECON_FILE%
  echo -exit
)>>%RECON_SCR%

if "%agrHTM%"=="1" echo ^</table^> >>%HTM_TAB%

%fnIM%magick ^
  -script %MK_SCR%

if "%agrHTM%"=="1" (
  for /L %%N in (0,1,%LAST_OCT%) do @(
    %IM7DEV%magick ^
      %fnPREFIX%full_%%N%fnNG_EXT% ^
      -process 'mkhisto capnumbuckets 512 norm' ^
      %fnPREFIX%full_%%N_h%fnNG_EXT%

    call %PICTBAT%graphLineCol %fnPREFIX%full_%%N_h%fnNG_EXT% . . 0
  )
)

rem type %MK_SCR%
rem type %HTM_TAB%
rem type %RECON_SCR%

call echoRestore

@endlocal
