rem From ordinary 3-channel image %1,
rem make anglegram %2
rem size Nx1 bins where %3 is N,
rem and optional chart %4.
rem %5 is normalisation:
rem   none
rem   separate
rem   together
@rem
@rem Updated:
@rem   24-August-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

rem @call echoOffSave

call %PICTBAT%setInOut %1 agrg

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set nBIN=%3
if "%nBIN%"=="." set nBIN=
if "%nBIN%"=="" set nBIN=360

set CHART=%4
if "%CHART%"=="." set CHART=

set NORM=%5
if "%NORM%"=="." set NORM=
if "%NORM%"=="" set NORM=none

if /I "%NORM%"=="none" (
  set MKH_NORM=
  set END_NORM=
) else if /I "%NORM%"=="separate" (
  set MKH_NORM=norm
  set END_NORM=
) else if /I "%NORM%"=="together" (
  set MKH_NORM=
  set END_NORM=-auto-level
) else (
  echo %0: Bad normalisation parameter.
  exit /B 1
)

set TMPDIR=\temp\
set SLP=%TMPDIR%%SIOCODE%_slp.miff
set MAG=%TMPDIR%%SIOCODE%_mag.miff
set DRN=%TMPDIR%%SIOCODE%_drn.miff
set CHTPREF=%TMPDIR%%SIOCODE%_cht_

call %PICTBAT%slopeXY ^
  %INFILE% %SLP% "-colorspace Gray"

if ERRORLEVEL 1 exit /B 1

call %PICTBAT%slopeXYmag ^
  %SLP% %MAG%

call %PICTBAT%slopeXYdirn ^
  %SLP% %DRN% ^
  SWAP . 75

%IM7DEV%magick ^
  %DRN% ^
  %MAG% ^
  -alpha off ^
  -compose CopyOpacity -composite ^
  -process 'mkhisto regardalpha capnumbuckets %nBIN% %MKH_NORM% v' ^
  -alpha off ^
  %END_NORM% ^
  -define "quantum:format=floating-point" ^
  +write %OUTFILE% ^
  %CHTPREF%_x.miff

if not "%CHART%"=="" (
  call %PICTBAT%graphBW %CHTPREF%_x.miff

  call %PICTBAT%gr2pol %CHTPREF%_x_gbw.miff %CHART% +append
)


call echoRestore
