#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <assert.h>
#include <math.h>
#include "vsn_defines.h"

/* Updated:
     3-April-2018 for v7.0.7-28
*/

/* Maybe see transform.c TransformImages and TransformImage.
*/

ModuleExport size_t appendlinesImage(Image **images,const int argc,
  const char **argv,ExceptionInfo *exception)
{
  (void) argc;
  (void) argv;

  Image
    *image;

  Image
    *new_image,
    *transform_images;

  assert(images != (Image **) NULL);
  assert(*images != (Image *) NULL);
  assert((*images)->signature == MAGICK_CORE_SIG);

  transform_images=NewImageList();

  image=(*images);
  for ( ; image != (Image *) NULL; image=GetNextImageInList(image))
  {
    CacheView
      *image_view,
      *out_view;

    ssize_t
      y;

    MagickBooleanType
      status;

    VIEW_PIX_PTR
      *q_out;

printf ("applines: in loop\n");

    new_image=CloneImage(image, image->rows*image->columns, 1, MagickTrue, exception);
    if (new_image == (Image *) NULL)
      return(-1);

    out_view=AcquireVirtualCacheView(new_image,exception);  // FIXME: or authentic?

    status=MagickTrue;

    q_out=GetCacheViewAuthenticPixels(out_view,0,0,new_image->columns,1,exception);
    if (q_out == (const VIEW_PIX_PTR *) NULL)
      status=MagickFalse;

    image_view=AcquireVirtualCacheView(image,exception);

#if defined(MAGICKCORE_OPENMP_SUPPORT)
    #pragma omp parallel for schedule(static,4) shared(status) \
      MAGICK_THREADS(image,image,image->rows,1)
#endif
    for (y=0; y < (ssize_t) image->rows; y++)
    {
      register const VIEW_PIX_PTR
        *p;

      register ssize_t
        x;

      if (status == MagickFalse)
        continue;
      p=GetCacheViewVirtualPixels(image_view,0,y,image->columns,1,exception);
      if (p == (const VIEW_PIX_PTR *) NULL)
      {
        status=MagickFalse;
        continue;
      }

      for (x=0; x < (ssize_t) image->columns; x++)
      {
        SET_PIXEL_RED   (new_image,GET_PIXEL_RED(image,p),   q_out);
        SET_PIXEL_GREEN (new_image,GET_PIXEL_GREEN(image,p), q_out);
        SET_PIXEL_BLUE  (new_image,GET_PIXEL_BLUE(image,p),  q_out);
//        p++;
//        q_out++;

        p += Inc_ViewPixPtr (image);
        q_out += Inc_ViewPixPtr (new_image);

      }
      if (SyncCacheViewAuthenticPixels(out_view,exception) == MagickFalse)
        status=MagickFalse;
    }

    AppendImageToList(&transform_images,new_image);
    image_view=DestroyCacheView(image_view);
    out_view=DestroyCacheView(out_view);

  }
  *images=transform_images;

  return(MagickImageFilterSignature);
}
