rem Makes auotolevel version, such that 50% remains at 50%.
rem Output %2 will have 0% or 100%, but generally not both.
rem %3 if not 0, will first add 50% to the image.
@rem
@rem Assumes magick is HDRI.
@rem
@rem Updated:
@rem   25-June-2017 Added "ADDHALF" facility.
@rem   22-July-2022 Upgraded for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 alm

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set ADDHALF=%3
if "%ADDHALF%"=="." set ADDHALF=
if "%ADDHALF%"=="" set ADDHALF=0

if "%ADDHALF%"=="0" (
  set sADDHALF=
) else (
  set sADDHALF=-evaluate Add 50%%
)

for /F "usebackq" %%L in (`%IMG7%magick ^
  %INFILE% ^
  %sADDHALF% ^
  -format "dm=%%[fx:abs(minima-0.5)>abs(maxima)?minima:maxima]" ^
  info:`) do set %%L

echo %0: dm=%dm%

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "dm=%%[fx:100*(%dm%>0.5?1-%dm%:%dm%)]" ^
  xc:`) do set %%L

echo %0: dm=%dm%

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "dmo=%%[fx:100-%dm%]" ^
  xc:`) do set %%L

echo %0: dmo=%dmo%

%IMG7%magick ^
  %INFILE% ^
  %sADDHALF% ^
  -level %dm%,%dmo%%% ^
  %OUTFILE%


call echoRestore

endlocal & set almOUTFILE=%OUTFILE%&

