rem Given %1 and %2 are width and height eg 267, 233
rem %3 is (quoted) set of barrel parameters
rem %4 is multiple of size for first guess, integer, [default 3]
rem finds output width and height that contains all the pixel data.
@rem
@rem Updated:
@rem   21-August-2022 Upgraded for IM v7.
@rem

setlocal

set WW=%1
set HH=%2

set DP=%3

set MULT_SZ=%4
if "%MULT_SZ%"=="." set MULT_SZ=
if "%MULT_SZ%"=="" set MULT_SZ=3

set /A W_MULT=%MULT_SZ%*%WW%
set /A H_MULT=%MULT_SZ%*%HH%

set /A VX=(%W_MULT%-%WW%)/2
set /A VY=(%H_MULT%-%HH%)/2

echo %0: %W_MULT%x%H_MULT%-%VX%-%VY%

for /F "usebackq" %%L in (`%IMG7%magick ^
  -size %WW%x%HH% ^
  xc:White ^
  -virtual-pixel Black ^
  -define distort:viewport^=%W_MULT%x%H_MULT%-%VX%-%VY% ^
  -distort barrel %DP% ^
  -trim +repage ^
  -format "VW=%%w\nVH=%%h\nVX=%%[fx:int((w-%WW%)/2+0.5)]\nVY=%%[fx:int((h-%HH%)/2+0.5)]" ^
  info:`) do set %%L

if %VW%==%W3% exit /B 1
if %VH%==%H3% exit /B 1

endlocal & set bsVP=%VW%x%VH%-%VX%-%VY%
