rem %1 is image with two non-intersecting aliased blue lines.
rem %2 is template name for the two output Nx1 files. Must contain XX.
rem %3 channel for separation: R or G or B [default B].
rem %4 method shrink or stretch or mean [shrink]
rem %5 prefix for environment variables [b2c]
@rem
@rem Also uses:
@rem   b2cDEBUG name for debugging outputs. Must contain XX.
@rem
@rem Updated:
@rem   11-July-2021 Corrected ShrStr error message.


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 b2c

set OUTTMPLT=%2
if "%OUTTMPLT%"=="." set OUTTMPLT=
if "%OUTTMPLT%"=="" set OUTTMPLT=b2c_XX.miff

set OUT1=%OUTTMPLT:XX=1%
set OUT2=%OUTTMPLT:XX=2%

set chSEP=%3
if "%chSEP%"=="." set chSEP=
if "%chSEP%"=="" set chSEP=B

set ShrStr=%4
if "%ShrStr%"=="." set ShrStr=
if "%ShrStr%"=="" set ShrStr=shrink

set ENVPREF=%5
if "%ENVPREF%"=="." set ENVPREF=
if "%ENVPREF%"=="" set ENVPREF=b2c

if /I %ShrStr%==shrink (
  set MINMAX=maxima
) else if /I %ShrStr%==stretch (
  set MINMAX=minima
) else if /I %ShrStr%==mean (
  set MINMAX=mean
) else (
  echo %0: ShrStr is neither shrink nor stretch nor mean
  exit /B 1
)

if "%b2cDEBUG%"=="" (
  set WRDBG1=
  set WRDBG2=
) else (
  set WRDBG1=+write %b2cDEBUG:XX=1%
  set WRDBG2=+write %b2cDEBUG:XX=2%
)

set MAXGAP=

for /F "usebackq" %%L in (`%IMG7%magick ^
  %INFILE% ^
  -format "WW=%%[w]\nHH=%%[h]\n" ^
  +write info: ^
  -define quantum:format^=floating-point ^
  -depth 32 ^
  -precision 16 ^
  -channel %chSEP% -separate +channel ^
  -fill Black +opaque White ^
  ^( -clone 0 ^
     -fill White -draw "color 0,0 floodfill" ^
     -fill Red -draw "color 0,0 floodfill" ^
     -fill Black -opaque White ^
     -fill White -draw "color 0,0 floodfill" ^
     +write mpr:WtTOP ^
     %WRDBG1% ^
     -scale "x1^!" ^
     -channel RGB ^
     -format "MAXTOP=%%[fx:%MINMAX%*100]\n" +write info: ^
     -evaluate Subtract %%[%MINMAX%] ^
     -function polynomial "1,0.5" ^
     +channel ^
     -write %OUT1% ^
     +delete ^
  ^) ^
  -fill White -draw "color 0,%%[fx:h-1] floodfill" ^
  -fill Red -draw "color 0,%%[fx:h-1] floodfill" ^
  -fill Black -opaque White ^
  -fill White -draw "color 0,%%[fx:h-1] floodfill" ^
  +write mpr:WtBOT ^
  %WRDBG2% ^
  -scale "x1^!" ^
  -channel RGB ^
  -format "MAXBOT=%%[fx:%MINMAX%*100]\n" +write info: ^
  -evaluate Subtract %%[%MINMAX%] ^
  -function polynomial "-1,0.5" ^
  +channel ^
  -write %OUT2% ^
  +delete ^
  mpr:WtTOP ^
  mpr:WtBOT ^
  -compose Lighten -composite ^
  -channel RGB -negate +channel ^
  -scale "x1^!" ^
  -format "MINGAP=%%[fx:minima]\n" +write info: ^
  -format "MAXGAP=%%[fx:maxima]\n" +write info: ^
  NULL:`) do set %%L

if "%MAXGAP%"=="" (
  echo %0: MAXGAP not set
  exit /B 1
)

set sFMT=^
XTRATOP=%%[fx:0-100/(100-%MAXTOP%-%MAXBOT%)*%MAXTOP%]\n^
XTRABOT=%%[fx:100+100/(100-%MAXTOP%-%MAXBOT%)*%MAXBOT%]\n^
NEWHH=%%[fx:int(%HH%*(100-%MAXTOP%-%MAXBOT%)/100+0.5)]\n^
NEWY=%%[fx:int(%HH%*%MAXTOP%/100+0.5)]\n^
MINGAP=%%[fx:int(%HH%*%MINGAP%+0.5)]\n^
MAXGAP=%%[fx:int(%HH%*%MAXGAP%+0.5)]\n

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 16 ^
  -format "%sFMT%" ^
  xc:`) do set %%L

set /A BOTHH=%HH%-%NEWHH%-%NEWY%

set /A BOTY=%NEWHH%+%NEWY%

call echoRestore

@endlocal & set %ENVPREF%WW=%WW%& set %ENVPREF%HH=%HH%& ^
set %ENVPREF%NEWHH=%NEWHH%& set %ENVPREF%NEWY=%NEWY%& ^
set %ENVPREF%MAXTOP=%MAXTOP%& set %ENVPREF%MAXBOT=%MAXBOT%& ^
set %ENVPREF%XTRATOP=%XTRATOP%& set %ENVPREF%XTRABOT=%XTRABOT%& ^
set %ENVPREF%MINGAP=%MINGAP%& set %ENVPREF%MAXGAP=%MAXGAP%& ^
set %ENVPREF%BOTHH=%BOTHH%& set %ENVPREF%BOTY=%BOTY%
