rem rem Given %1 is wildcard file (eg mydir\*.png),
rem writes filename and 21 (or 14) perceptual hash values
rem (first column only)
rem to CSV files for various colorspaces.

set IMAGES=%1

if "%IMAGES%"=="" (
  echo %0: No images.
  exit /B 1
)

call %PICTBAT%setPhEnv

if "%PH_CSVDIR%"=="" exit /B 1

echo %0: %IMAGES%

goto skip

rem Calculate PHs for ordinary colorspaces.
rem

for %%C in (%COLSP3%) do (
  call %PICTBAT%idPh21imgs %IMAGES% %PH_CSVDIR%\idPh21_%%C.csv %%C

  if ERRORLEVEL 1 exit /B 1
)

rem Calculate PHs for H** colorspaces, without the H channel.
rem

for %%C in (%COLSP_NO_H%) do (
  call %PICTBAT%idPh21imgs %IMAGES% %PH_CSVDIR%\idPh21_%%C.csv H%%C 12

  if ERRORLEVEL 1 exit /B 1
)

:skip

rem Calculate PHs for Y** colorspaces, without the Y channel.
rem

for %%C in (%COLSP_NO_Y%) do (
  call %PICTBAT%idPh21imgs %IMAGES% %PH_CSVDIR%\idPh21_%%C.csv Y%%C 12

  if ERRORLEVEL 1 exit /B 1
)

exit /B 0
