rem From input image %1,
rem makes cartoon and textures outputs
rem using technique of Buades et al.
rem %2 is output name, including XX, which will be substituted by cart or text.
rem such that input = cartoon + texture - 50%.
rem %3 is blur sigma.
@rem
@rem Future: allow for heavy blur.
@rem
@rem This works best when IM has HDRI.
@rem
@rem Updated:
@rem   6-August-2022 for IM v7
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 ctxb

set OUTFILE=%2
if "%OUTFILE%"=="." set OUTFILE=
if "%OUTFILE%"=="" set OUTFILE=%BASENAME%_ctx_XX%EXT%

set OUT_CART=%OUTFILE:XX=cart%
set OUT_TEXT=%OUTFILE:XX=text%

if "%OUT_CART%"=="%OUT_TEXT%" (
  echo Bad OUTFILE [%OUTFILE%] -- should contain XX
  exit /B 1
)

echo OUT_CART=%OUT_CART% OUT_TEXT=%OUT_TEXT%

set BLR_SIG=%3
if "%BLR_SIG%"=="." set BLR_SIG=
if "%BLR_SIG%"=="" set BLR_SIG=1

set BLR_SIG2=%4
if "%BLR_SIG2%"=="." set BLR_SIG2=
if "%BLR_SIG2%"=="" set BLR_SIG2=%BLR_SIG%

set BLR_IMG=%OUTBASE%_ctx_blr.miff
set LTV_IMG=%OUTBASE%_ctx_ltv.miff
set LTV_BLR=%OUTBASE%_ctx_ltvblr.miff
set LAMBDA=%OUTBASE%_ctx_lambda.miff

%IMG7%magick ^
  %INFILE% ^
  -blur 0x%BLR_SIG% ^
  +depth ^
  %BLR_IMG%

call %PICTBAT%locTotVar %INFILE% %LTV_IMG% %BLR_SIG2%

call %PICTBAT%locTotVar %BLR_IMG% %LTV_BLR% %BLR_SIG2%

set sLEVEL=
set sLEVEL=-level 25%%,50%%

%IMG7%magick ^
  %LTV_IMG% +write mpr:LTVIMG ^
  %LTV_BLR% ^
  -compose MinusSrc -composite ^
  mpr:LTVIMG ^
  -compose DivideSrc -composite ^
  %sLEVEL% ^
  +depth ^
  %LAMBDA%

%IMG7%magick ^
  %INFILE% ^
  %BLR_IMG% ^
  %LAMBDA% ^
  -compose Over -composite ^
  +depth ^
  %OUT_CART%

%IMG7%magick ^
  %INFILE% ^
  %OUT_CART% ^
  -compose Mathematics -define compose:args=0,-1,1,0.5 -composite ^
  +depth ^
  %OUT_TEXT%

  
call echoRestore

endlocal
