rem From input image %1,
rem makes cartoon and textures outputs
rem using Erase Edge Pixel method.
rem %2 is output name, including XX, which will be substituted by cart, text, edges or skel.
rem such that input = cartoon + texture - 50%.
rem %3 is blur sigma.
@rem
@rem Future: allow for heavy blur.
@rem
@rem This works best when IM has HDRI.
@rem
@rem Updated:
@rem   6-August-2022 for IM v7
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 ctxb

set OUTFILE=%~2
if "%OUTFILE%"=="." set OUTFILE=
if "%OUTFILE%"=="" set OUTFILE=%BASENAME%_ctx_XX%EXT%

set OUT_CART="%OUTFILE:XX=cart%"
set OUT_TEXT="%OUTFILE:XX=text%"
set OUT_EDGES="%OUTFILE:XX=edges%"
set OUT_SKEL="%OUTFILE:XX=skel%"

if [%OUT_CART%]==[%OUT_TEXT%] (
  echo %0: Bad OUTFILE [%OUTFILE%] -- should contain XX
  exit /B 1
)

echo %0: OUT_CART=%OUT_CART% OUT_TEXT=%OUT_TEXT%

set BLR_SIG=%3
if "%BLR_SIG%"=="." set BLR_SIG=
if "%BLR_SIG%"=="" set BLR_SIG=1

set BLR_IMG=%BASENAME%_ctx_blr.miff
set SLOP_MAG=%BASENAME%_ctx_bsm.miff
set HOLED_MAG=%BASENAME%_ctx_holed.miff

%IMG7%magick ^
  %INFILE% ^
  -blur 0x%BLR_SIG% ^
  +depth ^
  %BLR_IMG%

set smAUTO=0

call %PICTBAT%slopeMag %BLR_IMG% %SLOP_MAG%

%IMG7%magick ^
  %SLOP_MAG% ^
  -auto-level ^
  -unsharp 0x%BLR_SIG%+50+0 ^
  -blur 0x%BLR_SIG% ^
  -threshold 50%% ^
  +depth ^
  %OUT_EDGES%

if ERRORLEVEL 1 exit /B 1

%IMG7%magick ^
  %BLR_IMG% ^
  ( %OUT_EDGES% -negate ) ^
  -compose CopyOpacity -composite ^
  %HOLED_MAG%

if ERRORLEVEL 1 exit /B 1

call %PICTBAT%shiftFill %HOLED_MAG% . %OUT_CART%

if ERRORLEVEL 1 exit /B 1

%IMG7%magick ^
  %INFILE% ^
  %OUT_CART% ^
  -compose Mathematics ^
    -define compose:args=0,-1,1,0.5 ^
  -composite ^
  +depth ^
  %OUT_TEXT%

if ERRORLEVEL 1 exit /B 1

%IMG7%magick ^
  %OUT_EDGES% ^
  -morphology Thinning:-1 skeleton ^
  -clamp ^
  -blur 0x0.5 ^
  -auto-level -negate ^
  %OUT_SKEL%

if ERRORLEVEL 1 exit /B 1

call echoRestore

endlocal
