@rem
@rem Updated:
@rem   7-September-2022 for IM v7.
@rem


set CCM_LIS=ColorDodge+ColorBurn,LinearDodge+LinearBurn,^
Screen+Multiply,Overlay+HardLight,^
PegtopLight+SoftLight,VividLight+PinLight,^
Darken+Lighten,DarkenIntensity+LightenIntensity

set LIS=ccm_ckbk2.inc

echo \[table\] >%LIS%
echo \[tr\]\[th\]Method\[/th\]\[th\]with \[tt\]ccm_grgrad.png\[/tt\] \[/th\]\[th\]with \[tt\]ccm_colgrad.png\[/tt\]\[/th\]\[/tr\] >>%LIS%

set N=0
for %%A in (%CCM_LIS%) do (
  echo %%A

  call :split %%A

  set FileA=ccm_2a_!N!.png
  set FileB=ccm_2b_!N!.png

  %IMG7%magick ^
    %SRC% ^
    ccm_grgrad.png ^
    -gravity Center ^
    ^( -clone 0-1 ^
       -compose !C1! -composite ^
    ^) ^
    ^( -clone 0-1 ^
       -compose !C2! -composite ^
    ^) ^
    -delete 0-1 ^
    -evaluate-sequence Mean ^
    !FileA!

  %IMG7%magick ^
    %SRC% ^
    ccm_colgrad.png ^
    -gravity Center ^
    ^( -clone 0-1 ^
       -compose !C1! -composite ^
    ^) ^
    ^( -clone 0-1 ^
       -compose !C2! -composite ^
    ^) ^
    -delete 0-1 ^
    -evaluate-sequence Mean ^
    !FileB!

  echo \[tr\]\[td\]!C1!, !C2!\[/td\]\[td\]\[img src="!FileA!jpg" /\]\[/td\]\[td\]\[img src="!FileB!jpg" /\]\[/td\]\[/tr\] >>%LIS%

  set /A N+=1
)

echo \[/table\] >>%LIS%


type %LIS%

chstrs /i%LIS% /f\\[ /t\(
chstrs /i%LIS% /f\\] /t\)

rem type %LIS%

exit /B 0

::-----------------------------------
:: Subroutines

:split
  set C=%1

  set C2=!C:*+=!
  set C1=!C:+%C2%=!

  echo [!C1!][!C2!]

exit /B 0
