rem %1 Prefix for first input chainset.
rem %2 Prefix for second input chainset.
rem %3 Prefix for output chainset.

@if "%3"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave


set InPref1=%1
set InPref2=%2
set OutPref=%3

call %PICTBAT%chainRdEnv %InPref1%
if ERRORLEVEL 1 exit /B 1

call %PICTBAT%chainRdEnv %InPref2%
if ERRORLEVEL 1 exit /B 1

call %PICTBAT%chainClean %OutPref%

set cnfInPref=%~n1
set cnfOutPref=%~n3

call :ChkOneDirn fwd
if ERRORLEVEL 1 exit /B 1
call :ChkOneDirn bwd
if ERRORLEVEL 1 exit /B 1

type %InPref1%_all.lis >%OutPref%_all.lis
if ERRORLEVEL 1 exit /B 1
type %InPref1%_fwd.lis >%OutPref%_fwd.lis
if ERRORLEVEL 1 exit /B 1
type %InPref1%_bwd.lis >%OutPref%_bwd.lis
if ERRORLEVEL 1 exit /B 1

call %PICTBAT%csaNumFeat %InPref1%
set nFeat1m1=!%cnfPref%.NumFeatM1!
for /L %%I in (0,1,%nFeat1m1%) do (
  echo Copy from %InPref1% feature %%I
  type %InPref1%_coords_f%%I_fwd.lis >%OutPref%_coords_f%%I_fwd.lis
  type %InPref1%_coords_f%%I_bwd.lis >%OutPref%_coords_f%%I_bwd.lis
)

set Offset=!%cnfPref%.NumFeat!

call %PICTBAT%csaNumFeat %InPref2%
set nFeat2m1=!%cnfPref%.NumFeatM1!
for /L %%I in (0,1,%nFeat2m1%) do (
  set /A NewNum=%%I+%Offset%
  echo Copy from %InPref1% feature %%I, renumbered !NewNum!
  type %InPref1%_coords_f%%I_fwd.lis >%OutPref%_coords_f!NewNum!_fwd.lis
  type %InPref1%_coords_f%%I_bwd.lis >%OutPref%_coords_f!NewNum!_bwd.lis
)

echo %0: Written chainset %OutPref%

set %cnfOutPref%.InFrames=!%cnfInPref%.InFrames!
set %cnfOutPref%.InExt=!%cnfInPref%.InExt!
set /A %cnfOutPref%.NumFeat=%nFeat1m1%+%nFeat1m1%+2
set /A %cnfOutPref%.NumFeatM1=%nFeat1m1%+%nFeat1m1%+1
@call %PICTBAT%chainWrEnv %OutPref%
if ERRORLEVEL 1 exit /B 1

call echoRestore

@endlocal

@exit /B 0

::------------------------------------------------------
:: Subroutines

:ChkOneDirn
set DIRN=%1
rem Checks the input lists are compatible.

call readArray %InPref1%_%DIRN%.lis InImgs1
if ERRORLEVEL 1 exit /B 1

call readArray %InPref2%_%DIRN%.lis InImgs2
if ERRORLEVEL 1 exit /B 1

if %InImgs1_CNT% NEQ %InImgs1_CNT% (
  echo %0: Different lengths in %DIRN%
  exit /B 1
)

if %InImgs1[0]% NEQ %InImgs2[0]% (
  echo %0: Different first images in %DIRN% [%InImgs1[0]% NEQ %InImgs2[0]%]
  exit /B 1
)

exit /B 0

