rem %1 prefix for input chainset
rem %2 prefix for output chainset
rem %3 name of frame to pivot around [default: first]

rem Pivots file lists and coordinate lists
rem so bwd lists have only one entry,
rem and fwd lists have all the entries that were in the bwd and fwd lists.

rem Copy the all list.

rem Read the bwd into an array.
rem Write it (exclding first entry) backwards into fwds,
rem then copy the rest of the fwds list.

rem Repeat for each of the features.

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave


set InPref=%1
set OutPref=%2
set PivotFrame=%3

if "%PivotFrame%"=="." set PivotFrame=

call %PICTBAT%chainRdEnv %InPref%
if ERRORLEVEL 1 exit /B 1

set cnfInPref=%~n1
set cnfOutPref=%~n2

set FirstOut=%OutPref%
if not "%PivotFrame%"=="" set FirstOut=\temp\chp

call %PICTBAT%csaNumFeat %InPref%

type %InPref%_all.lis >%OutPref%_all.lis

call :pivotOnePairFirst %InPref% %FirstOut%
if ERRORLEVEL 1 exit /B 1

for /L %%F in (0,1,!%cnfPref%.NumFeatM1!) do (
  call :pivotOnePairFirst %InPref% %FirstOut% _coords_f%%F
  if ERRORLEVEL 1 exit /B 1
)

if "%PivotFrame%"=="" goto finished

echo Finding pivot frame [%PivotFrame%].
call readArray %FirstOut%_fwd.lis NewImgs
if ERRORLEVEL 1 exit /B 1

set ndx=-1
for /L %%I in (0,1,!NewImgs_CNTm1!) do (
  echo !NewImgs[%%I]!
  if /I %PivotFrame%==!NewImgs[%%I]! set ndx=%%I
)
if !ndx!==-1 (
  echo %0: Frame [%PivotFrame%] not found.
  exit /B 1
)
echo Found at !ndx!

call :pivotOnePairN %FirstOut% %OutPref%
if ERRORLEVEL 1 exit /B 1

for /L %%F in (0,1,!%cnfPref%.NumFeatM1!) do (
  call :pivotOnePairN %FirstOut% %OutPref% _coords_f%%F
  if ERRORLEVEL 1 exit /B 1
)


:finished

call echoRestore

set InFrm=!%cnfInPref%.InFrames!
set InExt=!%cnfInPref%.InExt!

set %cnfOutPref%.InFrames=%InFrm%
set %cnfOutPref%.InExt=%InExt%
@call %PICTBAT%chainWrEnv %OutPref%
if ERRORLEVEL 1 exit /B 1

@endlocal & set %cnfOutPref%.InFrames=%InFrm%& set %cnfOutPref%.InExt=%InExt%

@exit /B 0

::----------------------------------------------
:: Subroutines

:: %1 is input prefix
:: %2 is output prefix
:: %3 is next part, eg blank or _coords_f0 etc.
:pivotOnePairFirst

echo %0: %1 %2 %3

set InFwd=%1%3_fwd.lis
set InBwd=%1%3_bwd.lis
set OutFwd=%2%3_fwd.lis
set OutBwd=%2%3_bwd.lis

call readArray %InBwd% InBwd
if ERRORLEVEL 1 exit /B 1

(echo !InBwd[%InBwd_CNTm1%]!) >%OutBwd%

(
  for /L %%I in (%InBwd_CNTm1%,-1,1) do echo !InBwd[%%I]!
  type %InFwd%
) >%OutFwd%

exit /B 0

::----------------------------------------------
:: %1 is input prefix
:: %2 is output prefix
:: %3 is next part, eg blank or _coords_f0 etc.
:: Also uses ndx.
:pivotOnePairN

echo %0: %1 %2 %3 %ndx%

set InFwd=%1%3_fwd.lis
set InBwd=%1%3_bwd.lis
set OutFwd=%2%3_fwd.lis
set OutBwd=%2%3_bwd.lis

call readArray %InFwd% InFwd
if ERRORLEVEL 1 exit /B 1

(
  for /L %%I in (%ndx%,-1,0) do echo bwd %%I: !InFwd[%%I]!
) >%OutBwd%

(
  for /L %%I in (%ndx%,1,%InFwd_CNTm1%) do echo fwd %%I: !InFwd[%%I]!
) >%OutFwd%


exit /B 0
