rem From image %1
rem crop parameters %2 to %5
rem calculates chromatic aberration parameters by trial and error
rem setting environment variables prefixed with %6.
@rem
@rem Updated:
@rem   10-August-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave


set INFILE=%1

set CaW=%2
if "%CaW%"=="." set CaW=
if "%CaW%"=="" set CaW=w

set CaH=%3
if "%CaH%"=="." set CaH=
if "%CaH%"=="" set CaH=h

set CaX=%4
if "%CaX%"=="." set CaX=
if "%CaX%"=="" set CaX=0

set CaY=%5
if "%CaY%"=="." set CaY=
if "%CaY%"=="" set CaY=0

set ENVPREF=%6
if "%ENVPREF%"=="." set ENVPREF=
if "%ENVPREF%"=="" set ENVPREF=cab__

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "WW=%%w\nHH=%%h\nHalfSht=%%[fx:min(w,h)/2]\nCaDX=%%[fx:(w/2-%CaX%-%CaW%/2)]\nCaDY=%%[fx:(h/2-%CaY%-%CaH%/2)]\n" ^
  %INFILE%`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "CaRad=%%[fx:hypot(2*%CaDX%/%WW%,2*%CaDY%/%HH%)]\n" ^
  xc:`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "CaRad=%%[fx:hypot(%CaDX%/%WW%,%CaDY%/%HH%)/%HalfSht%]\n" ^
  xc:`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "CaRad=%%[fx:2*hypot(%CaDX%,%CaDY%)/hypot(%WW%,%HH%)]\n" ^
  xc:`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "PorM=%%[fx:hypot(%CaW%,%CaH%)/hypot(%CaDX%,%CaDY%)/4]\n" ^
  xc:`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "F1=%%[fx:1-%PorM%]\nF2=%%[fx:1+%PorM%]\n" ^
  xc:`) do set %%L

set sCROP=-crop %CaW%x%CaH%+%CaX%+%CaY% +repage

set sPROC=-strip %sCROP% -scale 5000%%

set TMPPREF=\temp\ch_
set TMPEXT=miff

%IMG7%magick ^
  %INFILE% ^
  -strip %sCROP% -separate ^
  +adjoin ^
  %TMPPREF%_%%d.%TMPEXT%

rem echo WW=%WW% HH=%HH% CaDX=%CaDX% CaDY=%CaDY% CaRad=%CaRad%

call %PICTBAT%whatScaleT2 ^
  %TMPPREF%_0.%TMPEXT% ^
  %TMPPREF%_1.%TMPEXT% ^
  %F1% %F2% %CaDX% %CaDY%

if ERRORLEVEL 1 exit /B 1

set ScaleR=%wstSCALE%

call %PICTBAT%whatScaleT2 ^
  %TMPPREF%_2.%TMPEXT% ^
  %TMPPREF%_1.%TMPEXT% ^
  %F1% %F2% %CaDX% %CaDY%

if ERRORLEVEL 1 exit /B 1

set ScaleB=%wstSCALE%


call echoRestore

endlocal & set %ENVPREF%_CaRad=%CaRad%& set %ENVPREF%_ScaleR=%ScaleR%& set %ENVPREF%_ScaleB=%ScaleB%
