rem Given opaque image %1 of white loops only,
rem make image %2 of white pixels that break the loops,
rem otherwise black.
@rem
@rem Updated:
@rem   14-September-2022 for IM v7.
@rem

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 c2lb

set OUTFILE=%2


set TMPDIR=\temp\
if not exist %TMPDIR% md %TMPDIR%

set TMPEXT=.miff

set TMPIN=%TMPDIR%c2p_tmpin%TMPEXT%
set BRK=%TMPDIR%c2p_brk%TMPEXT%
set LPBK=%TMPDIR%c2p_lpbk%TMPEXT%

%IMG7%magick ^
  %INFILE% ^
  -alpha off ^
  -morphology Thinning:-1 Skeleton ^
  -alpha off -clamp ^
  +write %TMPIN% ^
  +write %BRK% ^
  -fill Black -colorize 100 ^
  -alpha off ^
  %LPBK%

if ERRORLEVEL 1 exit /B 1


:multiLoop

set numEnds=

for /F "usebackq" %%L in (`%IMG7%magick ^
  %BRK% ^
  -alpha off ^
  -format "maxVal=%%[fx:maxima]\n" ^
  +write info: ^
  -morphology HMT LineEnds ^
  -alpha off -clamp ^
  -format "numEnds=%%[fx:int(mean*w*h+0.5)]\n" ^
  info:`) do set %%L

if not "%numEnds%"=="0" (
  echo %0: numEnds=%numEnds%
  exit /B 1
)

echo %0: numEnds=%numEnds% maxVal=%maxVal%

if %maxVal%==0 goto finished

%IMG7%magick ^
  %BRK% ^
  -alpha off ^
  %TMPIN%

:brkLoop
:: Break a loop
for /F "usebackq tokens=1-3 delims=:, " %%A in (`%IM7DEV%magick ^
  %TMPIN% ^
  -alpha off ^
  -process onewhite ^
  NULL: 2^>^&1`) do (
  set tag=%%A
  set X=%%B
  set Y=%%C
)

echo %0: %tag% %X% %Y%

if %X%==none (
  echo %0: Bug: nothing to break.  INFILE=%INFILE%  TMPIN=%TMPIN%
  exit /B 1
)

for /F "usebackq" %%L in (`%IMG7%magick ^
  %TMPIN% ^
  -alpha off ^
  -fill Black -draw "point %X%,%Y%" ^
  +write %TMPIN% ^
  -alpha off ^
  -morphology HMT LineEnds ^
  -format "numEnds=%%[fx:int(mean*w*h+0.5)]\n" ^
  +write info: ^
  +delete ^
  %LPBK% ^
  -fill White -draw "point %X%,%Y%" ^
  -alpha off ^
  %LPBK%`) do set %%L

echo %0: numEnds=%numEnds%

if %numEnds%==0 goto brkLoop

if not %numEnds%==2 (
  echo %0: numEnds=%numEnds%
)


:doneBrkLoop
echo %0: doneBrkLoop

call %PICTBAT%fillPix %BRK% %LPBK% black %BRK%

goto multiLoop


:finished
echo %0: finished

%IMG7%magick %LPBK% -alpha off %OUTFILE%

call echoRestore

@endlocal & set c2lbOUTFILE=%OUTFILE%
