rem Given image %1, white points on black background,
rem where groups of 4- or 8-connected points form zero or more closed curves,
rem writes text file %2 of the points.
@rem
@rem Updated:
@rem   25-September-2022 for IM v7.
@rem

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 c2p

set OUTFILE=%2


set TMPDIR=\temp\
if not exist %TMPDIR% md %TMPDIR%

set TMPEXT=.miff

set TMPIN=%TMPDIR%c2p_tmpin%TMPEXT%
set LPBK=%TMPDIR%c2p_lpbk%TMPEXT%

set numEnds=

for /F "usebackq" %%L in (`%IMG7%magick ^
  %INFILE% ^
  +write %TMPIN% ^
  -format "maxVal=%%[fx:maxima]\n" ^
  +write info: ^
  -morphology HMT LineEnds -clamp ^
  -format "numEnds=%%[fx:int(mean*w*h+0.5)]\n" ^
  +write info: ^
  -fill Black -colorize 100 ^
  %LPBK%`) do set %%L

if "%numEnds%"=="" exit /B 1

echo %0: numEnds=%numEnds% maxVal=%maxVal%

if %maxVal%==0 goto finished


:brkLoop
:: Break a loop
for /F "usebackq tokens=1-3 delims=:, " %%A in (`%IM7DEV%magick ^
  %TMPIN% ^
  -process onewhite ^
  NULL: 2^>^&1`) do (
  set tag=%%A
  set X=%%B
  set Y=%%C
)

echo %0: %tag% %X% %Y%

if %X%==none exit /B 1

for /F "usebackq" %%L in (`%IMG7%magick ^
  %TMPIN% ^
  -fill Black -draw "point %X%,%Y%" ^
  +write %TMPIN% ^
  -morphology HMT LineEnds -clamp ^
  -format "numEnds=%%[fx:int(mean*w*h+0.5)]\n" ^
  +write info: ^
  +delete ^
  %LPBK% ^
  -fill White -draw "point %X%,%Y%" ^
  %LPBK%`) do set %%L

echo %0: numEnds=%numEnds%

if %numEnds%==0 goto brkLoop

if not %numEnds%==2 (
  echo %0: numEnds=%numEnds%
)


:doneBrkLoop
echo doneBrkLoop




call %PICTBAT%lns2pts %TMPIN% x.txt

echo l2pNumPts=%l2pNumPts% l2pLastX=%l2pLastX% l2pLastY=%l2pLastY%

:: Add in the points that were removed.
:: These form a line (we hope) so lns2pts it,
:: starting with the nearest end to the final pixel of the one just listed.


:: goto do another

:finished
echo finished

call echoRestore

@endlocal & set c2pOUTFILE=%OUTFILE%
