rem From input %1,
rem makes output %2 with clipped pixels made transparent.
rem Other pixels are made opaque.
rem %3 if "mask", output is black/white instead (black where clipped).
rem %4 test for clip at zero, eg "-level 0,10%%".
rem %5 test for clip at 100%, eg "-level 99,100%%".
rem   Default %4 and %5 tests at both ends.
rem   Make either "0" to prevent that test.
@rem
@rem Updated:
@rem   24-August-2022 for IM v7.
@rem

rem FIXME: we need the option to just do one end.

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 c2t

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set MASK=%3
if "%MASK%"=="." set MASK=

set TEST0=%4
if "%TEST0%"=="." set TEST0=
if "%TEST0%"=="" set TEST0=-fill White +opaque Black
if "%TEST0%"=="0" set TEST0=-fill White -colorize 100

set TEST100=%5
if "%TEST100%"=="." set TEST100=
if "%TEST100%"=="" set TEST100=-fill Black +opaque White
if "%TEST100%"=="0" set TEST100=-fill Black -colorize 100

set MASK=%3
if "%MASK%"=="." set MASK=

if /I "%MASK%"=="" (
  set sMASK=-compose CopyOpacity -composite
) else if "%MASK%"=="mask" (
  set sMASK=-delete 0
) else (
  echo %0: Bad mask setting [%MASK%]
  exit /B 1
)

:: Next works best with HDRI.
::
%IMG7%magick ^
  %INFILE% ^
  ( +clone ^
    -channel RGB -separate +channel ^
    -alpha off ^
    +write mpr:CHANS ^
    -evaluate-sequence Min ^
    %TEST0% ^
  ) ^
  ( mpr:CHANS ^
    -evaluate-sequence Max ^
    %TEST100% ^
    -negate ^
  ) ^
  ( -clone 1-2 ^
    -compose Darken -composite ^
  ) ^
  -delete 1-2 ^
  -alpha off ^
  %sMASK% ^
  -define quantum:format=floating-point ^
  -depth 32 ^
  %OUTFILE%

call echoRestore

@endlocal & set c2tOUTFILE=%OUTFILE%
