rem From clut image %1,
rem sets linear regression information to environment variable, prefix %2.
rem 3 channels?
@rem
@rem Updated:
@rem   22-July-2022 Upgraded for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

rem @call echoOffSave

call %PICTBAT%setInOut %1  c2lr

set ENV_PREF=%2
if "%ENV_PREF%"=="." set ENV_PREF=
if "%ENV_PREF%"=="" set ENV_PREF=LINREG

set meanClGr=
set meanClSq=

for /F "usebackq" %%L in (`%IMG7%magick ^
  -precision 19 ^
  %INFILE% ^
  -alpha off ^
  ^( +clone ^
     -sparse-color bilinear ^
       "0,0,Black %%[fx:w-1],0,White" ^
  ^) ^
  -compose Multiply -composite ^
  -format "HH=%%h\nmeanClGr=%%[fx:mean]" ^
  info:`) do set %%L

if not "%HH%"=="1" exit /B 1

for /F "usebackq" %%L in (`%IMG7%magick ^
  -precision 19 ^
  %INFILE% ^
  -sparse-color bilinear ^
    "0,0,Black %%[fx:w-1],0,White" ^
  -evaluate Pow 2 ^
  -format "meanClSq=%%[fx:mean]" ^
  info:`) do set %%L

goto skipMult
for /F "usebackq" %%L in (`%IMG7%magick ^
  -precision 19 ^
  %INFILE% ^
  -duplicate 1 ^
  -compose Multiply -composite ^
  -format "meanClSq=%%[fx:mean]" ^
  info:`) do set %%L
:skipMult

echo %0: meanClGr=%meanClGr% meanClSq=%meanClSq%

set nPoints=0

set sFORMAT1=^
nPoints=%%w\n^
meanY=%%[fx:mean]\n^
sigX=%%[fx:0.5*w]\n^
sigY=%%[fx:mean*w]\n^
sumXY=%%[fx:w*%meanClGr%]\n^
sumXsquared=%%[fx:w*%meanClSq%]

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 19 ^
  -format "%sFORMAT1%" ^
  %INFILE%`) do set %%L

echo %0: nPoints=%nPoints% meanY=%meanY% sigX=%sigX% sigY=%sigY% sumXY=%sumXY% sumXsquared=%sumXsquared% 

if %nPoints%==0 exit /B 1

set sFORMAT2=^
slope=%%[fx:(%nPoints%*%sumXY%-(%sigX%)*%sigY%)/(%nPoints%*%sumXsquared%-(%sigX%)*%sigX%)]

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 19 ^
  -format "%sFORMAT2%" ^
  xc:`) do set %%L


set sFORMAT3=^
intercept=%%[fx:%meanY%-(%slope%)*0.5]

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 19 ^
  -format "%sFORMAT3%" ^
  xc:`) do set %%L

rem set ENV_LIST=c2lrEnv.lis

rem set %ENV_PREF% >%ENV_LIST%


call echoRestore

rem endlocal & for /F %%L in (%ENV_LIST%) do @set %%L

endlocal & set %ENV_PREF%.nPoints=%nPoints%& set %ENV_PREF%.slope=%slope%& set %ENV_PREF%.intercept=%intercept%
