rem Given %1 is 3-channel image Nx1 with alpha,
rem writes %2 text file of non-transparent pixels.
rem   Each output line has five numbers:
rem   x-coordinate, y-coordinate, and number generally 0 to Quantum for R, G and B.
rem See also txt2clut3c.bat

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 c2t3

if not "%2"=="" if not "%2"=="." set OUTFILE=%2


for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 16 ^
  -format "QPC=%%[fx:QuantumRange/100]\nQ255=%%[fx:QuantumRange/255]\n" ^
  xc:`) do set %%L


:: Colour may have % suffix, or be integer in scale 0-255.

(
  for /F "usebackq tokens=1,2,4,5,6 delims=,() " %%A in (`%IMG7%magick ^
    %INFILE% ^
    -precision 16 ^
    sparse-color:- ^| sed -e 's/ /\n/g' -e 's/%%/c/g' `) do (

    call :calcVal "%%C"
    set VALR=!VAL!
    call :calcVal "%%D"
    set VALG=!VAL!
    call :calcVal "%%E"
    set VALB=!VAL!

    echo %%A %%B !VALR! !VALG! !VALB!
  )
) >%OUTFILE%

call echoRestore

@endlocal & set c2t3OUTFILE=%OUTFILE%

@exit /B 0

::--------------------------------------------
:: Subroutines

:calcVal
    set VAL=%~1
    set LASTCH=!VAL:~-1!
    if !LASTCH!==c (
      set VAL=!VAL:~0,-1!
      for /F "usebackq" %%L in (`%IMG7%magick identify ^
        -precision 16 ^
        -format "%%[fx:!VAL!*%QPC%]" ^
        xc:`) do set VAL=%%L
    ) else (
      for /F "usebackq" %%L in (`%IMG7%magick identify ^
        -precision 16 ^
        -format "%%[fx:!VAL!*%Q255%]" ^
        xc:`) do set VAL=%%L
    )

exit /B 0