rem From colour image %1,
rem makes 3-channel clut of the cumulative histogram.
rem
rem If %2 is given, this will be the output file.
@rem
@rem Also uses:
@rem   c2hINBITS optional, 8, 16. If not set, uses depth of input.
@rem     8 is quicker but less precise.
@rem   c2hDO_CUMUL if 1, makes cumulative histogram.
@rem
@rem Updated:
@rem   25-September-2022 for IM v7.
@rem


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 c2h

if not "%2"=="" set OUTFILE=%2

set TMPEXT=.miff
set TMPEXT=%EXT%

if "%c2hDO_CUMUL%"=="" set c2hDO_CUMUL=0

set g2hDO_CUMUL=%c2hDO_CUMUL%

if %c2hDO_CUMUL%==0 (
  set AUTO=-auto-level
) else (
  set AUTO=
)

if "%c2hINBITS%"=="" (
  for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -format "c2hINBITS=%%z" %INFILE%`) do set %%L
  set SETDEPTH=
) else (
  set SETDEPTH=-depth %c2hINBITS%
)

if "%c2hINBITS%"=="" (
  echo %0: Failed to find INBITS for INFILE [%INFILE%]
  exit /B 1
)

set g2hINBITS=%c2hINBITS%


set TEMPDIR=%TEMP%

%IMG7%magick ^
  %INFILE% ^
  %SETDEPTH% ^
  -separate ^
  %TEMPDIR%\%~n1_%sioCODE%_%%d%TMPEXT%


call %PICTBAT%gray2Histo %TEMPDIR%\%~n1_%sioCODE%_0%TMPEXT%
if ERRORLEVEL 1 exit /B 1
set c0=%g2hOUTFILE%

call %PICTBAT%gray2Histo %TEMPDIR%\%~n1_%sioCODE%_1%TMPEXT%
if ERRORLEVEL 1 exit /B 1
set c1=%g2hOUTFILE%

call %PICTBAT%gray2Histo %TEMPDIR%\%~n1_%sioCODE%_2%TMPEXT%
if ERRORLEVEL 1 exit /B 1
set c2=%g2hOUTFILE%

%IMG7%magick ^
  %c0% ^
  %c1% ^
  %c2% ^
  -combine ^
  -set colorspace sRGB ^
  %AUTO% ^
  %OUTFILE%


call echoRestore

endlocal & set c2hOUTFILE=%OUTFILE%

