rem Given images %1 and %2
rem %3 is an offset for #2 with respect to #1
rem makes output %4
rem that is #2 composited over #1, and colour-corrected.
@rem
@rem Also uses:
@rem   cc2DRAW if provided, draws this in gray before relax-fill.
@rem
@rem
@rem Updated:
@rem   24-July-2022 for IM v7.
@rem


@if "%3"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

set INFILE1=%1
set INFILE2=%2
set OFFS_2=%3
set OUTFILE=%4

set TMP_FILE=\temp\cc2.miff

if "%cc2DRAW%"=="" (
  set sDRAW=
) else (
  set sDRAW=-fill gray^(50%%^) -stroke gray^(50%%^) -draw "%cc2DRAW%"
)

%IMG7%magick ^
  ( %INFILE1% +write mpr:IN1 ) ^
  -fill gray(50%%) -colorize 100 ^
  -fuzz 0.1%% ^
  ( %INFILE2% +write mpr:IN2 ^
    -fill Red -colorize 100 ^
    -shave 1x1 -bordercolor gray(50%%) -border 1 ^
    -repage %OFFS_2% ^
  ) ^
  -background Black ^
  -compose Plus -layers merge +repage ^
  -fill Black +opaque White ^
  -crop %OFFS_2% +repage ^
  +write mpr:LMASK ^
  +delete ^
  mpr:IN1 ^
  ( mpr:IN2 -repage %OFFS_2% ) ^
  -compose Mathematics ^
    -define compose:args=0,-0.5,0.5,0.5 ^
  -background None ^
  -layers merge ^
  -crop %OFFS_2% +repage ^
  mpr:LMASK ^
  -alpha off ^
  -compose CopyOpacity -composite ^
  %sDRAW% ^
  %TMP_FILE%

if ERRORLEVEL 1 exit /B 1

rem Relax-fill to get an adjustment image:

call %PICTBAT%relaxFillMS ^
  %TMP_FILE% . %TMP_FILE% ^
  1e-6 1000

if ERRORLEVEL 1 exit /B 1


:skip

rem Add the adjustment image to #2:

%IMG7%magick ^
  %INFILE2% ^
  %TMP_FILE% ^
  -compose Mathematics ^
    -define compose:args=0,2,1,-1 -composite ^
  -repage %OFFS_2% ^
  %INFILE1% ^
  +swap ^
  -background None -compose Over ^
  -layers merge +repage ^
  %OUTFILE%

if ERRORLEVEL 1 exit /B 1

endlocal& set cc2OUTFILE=%OUTFILE%

