rem Given image %1,
rem for each colour cycling method, makes test GIF named cct_!METH!.gif
rem Also creates an HTM file, name %2.
rem %3 optional prefix for GIF files. [cct]
@rem
@rem Updated:
@rem   25-September-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 pd

set HTM=%2
if "%HTM%"=="" set HTM=cct_gifs.h1

set GIF_PREF=%3
if "%GIF_PREF%"=="" set GIF_PREF=cct


set TMPDIR=%TEMP%\

del %TMPDIR%cct_*.miff 2>nul

set METH_LIST=%TEMP%\cctList.lis
del %HTM% 2>nul

set TXT=%TMPDIR%cct_text.png


for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "WW=%%w\nHH=%%h\nWT=%%[fx:max(w*0.9,50)]\nHT=%%[fx:max(h*0.9,20)]" ^
  %INFILE%`) do set %%L


echo ^<h1^>Color cycle tests^</h1^> >%HTM%
echo ^<p^>This page is automatically created by the script ^<tt^>colCyclTst.bat^</tt^>. >>%HTM%
echo See ^<a href="colcycl.htm#cct"^>Colour cycling: tests^</a^>.^</p^> >>%HTM%

set FOR_ARGS=0,2,99

call %PICTBAT%colCyclList >%METH_LIST%

for /F %%M in (%METH_LIST%) do (
  set METH=%%M
  echo method=!METH!

  %IMG7%magick ^
    -size %WT%x%HT% label:!METH! ^
    -trim +repage ^
    -bordercolor White -border 3 ^
    -size %WW%x%HH% xc: ^
    +swap ^
    -gravity South -append +repage ^
    %TXT%

  for /L %%i in (%FOR_ARGS%) do (

    set LZ=000000%%i
    set LZ=!LZ:~-6!

    call %PICTBAT%colCyclStr !METH! %%i

    %IMG7%magick ^
      %INFILE% ^
      !ccsImStr! ^
      %TMPDIR%cct_!LZ!.miff
  )

  %IMG7%magick ^
    -loop 0 ^
    %TXT% ^
    null: ^
    %TMPDIR%cct_*.miff ^
    -gravity North ^
    -layers composite ^
    +repage ^
    -layers optimize ^
    %GIF_PREF%_!METH!.gif

  del %TMPDIR%cct_*.miff

  echo ^<img src="%GIF_PREF%_!METH!.gif" /^> >>%HTM%
)

setlocal DisableDelayedExpansion
echo ^<!--Page-version v1.0 23-Sep-2015--^> >>%HTM%
endlocal

echo Created cct_*.gif and %HTM%

call echoRestore

@endlocal & set pdOUTFILE=%HTM%
