rem From image %1,
rem Nx1 unique map %2,
rem make output:
rem -- single file if %3 does not contain _XX_
rem -- multiple if %3 is template %3 containing _XX_,
rem starting at %4, going down, ending at %5.
@rem
@rem Colour clustering by merge.
@rem
@rem Updated:
@rem   25-September-2022 for IM v7.
@rem   12-November-2022 corrected "-map" to "-remap".
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 cp


set INFILE=%1

set MAP=%2
if "%MAP%"=="." set MAP=

set TMPLT=%3
if "%TMPLT%"=="." set TMPLT=
if "%TMPLT%"=="" set TMPLT=crm__XX_.png

set OUTFILE=%3
if "%OUTFILE%"=="." set OUTFILE=

if "!TMPLT:_XX_=123!" EQU "%TMPLT%" (
  set OUTFILE=%TMPLT%
  set TMPLT=
  echo Outfile [%OUTFILE%]
) else (
  echo Template [%TMPLT%]
  set OUTFILE=
)

set nSTART=%4
if "%nSTART%"=="." set nSTART=
if "%nSTART%"=="" set nSTART=19

set nEND=%5
if "%nEND%"=="." set nEND=
if "%nEND%"=="" set nEND=1

if %nSTART% LSS %nEND% (
  echo %0: nStart %nSTART% LSS nEnd %nEND%
  exit /B 1
)

set /A nSTARTm1=%nSTART%-1

set sDITHER=
set sDITHER=+dither

set TMPMAP=\temp\crm_map.miff

if "%MAP%"=="" (

  %IMG7%magick ^
    %INFILE% ^
    %sDITHER% ^
    -colors %nSTART% ^
    -unique-colors ^
    %TMPMAP%

) else (
  %IMG7%magick %MAP% %TMPMAP%
)

echo TMPLT=%TMPLT%

if not "%TMPLT%"=="" call :SaveFile %nSTART%

%IMG7%magick identify %TMPMAP%

for /L %%I in (%nSTARTm1%,-1,%nEND%) do (
  call %PICTBAT%closestMapMrge %TMPMAP% %TMPMAP% Lab

  if not "%TMPLT%"=="" call :SaveFile %%I
)

%IMG7%magick identify %TMPMAP%

set MNEDGE=

if not "%OUTFILE%"=="" (
  %IMG7%magick ^
    %INFILE% ^
    %sDITHER% ^
    -remap %TMPMAP% ^
    %OUTFILE%

  for /F "usebackq" %%L in (`%IMG7%magick ^
    %INFILE% ^
    %sDITHER% ^
    -remap %TMPMAP% ^
    -edge 1 ^
    -precision 19 ^
    -format "%%[fx:mean]" ^
    info:`) do set MNEDGE=%%L
)

rem     -fill White +opaque Black

echo %0: MNEDGE=%MNEDGE%

call echoRestore

endlocal & set crmMNEDGE=%MNEDGE%

exit /B 0

::--------------------------------------------------
:: Subroutine

:SaveFile

  set FNAME=!TMPLT:_XX_=%1!

  echo FNAME=!FNAME!




  %IMG7%magick ^
    %INFILE% ^
    %sDITHER% ^
    -remap %TMPMAP% ^
    !FNAME!

exit /B 0
