rem Makes ckbkColSp.h1
@rem
@rem Updated:
@rem   25-September-2022 for IM v7.
@rem

set ww=100
set hh=100

setlocal enabledelayedexpansion

set/A wwm1=%ww%-1
set/A hhm1=%hh%-1

"%IMG7%magick" -list colorspace >cs.lis
type cs.lis

rem sRGB is used for the second group of all the color spaces, so create it first.
set colspc=sRGB
call %PICTBAT%oneColSp

rem goto skip
for /F %%a in (cs.lis) do (
  set colspc=%%a
  call %PICTBAT%oneColSp
)
:skip


cEcho /ockbkColsp.h1 /X /s"@%%H1DIR%%snibgoim.inc"
cEcho /OckbkColsp.h1 /X /s"\(h1\)Colorspace cookbook\(/h1\)"
cEcho /OckbkColsp.h1 /X /s"\(p\)ImageMagick can change colorspaces. We can examine the effect of a round-trip from sRGB, to another colorspace, and back, both pictorially and numerically.\(/p\)"

cEcho /OckbkColsp.h1 /X /s"@%%H1DIR%%colspace.txt"

for /F %%a in (cs.lis) do (
  @set colspc=%%a
  @rem cEcho /OckbkColsp.h1 /X /s"\(a name=\q!colspc!\q\)"
  @rem cEcho /OckbkColsp.h1 /X /s"\(h2\)!colspc!\(/h2\)"
  @rem cEcho /OckbkColsp.h1 /X /s"\(/a\)"

  @rem Tidy wants tag "a" inside "h2".
  @cEcho /OckbkColsp.h1 /X /s"\(h2\)\(a name=\q!colspc!\q\)!colspc!\(/a\)\(/h2\)"

  @cEcho /OckbkColsp.h1 /X /s"@%%H1DIR%%!colspc!.txt"
  @cEcho /OckbkColsp.h1 /X /s"\(img class=\qcenter\q src=\q!colspc!.pngjpg\q /\)"
  @cEcho /OckbkColsp.h1 /X /s"\(br /\)"
  @cEcho /OckbkColsp.h1 /X /s"\(img class=\qcenter\q src=\q!colspc!_conv.pngjpg\q /\)"
  @cEcho /OckbkColsp.h1 /X /s"\(br /\)"
)

cEcho /OckbkColsp.h1 /X /s"\(hr /\)"
cEcho /OckbkColsp.h1 /X /s"\(h2\)Numerical round-trip\(/h2\)"

cEcho /OckbkColsp.h1 /X /s"\(p\)We can compare numerical results of each round-trip.\(/p\)"

cEcho /OckbkColsp.h1 /X /s"\(p\)Where the first column is near 1, the round trip is successful.\(/p\)"

cEcho /OckbkColsp.h1 /X /s"\(p\)Round trips for monochrome colorspaces are expected to have a large difference.\(/p\)"

cEcho /OckbkColsp.h1 /X /s"\(code\)\ncall %%PICTBAT%%colSpRndTrip\n\(/code\)\n"
cEcho /OckbkColsp.h1 /X /s"@csrt.htm"

cEcho /OckbkColsp.h1 /X /s"\(hr /\)"
cEcho /OckbkColsp.h1 /X /s"\(h2\)Scripts\(/h2\)"

cEcho /OckbkColsp.h1 /X /s"\(p\)The following Windows bat scripts generated this page:\(/p\)"

cEcho /OckbkColsp.h1 /X /s"\(h3\)colSpace.bat\(/h3\)"
cEcho /OckbkColsp.h1 /X /s"\(pre\)"
cEcho /OckbkColsp.h1 /X /s"@%%PICTBAT%%colSpace.bat"
cEcho /OckbkColsp.h1 /X /s"\(/pre\)"

cEcho /OckbkColsp.h1 /X /s"\(h3\)oneColSp.bat\(/h3\)"
cEcho /OckbkColsp.h1 /X /s"\(pre\)"
cEcho /OckbkColsp.h1 /X /s"@%%PICTBAT%%oneColSp.bat"
cEcho /OckbkColsp.h1 /X /s"\(/pre\)"

cEcho /OckbkColsp.h1 /X /s"\(h3\)colSpRndTrip.bat\(/h3\)"
cEcho /OckbkColsp.h1 /X /s"\(pre\)"
cEcho /OckbkColsp.h1 /X /s"@%%PICTBAT%%colSpRndTrip.bat"
cEcho /OckbkColsp.h1 /X /s"\(/pre\)"

cEcho /OckbkColsp.h1 /X /s"\(hr /\)"

cEcho /OckbkColsp.h1 /X /f\r /s"\(p\)To create this page, run \(tt\)"
cEcho /OckbkColsp.h1    /f\r /s"%%PICTBAT%%colSpace.bat"
cEcho /OckbkColsp.h1 /X      /s"\(/tt\) to create the images and ckbkColSp.h1, then \(tt\)procH1 ckbkColSp\(/tt\).\(/p\)"

"%IMG7%magick" -version>imversion.txt
cEcho /OckbkColsp.h1 /X /s"\(p\)Images and data on this page were created using:\(/p\)"
cEcho /OckbkColsp.h1 /X /s"\(pre\)"
cEcho /OckbkColsp.h1 /X /s"@imversion.txt"
cEcho /OckbkColsp.h1 /X /s"\(/pre\)"

cEcho /OckbkColsp.h1 /X /s"@%%H1DIR%%snibgocr.inc"

cEcho /OckbkColsp.h1 /X /s"\(^!--Page-version v1.1 20-Feb-2014--\)"
cEcho /OckbkColsp.h1 /X /s"\(^!--Trailer-img sRGB.png --\)"

rem call %PICTBAT%cookbook.bat

endlocal
