rem From %1, a Bayer mosaic image,
rem colours each pixel with red, green or blue.
rem %2 %3 %4 and %5 are multipliers for R G0 G1 and B channels.
rem %6 is optional output file.
@rem
@rem Assumes Bayer patern is:
@rem   R  G0
@rem   G1 B
@rem
@rem Updated:
@rem   28-July-2022 for IM 7.

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 clm

if not "%6"=="" if not "%7"=="." set OUTFILE=%6


for /F "usebackq" %%L ^
in (`%IMG7%magick identify -format "WW=%%w\nHH=%%h" %INFILE%`) ^
do set /A %%L

%IMG7%magick ^
  ( xc:red  xc:lime +append +repage ) ^
  ( xc:lime xc:blue +append +repage ) ^
  -append +repage ^
  -write mpr:BAYER +delete ^
  -size %WW%x%HH% ^
  tile:mpr:BAYER ^
  %INFILE% ^
  -compose Multiply -composite ^
  %OUTFILE%

call echoRestore

endlocal & set clmOUTFILE=%OUTFILE%
