rem Speeds of writing compressed outputs.

@rem %1 is input image file.
@rem %2 is prefix for output data files.
@rem %3 is output sufix, eg png, tiff, jpg.
@rem %4 is number of times to execute command [default 1].
@rem %5 is output summary list.


set INFILE=%1

set OUT_PREFIX=%2
if "%OUT_PREFIX%"=="" set OUT_PREFIX=ts

set EXT=%3
if "%EXT%"=="" set EXT=tiff

set N_TIMES=%4
if "%N_TIMES%"=="" set N_TIMES=1

set BASE_CMD=%IM%convert %INFILE% -quiet

set DATA_EXT=%EXT%
if /i "%DATA_EXT%"=="mpc" set DATA_EXT=cache

set OUTFILE=%OUT_PREFIX%_cs.%EXT%
set DATAFILE=%OUT_PREFIX%_cs.%DATA_EXT%

set SUM_LIST=
if not "%5"=="" set SUM_LIST=%5


for /F "usebackq" %%B in (`timecc ^
  /n%N_TIMES% /f"\t" ^
  /c"%BASE_CMD% -compress None NULL:"`) do set BASE_TIME=%%B

echo BASE_TIME=%BASE_TIME%

echo -compress,Seconds,Compression %%,Difference >%OUT_PREFIX%.csv

rem FIXME: also do one with no "-compress" setting.

for /F "usebackq" %%C in (`%IM%convert -list compress`) do (
  echo %%C

  del %OUTFILE% 2>nul

  rem timecc ^
  rem   /n%N_TIMES% /f"%%C,\t," ^
  rem   /O%OUT_PREFIX%.csv /b%BASE_TIME% ^
  rem   /c"%BASE_CMD% -compress %%C %OUTFILE%"

  for /F "usebackq" %%T in (`timecc ^
    /n%N_TIMES% /f"\t" ^
    /o- /b%BASE_TIME% ^
    /c"%BASE_CMD% -compress %%C %OUTFILE%"`) do set TIME=%%T

  if exist %OUTFILE% (

    for /F "usebackq tokens=2 delims=() " %%D in (`%IM%compare ^
      -quiet -metric RMSE %INFILE% %OUTFILE% NULL: 2^>^&1`) do set DIFF=%%D

    for /F "usebackq" %%B in (`stat --printf=%%s %DATAFILE%`) do set BYTES=%%B
    echo BYTES=%BYTES%

    for /F "usebackq" %%C in (`%IM%identify ^
      -ping ^
      -format "%%[fx:int(!BYTES!*100/w/h/6*100+0.5)/100]" ^
      %OUTFILE%`) do set COMPR=%%C

    cEcho /O%OUT_PREFIX%.csv /X /s"%%C,!TIME!s,!COMPR!%%,!DIFF!"

    if not "%SUM_LIST%"=="" if /I "%%C"=="None" cEcho /O%SUM_LIST% /s"%EXT%,-compress None,!TIME!,!COMPR!,!DIFF!"

  ) else (
    echo No output file >>%OUT_PREFIX%.csv
  )
)

del %OUTFILE% 2>nul
del %DATAFILE% 2>nul

type %OUT_PREFIX%.csv

call csv2tab %OUT_PREFIX%
