rem Compress the dynamic range of L channel of Lab and expand detail.
rem Uses guided filter as base image. Both base and detail can be processed.

rem %1 input, assumed sRGB.
rem %2 output, sRGB.
rem %3 quoted parameters for guided filter [". 19x19 . 4"]
rem %4 quoted IM processing for base eg "+sigmoidal-contrast 5,50%%"
rem %5 quoted IM processing for detail eg "-evaluate Multiply 2.0"
@rem
@rem Note: This uses "-colorspace Lab".
@rem
@rem Also uses:
@rem   COMPRL_DBG format for debug files. Must contain _XX_, or be blank.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 compl

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set PROC_GDEFILT=%~3
if "%PROC_GDEFILT%"=="." set PROC_GDEFILT=
if "%PROC_GDEFILT%"=="" set PROC_GDEFILT=. 19x19 . 4

set PROC_BASE=%~4
if "%PROC_BASE%"=="." set PROC_BASE=

set PROC_DETL=%~5
if "%PROC_DETL%"=="." set PROC_DETL=

set TMPDIR=\temp\
set TMPDIR=
set TMPPREF=%TMPDIR%compl
set TMPEXT=miff

if "%COMPRL_DBG%"=="" (
  set WR_DETL=
  set WR_BASE_MOD=
  set WR_DETL_MOD=
  set WR_OUT=
) else (
  set WR_DETL=+write %COMPRL_DBG:_XX_=_detl_%
  set WR_BASE_MOD=+write %COMPRL_DBG:_XX_=_base_mod_%
  set WR_DETL_MOD=+write %COMPRL_DBG:_XX_=_detl_mod_%
  set WR_OUT=+write %COMPRL_DBG:_XX_=_out_%
)



%IMG7%magick ^
  %INFILE% ^
  -colorspace Lab -separate ^
  -define quantum:format=floating-point -depth 32 ^
  +adjoin ^
  %TMPPREF%_lab.%TMPEXT%

::--- call compressOne

call %PICTBAT%compressOne ^
  %TMPPREF%_lab-0.%TMPEXT% %INFILE% ^
  %TMPPREF%_src_mod.%TMPEXT% ^
  "%PROC_GDEFILT%" ^
  "%PROC_BASE%" ^
  "%PROC_DETL%"

goto skipOld

call %PICTBAT%guideFilt ^
  %TMPPREF%_lab-0.%TMPEXT% %INFILE% ^
  %TMPPREF%_base.%TMPEXT% ^
  . %PROC_GDEFILT%


rem Make detail, process base, process detail, and add modified base and detail.

:: How do we execute external command eg a PowLinPow curve?
:: Answer: create the clut before this script, and set PROC_BASE to "-clut clutfile.ext".

%IMG7%magick ^
  %TMPPREF%_lab-0.%TMPEXT% ^
  ( %TMPPREF%_base.%TMPEXT% -colorspace Gray +write mpr:BASE ) ^
  -define compose:clamp=off ^
  -compose MinusSrc -composite ^
  -define quantum:format=floating-point -depth 32 ^
  +write mpr:DETL ^
  %WR_DETL% ^
  +delete ^
  mpr:BASE ^
  %PROC_BASE% ^
  %WR_BASE_MOD% ^
  ( mpr:DETL ^
    %PROC_DETL% ^
    %WR_DETL_MOD% ^
  ) ^
  -compose Plus -composite ^
  %TMPPREF%_src_mod.%TMPEXT%

::-- end compressOne

:skipOld

:: Combine L*, a* and b*. Then oogbox in sRGB.
%IM7DEV%magick ^
  %TMPPREF%_src_mod.%TMPEXT% ^
  %TMPPREF%_lab-1.%TMPEXT% %TMPPREF%_lab-2.%TMPEXT% ^
  -combine ^
  -set colorspace Lab -colorspace sRGB ^
  -process oogbox ^
  %OUTFILE%

call echoRestore

@endlocal & set complOUTFILE=%OUTFILE%
