typedef enum {
  cwrSuccess,
  cwrGetCache,
  cwrEquCoord,
  cwrSubAllTrans,
  cwrCentTrans,
  cwrRefTrans,
  cwrNoOpaq,
  cwrOutside
} cwReasonT;

// Compares window in sub_view with windows in ref_view.
// Treatment of alpha is not symmetrical,
// so sub and ref are _not_ interchangable.

typedef struct {
  Image
    *ref_image,
    *sub_image;

  CacheView
    *ref_view,  // These can be views ...
    *sub_view;  //   ... of the same image

  ssize_t
    win_wi,
    win_ht,
    refX,  // Top-left corner of ...
    refY,  //   ... window in ref_view
    subX,  // Top-left corner of ...
    subY;  //   ... window in sub_view

  double
    WorstCompare,  //  Some large number
    HomChk;

  MagickBooleanType
    HomChkOn,
    AllowEquCoord;

  // Returns:
  cwReasonT
    Reason;

  ssize_t
    nCompares;

} CompWindT;


