rem Given image %1,
rem writes environment variable cccwCROP
rem as the bounding box WxH+X+Y of the
rem largest white connected component.
rem Also sets CW, CH, CX and CY.
@rem
@rem Updated:
@rem   25-September-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 cccw

if "%cccwAREA_TH%"=="" set cccwAREA_TH=2

echo %0: cccwAREA_TH=%cccwAREA_TH%

set CROP=
set CW=

for /F "usebackq skip=1 tokens=2,5" %%A in (`%IMG7%magick ^
  %INFILE% ^
  -alpha off ^
  -define connected-components:verbose^=true ^
  -define connected-components:area-threshold^=%cccwAREA_TH% ^
  -connected-components 8 ^
  NULL:`) do (
  if "!CROP!"=="" (
    set IsWhite=0
    if "%%B"=="srgb(100%%,100%%,100%%)" set IsWhite=1
    if "%%B"=="srgb(255,255,255)" set IsWhite=1
    if "%%B"=="gray(255)" set IsWhite=1
    if !IsWhite!==1 (
      set CROP=%%A
    )
  )
)

if "%CROP%"=="" (
  echo %0: No white components found in %INFILE%.
  exit /B 1
)

for /F "tokens=1-4 delims=+x" %%A in ("%CROP%") do (
  set CW=%%A
  set CH=%%B
  set CX=%%C
  set CY=%%D
  set AREA=%%A*%%B
)

echo %0: CROP=%CROP%  %CW% %CH% %CX% %CY%

call echoRestore

@endlocal & set cccwCROP=CROP& set CW=%CW%& set CH=%CH%& set CX=%CX%& set CY=%CY%
