rem Given image %1,
rem makes %2
rem from connected components that are at least %3 pixels.
@rem   %3 may have suffix 'c' or '%' for percentage or 'p' for proportion of image w*h.
@rem   Default 0.
@rem
@rem Each output connected component is the mean of its input pixels.
@rem
@rem Updated:
@rem   24-July-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 ccla

if not "%2"=="" if not "%2"=="." set OUTFILE=%2


set THRESH=%3
if "%THRESH%"=="." set THRESH=
if "%THRESH%"=="" set THRESH=0


set TH_LAST=%THRESH:~-1%

if "%TH_LAST%"=="^%" set TH_LAST=c

if /I "%TH_LAST%"=="c" (

  for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -format "nTHRESH=%%[fx:w*h*%THRESH:~0,-1%/100]" ^
    %INFILE%`) do set %%L

) else if /I "%TH_LAST%"=="p" (

  for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -format "nTHRESH=%%[fx:w*h*%THRESH:~0,-1%]" ^
    %INFILE%`) do set %%L

) else (
  set nTHRESH=%THRESH%
)

if %nTHRESH%==0 (
  set sTHRESH=
) else (
  set "sTHRESH=-define connected-components:area-threshold^=%nTHRESH%"
)


%IMG7%magick ^
  %INFILE% ^
  -define connected-components:verbose^=true ^
  -define connected-components:mean-color=true ^
  %sTHRESH% ^
  -connected-components 4 ^
  %OUTFILE%


call echoRestore

@endlocal & set cclaOUTFILE=%OUTFILE%
