rem Given image %1,
rem makes %2
rem from the largest %3 connected components.
@rem
@rem For performance, use the output from connCompLimitArea.bat
@rem to reduce the number of components this script considers.
@rem (or add area parameter to this script?)
@rem
@rem When an eliminated component is adjacent to more than one other component,
@rem   it may merge with the "wrong" one.
@rem
@rem Each output connected component is the mean of its input pixels.
@rem
@rem Updated:
@rem   24-July-2022 for IM v7.
@rem   29-July-2022 Bug in "-connected-components" hinders merging. "-virtual-pixel None" may help.
@rem     Also repeating "-connected-components" with rotated image.
@rem     (See https://github.com/ImageMagick/ImageMagick/issues/5368 )
@rem


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

rem @call echoOffSave

call %PICTBAT%setInOut %1 ccln

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set NUM=%3
if "%NUM%"=="." set NUM=
if "%NUM%"=="" set NUM=1

set N_CONNECT=8
set N_CONNECT=4

goto skip1

%IMG7%magick ^
  %INFILE% ^
  -define connected-components:verbose^=true ^
  -connected-components %N_CONNECT% ^
  NULL:

:skip1

set sKEEP=
set CNT=1
set LIM_AREA=0
set nTHRESH=
for /F "usebackq skip=1 tokens=4" %%A in (`%IMG7%magick ^
  %INFILE% ^
  -define connected-components:verbose^=true ^
  -connected-components %N_CONNECT% ^
  NULL:`) do (
  rem echo %%A
  if !CNT!==%NUM% set nTHRESH=%%A
  set /A CNT+=1
)

echo %0: nTHRESH=%nTHRESH%

if "%nTHRESH%"=="" (
  echo %0: Found CNT=%CNT%, not NUM=%NUM%
  exit /B 1
)

%IMG7%magick ^
  %INFILE% ^
  -virtual-pixel None ^
  -define connected-components:verbose=true ^
  -define connected-components:mean-color=true ^
  -define connected-components:area-threshold=%nTHRESH% ^
  -connected-components %N_CONNECT% ^
  -rotate 180 ^
  -connected-components %N_CONNECT% ^
  -rotate -180 ^
  %OUTFILE%

goto end


set sKEEP=
set CNT=1
set LIM_AREA=0
for /F "usebackq skip=1 tokens=1 delims=: " %%A in (`%IMG7%magick ^
  %INFILE% ^
  -define connected-components:verbose^=true ^
  -connected-components %N_CONNECT% ^
  NULL:`) do (
  rem echo %%A
  if !CNT! LEQ %NUM% set sKEEP=!sKEEP!,%%A
  set /A CNT+=1
)

echo sKEEP=%sKEEP%

rem Remove initial comma
set sKEEP=%sKEEP:~1%

echo sKEEP=%sKEEP%


:: FIXME: No, this makes the others transparent!!
:: We need to find the limiting area.

set UNIQ=\temp\ccln_uniq.png

%IMG7%magick ^
  %INFILE% ^
  -define connected-components:verbose^=true ^
  -define connected-components:keep=%sKEEP% ^
  -define connected-components:mean-color=true ^
  -connected-components %N_CONNECT% ^
  -unique-colors ^
  %UNIQ%

%IMG7%magick identify %UNIQ%

:end

call echoRestore

@endlocal & set cclnOUTFILE=%OUTFILE%
