rem From image %1,
rem makes output %2
rem blurred parallel to contours then sharpened perpendicular to contours.
rem %3 edge detector sigma
rem %4 blur sigma
rem %5 unsharp sigma
rem %6 percentage extrapolate for unsharp (100=no effect)
@rem
@rem Updated:
@rem   22-July-2022 Upgraded for IM v7.
@rem


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

rem @call echoOffSave

call %PICTBAT%setInOut %1 cbs

if not "%2"=="" if not "%2"=="." set OUTFILE=%2


set EDGE_SIG=%3
if "%EDGE_SIG%"=="." set EDGE_SIG=
if "%EDGE_SIG%"=="" set EDGE_SIG=10

set BLUR_SIG=%4
if "%BLUR_SIG%"=="." set BLUR_SIG=
if "%BLUR_SIG%"=="" set /A BLUR_SIG=%EDGE_SIG%/2

set UNSH_SIG=%5
if "%UNSH_SIG%"=="." set UNSH_SIG=
if "%UNSH_SIG%"=="" set /A UNSH_SIG=%BLUR_SIG%

set EXTR_PC=%6
if "%EXTR_PC%"=="." set EXTR_PC=
if "%EXTR_PC%"=="" set EXTR_PC=150

set TMPDIR=\temp\
set TMPGRAY=%TMPDIR%cbs_gray.miff
set TMPSLOPE=%TMPDIR%cbs_gray_slp.miff
rem set TMPMAG=%TMPDIR%cbs_gray_mag.miff

%IMG7%magick ^
  %INFILE% ^
  -colorspace Gray ^
  %TMPGRAY%

call %PICTBAT%slopeXYbl ^
  %TMPGRAY% %TMPGRAY% %EDGE_SIG%

call %PICTBAT%slopeXYdirn ^
  %TMPGRAY% %TMPSLOPE% ^
  SWAP . 75

rem call %PICTBAT%slopeXYmag ^
rem   %TMPGRAY% %TMPMAG%

%IMG7%magick ^
  %TMPSLOPE% ^
  ( +clone -fill White -colorize 100 ) ^
  ( +clone ) ^
  -swap 0,2 ^
  -combine ^
  %TMPSLOPE%

%IMG7%magick ^
  %INFILE% ^
  %TMPSLOPE% +write mpr:MASK ^
  -compose Blur ^
  -set option:compose:args %BLUR_SIG%x0+0+360 ^
  -composite ^
  ( +clone ^
    mpr:MASK ^
    -compose Blur ^
    -set option:compose:args 0x%UNSH_SIG%+0+360 ^
    -composite ^
  ) ^
  +swap ^
  -compose blend ^
    -define compose:args=%EXTR_PC% ^
  -composite ^
  %OUTFILE%


call echoRestore

@endlocal & set cbsOUTFILE=%OUTFILE%
