rem From %1, the text output from "-verbose" triangulate,
rem makes %2_l.png, %2_t.png and %2_c.png
rem showing lines, triangles and convex hull.
@rem
@rem Updated:
@rem   27-August-2022 for IM v7.
@rem

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

rem @call echoOffSave


set INLIS=%1

set OUTBASE=%2
if "%OUTBASE%"=="" set OUTBASE=data

set OUTLINES=%OUTBASE%_l.png
set OUTEDGES=%OUTBASE%_e.png
set OUTTRI=%OUTBASE%_t.png
set OUTCONV=%OUTBASE%_c.png

rem type %INLIS%

set WW=
for /F "tokens=2,3 usebackq delims=:, " %%A in (`cGrep /p0 /i%INLIS% /sMaxCoord:*`) do (
  rem set /A WW=1+%%A
  rem set /A HH=1+%%B

  for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -format "WW=%%[fx:int(%%A+20)]\nHH=%%[fx:int(%%B+20)]" ^
    xc:`) do set %%L
)
if "%WW%"=="" (
  echo %0: WW not set. Not "-verbose" output? stderr not captured?
  exit /B 1
)

echo WW=%WW% HH=%HH%

set /A PNTSIZE=%WW%/60
if %PNTSIZE% LSS 20 set PNTSIZE=20
set /A H_MARG=%PNTSIZE%*3/2
set /A V_MARG=%PNTSIZE%*3/4

set /A Wm=%WW%-%H_MARG%
set /A Hm=%HH%-%V_MARG%

cGrep /i%INLIS% /opoints.txt /s"point:"

:: points2.txt isn't used
(for /F "tokens=2,3 usebackq delims=:, " %%A in (`cGrep /p0 /i%INLIS% /s*point:*`) do @(
  @rem @set /A newY=50+%%B

  @for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -format "newY=%%[fx:%%B+50]" ^
    xc:`) do @set %%L

  @echo circle %%A,%%B,%%A,!newY!
)) >points2.txt

(for /F "tokens=2-4 usebackq delims=:,# " %%A in (`cGrep /p0 /i%INLIS% /s*point:*`) do @(
  @rem @set /A x=%%A
  @rem @set /A y=%%B

  @for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -format "x=%%[fx:int(%%A)]\ny=%%[fx:int(%%B)]" ^
    xc:`) do @set %%L

  @if !x! GTR %Wm% set /A x=!x!-%H_MARG%
  @if !y! LSS %V_MARG% set /A y=%V_MARG%
  @echo text !x!,!y! "%%C"
)) >pointsNum.txt

(for /F "tokens=2-6 usebackq delims=:,# " %%A in (`cGrep /p0 /i%INLIS% /s*edge:*`) do @(
  @rem @set /A x=^(%%A+%%C^)/2
  @rem @set /A y=^(%%B+%%D^)/2
  @rem @set /A x=%%A/2+%%C/2
  @rem @set /A y=%%B/2+%%D/2

  @for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -format "x=%%[fx:int((%%A+%%C)/2)]\ny=%%[fx:int((%%B+%%D)/2)]" ^
    xc:`) do @set %%L

  @if !x! GTR %Wm% set /A x=!x!-%H_MARG%
  @if !y! LSS %V_MARG% set /A y=%V_MARG%
  @echo text !x!,!y! "%%E"
)) >edgeNum.txt

(for /F "tokens=2-7 usebackq delims=:,# " %%A in (`cGrep /p0 /i%INLIS% /s*triangle:*`) do @(
  @echo polygon %%A,%%B %%C,%%D %%E,%%F
)) >tri.txt

set count=0
(for /F "tokens=2-7 usebackq delims=:,# " %%A in (`cGrep /p0 /i%INLIS% /s*triangle:*`) do @(
  @rem @set /A x=^(%%A+%%C+%%E^)/3
  @rem @set /A y=^(%%B+%%D+%%F^)/3
  @rem @set /A x=%%A/3+%%C/3+%%E/3
  @rem @set /A y=%%B/3+%%D/3+%%F/3

  @for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -format "x=%%[fx:int((%%A+%%C+%%E)/3)]\ny=%%[fx:int((%%B+%%D+%%F)/3)]" ^
    xc:`) do @set %%L

  @if !x! GTR %Wm% set /A x=!x!-%H_MARG%
  @if !y! LSS %V_MARG% set /A y=%V_MARG%
  @echo text !x!,!y! "!count!"
  @set /A count+=1
)) >triNum.txt

chStrs  /p0 /ipoints.txt /f"  point: "     /t"\0"
chStrs  /p0 /ipoints.txt /f" "     /t","
cPrefix /p0 /ipoints.txt /l"translate " /r" circle 0,0 0,20"

rem type points.txt
rem type points2.txt

cGrep  /p0 /i%INLIS% /olines.txt /s"edge:"
chStrs /p0 /ilines.txt /f"edge:"     /t"line"

%IMG7%magick ^
  -size %WW%x%HH% xc:None ^
  -stroke #000 -fill None ^
  -draw "@lines.txt" ^
  -pointsize %PNTSIZE% -fill #a00 -stroke None ^
  -undercolor rgba(100%%,100%%,100%%,0.5) ^
  -draw "@pointsNum.txt" ^
  -fill #00f ^
  -draw "@edgeNum.txt" ^
  -fill #080 ^
  -draw "@triNum.txt" ^
  %OUTLINES%

%IMG7%magick ^
  -size %WW%x%HH% xc:None ^
  -stroke #000 -fill None ^
  -draw "@lines.txt" ^
  -pointsize %PNTSIZE% -fill #a00 -stroke None ^
  -undercolor rgba(100%%,100%%,100%%,0.5) ^
  -fill #00f ^
  -draw "@edgeNum.txt" ^
  %OUTEDGES%

%IMG7%magick ^
  -size %WW%x%HH% xc: ^
  -fill rgba(75%%,75%%,100%%,0.5) ^
  -draw "@tri.txt" ^
  -stroke #000 -fill None ^
  -draw "@lines.txt" ^
  -pointsize %PNTSIZE% -stroke None ^
  -fill #080 ^
  -draw "@triNum.txt" ^
  %OUTTRI%

%IMG7%magick ^
  -size %WW%x%HH% xc:#000 ^
  -fill #fff ^
  -draw "@tri.txt" ^
  -pointsize %PNTSIZE% -fill #f80 -stroke None ^
  -draw "@pointsNum.txt" ^
  %OUTCONV%

call echoRestore

@endlocal
