rem Like cropToDetailSml.bat, but for large images.
@rem
@rem Updated:
@rem   25-September-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

echo %0: %1 %2 %3 %4 %5
echo %0: ctdBLR_SIG=%ctdBLR_SIG% ctdUSE_CONN_COMP=%ctdUSE_CONN_COMP% ctdDO_RECURSE=%ctdDO_RECURSE%

call %PICTBAT%setInOut %1 ctdl

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set DIMS=%3
if "%DIMS%"=="." set DIMS=
if "%DIMS%"=="" set DIMS=0x0

set FORCE_TH=%4
if "%FORCE_TH%"=="." set FORCE_TH=


set LIM_W=600
set LIM_H=600

set WW=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "WW=%%w\nHH=%%h\n" ^
  %INFILE%`) do set %%L
if "%WW%"=="" exit /B 1

call parseXxY2i %WW% %HH% DIMS %DIMS%

set R_WI=%DIMS_X%
set R_HT=%DIMS_Y%

if not "%R_WI%"=="0" (
  if %R_WI% GTR %WW% set R_WI=%WW%
)

if not "%R_HT%"=="0" (
  if %R_HT% GTR %HH% set R_HT=%HH%
)

echo %0: WW=%WW% HH=%HH% req:%R_WI%x%R_HT% ctdBLR_SIG=%ctdBLR_SIG% ctdUSE_CONN_COMP=%ctdUSE_CONN_COMP% ctdDO_RECURSE=%ctdDO_RECURSE% DIAG_FACT=%DIAG_FACT% FORCE_TH=%FORCE_TH%

if %WW% LEQ %LIM_W% if %HH% LEQ %LIM_H% (
  call %PICTBAT%cropToDetailSml %INFILE% %OUTFILE% %DIMS% %FORCE_TH%
  if ERRORLEVEL 1 exit /B 1

  set CROP4=!ctdCROP!
  set SCORE=!ctdSCORE!

  goto end
)


set TMPDIR=\temp\
set SML_IMG=%TMPDIR%ctdl_sml.miff

set sFMT=^
MULT_W=%%[fx:%WW%/w]\n^
MULT_H=%%[fx:%HH%/h]\n^
RW=%%[fx:int(%R_HT%*w/%WW%+0.5)]\n^
RH=%%[fx:int(%R_HT%*h/%HH%+0.5)]\n

set RW=
for /F "usebackq" %%L in (`%IMG7%magick ^
  %INFILE% ^
  -resize %LIM_W%x%LIM_H% ^
  +write %SML_IMG% ^
  -precision 9 ^
  -format "%sFMT%" ^
  info:`) do set %%L
if "%RW%"=="" exit /B 1


call %PICTBAT%cropToDetailSml %SML_IMG% null: %RW%x%RH% %FORCE_TH%
if ERRORLEVEL 1 exit /B 1

echo %0: ctdCROP=%ctdCROP%
set SCORE=!ctdSCORE!

set sFMT=
for /F "tokens=1-4 delims=+x" %%A in ("%ctdCROP%") do set sFMT=^
FW=%%[fx:int(%%A*%MULT_W%+0.5)]\n^
FH=%%[fx:int(%%B*%MULT_H%+0.5)]\n^
FX=%%[fx:int(%%C*%MULT_W%+0.5)]\n^
FY=%%[fx:int(%%D*%MULT_H%+0.5)]\n

if "%sFMT%"=="" exit /B 1

set FW=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 16 ^
  -format "%sFMT%" ^
  xc:`) do set %%L
if "%FW%"=="" exit /B 1

if %FW%==0 set FW=1
if %FH%==0 set FH=1

rem If this script was called with explicit W and H, use those.
rem
if not "%R_WI%"=="0" set FW=%R_WI%
if not "%R_HT%"=="0" set FH=%R_HT%

set CROP4=%FW%x%FH%+%FX%+%FY%

echo %0: CROP4 = %CROP4%

if /I "%OUTFILE%" NEQ "null:" %IMG7%magick ^
  %INFILE% ^
  -crop %CROP4% +repage ^
  %OUTFILE%

:end

@call echoRestore

@endlocal & set ctdlOUTFILE=%OUTFILE%& set ctdlSCORE=%SCORE%& set ctdlCROP=%CROP4%

@exit /B 0
