rem %1 Prefix for input fwd and bwd lists.
rem %2 Quoted list of features to align, separated by commas or spaces.
rem %3 NxN: Percentage movements in X and Y [default 100x100].
rem %4 Distortion method (affine, perspective, shepards etc).
rem %5 Quoted list of coefficients to nullify.
rem %6 Feature to align for sxd and syd.


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

set InPref=%1

call %PICTBAT%chainRdEnv %InPref%
if ERRORLEVEL 1 exit /B 1

call %PICTBAT%csaChkVars %InPref%
if ERRORLEVEL 1 exit /B 1

set FEAT_LIST=%~2
if "%FEAT_LIST%"=="." set FEAT_LIST=
if "%FEAT_LIST%"=="" for /L %%I in (0,1,!%cnfPref%.NumFeatM1!) do set FEAT_LIST=!FEAT_LIST! %%I

set MOVE=%3
if "%MOVE%"=="" set MOVE=.
call parseXxY 100 100 %MOVE% MOVE_PC

set MOVE_PC

set MTHD=%4
if "%MTHD%"=="." set MTHD=
if "%MTHD%"=="" set MTHD=perspective

set NULLIFY=%~5
echo NULIFY is [%NULLIFY%]
if "%NULLIFY%"=="." set NULLIFY=

set SD_FEAT=%~6
if "%SD_FEAT%"=="." set SD_FEAT=
echo SD_FEAT is [%SD_FEAT%]

call :OneDirn fwd
if ERRORLEVEL 1 exit /B 1

call :OneDirn bwd
if ERRORLEVEL 1 exit /B 1

call echoRestore

@endlocal

@exit /B 0

::------------------------------------------------------
:: Subroutines

:OneDirn
set DIRN=%1

call readArray %InPref%_%DIRN%.lis InImgs
if ERRORLEVEL 1 exit /B 1

:: InCoords[a][b][c] where:
::   a is feature, b is image, c is 0 for X or 1 for Y.

for /L %%J in (0,1,!%cnfPref%.NumFeatM1!) do (
  call readArrayXY %InPref%_coords_f%%J_%DIRN%.lis InCoords[%%J]
  if ERRORLEVEL 1 exit /B 1
  if !InCoords[%%J]_CNT! NEQ %InImgs_CNT% (
    echo %0: Bad %InPref%_coords_f%%J_%DIRN%.lis
    exit /B 1
  )
)

call %PICTBAT%csaCalcPseudoFeat %SD_FEAT%
if ERRORLEVEL 1 exit /B 1

if "%SD_FEAT%"=="" (
  set SXD_X=0
  set SYD_Y=0
) else (
  set SXD_X=!InCoords[%SD_FEAT%][0][X]!
  set SYD_Y=!InCoords[%SD_FEAT%][0][Y]!
)

if "%SXD_X%"=="" (
  echo SXD_X bad
  exit /B 1
)
if "%SYD_Y%"=="" (
  echo SXD_Y bad
  exit /B 1
)

set FIRSTIMG=0
if %DIRN%==bwd set FIRSTIMG=1

for /L %%I in (%FIRSTIMG%,1,%InImgs_CNTm1%) do (
  for /F %%F in ("!InImgs[%%I]!") do (
    set OUTFILE=!%cnfPref%.OutFrames!%%~nF.!%cnfPref%.OutExt!
  )

  if %%I==0 (
    %IMG7%magick ^
      !%cnfPref%.InFrames!!InImgs[0]!.!%cnfPref%.InExt! ^
      !%cnfPref%.FramePreProc! ^
      -virtual-pixel None ^
      -distort AffineProjection 1,0,0,1,0,0 ^
      !%cnfPref%.FramePostProc! ^
      !OUTFILE!
  ) else (

    set SRCS=
    for %%J in (%FEAT_LIST%) do (

      set AX=!InCoords[%%J][0][X]!
      set AY=!InCoords[%%J][0][Y]!

      set X=!InCoords[%%J][%%I][X]!
      set Y=!InCoords[%%J][%%I][Y]!

      if not !X!==missing if not !Y!==missing (
        set NewX=
        set NewY=
        for /F "usebackq" %%L in (`%IMG7%magick identify ^
          -precision 16 ^
          -format "NewX=%%[fx:!X!+^(!AX!-!X!^)*%MOVE_PC_X%/100]\nNewY=%%[fx:!Y!+^(!AY!-!Y!^)*%MOVE_PC_Y%/100]\n" ^
          xc:`) do set %%L
        if "!NewX!"=="" exit /B 1
        if "!NewY!"=="" exit /B 1
        set SRCS=!SRCS! !X!,!Y!,!NewX!,!NewY!
      )
    )
    if ERRORLEVEL 1 exit /B 1

    echo %1: Writing !OUTFILE!

    if "%NULLIFY%"=="" (
      %IMG7%magick ^
        !%cnfPref%.InFrames!!InImgs[%%I]!.!%cnfPref%.InExt! ^
        !%cnfPref%.FramePreProc! ^
        -virtual-pixel None ^
        -distort %MTHD% "!SRCS!" ^
        !%cnfPref%.FramePostProc! ^
        !OUTFILE!
    ) else (
      call %PICTBAT%alignPntSrt ^
        !%cnfPref%.InFrames!!InImgs[%%I]!.!%cnfPref%.InExt! ^
        !OUTFILE! "!SRCS!" %MTHD% "%NULLIFY%" !SXD_X!x!SYD_Y!
    )
  )
)
if ERRORLEVEL 1 exit /B 1

exit /B 0

