rem Assumes FEAT_LIST (not quote), cnfPref, InImgs array, {prefix}.NumFeatM1, InCoords array are correct.

set ccpfNeedCentroid=0
set ccpfNeedMin=0
set ccpfNeedMax=0
set ccpfNeedAll=0

if ERRORLEVEL 1 exit /B 1

set EXTRA=%~1
if "%EXTRA%"=="" set EXTRA=

call :FindNeeds "%FEAT_LIST%"
if ERRORLEVEL 1 exit /B 1

if not "%EXTRA%"=="" (
  echo %0: extra needs [%EXTRA%]
  call :FindNeeds "%EXTRA%"
  if ERRORLEVEL 1 exit /B 1
)

rem echo %0: Needs %ccpfNeedCentroid% %ccpfNeedMin% %ccpfNeedMax%

if %ccpfNeedCentroid%==1 (
  for /L %%I in (0,1,%InImgs_CNTm1%) do (
    set ccpfSumX=0
    set ccpfSumY=0
    set ccpfNUM_X=0
    set ccpfNUM_Y=0
    for /L %%J in (0,1,!%cnfPref%.NumFeatM1!) do (
      if not !InCoords[%%J][%%I][X]!==missing (
        set /A ccpfSumX+=!InCoords[%%J][%%I][X]!
        set /A ccpfNUM_X+=1
      )
      if not !InCoords[%%J][%%I][Y]!==missing (
        set /A ccpfSumY+=!InCoords[%%J][%%I][Y]!
        set /A ccpfNUM_Y+=1
      )
    )
    rem set /A InCoords[Centroid][%%I][X]=!ccpfSumX!/!ccpfNUM_X!
    rem set /A InCoords[Centroid][%%I][Y]=!ccpfSumY!/!ccpfNUM_Y!

    set /A InCoords[Centroid][%%I][X]=0
    set /A InCoords[Centroid][%%I][Y]=0

    set FMT=^
InCoords[Centroid][%%I][X]=%%[fx:!ccpfSumX!/!ccpfNUM_X!]\n^
InCoords[Centroid][%%I][Y]=%%[fx:!ccpfSumY!/!ccpfNUM_Y!]\n

    for /F "usebackq" %%L in (`%IMG7%magick identify ^
      -precision 16 ^
      -format "!FMT!" ^
      xc:`) do set %%L
  )
  set InCoords[Centroid]
)

if %ccpfNeedMin%==1 (
  for /L %%I in (0,1,%InImgs_CNTm1%) do (
    set ccpfMinX=999999
    set ccpfMinY=999999
    for /L %%J in (0,1,!%cnfPref%.NumFeatM1!) do (
      if not !InCoords[%%J][%%I][X]!==missing (
        if !ccpfMinX! GTR !InCoords[%%J][%%I][X]! set ccpfMinX=!InCoords[%%J][%%I][X]!
      )
      if not !InCoords[%%J][%%I][Y]!==missing (
        if !ccpfMinY! GTR !InCoords[%%J][%%I][Y]! set ccpfMinY=!InCoords[%%J][%%I][Y]!
      )
    )
    set /A InCoords[Min][%%I][X]=!ccpfMinX!
    set /A InCoords[Min][%%I][Y]=!ccpfMinY!
  )
  set InCoords[Min]
)

if %ccpfNeedMax%==1 (
  for /L %%I in (0,1,%InImgs_CNTm1%) do (
    set ccpfMaxX=-1
    set ccpfMaxY=-1
    for /L %%J in (0,1,!%cnfPref%.NumFeatM1!) do (
      if not !InCoords[%%J][%%I][X]!==missing (
        if !ccpfMaxX! LSS !InCoords[%%J][%%I][X]! set ccpfMaxX=!InCoords[%%J][%%I][X]!
      )
      if not !InCoords[%%J][%%I][Y]!==missing (
        if !ccpfMaxY! LSS !InCoords[%%J][%%I][Y]! set ccpfMaxY=!InCoords[%%J][%%I][Y]!
      )
    )
    set /A InCoords[Max][%%I][X]=!ccpfMaxX!
    set /A InCoords[Max][%%I][Y]=!ccpfMaxY!
  )
  set InCoords[Max]
)

exit /B 0

::----------------------------------------
:: Subroutines

:FindNeeds
set PARAM=%~1
for %%J in (%PARAM%) do (
  if /I %%J==Centroid (
    set ccpfNeedCentroid=1
  ) else if /I %%J==Min (
    set ccpfNeedMin=1
  ) else if /I %%J==Max (
    set ccpfNeedMax=1
  ) else if /I %%J==All (
    set ccpfNeedCentroid=1
    set ccpfNeedMin=1
    set ccpfNeedMax=1
  ) else if %%J GEQ !%cnfPref%.NumFeat! (
      echo %0: Specified feature [%%J] too large for %cnfPref%.NumFeat [!%cnfPref%.NumFeat!]
      exit /B 1
  ) else if "%%J" LSS "0" (
      echo %0: Specified feature [%%J] unknown
      exit /B 1
  )
)
if ERRORLEVEL 1 exit /B 1

exit /B 0
