rem %1 Prefix for input fwd and bwd, and coordinate, lists.
rem %2 Quoted list of feature numbers, separated by commas or spaces.
rem %3 Text file with list of source images for composites, corresponding to %2.


@if "%3"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

set InPref=%1

call %PICTBAT%chainRdEnv %InPref%
if ERRORLEVEL 1 exit /B 1

call %PICTBAT%csaChkVars %InPref%
if ERRORLEVEL 1 exit /B 1

set FEAT_LIST=%~2
if "%FEAT_LIST%"=="." set FEAT_LIST=
if "%FEAT_LIST%"=="" for /L %%I in (0,1,!%cnfPref%.NumFeatM1!) do set FEAT_LIST=!FEAT_LIST! %%I

set SrcImgsF=%3

call readArray %SrcImgsF% SrcImgs
if ERRORLEVEL 1 exit /B 1

set SrcImgs

if %SrcImgs_CNT% NEQ !%cnfPref%.NumFeat! (
  echo %0: SrcImgs_CNT NEQ %cnfPref%.NumFeat  [%SrcImgs_CNT% NEQ !%cnfPref%.NumFeat!]
)

call :OneDirn fwd
if ERRORLEVEL 1 exit /B 1

call :OneDirn bwd
if ERRORLEVEL 1 exit /B 1

call echoRestore

@endlocal

@exit /B 0

::------------------------------------------------------
:: Subroutines

:OneDirn
set DIRN=%1

call readArray %InPref%_%DIRN%.lis InImgs
if ERRORLEVEL 1 exit /B 1

for /L %%J in (0,1,!%cnfPref%.NumFeatM1!) do (
  call readArrayXY %InPref%_coords_f%%J_%DIRN%.lis InCoords[%%J]
  if ERRORLEVEL 1 exit /B 1
  if !InCoords[%%J]_CNT! NEQ %InImgs_CNT% (
    echo %0: Bad %InPref%_coords_f%%J_%DIRN%.lis
    exit /B 1
  )
)

call %PICTBAT%csaCalcPseudoFeat
if ERRORLEVEL 1 exit /B 1

set FIRSTIMG=0
if %DIRN%==bwd set FIRSTIMG=1

for /L %%I in (%FIRSTIMG%,1,%InImgs_CNTm1%) do (
  rem echo !InImgs[%%I]!
  set SRCS=
  set FeatNum=0
  for %%J in (%FEAT_LIST%) do (
    set X=!InCoords[%%J][%%I][X]!
    set Y=!InCoords[%%J][%%I][Y]!
    call :getSrcImg !FeatNum!
    if not !FSrc!=="" if not !FSrc!=="." if not !X!==missing if not !Y!==missing (
      if not exist !FSrc! (
        echo %0: Can't find SrcImgs[%%J] [!FSrc!]
        exit /B 1
      )
      
      set SRCS=!SRCS! ^( !FSrc! -repage +%%[fx:!X!-w/2]+%%[fx:!Y!-h/2] ^)
    )
    set /A FeatNum+=1
  )
  rem echo SRCS=[!SRCS!]

  for /F %%F in ("!InImgs[%%I]!") do set OUTFILE=!%cnfPref%.OutFrames!%%~nF.!%cnfPref%.OutExt!

  echo Writing !OUTFILE!

  %IMG7%magick ^
    !%cnfPref%.InFrames!!InImgs[%%I]!.!%cnfPref%.InExt! ^
    !%cnfPref%.FramePreProc! ^
    !SRCS! ^
    -background None ^
    -compose Over -layers Flatten ^
    !%cnfPref%.FramePostProc! ^
    !OUTFILE!
)

rem echo SrcImgs_CNT = %SrcImgs_CNT%

rem set SrcImgs

exit /B 0

::------------------------------------------

:getSrcImg
set FSrc=!SrcImgs[%1]!
