rem %1 Prefix for input fwd and bwd, and coordinate, lists.
rem %2 Quoted list of pseudo-features required by %3.
rem %3 Input text file of IM draw commands.


@if "%3"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

set InPref=%1

call %PICTBAT%chainRdEnv %InPref%
if ERRORLEVEL 1 exit /B 1

call %PICTBAT%csaChkVars %InPref%
if ERRORLEVEL 1 exit /B 1

set FEAT_LIST=%~2
if "%FEAT_LIST%"=="." set FEAT_LIST=

set InDraw=%3

call :OneDirn fwd
if ERRORLEVEL 1 exit /B 1

call :OneDirn bwd
if ERRORLEVEL 1 exit /B 1

call echoRestore

@endlocal

@exit /B 0

::------------------------------------------------------
:: Subroutines

:OneDirn
set DIRN=%1

call readArray %InPref%_%DIRN%.lis InImgs
if ERRORLEVEL 1 exit /B 1

for /L %%J in (0,1,!%cnfPref%.NumFeatM1!) do (
  call readArrayXY %InPref%_coords_f%%J_%DIRN%.lis InCoords[%%J]
  if ERRORLEVEL 1 exit /B 1
  if !InCoords[%%J]_CNT! NEQ %InImgs_CNT% (
    echo %0: Bad %InPref%_coords_f%%J_%DIRN%.lis
    exit /B 1
  )
)

set FIRSTIMG=0
if %DIRN%==bwd set FIRSTIMG=1

for /L %%I in (%FIRSTIMG%,1,%InImgs_CNTm1%) do (
  for /F %%F in ("!InImgs[%%I]!") do (
    set OUTFILE=!%cnfPref%.OutFrames!%%~nF.!%cnfPref%.OutExt!
  )

  if not "%FEAT_LIST%"=="" (
    call %PICTBAT%csaCalcPseudoFeat
    if ERRORLEVEL 1 exit /B 1
  )

  set /A IPREV=%%I-1
  set /A INEXT=%%I+1

  if !IPREV! LSS 0 set IPREV=0
  if !INEXT! GTR %InImgs_CNTm1% set INEXT=%InImgs_CNTm1%

  set SRCS=

  for /F "tokens=*" %%L in (%InDraw%) do (
    set SRCS=!SRCS! %%L
  )

  set SUBS=^
-e 's/{/^^^!/g' ^
-e 's/}/^^^!/g' ^
-e 's/inum/%%I/gi' ^
-e 's/iprev/!IPREV!/gi' ^
-e 's/inext/!INEXT!/gi'

  for /F "usebackq tokens=*" %%L ^
in (`echo !SRCS! ^|sed !SUBS!`) ^
do set SRCS2=%%L

  echo SRCS2 !SRCS2!

  echo Writing !OUTFILE!

  %IMG7%magick ^
    !%cnfPref%.InFrames!!InImgs[%%I]!.!%cnfPref%.InExt! ^
    !%cnfPref%.FramePreProc! ^
    -virtual-pixel None ^
    -draw "!SRCS2!" ^
    !%cnfPref%.FramePostProc! ^
    !OUTFILE!

  if ERRORLEVEL 1 (
    echo %0: failure in magick
    exit /B 1
  )
)
if ERRORLEVEL 1 (
  echo %0: failure in loop
  exit /B 1
)

exit /B 0
