rem %1 Prefix for input fwd and bwd, and coordinate, lists.
rem %2 Quoted list of feature numbers, separated by commas or spaces.
rem %3 Index of a frame in the _fwd list [default 0].
rem %4 Index of another frame in the _fwd list [default: %3 + 1].
rem %5 Number of frames to create.
rem %6 Whether to create final frame.
rem %7 Distortion method (affine, perspective, shepards etc).
rem %8 Quoted list of coefficients to nullify.
rem %9 Feature to align for <tt>sxd</tt> and <tt>syd</tt>.


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

set InPref=%1

call %PICTBAT%chainRdEnv %InPref%
if ERRORLEVEL 1 exit /B 1

call %PICTBAT%csaChkVars %InPref%
if ERRORLEVEL 1 exit /B 1

set cnfPref=%~n1

set FEAT_LIST=%~2
if "%FEAT_LIST%"=="." set FEAT_LIST=
if "%FEAT_LIST%"=="" for /L %%I in (0,1,!%cnfPref%.NumFeatM1!) do set FEAT_LIST=!FEAT_LIST! %%I

set FEAT_LIST=%FEAT_LIST%

set NDX_FROM=%3
if "%NDX_FROM%"=="." set NDX_FROM=
if "%NDX_FROM%"=="" set NDX_FROM=0

set NDX_TO=%4
if "%NDX_TO%"=="." set NDX_TO=
if "%NDX_TO%"=="" set /A NDX_TO=%NDX_FROM%+1

set nFrames=%5
if "%nFrames%"=="." set nFrames=
if "%nFrames%"=="" set nFrames=5

set DoFinal=%6
if "%DoFinal%"=="." set DoFinal=
if "%DoFinal%"=="" set DoFinal=1

set /A NoFinal=1-%DoFinal%

set MTHD=%7
if "%MTHD%"=="" set MTHD=.

set NULLIFY=%~8
if "%NULLIFY%"=="" set NULLIFY=.

set SD_FEAT=%~9
if "%SD_FEAT%"=="" set SD_FEAT=.


set CNT=0

for /L %%I in (0,1,%nFrames%) do (
  for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -format "PC=%%[fx:100*%%I/(%nFrames%+%NoFinal%)]\nPC2=%%[fx:100-100*%%I/(%nFrames%+%NoFinal%)]\n" ^
    xc:`) do set %%L

  call %PICTBAT%csaInterpAlignOne chs_files . %NDX_FROM% %NDX_TO% !PC!x!PC! %MTHD% %NULLIFY% %SD_FEAT%
  set tmp_a=!csaiaoOUTFILE!
  set IN_FRAME=!csaiaoIN_FROM!
  call %PICTBAT%csaInterpAlignOne chs_files . %NDX_TO% %NDX_FROM% !PC2!x!PC2! %MTHD% %NULLIFY% %SD_FEAT%
  set tmp_b=!csaiaoOUTFILE!

  set LZ=000000!CNT!
  set LZ=!LZ:~-6!

  set OUTFILE=!%cnfPref%.OutFrames!!IN_FRAME!_!LZ!.!%cnfPref%.OutExt!
  echo %0: Writing !OUTFILE!

  %IMG7%magick ^
    !tmp_a! !tmp_b! ^
    -compose Blend -define compose:args=!PC! -composite ^
    !OUTFILE!

  if ERRORLEVEL 1 echo %0: Failed.

  set /A CNT+=1
  del !tmp_a!
  del !tmp_b!
)

call echoRestore

endlocal

@exit /B 0
