rem %1 Prefix for chainset.
rem %2 Quoted list of feature numbers, separated by commas or spaces.
rem %3 Index of a frame in the _fwd list [default 0].
rem %4 Index of another frame in the _fwd list [default: %3 + 1].

rem %5 NxN: Percentage movements in X and Y [default 100x100].
rem %6 Distortion method (affine, perspective, shepards etc).
rem %7 Quoted list of coefficients to nullify.
rem %8 Feature to align for <tt>sxd</tt> and <tt>syd</tt>.


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

set InPref=%1

rem Assume InPref env vars have been set and are valid.

rem call %PICTBAT%chainRdEnv %InPref%
rem if ERRORLEVEL 1 exit /B 1
rem
rem call %PICTBAT%csaChkVars %InPref%
rem if ERRORLEVEL 1 exit /B 1

set cnfPref=%~n1

set FEAT_LIST=%~2
if "%FEAT_LIST%"=="." set FEAT_LIST=
if "%FEAT_LIST%"=="" for /L %%I in (0,1,!%cnfPref%.NumFeatM1!) do set FEAT_LIST=!FEAT_LIST! %%I

set FEAT_LIST=%FEAT_LIST%

set NDX_FROM=%3
if "%NDX_FROM%"=="." set NDX_FROM=
if "%NDX_FROM%"=="" set NDX_FROM=0

set NDX_TO=%4
if "%NDX_TO%"=="." set NDX_TO=
if "%NDX_TO%"=="" set /A NDX_TO=%NDX_FROM%+1

set MOVE=%5
if "%MOVE%"=="" set MOVE=.
call parseXxY 100 100 %MOVE% MOVE_PC

set MTHD=%6
if "%MTHD%"=="." set MTHD=
if "%MTHD%"=="" set MTHD=perspective

set NULLIFY=%~7
if "%NULLIFY%"=="." set NULLIFY=

set SD_FEAT=%~8
if "%SD_FEAT%"=="." set SD_FEAT=

set DIRN=fwd

call readArray %InPref%_%DIRN%.lis InImgs
if ERRORLEVEL 1 exit /B 1

if %NDX_FROM% GEQ %InImgs_CNT% (
  echo NDX_FROM [%NDX_FROM%] too large
  exit /B 1
)

if %NDX_TO% GEQ %InImgs_CNT% (
  echo NDX_TO [%NDX_TO%] too large
  exit /B 1
)

for /L %%J in (0,1,!%cnfPref%.NumFeatM1!) do (
  call readArrayXY %InPref%_coords_f%%J_%DIRN%.lis InCoords[%%J]
  if ERRORLEVEL 1 exit /B 1
  if !InCoords[%%J]_CNT! NEQ %InImgs_CNT% (
    echo %0: Bad %InPref%_coords_f%%J_%DIRN%.lis
    exit /B 1
  )
)

call %PICTBAT%csaCalcPseudoFeat %SD_FEAT%
if ERRORLEVEL 1 exit /B 1

if "%SD_FEAT%"=="" (
  set SXD_X=0
  set SYD_Y=0
) else (
  set SXD_X=!InCoords[%SD_FEAT%][0][X]!
  set SYD_Y=!InCoords[%SD_FEAT%][0][Y]!
)

if "%SXD_X%"=="" (
  echo SXD_X bad
  exit /B 1
)
if "%SYD_Y%"=="" (
  echo SXD_Y bad
  exit /B 1
)

set OUTFILE=!%cnfPref%.OutFrames!csabet_%NDX_FROM%_%NDX_TO%.!%cnfPref%.OutExt!

set IN_FRAME=!InImgs[%NDX_FROM%]!
set IN_FROM=!%cnfPref%.InFrames!%IN_FRAME%.!%cnfPref%.InExt!

set SRCS=
for %%J in (%FEAT_LIST%) do (

  set AX=!InCoords[%%J][%NDX_TO%][X]!
  set AY=!InCoords[%%J][%NDX_TO%][Y]!

  if not !AX!==missing if not !AY!==missing (

    set X=!InCoords[%%J][%NDX_FROM%][X]!
    set Y=!InCoords[%%J][%NDX_FROM%][Y]!

    if not !X!==missing if not !Y!==missing (
      set NewX=%%[fx:!X!+^(!AX!-!X!^)*%MOVE_PC_X%/100]
      set NewY=%%[fx:!Y!+^(!AY!-!Y!^)*%MOVE_PC_Y%/100]
      set SRCS=!SRCS! !X!,!Y!,!NewX!,!NewY!
    )
  )
)
if ERRORLEVEL 1 exit /B 1
echo %0: Writing !OUTFILE!

if "%NULLIFY%"=="" (
  %IMG7%magick ^
    %IN_FROM% ^
    !%cnfPref%.FramePreProc! ^
    -virtual-pixel None ^
    -distort %MTHD% "!SRCS!" ^
    !%cnfPref%.FramePostProc! ^
    !OUTFILE!
) else (
  call %PICTBAT%alignPntSrt ^
    %IN_FROM% ^
    !OUTFILE! "!SRCS!" %MTHD% "%NULLIFY%" !SXD_X!x!SYD_Y!
)

call echoRestore

endlocal & set csaiaoOUTFILE=%OUTFILE%& set csaiaoIN_FROM=%IN_FRAME%

@exit /B 0

