rem %1 Prefix for input fwd and bwd, and coordinate, lists.
rem %2 Destination directory for output masks.
rem %3 Filetype for output images eg "miff" or "png".
rem %4 Quoted list of feature numbers, separated by commas or spaces.
rem %5 Draw at each feature eg "circle 0,0 30,0".
rem %6 Post-process eg "-blur 0x5".

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

set InPref=%1

call %PICTBAT%chainRdEnv %InPref%
if ERRORLEVEL 1 exit /B 1

set cnfPref=%~n1

if "!%cnfPref%.NumFeat!"=="" (
  echo %0: %cnfPref%.NumFeat is not set.
  exit /B 1
)
set /A %cnfPref%.NumFeatM1=!%cnfPref%.NumFeat!-1


set DestDir=%2
set OutExt=%3

if "%OutExt%"=="." set OutExt=
if "%OutExt%"=="" set OutExt=miff

set FEAT_LIST=%~4
if "%FEAT_LIST%"=="." set FEAT_LIST=
if "%FEAT_LIST%"=="" for /L %%I in (0,1,!%cnfPref%.NumFeatM1!) do set FEAT_LIST=!FEAT_LIST! %%I

set DRAW_FEAT=%~5

set POSTPROC=%~6

if not exist %DestDir% md %DestDir%

call :OneDirn fwd
if ERRORLEVEL 1 exit /B 1

call :OneDirn bwd
if ERRORLEVEL 1 exit /B 1

call echoRestore

@endlocal

@exit /B 0

::------------------------------------------------------
:: Subroutines

:OneDirn
set DIRN=%1

call readArray %InPref%_%DIRN%.lis InImgs
if ERRORLEVEL 1 exit /B 1

for /L %%J in (0,1,!%cnfPref%.NumFeatM1!) do (
  call readArrayXY %InPref%_coords_f%%J_%DIRN%.lis InCoords[%%J]
  if ERRORLEVEL 1 exit /B 1
  if !InCoords[%%J]_CNT! NEQ %InImgs_CNT% (
    echo %0: Bad %InPref%_coords_f%%J_%DIRN%.lis
    exit /B 1
  )
)

:: InCoords[a][b][c] where:
::   a is feature, b is image, c is 0 for X or 1 for Y.

call %PICTBAT%csaCalcPseudoFeat
if ERRORLEVEL 1 exit /B 1

set FIRSTIMG=0
if %DIRN%==bwd set FIRSTIMG=1

for /L %%I in (%FIRSTIMG%,1,%InImgs_CNTm1%) do (
  set SRCS=

  for %%J in (%FEAT_LIST%) do (

    set X=!InCoords[%%J][%%I][X]!
    set Y=!InCoords[%%J][%%I][Y]!

    if not !X!==missing if not !Y!==missing (
      set SRCS=!SRCS! -draw "translate !X!,!Y! %DRAW_FEAT%"
    )
  )
  rem echo SRCS=[!SRCS!]

  for /F %%F in ("!InImgs[%%I]!") do set OUTFILE=%DestDir%%%~nF.%OutExt%

  echo Writing !OUTFILE!

  %IMG7%magick ^
    !%cnfPref%.InFrames!!InImgs[%%I]!.!%cnfPref%.InExt! ^
    -fill Black -colorize 100 ^
    -fill White ^
    !SRCS! ^
    %POSTPROC% ^
    !OUTFILE!

  if ERRORLEVEL 1 exit /B 1
)

exit /B 0
