rem %1 Prefix for input fwd and bwd lists.
rem %2 is WxH, required aspect ratio.
@rem
@rem Also uses:
@rem   ttPREPROC pre-processing for the image eg "-alpha extract".
@rem   ttDEBUG if not blank, writes debugging image
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

set InPref=%1
set cnfPref=%~n1

call %PICTBAT%chainRdEnv %InPref%
if ERRORLEVEL 1 exit /B 1

call %PICTBAT%csaChkVars %InPref%
if ERRORLEVEL 1 exit /B 1

set reqAR=%2
if "%reqAR%"=="" set reqAR=.

set EvPref=csatt


call :OneDirnStats fwd
if ERRORLEVEL 1 exit /B 1

call :OneDirnStats bwd
if ERRORLEVEL 1 exit /B 1

echo %0: Crop is !%EvPref%.crop!

set %EvPref%

call :OneDirnCrop fwd
if ERRORLEVEL 1 exit /B 1

call :OneDirnCrop bwd
if ERRORLEVEL 1 exit /B 1



call echoRestore

@endlocal

@exit /B 0

::------------------------------------------------------
:: Subroutines

:OneDirnStats
set DIRN=%1

call readArray %InPref%_%DIRN%.lis InImgs
if ERRORLEVEL 1 exit /B 1

set FIRSTIMG=0
if %DIRN%==bwd set FIRSTIMG=1

set ttPREPROC=-alpha extract
set ttDEBUG=

for /L %%I in (%FIRSTIMG%,1,%InImgs_CNTm1%) do (
  set mode=cumul
  if %%I==0 set mode=first

  call %PICTBAT%trimTri ^
    !%cnfPref%.InFrames!!InImgs[%%I]!.!%cnfPref%.InExt! ^
    %EvPref% %reqAR% !mode!

  if ERRORLEVEL 1 exit /B 1

  if !%EvPref%.Okay!==0 exit /B 1
)
if ERRORLEVEL 1 exit /B 1

exit /B 0

::-----------------------

:OneDirnCrop
set DIRN=%1

call readArray %InPref%_%DIRN%.lis InImgs
if ERRORLEVEL 1 exit /B 1

set FIRSTIMG=0
if %DIRN%==bwd set FIRSTIMG=1

for /L %%I in (%FIRSTIMG%,1,%InImgs_CNTm1%) do (
  for /F %%F in ("!InImgs[%%I]!") do (
    set OUTFILE=!%cnfPref%.OutFrames!%%~nF.!%cnfPref%.OutExt!
  )

  echo %0: Writing !OUTFILE!
  %IMG7%magick ^
    !%cnfPref%.InFrames!!InImgs[%%I]!.!%cnfPref%.InExt! ^
    -crop !%EvPref%.crop! +repage ^
    !OUTFILE!

  if ERRORLEVEL 1 exit /B 1
)
if ERRORLEVEL 1 exit /B 1

exit /B 0
