#version 3.7;
global_settings { assumed_gamma 1.0 } 

#include "colors.inc"
#include "textures.inc"
#include "shapes.inc"
#include "metals.inc"
#include "glass.inc"
#include "woods.inc"         

camera {
   location <-5, 10, -15>
   angle 45 // direction <0, 0,  1.7>
   right x*image_width/image_height
   look_at <0,0,0>
}

// Uncomment the area lights only if you've got lots of time.
#declare Dist=80.0;

light_source {< -50, 25, -50> color White
     fade_distance Dist fade_power 2
//   area_light <-40, 0, -40>, <40, 0, 40>, 3, 3
//   adaptive 1
//   jitter
}
light_source {< 50, 10,  -4> color Gray30
     fade_distance Dist fade_power 2
     area_light <-20, 0, -20>, <20, 0, 20>, 3, 3
     adaptive 1
     jitter
}
light_source {< 0, 100,  0> color Gray30
     fade_distance Dist fade_power 2
//   area_light <-30, 0, -30>, <30, 0, 30>, 3, 3
//   adaptive 1
//   jitter
}

//sky_sphere {
//    pigment {
//        gradient y
//        color_map {
//            [0, 1  color Gray50 color Gray80]
//        }
//    }
//}

#declare M_Wood18B =
colour_map {
    [0.00 0.25   color rgbf < 0.50, 0.26, 0.12, 0.10>
                 color rgbf < 0.54, 0.29, 0.13, 0.20>]
    [0.25 0.40   color rgbf < 0.54, 0.29, 0.13, 0.20>
                 color rgbf < 0.55, 0.28, 0.10, 0.70>]
    [0.40 0.50   color rgbf < 0.55, 0.28, 0.10, 0.70>
                 color rgbf < 0.50, 0.23, 0.15, 0.95>]
    [0.50 0.70   color rgbf < 0.50, 0.23, 0.15, 0.95>
                 color rgbf < 0.56, 0.29, 0.17, 0.70>]
    [0.70 0.98   color rgbf < 0.56, 0.29, 0.17, 0.70>
                 color rgbf < 0.54, 0.29, 0.13, 0.20>]
    [0.98 1.00   color rgbf < 0.54, 0.29, 0.13, 0.20>
                 color rgbf < 0.50, 0.26, 0.12, 0.10>]
}


#declare Floor_Texture =
    texture { pigment { P_WoodGrain18A color_map { M_Wood18A }}}
    texture { pigment { P_WoodGrain12A color_map { M_Wood18B }}}
    texture {
        pigment { P_WoodGrain12B color_map { M_Wood18B }}
        finish { reflection 0.25 }
    }

#declare Floor =
plane { y,0
    texture { Floor_Texture
        scale 0.5
        rotate y*90
        rotate <10, 0, 15>
        translate z*4
    }
}



#declare SnibCylPig =
  pigment {
    image_map {
      "cp_plane_ext.png"
      map_type 2
    }       
  }


#declare SnibCyl =
cylinder {
  <0, 0.00,  0.0>,
  <0, 1.00,  0.0>, 1 
  open
  pigment { SnibCylPig }
  finish { phong 1 }
  scale 4.0
}


#declare SnibSor =
sor{
  7,
  <0.000, 0.000>,
  <0.800, 0.000>,
  <0.900, 0.300>,
  <0.600, 0.500>,
  <0.800, 0.800>,
  <1.000, 1.000>,
  <1.200, 1.200>
  open
  pigment { SnibCylPig }
  scale 4.0  rotate<0,0,0> translate<0,0,0>
}


#declare SnibLathe =
lathe {
  linear_spline
  5,
  <0.8, 0>, <1, 0>, <1, 1>, <0.8, 1>, <0.8, 0>
  pigment { SnibCylPig }
  scale 4.0  rotate<0,0,0> translate<0,0,0>
}
