rem Given %1 is image, whitish quadrangle on blackish background,
rem finds the four corners by pattern-matching.
rem Writes enviroment variables dcXtl, dcYtl, dcXtr, etc.
rem Writes enviroment variable prefix %2
rem and output image %3.
@rem
@rem Updated:
@rem   29-August-2022
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 dc


set CORNER=%BASENAME%_dcCorner.miff

set QUARTERS=%BASENAME%_dcQuarters.miff


%IMG7%magick ^
  %INFILE% ^
  -crop 2x2@ ^
  %QUARTERS%

:: Top-left
%IMG7%magick ^
  -size 4x4 xc:Black ^
  -fill White ^
  -draw "rectangle 2,2 3,3" ^
  %CORNER%

call %PICTBAT%subSrchFact %QUARTERS%[0] %CORNER% 20

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "offsX=%%X\noffsY=%%Y" ^
  %QUARTERS%[0]`) do set /A %%L

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "dcXtl=%%[fx:%offsX%+%ssfX%]\ndcYtl=%%[fx:%offsY%+%ssfY%]" ^
  xc:`) do set %%L


:: Top-right
%IMG7%magick ^
  %CORNER% ^
  -rotate 90 ^
  %CORNER%

call %PICTBAT%subSrchFact %QUARTERS%[1] %CORNER% 20

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "offsX=%%X\noffsY=%%Y" ^
  %QUARTERS%[1]`) do set /A %%L

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "dcXtr=%%[fx:%offsX%+%ssfX%]\ndcYtr=%%[fx:%offsY%+%ssfY%]" ^
  xc:`) do set %%L


:: Bottom-right
%IMG7%magick ^
  %CORNER% ^
  -rotate 90 ^
  %CORNER%

call %PICTBAT%subSrchFact %QUARTERS%[3] %CORNER% 20

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "offsX=%%X\noffsY=%%Y" ^
  %QUARTERS%[3]`) do set /A %%L

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "dcXbr=%%[fx:%offsX%+%ssfX%]\ndcYbr=%%[fx:%offsY%+%ssfY%]" ^
  xc:`) do set %%L


:: Bottom-left
%IMG7%magick ^
  %CORNER% ^
  -rotate 90 ^
  %CORNER%

call %PICTBAT%subSrchFact %QUARTERS%[2] %CORNER% 20

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "offsX=%%X\noffsY=%%Y" ^
  %QUARTERS%[2]`) do set /A %%L

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "dcXbl=%%[fx:%offsX%+%ssfX%]\ndcYbl=%%[fx:%offsY%+%ssfY%]" ^
  xc:`) do set %%L


set dcX
set dcY


:: Create a debugging image
%IMG7%magick ^
  %INFILE% ^
  -fill None ^
  -stroke Red ^
  -strokewidth 1 ^
  -draw "translate %dcXtl%,%dcYtl% circle 0,0 0,50" ^
  -draw "translate %dcXtr%,%dcYtr% circle 0,0 0,50" ^
  -draw "translate %dcXbl%,%dcYbl% circle 0,0 0,50" ^
  -draw "translate %dcXbr%,%dcYbr% circle 0,0 0,50" ^
  dc_debug.png




call echoRestore

@endlocal & set dmCROP=%WW%x%HH%+%LL%+%TT%
