rem Given %1 is image, whitish quadrangle on blackish background (margins),
rem creates trimmed output %2.
rem %3 is fuzz factor for black,
rem returns width of left, top, right and bottom margins.
@rem
@rem Updated:
@rem   29-August-2022
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 dm

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set FUZZ=%3
if "%FUZZ%"=="." set FUZZ=
if "%FUZZ%"=="" set FUZZ=5

set sFUZZ=-fuzz %FUZZ%%%

for /F "usebackq" %%L in (`%IMG7%magick ^
  %INFILE% ^
  ^( +clone ^
    -scale "x1^!" ^
    -bordercolor Black -border 1 ^
    %sFUZZ% ^
    -format "HORZ=%%@\n" ^
    +write info: ^
    +delete ^
  ^) ^
  -scale "1x^!" ^
  -bordercolor Black -border 1 ^
  %sFUZZ% ^
  -format "VERT=%%@" ^
  info:`) do set %%L

echo HORZ=%HORZ% VERT=%VERT%

for /F "tokens=1-4 delims=x+" %%A in ("%HORZ%") do (
  set WW=%%A
  set /A LL=%%C-1
)

for /F "tokens=1-4 delims=x+" %%A in ("%VERT%") do (
  set HH=%%B
  set /A TT=%%D-1
)

echo %WW%x%HH%+%LL%+%TT%

%IMG7%magick ^
  %INFILE% ^
  -crop %WW%x%HH%+%LL%+%TT% +repage ^
  %OUTFILE%

call echoRestore

@endlocal & set dmCROP=%WW%x%HH%+%LL%+%TT%
