rem Given %1 is image, whitish quadrangle on blackish background (margins),
rem creates repeatedly-trimmed output %2.
rem %3 is initial fuzz factor for black,
rem returns width of left, top, right and bottom margins.
@rem
@rem Updated:
@rem   29-August-2022
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

rem @call echoOffSave

call %PICTBAT%setInOut %1 dmr

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set FUZZ=%3
if "%FUZZ%"=="." set FUZZ=
if "%FUZZ%"=="" set FUZZ=5

set WW=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "WW=%%w\nHH=%%h" ^
  %INFILE%`) do set %%L
if "%WW%"=="" exit /B 1

set LL=0
set TT=0
set RR=0
set BB=0
set W=%WW%
set H=%HH%

set newCROP=%WW%x%HH%+0+0

:loop

set sCROP=%newCROP%

for /F "usebackq" %%L in (`%IMG7%magick ^
  %INFILE% ^
  -crop %sCROP% +repage ^
  ^( +clone ^
    -scale "x1^!" ^
    -bordercolor Black -border 1 ^
    -fuzz %FUZZ%%% ^
    -format "HORZ=%%@\n" ^
    +write info: ^
    +delete ^
  ^) ^
  -scale "1x^!" ^
  -bordercolor Black -border 1 ^
  -fuzz %FUZZ%%% ^
  -format "VERT=%%@" ^
  info:`) do set %%L

echo HORZ=%HORZ% VERT=%VERT%

for /F "tokens=1-4 delims=x+" %%A in ("%HORZ%") do (
  set /A LL=%LL%+%%C-1
  set /A RR=%WW%-%%A-!LL!
)

for /F "tokens=1-4 delims=x+" %%A in ("%VERT%") do (
  set /A TT=%TT%+%%D-1
  set /A BB=%HH%-%%B-!TT!
)

set /A W=%WW%-%LL%-%RR%
set /A H=%HH%-%TT%-%BB%

set newCROP=%W%x%H%+%LL%+%TT%

echo newCROP=%newCROP%

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "FUZZ=%%[fx:%FUZZ%+(100-%FUZZ%)/2]" ^
  xc:`) do set %%L

if %newCROP% NEQ %sCROP% goto loop


%IMG7%magick ^
  %INFILE% ^
  -crop %newCROP% +repage ^
  %OUTFILE%




call echoRestore

@endlocal & set dmrCROP=%newCROP%
