rem Given %1 is an RGB image, scene-referred or linear RGB,
rem with some values clipped at 100%,
rem writes HDRI output %2
rem with clipped values replaced by values above 100%.
@rem
@rem This assumes that %IMG7%magick is HDRI.

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 dch

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set TMPDIR=\temp
set TMPEXT=miff
set SRCPREF=%TMPDIR%\dch_src
set WCPREF=%TMPDIR%\dch_wc


%IMG7%magick ^
  %INFILE% ^
  -fill Black ^
  -separate ^
  -depth 32 ^
  -define quantum:format=floating-point ^
  +write %SRCPREF%_sep_%%d.%TMPEXT% ^
  ( -clone 0 -fill Black +opaque White ) ^
  ( -clone 1 -fill Black +opaque White ) ^
  ( -clone 2 -fill Black +opaque White ) ^
  -delete 0-2 ^
  +write %WCPREF%_sep_%%d.%TMPEXT% ^
  -background White ^
  -compose Multiply -layers Merge ^
  -negate ^
  %WCPREF%_allcl.%TMPEXT%

call :deClipChCh 0 1
call :deClipChCh 0 2
call :deClipChCh 1 0
call :deClipChCh 1 2
call :deClipChCh 2 0
call :deClipChCh 2 1

:: For each channel we find the mean of the new values.

call %PICTBAT%meanImg ^
  "%SRCPREF%_mult01.%TMPEXT% %SRCPREF%_mult02.%TMPEXT%" ^
  %SRCPREF%_0.%TMPEXT%

call %PICTBAT%meanImg ^
  "%SRCPREF%_mult10.%TMPEXT% %SRCPREF%_mult12.%TMPEXT%" ^
  %SRCPREF%_1.%TMPEXT%

call %PICTBAT%meanImg ^
  "%SRCPREF%_mult20.%TMPEXT% %SRCPREF%_mult21.%TMPEXT%" ^
  %SRCPREF%_2.%TMPEXT%

%IMG7%magick ^
  %SRCPREF%_sep_0.%TMPEXT% ^
  %SRCPREF%_0.%TMPEXT% ^
  %WCPREF%_sep_0.%TMPEXT% ^
  -define compose:clamp=off ^
  -compose Over -composite ^
  %WCPREF%_allcl.%TMPEXT% ^
  -alpha off ^
  -compose CopyOpacity -composite ^
  -depth 32 ^
  -define quantum:format=floating-point ^
  %SRCPREF%_0f.%TMPEXT%

%IMG7%magick ^
  %SRCPREF%_sep_1.%TMPEXT% ^
  %SRCPREF%_1.%TMPEXT% ^
  %WCPREF%_sep_1.%TMPEXT% ^
  -define compose:clamp=off ^
  -compose Over -composite ^
  %WCPREF%_allcl.%TMPEXT% ^
  -alpha off ^
  -compose CopyOpacity -composite ^
  -depth 32 ^
  -define quantum:format=floating-point ^
  %SRCPREF%_1f.%TMPEXT%

%IMG7%magick ^
  %SRCPREF%_sep_2.%TMPEXT% ^
  %SRCPREF%_2.%TMPEXT% ^
  %WCPREF%_sep_2.%TMPEXT% ^
  -define compose:clamp=off ^
  -compose Over -composite ^
  %WCPREF%_allcl.%TMPEXT% ^
  -alpha off ^
  -compose CopyOpacity -composite ^
  -depth 32 ^
  -define quantum:format=floating-point ^
  %SRCPREF%_2f.%TMPEXT%

:: The holes in each channel are now where all channels were clipped.

call %PICTBAT%blurFillFp ^
  %SRCPREF%_0f.%TMPEXT% . %SRCPREF%_0f2.%TMPEXT% 4

call %PICTBAT%blurFillFp ^
  %SRCPREF%_1f.%TMPEXT% . %SRCPREF%_1f2.%TMPEXT% 4

call %PICTBAT%blurFillFp ^
  %SRCPREF%_2f.%TMPEXT% . %SRCPREF%_2f2.%TMPEXT% 4

%IMG7%magick ^
  %SRCPREF%_0f2.%TMPEXT% ^
  %SRCPREF%_1f2.%TMPEXT% ^
  %SRCPREF%_2f2.%TMPEXT% ^
  -combine ^
  -set colorspace RGB ^
  %OUTFILE%  


call echoRestore

@endlocal & set dchOUTFILE=%OUTFILE%

exit /B 0

::---------------------------------------------
:: Subroutine

:deClipChCh
set ch0=%1
set ch1=%2

%IMG7%magick ^
  %WCPREF%_sep_%ch0%.%TMPEXT% ^
  ( %WCPREF%_sep_%ch1%.%TMPEXT% -negate ) ^
  -define compose:clamp=off ^
  -compose Multiply -composite ^
  %SRCPREF%_rcgn.%TMPEXT%

%IMG7%magick ^
  %SRCPREF%_sep_%ch0%.%TMPEXT% ^
  %SRCPREF%_sep_%ch1%.%TMPEXT% ^
  -define compose:clamp=off ^
  -compose DivideSrc -composite ^
  ( %WCPREF%_sep_%ch0%.%TMPEXT% ^
    -negate ^
  ) ^
  -compose CopyOpacity -composite ^
  -depth 32 ^
  -define quantum:format=floating-point ^
  %SRCPREF%_div%ch0%%ch1%.%TMPEXT%

call %PICTBAT%blurFillFp ^
  %SRCPREF%_div%ch0%%ch1%.%TMPEXT% . %SRCPREF%_div%ch0%%ch1%f.%TMPEXT% 4

%IMG7%magick ^
  %INFILE% ^
  -channel %ch1% -separate +channel ^
  %SRCPREF%_div%ch0%%ch1%f.%TMPEXT% ^
  -define compose:clamp=off ^
  -compose Multiply -composite ^
  %SRCPREF%_rcgn.%TMPEXT% ^
  -alpha off ^
  -compose CopyOpacity -composite ^
  -depth 32 ^
  -define quantum:format=floating-point ^
  %SRCPREF%_mult%ch0%%ch1%.%TMPEXT%

exit /B 0
