rem Given %1 is an ordinary image,
rem makes output %2 with edges blurred by sigma %3,
rem up to distance %4 from edges.

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 deff

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set BLR_SIG=%3
if "%BLR_SIG%"=="." set BLR_SIG=
if "%BLR_SIG%"=="" set BLR_SIG=10

set WW=
for /F "usebackq" %%L in (`%IM%convert ^
  %INFILE% ^
  -format "WW=%%w\nHH=%%h\nEDGE_DIST=%%[fx:%BLR_SIG%*3]" ^
  info:`) do set %%L
if "%WW%"=="" exit /B 1

if not "%4"=="" if not "%4"=="." set EDGE_DIST=%4

%IM%convert ^
  %INFILE% ^
  ( -size %WW%x%HH% ^
    xc:Black ^
    -compose Lighten ^
    -size %WW%x%EDGE_DIST% ^
    gradient:white-black ^
    -gravity North -composite ^
    gradient:black-white ^
    -gravity South -composite ^
    -size %HH%x%EDGE_DIST% ^
    ( gradient:white-black -rotate -90 ) ^
    -gravity West -composite ^
    ( gradient:white-black -rotate 90 ) ^
    -gravity East -composite ^
  ) ^
  -virtual-pixel Tile ^
  -compose Blur ^
  -set option:compose:args %BLR_SIG%x%BLR_SIG% ^
  -composite ^
  %OUTFILE%


call echoRestore

@endlocal
