rem Given %1 is an ordinary image,
rem makes output %2
rem with edges fade to colour %3 [gray(50%)],
rem up to distance %4 from edges [4c].
rem %5 is any of LTRB, any case. [LTRB]
@rem
@rem %4 is pixels,
@rem   or can be suffixed with p or % or c, for proportion or percentage of minimum dimension.
@rem
@rem Also uses:
@rem
@rem   deefGRAD_MOD a modifier for the gradients, eg for cosine-bell rolloff:
@rem      -function sinusoid 0.5,-90,0.5,0.5
@rem


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 deff

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set EDGE_COL=%3
if "%EDGE_COL%"=="." set EDGE_COL=
if "%EDGE_COL%"=="" set EDGE_COL=gray(50%%)

set EDGE_DIST=%4
if "%EDGE_DIST%"=="." set EDGE_DIST=
if "%EDGE_DIST%"=="" set EDGE_DIST=4c

set EDGES=%5
if "%EDGES%"=="." set EDGES=
if "%EDGES%"=="" set EDGES=LTRB
call %PICTBAT%getLtrb %EDGES%
if %ltrbERR%==1 exit /B 1

set WW=
for /F "usebackq" %%L in (`%IM%convert ^
  %INFILE% ^
  -format "WW=%%w\nHH=%%h\nMID_DIM=%%[fx:min(w,h)]" ^
  info:`) do set %%L
if "%WW%"=="" exit /B 1

set ED_LAST=%EDGE_DIST:~-1%

if "%ED_LAST%"=="^%" set ED_LAST=c

if /I "%ED_LAST%"=="c" (

  for /F "usebackq" %%L in (`%IM%identify ^
    -format "nED=%%[fx:%MID_DIM%*%EDGE_DIST:~0,-1%/100]" ^
    xc:`) do set %%L

) else if /I "%ED_LAST%"=="p" (

  for /F "usebackq" %%L in (`%IM%identify ^
    -format "nED=%%[fx:%MID_DIM%*%EDGE_DIST:~0,-1%]" ^
    xc:`) do set %%L

) else (
  set nED=%EDGE_DIST%
)

set sL=
set sT=
set sR=
set sB=

if %ltrbL%==1 set sL=( gradient:white-black -rotate -90 %deefGRAD_MOD% ) -gravity West -composite

if %ltrbT%==1 set sT=( gradient:white-black %deefGRAD_MOD% ) -gravity North -composite

if %ltrbR%==1 set sR=( gradient:white-black -rotate 90 %deefGRAD_MOD% ) -gravity East -composite

if %ltrbB%==1 set sB=( gradient:black-white %deefGRAD_MOD% ) -gravity South -composite

%IM%convert ^
  %INFILE% ^
  ( -size %WW%x%HH% ^
    xc:%EDGE_COL% ^
  ) ^
  ( -size %WW%x%HH% ^
    xc:Black ^
    -compose Lighten ^
    -size %WW%x%nED% ^
    %sT% ^
    %sB% ^
    -size %HH%x%nED% ^
    %sL% ^
    %sR% ^
  ) ^
  -compose Over -composite ^
  %OUTFILE%

if ERRORLEVEL 1 exit /B 1

call echoRestore

@endlocal
