rem From %1, basename of N masks numbered from 1,
rem and %2 image, size Nx1,
rem makes output %3 of flattened images
rem   where colour of each image is from %2 and alpha from corresponding %1.
@rem
@rem This is the opposite to mMapMasks.bat.
@rem
@rem Updated:
@rem   6-August-2022 for IM v7
@rem


@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 dmm

set MAP_FILE=%2

if not "%3"=="" if not "%3"=="." set OUTFILE=%3

set MASK_DD=%~dp1
set MASK_PREF=%~n1
set MASK_EXT=%~x1


if "%MASK_PREF%"=="" set MASK_PREF=%sioCODE%
if "%MASK_EXT%"=="" set MASK_EXT=.png

set SCR_FILE=%TEMP%\%MASK_PREF%_scr.bat


set MASK_FILE=%MASK_DD%%MASK_PREF%1%MASK_EXT%

set HH=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "HH=%%h\nWW=%%w" ^
  %MASK_FILE%`) do set %%L
if "%HH%"=="" exit /B 1

set MH=
set NumMasks=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "MH=%%h\nNumMasks=%%w" ^
  %MAP_FILE%`) do set %%L

if not "%MH%"=="1" (
  echo %0: map file [%MAP_FILE%] not height 1
  exit /B 1
)
if "%NumMasks%"=="" exit /B 1

echo %IMG7%magick -size %WW%x%HH% -compose CopyOpacity >%SCR_FILE%

set CNT=1
for /F "usebackq skip=1 tokens=6 delims=,:() " %%C in (`%IMG7%magick ^
  %MAP_FILE% ^
  -colorspace sRGB ^
  txt:`) do (
  set MASK_FILE=%MASK_DD%%MASK_PREF%!CNT!%MASK_EXT%

  echo ^( xc:%%C !MASK_FILE! -alpha off -composite ^) >>%SCR_FILE%

  set /A CNT+=1
)

echo -compose Over -background None -layers Flatten  >>%SCR_FILE%

cPrefix /i%SCR_FILE% /r^^ 
echo %OUTFILE% >>%SCR_FILE%

echo SCR_FILE=[%SCR_FILE%]
type %SCR_FILE%
call %SCR_FILE%

if ERRORLEVEL 1 exit /B 1

call echoRestore

endlocal & set dmmOUTFILE=%OUTFILE%& set dmmNumMasks=%NumMasks%
