rem From image %1,
rem make %2
rem replacing pixels outside range (mean plus or minus k*SD) by range limit.
rem %3 window dimensions, WxH 
rem %4 k, typically 1.0 to 3.0 [default 2].
rem %5 post-processing, eg "-auto-level".
@rem
@rem Updated:
@rem   8-August-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 do

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set WINDIMS=%3
if "%WINDIMS%"=="." set WINDIMS=
if "%WINDIMS%"=="" set WINDIMS=10x10

set K=%4
if "%K%"=="." set K=
if "%K%"=="" set K=2

set POSTPROC=%~5
if "%POSTPROC%"=="." set POSTPROC=

%IM7DEV%magick ^
  %INFILE% ^
  +write mpr:SRC ^
  +delete ^
  ( mpr:SRC ^
    -depth 32 ^
    -define quantum:format=floating-point ^
    ^( -clone 0 ^
       -evaluate Pow 2 ^
       -process 'integim' ^
       -process 'deintegim window %WINDIMS%' ^
    ^) ^
    ^( -clone 0 ^
       -process 'integim' ^
       -process 'deintegim window %WINDIMS%' ^
       +write mpr:MEAN ^
       -evaluate Pow 2 ^
    ^) ^
    -delete 0 ^
    -alpha off ^
    -compose MinusSrc -composite ^
    -evaluate Pow 0.5 ^
    +write mpr:SD ^
    +delete ^
  ) ^
  mpr:MEAN ^
  mpr:SD ^
  ( -clone 0-1 ^
    -compose Mathematics ^
    -define compose:args=0,-%K%,1,0 -composite ^
    mpr:SRC ^
    -evaluate-sequence Max ^
  ) ^
  ( -clone 0-1 ^
    -compose Mathematics ^
    -define compose:args=0,%K%,1,0 -composite ^
  ) ^
  -delete 0-1 ^
  -evaluate-sequence Min ^
  %POSTPROC% ^
  %OUTFILE%

if ERRORLEVEL 1 exit /B 1

call echoRestore

endlocal & set doOUTFILE=%OUTFILE%
