rem Richardson-Lucy deconvolution.
rem %1 is image.
rem %2 is kernel (PSF).
rem %3 is number of iterations (default 10).
rem %4 is optional name of output file.
@rem
@rem Ref http://en.wikipedia.org/wiki/Richardson%E2%80%93Lucy_deconvolution
@rem
@rem We need option to NOT convert to linear.
@rem
@rem Updated:
@rem   21-August-2022 Upgraded for IM v7.
@rem

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 drl

set NITER=%3
if "%NITER%"=="." set NITER=
if "%NITER%"=="" set NITER=10

if not "%4"=="" set OUTFILE=%4

for /F "usebackq" %%L in (`cygpath %TEMP%`) do set CYGTEMP=%%L

set TMPDIR=%CYGTEMP%/
set TMPEXT=.miff

set PSF=%2
set PSFHAT=%TMPDIR%drl_psfhat%TMPEXT%
set EST=%TMPDIR%drl_est%TMPEXT%
set TMPIN=%TMPDIR%drl_in%TMPEXT%

%IMG7%magick ^
  %PSF% ^
  -flip -flop ^
  %PSFHAT%

%IMG7%magick ^
  %INFILE% ^
  -colorspace RGB ^
  +depth ^
  -write %TMPIN% ^
  %EST%

%IM7DEV%magick ^
  %PSF% -process img2knl NULL: >psf_knl.txt

%IM7DEV%magick ^
  %PSFHAT% -process img2knl NULL: >psfhat_knl.txt

for /L %%i in (1,1,%NITER%) do %IMG7%magick ^
  %EST% ^
  ( +clone ^
    ( +clone ^
      -define convolve:scale="^!" ^
      -morphology convolve @psf_knl.txt ^
      %TMPIN% ^
      -compose DivideDst -composite ^
      -morphology convolve @psfhat_knl.txt ^
    ) ^
    -compose Multiply -composite ^
  ) ^
  ( -clone 0-1 ^
    -metric RMSE ^
    -format "%%[distortion]\n" -compare -write info: ^
    -delete 0-1 ^
  ) ^
  -delete 0 ^
  +depth ^
  %EST%

%IMG7%magick ^
  %EST% ^
  -set colorspace RGB ^
  -colorspace sRGB ^
  +depth ^
  %OUTFILE%
