rem %1 image to be dehazed by guided filter method
rem %2 dehazed output
rem %3 coordinates in input for haze colour (instead of automatic)
rem dhRdark, dhRguide
rem dhW
rem dhT0
rem dhTopPc
rem ?? post-process eg oogbox, clamp, auto-level, none
@rem
@rem Reference: http://im.snibgo.com/dehaze.htm


@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 dh

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set A_COL_COORDS=%3
if "%A_COL_COORDS%"=="." set A_COL_COORDS=

if "%dhW%"=="" set dhW=0.95

if "%dhT0%"=="" set dhT0=0.1

if "%dhTopPc%"=="" set dhTopPc=0.1

set COL_SP_PRE=-set colorspace sRGB -colorspace RGB -set colorspace sRGB
set COL_SP_POST=-set colorspace RGB -colorspace sRGB
set COL_SP_PRE=
set COL_SP_POST=

set TMPDIR=%TEMP%\
set TMPDIR=
set TMP_IN=%TMPDIR%dh_tmp_in.miff
set TMP_MAP1=%TMPDIR%dh_tmp_map1.miff
set TMP_MAP2=%TMPDIR%dh_tmp_map2.miff
set TMP_T=%TMPDIR%dh_tmp_t.miff
set TMP_PROV=%TMPDIR%dh_tmp_prov.miff

for /F "usebackq" %%L in (`%IMG7%magick ^
  %INFILE% ^
  %COL_SP_PRE% ^
  -format "WW=%%w\nHH=%%h" +write info: ^
  %TMP_IN%`) do set %%L

set A_COL_X=
set A_COL_Y=
if not "%A_COL_COORDS%"=="" (
  call parseXxY2i %WW% %HH% A_COL %A_COL_COORDS%
  if ERRORLEVEL 1 exit /B 1
)

if "%dhRdark%"=="" (
  for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -format "rdark=%%[fx:max(7,min(30,int((%WW%*%HH%-200000)/4800000*23+7.5)))]\n" ^
    xc:`) do set %%L
) else (
  set rdark=%dhRdark%
)

set /A ddark=2*%rdark%+1

if "%dhRguide%"=="" (
  set /A rguide=5*%rdark%
) else (
  set rguide=%dhRguide%
)

echo %0: ddark=%ddark%  rguide=%rguide%

call StopWatch

%IMG7%magick ^
  %TMP_IN% ^
  -channel RGB ^
  -separate ^
  +channel ^
  -evaluate-sequence Min ^
  -statistic Minimum %ddark%x1 ^
  -statistic Minimum 1x%ddark% ^
  %TMP_MAP1%

call StopWatch

set gfPRE_INP=
set gfPRE_GDE=
set gfPOST=

call %PICTBAT%guideFilt ^
  %TMP_MAP1% %TMP_IN% %TMP_MAP2% . integ %rguide%x%rguide%

if ERRORLEVEL 1 exit /B 1

call StopWatch

rem %IMG7%magick ^
rem   %TMP_MAP2% ^
rem   -evaluate Multiply %w% ^
rem   -negate ^
rem   %TMP_T%

if "%A_COL_X%"=="" (
  for /F "usebackq tokens=4,5 delims=, " %%X in (`%IMG7%magick ^
    %TMP_IN% ^
    ^( %TMP_MAP2% ^
       -colorspace Gray ^
       -contrast-stretch "0,%dhTopPc%%%" ^
       -fill Black +opaque white ^
    ^) ^
    -compose Darken -composite ^
    -colorspace Gray ^
    -define "identify:locate=maximum" -define "identify:limit=1" ^
    info:`) do (
    set A_COL_X=%%X
    set A_COL_Y=%%Y
  )
)

echo %0: A_COL_X=%A_COL_X% A_COL_Y=%A_COL_Y% 

if "%A_COL_X%"=="" exit /B 1

call StopWatch

%IMG7%magick ^
  %TMP_IN% ^
  -define compose:clamp=off ^
  -set option:acol %%[hex:p{%A_COL_X%,%A_COL_Y%}] ^
  ( +clone ^
    -fill #%%[acol] -colorize 100 ^
    +write mpr:A ^
  ) ^
  -compose MinusSrc -composite ^
  ( %TMP_MAP2% ^
    -evaluate Multiply %dhW% ^
    -negate ^
    +write %TMP_T% ^
    -evaluate max %%[fx:%dhT0%*QuantumRange] ^
  ) ^
  -compose DivideSrc -composite ^
  mpr:A ^
  -compose Plus -composite ^
  -define quantum:format=floating-point -depth 32 ^
  %TMP_PROV%

%IM7DEV%magick ^
  %TMP_PROV% ^
  -process oogbox ^
  %COL_SP_POST% ^
  %OUTFILE%

call echoRestore

@endlocal & ^
set dh_used_W=%dhW%& set dh_used_T0=%dhT0%&^
set dh_used_rdark=%rdark%& set dh_used_rguide=%rguide%&^
set dhA_COL_X=%A_COL_X%& set dhA_COL_Y=%A_COL_Y%
