rem From integral %1, make image %2.
rem Input should be capable of storing HDRI values.
rem %3 is optional window size, eg 5x7.
rem
rem See also integral.bat.
@rem
@rem Assumes magick is HDRI.
@rem
@rem Updated:
@rem   8-August-2022 for IM v7.
@rem


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 deinteg

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

call parseXxY2 0 0 deinteg %3

echo %0: deinteg_X=%deinteg_X% deinteg_Y=%deinteg_Y%

set crpW=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "crpW=%%[fx:w-2*%deinteg_X%]\ncrpH=%%[fx:h-2*%deinteg_Y%]\n" ^
  %INFILE%`) do set %%L

if "%crpW%"=="" exit /B 1

set sCROP=-crop !crpW!x!crpH!+%deinteg_X%+%deinteg_Y% +repage

echo %0: sCROP=%sCROP%

%IMG7%magick ^
  %INFILE% ^
  ( -clone 0 -repage +1+0 ) ^
  ( -clone 0 -repage +0+1 ) ^
  ( -clone 0 -repage +1+1 ) ^
  -virtual-pixel Black ^
  -background None ^
  -define compose:clamp=off ^
  ( -clone 0-1 ^
    -compose MinusSrc -layers Flatten ^
    -clone 3 ^
    -compose Plus -layers Flatten ^
    -clone 2 ^
    -compose MinusSrc -layers Flatten ^
    +repage ^
  ) ^
  -delete 0-3 ^
  %sCROP% ^
  -alpha off ^
  -define quantum:format=floating-point ^
  %OUTFILE%

if ERRORLEVEL 1 exit /B 1

%IMG7%magick identify %OUTFILE%

call echoRestore

endlocal & set deintegOUTFILE=%OUTFILE%
