rem From image %1, perhaps 200x200 pixels,
rem makes %2 with HTML of a table with images and statistics.
rem %3 is optional seed.


echo 1: [%1]
echo 2: [%2]
echo 3: [%3]

set INFILE=%1
if "%INFILE%"=="." set INFILE=
if "%INFILE%"=="" set INFILE=-size 200x200 xc:gray^^^(50%%%%^^^)

set TAB_FILE=%2
if "%TAB_FILE%"=="." set TAB_FILE=
if "%TAB_FILE%"=="" set TAB_FILE=ns_table.htm

if "%3"=="" (
  set SEED=
) else (
  set SEED=-seed %3
)
if "%SEED%"=="." set SEED=

echo INFILE=%INFILE% TAB_FILE=%TAB_FILE% SEED=%SEED%


set ATTEN=-attenuate 2.5

if "%INFILE%"=="%1" (
  set PREFIX=ns_%~n1
) else (
  set PREFIX=ns_
)

echo ATTEN=%ATTEN% PREFIX=%PREFIX%
rem exit /B 1

cecho /o%TAB_FILE% /X /s\(table\)
cecho /O%TAB_FILE% /X "/s<tr><td></td><th colspan=\q3\q>no attenuate</th><th colspan=\q3\q><tt>%ATTEN%</tt></th></tr>"

cecho /O%TAB_FILE% /X "/s<tr><th><tt>+noise</tt></th><th>image</th><th>histogram</th><th>statistics</th>"
cecho /O%TAB_FILE% /X "/s<th>image</th><th>histogram</th><th>statistics</th></tr>"

for /F "usebackq" %%N in (`%IM7DEV%magick -list noise`) do (
  echo %%N

  cecho /O%TAB_FILE% /X "/s<tr><td><tt>%%N</tt></td>"

  %IM7DEV%magick ^
    %INFILE% ^
    %SEED% ^
    +noise %%N ^
    -clamp ^
    -format "min=%%[fx:minima]<br />\nmean=%%[fx:mean]<br />\nmax=%%[fx:maxima]<br />\nsd=%%[fx:standard_deviation]<br />\n" ^
    +write info: ^
    ^( +clone ^
      -separate ^
      -fill White -opaque Black ^
      -fill Black +opaque White ^
      -background Black ^
      -compose Lighten -layers Merge ^
      -format "clipped=%%[fx:mean]" ^
      +write info: ^
      +delete ^
    ^) ^
    +write %PREFIX%_nse_%%N.png ^
    -process 'mkhisto capnumbuckets 256 norm' ^
    %PREFIX%_hist_%%N.png >%PREFIX%_nse_%%N.lis

  if ERRORLEVEL 1 exit /B 1

  call %PICTBAT%graphLineCol %PREFIX%_hist_%%N.png . . 0 %PREFIX%_hist_%%N_glc.png

  if ERRORLEVEL 1 exit /B 1

  %IM7DEV%magick ^
    %INFILE% ^
    %ATTEN% ^
    %SEED% ^
    +noise %%N ^
    -clamp ^
    -format "min=%%[fx:minima]<br />\nmean=%%[fx:mean]<br />\nmax=%%[fx:maxima]<br />\nsd=%%[fx:standard_deviation]<br />\n" ^
    +write info: ^
    ^( +clone ^
      -separate ^
      -fill White -opaque Black ^
      -fill Black +opaque White ^
      -background Black ^
      -compose Lighten -layers Merge ^
      -format "clipped=%%[fx:mean]" ^
      +write info: ^
      +delete ^
    ^) ^
    +write %PREFIX%_nse_a_%%N.png ^
    -process 'mkhisto capnumbuckets 256 norm' ^
    %PREFIX%_hist_a_%%N.png >%PREFIX%_nse_a_%%N.lis

  if ERRORLEVEL 1 exit /B 1

  call %PICTBAT%graphLineCol %PREFIX%_hist_a_%%N.png . . 0 %PREFIX%_hist_a_%%N_glc.png

  if ERRORLEVEL 1 exit /B 1

  cecho /O%TAB_FILE% /X "/s<td class=\qnotwhite\q><img src=\q%PREFIX%_nse_%%N.png\q /></td>"
  cecho /O%TAB_FILE% /X "/s<td class=\qnotwhite\q><img src=\q%PREFIX%_hist_%%N_glc.png\q /></td>"
  cecho /O%TAB_FILE% /X "/s<td>\n@%PREFIX%_nse_%%N.lis\n</td>"

  cecho /O%TAB_FILE% /X "/s<td class=\qnotwhite\q><img src=\q%PREFIX%_nse_a_%%N.png\q /></td>"
  cecho /O%TAB_FILE% /X "/s<td class=\qnotwhite\q><img src=\q%PREFIX%_hist_a_%%N_glc.png\q /></td>"
  cecho /O%TAB_FILE% /X "/s<td>\n@%PREFIX%_nse_a_%%N.lis\n</td>"

  cecho /O%TAB_FILE% /X "/s</tr>"

)

cecho /O%TAB_FILE% /X /s\(/table\)


type %PREFIX%_nse*.lis

type %TAB_FILE%

expAt /i%TAB_FILE% /o%TAB_FILE%
