rem Given image %1 a white line on black background,
rem finds coords of the ends,
rem and makes output image %2 that has gradient for the line,
rem and transparent elsewhere.
rem Sets properties "line:*" in output.
@rem
@rem Updated:
@rem   20-August-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

rem @call echoOffSave

call %PICTBAT%setInOut %1 dp2g

if not "%2"=="" set OUTFILE=%2


set TMP_2ENDS=l2g_two_ends.miff

set ERR=0

set X0=
for /F "usebackq tokens=2,3 delims=:, " %%X in (`%IM7DEV%magick ^
  %INFILE% ^
  -virtual-pixel Black ^
  -morphology HMT LineEnds ^
  -process onewhite ^
  %TMP_2ENDS% 2^>^&1`) do (
  set X0=%%X
  set Y0=%%Y
)
if "%X0%"=="" exit /B 1

if "%X0%"=="none" (
  echo %0: no line ends [%INFILE%]
  set ERR=1
  goto end
)

for /F "usebackq tokens=2,3 delims=:, " %%X in (`%IM7DEV%magick ^
  %TMP_2ENDS% ^
  -fill Black -draw "point %X0%,%Y0%" ^
  -process onewhite ^
  NULL: 2^>^&1`) do (
  set X1=%%X
  set Y1=%%Y
)

if "%X1%"=="none" (
  echo %0: no second line end [%INFILE%]
  set ERR=1
  goto end
)


set nInPath=
for /F "usebackq tokens=1-2 delims=: " %%L in (`%IM7DEV%magick ^
  %INFILE% ^
  -negate ^
  -evaluate Subtract 1 -clamp -evaluate Add 1 ^
  -set colorspace sRGB ^
  -process ^
    "darkestpntpnt s %X0%,%Y0% e %X1%,%Y1% t 0.5 data v" ^
  -channel G -separate +channel ^
  -clamp ^
  -auto-level ^
  +depth ^
  %OUTFILE% 2^>^&1`) do (
  if /I "%%L"=="nInPath" set nInPath=%%M
  if /I "%%L"=="maxDist" set MaxDist=%%M
  if /I "%%L"=="Bug:" set ERR=1
)
if "%nInPath%"=="" exit /B 1

%IMG7%magick ^
  %OUTFILE% ^
  %INFILE% ^
  -compose CopyOpacity -composite ^
  -background gray(50%%) -alpha Background ^
  -auto-level ^
  -alpha Background ^
  -set line:len %nInPath% ^
  -set line:x0 %X0% ^
  -set line:y0 %Y0% ^
  -set line:x1 %X1% ^
  -set line:y1 %Y1% ^
  %OUTFILE%

:end

call echoRestore

endlocal & set dp2gOUTFILE=%OUTFILE%& set dp2gERR=%ERR%
