rem %1 is input chromaticity diagram.
rem %2 is output, with primaries and white point shown.
rem %3 is file of text verbose output from process module barymap.
@rem
@rem This picks up every inPrim etc,
@rem and draws them in different sizes.

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

set INFILE=%1
set OUTFILE=%2
set BARYLIS=%3

set inPrim=
set inWP=
set outPrim=
set outWP=

set NinPrim=0
set NinWP=0
set NoutPrim=0
set NoutWP=0

:: stat is 1 for "In:", 2 for "Out:", 0 for neither
set stat=0

for /F "usebackq tokens=1-2 delims=* " %%A in (%BARYLIS%) do (
  rem echo read [%%A] [%%B] [!stat!]
  if /I "%%A"=="In:" set stat=1
  if /I "%%A"=="Out:" set stat=2
  if /I "%%A"=="nAngMults" set stat=0
  if /I "%%A"=="inPrim" (
    echo inPrim %%B
    set inPrim[!NinPrim!]=%%B
    set /A NinPrim+=1
  )
  if /I "%%A"=="inWP" (
    echo inWP %%B
    set inWP[!NinWP!]=%%B
    set /A NinWP+=1
  )
  if /I "%%A"=="outPrim" (
    echo outPrim %%B
    set outPrim[!NoutPrim!]=%%B
    set /A NoutPrim+=1
  )
  if /I "%%A"=="outWP" (
    echo outWP %%B
    set outWP[!NoutWP!]=%%B
    set /A NoutWP+=1
  )
)

echo %NinPrim% %NinWP% %NoutPrim% %NoutWp%

set /A lastinPrim = NinPrim-1
set /A lastinWP   = NinWP-1
set /A lastoutPrim  = NoutPrim-1
set /A lastoutWP  = NoutWP-1

set sDRAWip=
for /L %%N in (0,1,%lastinPrim%) do (
  set prev=
  set i=0
  for %%A in (!inPrim[%%N]!) do (
    if "!prev!"=="" (
      set prev=%%A
    ) else (
      set /A rad=%%N*6+6
      echo ip !prev! and %%A !rad!
      set sDRAWip!i![%%N]=-draw "translate %%[fx:w*!prev!],%%[fx:h-h*%%A] circle 0,0,0,!rad!"
      set prev=
      set /A i+=1
    )
  )
  set sDRAWip=!sDRAWip! !sDRAWip0[%%N]! !sDRAWip1[%%N]! !sDRAWip2[%%N]!
)

set sDRAWiw=
for /L %%N in (0,1,%lastinWP%) do (
  set prev=
  for %%A in (!inWP[%%N]!) do (
    if "!prev!"=="" (
      set prev=%%A
    ) else (
      set /A rad=%%N*6+6
      echo iw !prev! and %%A !rad!
      set sDRAWiw[%%N]=-draw "translate %%[fx:w*!prev!],%%[fx:h-h*%%A] circle 0,0,0,!rad!"
      set prev=
      set /A i+=1
    )
  )
  set sDRAWiw=!sDRAWiw! !sDRAWiw[%%N]!
)

set sDRAWop=
for /L %%N in (0,1,%lastoutPrim%) do (
  set prev=
  set i=0
  for %%A in (!outPrim[%%N]!) do (
    if "!prev!"=="" (
      set prev=%%A
    ) else (
      set /A rad=%%N*6+8
      echo op !prev! and %%A  !rad!
      set sDRAWop!i![%%N]=-draw "translate %%[fx:w*!prev!],%%[fx:h-h*%%A] circle 0,0,0,!rad!"
      set prev=
      set /A i+=1
    )
  )
  set sDRAWop=!sDRAWop! !sDRAWop0[%%N]! !sDRAWop1[%%N]! !sDRAWop2[%%N]!
)

set sDRAWow=
for /L %%N in (0,1,%lastoutWP%) do (
  set prev=
  for %%A in (!outWP[%%N]!) do (
    if "!prev!"=="" (
      set prev=%%A
    ) else (
      set /A rad=%%N*6+8
      echo ow !prev! and %%A !rad!
      set sDRAWow[%%N]=-draw "translate %%[fx:w*!prev!],%%[fx:h-h*%%A] circle 0,0,0,!rad!"
      set prev=
      set /A i+=1
    )
  )
  set sDRAWow=!sDRAWow! !sDRAWow[%%N]!
)

echo ip = %sDRAWip%
echo op = %sDRAWop%

%IMG7%magick ^
  %INFILE% ^
  -fill None ^
  -stroke #f66 ^
  %sDRAWip% ^
  -stroke #a66 ^
  %sDRAWiw% ^
  -stroke #0d0 ^
  %sDRAWop% ^
  -stroke #6a6 ^
  %sDRAWow% ^
  %OUTFILE%

call echoRestore

@endlocal
