rem Generates a grayscale elliptical mask,
rem   width %1 height %2,
rem   centre %3 [default white] fading to %4 [black] at corners.
rem Colours are percentages gray, eg 0=white, 50=mid gray, 100=white
rem The image is contained within the ellipse, so only the corners are the background grey.
@rem
@rem Updated:
@rem   5-August-2022 for IM v7.
@rem

set WI=%1

set HT=%2
if "%HT%"=="" set HT=%1

set SIZ=%WI%
if %SIZ% LSS %HT% set SIZ=%HT%

set INCOL=%3
if "%INCOL%"=="" set INCOL=100

set OUTCOL=%4
if "%OUTCOL%"=="" set OUTCOL=0

for /F %%i in ('%IMG7%magick ^
  xc: ^
  -format "%%[fx:int(%SIZ%*sqrt(2)+0.5)]" ^
  info:') do set SQ_DIM=%%i

%IMG7%magick -size %SQ_DIM%x%SQ_DIM% ^
  radial-gradient:rgb(%INCOL%%%,%INCOL%%%,%INCOL%%%)-rgb(%OUTCOL%%%,%OUTCOL%%%,%OUTCOL%%%) ^
  -gravity Center ^
  -crop %SIZ%x%SIZ%+0+0 +repage ^
  -resize "%WI%x%HT%^!" ^
  ellipMaskCorn.png

%IMG7%magick identify ellipMaskCorn.png
