rem Makes ellipsoidal gradient.

rem %1 WxH
rem %2 output file: grayscale, can be greater than 100%.
rem %3 CXxCY centre. Default (W-1)/2,(H-1)/2
rem %4 radius. "nearCorner" or "farCorner" or "meanCorner" or "nearEdge" or "farEdge" or "meanEdge" or RXxRY
@rem
@rem  Maybe option to do fan composite with gradient from the edge.
@rem
@rem Makes a radial gradient with large radius, and divides appropriately.


@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 eg

set sWH=%1
if "%sWH%"=="." set sWH=
if "%sWH%"=="" set sWH=150x100

if not "%2"=="" set OUTFILE=%2

set sCent=%3
if "%sCent%"=="." set sCent=
if "%sCent%"=="" set sCent=50cx50c

set sRad=%4
if "%sRad%"=="." set sRad=
if "%sRad%"=="" set sRad=50cx50c

call parseXxY2 150 100 WH %sWH%

set WW=%WH_X%
set HH=%WH_Y%

set /A Wm1=%WH_X%-1
set /A Hm1=%WH_Y%-1

call parseXxY2 %Wm1% %Hm1% CENT %sCent%

@rem "nearEdge" means the darkest pixel that has same X or Y ordinate as the centre.
@rem "farEdge" means the lightest pixel that has same X or Y ordinate as the centre.
@rem Similarly corners.

for /F "usebackq" %%L in (`%IMG7%magick xc: ^
  -format "RAD_X=%%[fx:%Wm1%*sqrt(2)]\nRAD_Y=%%[fx:%Hm1%*sqrt(2)]\n" ^
  info:`) do set %%L

if /I %sRad%==nearCorner (
  set sADJ=^
    ^( +clone ^
      ^( -clone 0 -crop 1x1+0+0 ^) ^
      ^( -clone 0 -crop 1x1+%Wm1%+0 ^) ^
      ^( -clone 0 -crop 1x1+0+%Hm1% ^) ^
      ^( -clone 0 -crop 1x1+%Wm1%+%Hm1% ^) ^
      -delete 0 ^
      -evaluate-sequence Min ^
      -scale "%WW%x%HH%^^!" ^
    ^) ^
    -compose DivideSrc -composite 
) else if /I %sRad%==farCorner (
  set sADJ=^
    ^( +clone ^
      ^( -clone 0 -crop 1x1+0+0 ^) ^
      ^( -clone 0 -crop 1x1+%Wm1%+0 ^) ^
      ^( -clone 0 -crop 1x1+0+%Hm1% ^) ^
      ^( -clone 0 -crop 1x1+%Wm1%+%Hm1% ^) ^
      -delete 0 ^
      -evaluate-sequence Max ^
      -scale "%WW%x%HH%^^!" ^
    ^) ^
    -compose DivideSrc -composite 
) else if /I %sRad%==meanCorner (
  set sADJ=^
    ^( +clone ^
      ^( -clone 0 -crop 1x1+0+0 ^) ^
      ^( -clone 0 -crop 1x1+%Wm1%+0 ^) ^
      ^( -clone 0 -crop 1x1+0+%Hm1% ^) ^
      ^( -clone 0 -crop 1x1+%Wm1%+%Hm1% ^) ^
      -delete 0 ^
      -evaluate-sequence Mean ^
      -scale "%WW%x%HH%^^!" ^
    ^) ^
    -compose DivideSrc -composite 
) else if /I %sRad%==nearEdge (
  set sADJ=^
    ^( +clone ^
      ^( -clone 0 -crop 1x1+%CENT_X%+0 ^) ^
      ^( -clone 0 -crop 1x1+0+%CENT_Y% ^) ^
      ^( -clone 0 -crop 1x1+%CENT_X%+%Hm1% ^) ^
      ^( -clone 0 -crop 1x1+%Wm1%+%CENT_Y% ^) ^
      -delete 0 ^
      -evaluate-sequence Min ^
      -scale "%WW%x%HH%^^!" ^
    ^) ^
    -compose DivideSrc -composite 
) else if /I %sRad%==farEdge (
  set sADJ=^
    ^( +clone ^
      ^( -clone 0 -crop 1x1+%CENT_X%+0 ^) ^
      ^( -clone 0 -crop 1x1+0+%CENT_Y% ^) ^
      ^( -clone 0 -crop 1x1+%CENT_X%+%Hm1% ^) ^
      ^( -clone 0 -crop 1x1+%Wm1%+%CENT_Y% ^) ^
      -delete 0 ^
      -evaluate-sequence Max ^
      -scale "%WW%x%HH%^^!" ^
    ^) ^
    -compose DivideSrc -composite 
) else if /I %sRad%==meanEdge (
  set sADJ=^
    ^( +clone ^
      ^( -clone 0 -crop 1x1+%CENT_X%+0 ^) ^
      ^( -clone 0 -crop 1x1+0+%CENT_Y% ^) ^
      ^( -clone 0 -crop 1x1+%CENT_X%+%Hm1% ^) ^
      ^( -clone 0 -crop 1x1+%Wm1%+%CENT_Y% ^) ^
      -delete 0 ^
      -evaluate-sequence Mean ^
      -scale "%WW%x%HH%^^!" ^
    ^) ^
    -compose DivideSrc -composite 
) else (
  set sADJ=
  call parseXxY2 %Wm1% %Hm1% RAD %sRad%
)

%IMG7%magick ^
  -size %WW%x%HH% ^
  -define gradient:center=%CENT_X%,%CENT_Y% ^
  -define gradient:radii=%RAD_X%,%RAD_Y% ^
  radial-gradient:black-white ^
  -define compose:clamp=off ^
  %sADJ% ^
  -define quantum:format=floating-point -depth 32 ^
  %OUTFILE%

if ERRORLEVEL 1 exit /B 1

call echoRestore

@endlocal & set egOUTFILE=%OUTFILE%& set egWW=%WW%& set egHH=%HH%& set egCX=%CENT_X%& set egCY=%CENT_Y%
