rem Make elliptical (or circular) grid.
rem %1,%2 are width and height.
rem %3 is output file (default ellgrid.png)
rem %4 is number of ellipses, >=0 (default 4)
rem %5 is number of radii (default 8)
rem %6 is grid colour (default white)
rem %7 is background colour, can be "none" (default black)
@rem
@rem Also uses:
@rem   gridSTROKE_WIDTH default 1

@call echoOffSave

setlocal enabledelayedexpansion

set WW=%1
if "%WW%"=="." set WW=
if "%WW%"=="" set WW=150

set HH=%2
if "%HH%"=="." set HH=
if "%HH%"=="" set HH=100

set OUTFILE=%3
if "%OUTFILE%"=="." set OUTFILE=
if "%OUTFILE%"=="" set OUTFILE=ellgrid.png

set nELLIPSES=%4
if "%nELLIPSES%"=="." set nELLIPSES=
if "%nELLIPSES%"=="" set nELLIPSES=4

set nRADII=%5
if "%nRADII%"=="." set nRADII=
if "%nRADII%"=="" set nRADII=8

set GRID_COL=%6
if "%GRID_COL%"=="." set GRID_COL=
if "%GRID_COL%"=="" set GRID_COL=White

set BACK_COL=%7
if "%BACK_COL%"=="." set BACK_COL=
if "%BACK_COL%"=="" set BACK_COL=Black

if "%gridSTROKE_WIDTH%"=="" set gridSTROKE_WIDTH=0

if %gridSTROKE_WIDTH%==1 (
  set sSTROKEW=
) else (
  set sSTROKEW=-strokewidth %gridSTROKE_WIDTH%
)

for /F "usebackq" %%L in (`%IMG7%magick ^
  xc: ^
  -format "CX=%%[fx:(%WW%-1)/2]\nCY=%%[fx:(%HH%-1)/2]\nWFRAC=%%[fx:%WW%/2/%nELLIPSES%]\nHFRAC=%%[fx:%HH%/2/%nELLIPSES%]\nAngFRAC=%%[fx:2*PI/%nRADII%]\n" ^
  info:`) do set %%L

set sDraw=

for /L %%I in (%nELLIPSES%,-1,1) do (
  set sDraw=!sDraw! ellipse %CX%,%CY%,%%[fx:%WFRAC%*%%I],%%[fx:%HFRAC%*%%I],0,360
)

for /L %%I in (0,1,%nRADII%) do (
  set sDraw=!sDraw! line "%CX%,%CY%,%%[fx:%CX%*(1+sin(%AngFrac%*%%I))],%%[fx:%CY%*(1-cos(%AngFrac%*%%I))]"
)

rem echo sDraw=%sDraw%


%IMG7%magick ^
  -size %WW%x%HH% xc:%BACK_COL% ^
  -fill None -stroke %GRID_COL% ^
  %sSTROKEW% ^
  -draw "%sDraw%" ^
  %OUTFILE%
