rem Sweeps an ellipse with same aspect ratio as image.
rem   Stores sin(theta) in the red channel and -cos(theta) in the green channel.
rem %1  WxH: width and height
rem %2  output file
rem %3  centre XxY, each possibly suffixed
@rem
@rem Similar to ellipseSweep.bat and circGrad.bat

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 cg

set sWH=%1
if "%sWH%"=="." set sWH=
if "%sWH%"=="" set sWH=150x100

if not "%2"=="" set OUTFILE=%2

set sCent=%3
if "%sCent%"=="." set sCent=
if "%sCent%"=="" set sCent=50cx50c

call parseXxY2 150 100 WH %sWH%

call parseXxY2 %WH_X%-1 %WH_Y%-1 cent %sCent%

rem We go directly to sin and cos: sin=dx/hypot(dx,dy) etc.

%IMG7%magick ^
  -size %WH_X%x%WH_Y% xc:Black ^
  -channel R ^
  -fx "ASP=%%[fx:(w-1)/(h-1)]; dx = i-%cent_X%; dy = (j-%cent_Y%)*ASP; dx / hypot(dx,dy)" ^
  -channel G ^
  -fx "ASP=%%[fx:(w-1)/(h-1)]; dx = i-%cent_X%; dy = (j-%cent_Y%)*ASP; dy / hypot(dx,dy)" ^
  +channel ^
  -define quantum:format=floating-point -depth 32 ^
  %OUTFILE%

call echoRestore

endlocal & set esCX=%cent_X%& set esCY=%cent_Y%