rem Given
rem   %1 is the histogram of an image eg hpk_gr_h0.miff,
rem   %2 is CSV list of peaks in %1, from histoPeaks.bat,
rem     eg hpk_gr_t2t.lis
rem writes a clut image to equalise each peak.
rem Optional %3 is output filename.
@rem
@rem Updated:
@rem   12-August-2022 for IM v7
@rem


@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

rem @call echoOffSave

call %PICTBAT%setInOut %1 eqpk

set IN_HIST=%1
set IN_T2T=%2

if not "%3"=="" set OUTFILE=%3

set TMP_BAT=%TEMP%\%sioCODE%_tmp.bat


echo %IM7DEV%magick %IN_HIST% >%TMP_BAT%

set DONE_FIRST=0

set SET_WHITE=-fill White -colorize 100

for /F "skip=1 tokens=1,2,4,5 delims=, " %%A in (%IN_T2T%) do (
  echo %%A,%%B,%%C,%%D

  if !DONE_FIRST!==0 (
    echo ^( -clone 0 >>%TMP_BAT%
    echo   %SET_WHITE% >>%TMP_BAT%
    echo   -fx "i>=%%A?black:u" >>%TMP_BAT%
    echo   -process 'cumulhisto norm' >>%TMP_BAT%
    echo   +level 0,%%B%%%% ^) >>%TMP_BAT%

    set DONE_FIRST=1
  )

  echo ^( -clone 0 >>%TMP_BAT%
  echo   -fx "i<%%A?black:u" >>%TMP_BAT%
  echo   -fx "i>=%%C?black:u" >>%TMP_BAT%
  echo   -process 'cumulhisto norm' >>%TMP_BAT%
  echo   +level %%B%%%%,%%D%%%% >>%TMP_BAT%
  echo   -fx "i<%%A?black:u" ^) >>%TMP_BAT%

  set BUCK_NUM=%%C
  set THR=%%D
)

rem And last (or only) segment
if !DONE_FIRST!==1 (
  echo ^( -clone 0 >>%TMP_BAT%
  echo   %SET_WHITE% >>%TMP_BAT%
  echo   -fx "i<%BUCK_NUM%?black:u" >>%TMP_BAT%
  echo   -process 'cumulhisto norm' >>%TMP_BAT%
  echo   +level %THR%%%%%,100%%%% >>%TMP_BAT%
  echo   -fx "i<%BUCK_NUM%?black:u" ^) >>%TMP_BAT%
) else (
  echo ^( -clone 0 >>%TMP_BAT%
  echo   -process 'cumulhisto norm' ^) >>%TMP_BAT%
)

echo -delete 0 >>%TMP_BAT%
echo -evaluate-sequence Max >>%TMP_BAT%
cPrefix /i%TMP_BAT% /r"^"
echo %OUTFILE% >>%TMP_BAT%

type %TMP_BAT%

call %TMP_BAT%

call %PICTBAT%graphLineCol %OUTFILE%


call echoRestore

@endlocal & set eqpkOUTFILE=%OUTFILE%
