rem From image %1, makes other image
rem using a cumulative histogram with specified slopes at shadow and highlight.
rem
rem %2 is percentage along x-axis for shadow slope. [0]
rem %3 is percentage along x-axis for start of highlight slope. [100]
rem %4 is percentage up y-axis for shadow slope. [same as %2]
rem %5 is percentage up y-axis for start of highlight slope. [same as %3]
rem %6 is optional output filename.
@rem
@rem Updated:
@rem   27-July-2022 for IM v7.
@rem


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 eqs

if not "%6"=="" set OUTFILE=%6

set TMP_HIST=%INNAME%_%sioCODE%_hist.miff

%IM7DEV%magick ^
  %INFILE% ^
  -colorspace Gray ^
  -process 'mkhisto norm' ^
  %TMP_HIST%

call %PICTBAT%equSlopeH %TMP_HIST% %2 %3 %4 %5

%IM7DEV%magick ^
  %INFILE% ^
  %eqshOUTFILE% ^
  -clut ^
  %OUTFILE%

goto end


set AX=%2
set BX=%3
set AY=%4
set BY=%5

if "%AX%"=="." set AX=
if "%BX%"=="." set BX=
if "%AY%"=="." set AY=
if "%BY%"=="." set BY=

if "%AX%"=="" set AX=0
if "%BX%"=="" set BX=100
if "%AY%"=="" set AY=%AX%
if "%BY%"=="" set BY=%BX%

echo %AX% %BX% %AY% %BY%

if not "%6"=="" set OUTFILE=%6

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "Wm1=%%[fx:w-1]\nAXP=%%[fx:int(w*%AX%/100+0.5)]\nBXP=%%[fx:int(w*%BX%/100+0.5)]\nAXP2=%%[fx:w-int(w*%AX%/100+0.5)]\nBXP2=%%[fx:w-int(w*%BX%/100+0.5)]\n" ^
  %INFILE%`) do set %%L

echo AXP=%AXP% BXP=%BXP% AXP2=%AXP2% BXP2=%BXP2%

if %AX%==0 (
  set BKL=
  set WHR=
) else (
  set BKL=-size %AXP%x1 xc:#000 -gravity West -composite
  set WHR=-size %AXP2%x1 xc:#fff -gravity East -composite

  set G1=  ^( -clone 0 ^
    -sparse-color bilinear 0,0,#000,%Wm1%,0,#fff ^
    !WHR! ^
    +write G1.png ^
  ^) ^
  -evaluate-sequence Min

)

if %BX%==100 (
  set BKR=
  set WHL=
) else (
  set BKR=-size %BXP2%x1 xc:#000 -gravity East -composite
  set WHL=-size %BXP%x1 xc:#000 -gravity West -composite

  set G2=  ^( -clone 0 ^
    -sparse-color bilinear 0,0,#000,%Wm1%,0,#fff ^
    !WHL! ^
    +write G2.png ^
  ^) ^
  -evaluate-sequence Max

)

%IM7DEV%magick ^
  %INFILE% ^
  %BKL% ^
  %BKR% ^
  -process 'cumulhisto norm' ^
  +level %AY%%%,%BY%%% ^
  %G1% ^
  %G2% ^
  %OUTFILE%

call %PICTBAT%graphLineCol %OUTFILE%


:end

call echoRestore

@endlocal & set eqsOUTFILE=%OUTFILE%
