rem Extrapolate away from heavy blur. Increases local contrast.
rem A bit like tone-mapping, HDR, High Dynamic Range.
@rem
@rem %2 is resize amount (inverse of blur radius) as percentage of image size.
@rem   Small amounts (0.1-5) spread impact over large area. [0.5]
@rem   Large amounts (25-100) give unsharp mask.
@rem %3 is extrapolation as percentage.
@rem   0 is blur; 100 is no effect (unchanged image), 150 is subtle, 15000 is massive.
@rem %4, if given, is output filename.
@rem
@rem See also hvyBlrDiff.bat
@rem
@rem Updated:
@rem   26-July-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 ehb

set BLUR_PC=%2
if "%BLUR_PC%"=="." set BLUR_PC=
if "%BLUR_PC%"=="" set BLUR_PC=0.5

set BLEND_PC=%3
if "%BLEND_PC%"=="." set BLEND_PC=
if "%BLEND_PC%"=="" set BLEND_PC=200

if not "%4"=="" set OUTFILE=%4


FOR /F "usebackq" %%L IN (`%IMG7%magick identify -format "WW=%%w\nHH=%%h" %INFILE%`) DO set %%L

%IMG7%magick ^
  %INFILE% ^
  ^( +clone ^
     -resize %BLUR_PC%%% -resize "%WW%x%HH%^!" ^
  ^) ^
  +swap ^
  -compose Blend -define compose:args=%BLEND_PC% -composite ^
  %OUTFILE%

call echoRestore

@endlocal & set ehbOUTFILE=%OUTFILE%
