rem From image of white lines on black background, fully opaque,
rem writes output %2
rem by extending pairs of line-ends that are within proximity threshold %3 of each other.
rem %4 is method for holes:
rem   circles  holes are circles of given radius centred on centres between line-ends
rem   squares  holes are squares of given radius centred on centres between line-ends
rem   lines    holes are lines with rounded ends with spsLINE_THK_INT between line-ends
rem
rem Also uses:
rem   skelLineEnds if 1, skeletonises the output.
@rem
@rem Updated:
@rem   6-August-2022 for IM v7
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 ele

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set PROX_THRESH=%3
if "%PROX_THRESH%"=="." set PROX_THRESH=
if "%PROX_THRESH%"=="" set PROX_THRESH=10

set METHOD=%4
if "%METHOD%"=="." set METHOD=
if "%METHOD%"=="" set METHOD=circles

call %PICTBAT%skelPS ^
  %INFILE% %BASENAME%_%sioCODE%.png
if ERRORLEVEL 1 exit /B 1

echo %0: done skelPS

call %PICTBAT%pointsRdx ^
  %spsENDS% ^
  %spsCSVFILE% %BASENAME%_lines_%sioCODE%.scr %PROX_THRESH%
if ERRORLEVEL 1 exit /B 1

echo %0: done pointsRdx

set /A RAD=%PROX_THRESH%/2

set HOLES_SCR=%BASENAME%_holes_%sioCODE%.scr

echo %0: spsLINE_THK_INT=%spsLINE_THK_INT%

set sLINWID=

if /I %METHOD%==circles (
  call %PICTBAT%lines2circs %prdxOUTFILE% %HOLES_SCR% %RAD%
  if ERRORLEVEL 1 exit /B 1
) else if /I %METHOD%==squares (
  call %PICTBAT%lines2sqs %prdxOUTFILE% %HOLES_SCR% %RAD%
  if ERRORLEVEL 1 exit /B 1
) else if /I %METHOD%==lines (
  rem FIXME: more than the line width?
  set /A wider=2*%spsLINE_THK_INT%
  call %PICTBAT%lines2RndedLines %prdxOUTFILE% %HOLES_SCR%
  if ERRORLEVEL 1 exit /B 1
  set sLINWID=-stroke Black -linewidth !wider!
) else (
  echo %0: Unknown METHOD=%METHOD%
  exit /B 1
)

echo %0: HOLES_SCR=%HOLES_SCR%

type %HOLES_SCR%

if "%skelLineEnds%"=="1" (
  set sSKEL=-morphology Thinning:-1 skeleton -clamp
) else (
  set sSKEL=
)

set /A nLSR=(%RAD%+3)/4

set /A WR=%spsLINE_THK_INT%+2

set /A WR2=3*%WR%

if %nLSR% LSS %WR2% set nLSR=%WR2%

set /A nLSRp=%nLSR%+2

set FH_PARAMS=window_radius %WR% lsr %nLSR% auto_limit_search off auto_repeat v

echo FH_PARAMS=%FH_PARAMS%

:: FIXME: wrong check
if "%l2cCIRCS%"=="0" (

  echo %0: no holes

  %IMG7%magick ^
    %INFILE% ^
    %OUTFILE%
) else (

  echo %0: with holes sSKEL="%sSKEL%"

  %IM7DEV%magick ^
    %INFILE% ^
    +write mpr:IMG ^
    +antialias ^
    ^( mpr:IMG ^
       -fill White -colorize 100 ^
       -fill Black ^
       %sLINWID% ^
       -draw "@%HOLES_SCR%" ^
       mpr:IMG -compose Lighten -composite ^
       -fill Black +opaque White ^
    ^) ^
    -antialias ^
    -alpha off -compose CopyOpacity -composite ^
    -process 'fillholespri %FH_PARAMS% dt 0.01 copy window' ^
    -process 'fillholespri %FH_PARAMS% dt 0.1' ^
    -process 'fillholespri %FH_PARAMS% dt 0.5' ^
    -process 'fillholespri %FH_PARAMS%' ^
    -compose Over ^
    -alpha off ^
    %OUTFILE%

    if not "%sSKEL%"=="" %IMG7%magick ^
      %OUTFILE% ^
      %sSKEL% ^
      -alpha off ^
      %OUTFILE%

  echo %0: with holes done

)

if ERRORLEVEL 1 exit /B 1


call echoRestore

endlocal & set %sioCODE%OUTFILE=%OUTFILE%
