rem A compose like a fan.
@rem
@rem Bottom-left: 0.5*y/(1-x)
@rem Top-right: 1 - 0.5*(1-x)/y
@rem Result is black where %2 is black;
@rem white where %1 is white.
@rem Optional %3 is:
@rem   0: no adjustment
@rem   1: adjust by sigmoidal-contrat
@rem   2: adjust by clut
@rem
@rem Updated:
@rem   21-August-2022 Upgraded for IM v7.
@rem


@if "%3"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

rem @call echoOffSave


set ADJ=%4

set FAN_DIAG=%TEMP%\fanDiag.miff
set FAN_CLUT=%TEMP%\fanDiag_icl.miff
set fcTEMP=%TEMP%\fc_wb.miff

if "%ADJ%"=="1" (
  set sADJ=+sigmoidal-contrast "5.45806x50%%"
) else if "%ADJ%"=="2" (

  if not exist %FAN_CLUT% (

    %IMG7%magick ^
      -size 1x10000 gradient:white-black -rotate 90 ^
      %fcTEMP%

    call %PICTBAT%fanComp ^
      %fcTEMP% ^
      %fcTEMP% ^
      %FAN_DIAG%

    del %fcTEMP%

    call %PICTBAT%invClut %FAN_DIAG% %FAN_CLUT%

    del %FAN_DIAG%
  )

  set sADJ=%FAN_CLUT% -clut
) else (
  set sADJ=
)

%IMG7%magick ^
  %1 ^
  %2 ^
  ( -clone 0-1 ^
    ( -clone 0 -negate ) ^
    ( -clone 1 -evaluate Divide 2 ) ^
    -delete 0-1 ^
    -compose DivideDst -composite ^
  ) ^
  ( -clone 0-1 ^
    ( -clone 0 -negate -evaluate Divide 2 ) ^
    -delete 0 ^
    -compose DivideDst -composite ^
    -negate ^
  ) ^
  -delete 0-1 ^
  ( -clone 1 -threshold 50%% ) ^
  -compose Over -composite ^
  %sADJ% ^
  %3


@call echoRestore

@endlocal
