rem Given image %1,
rem %2 text list of coordinates (after 1-line header),
rem colour %3 [black]
rem fill at each coordinate, output to %4.
@rem
@rem Updated:
@rem   14-September-2022 for IM v7.
@rem

setlocal enabledelayedexpansion

set INFILE=%1
set COORDS=%2
set COL=%3
set OUTFILE=%4

if "%COL%"=="." set COL=
if "%COL%"=="" set COL=black

set FC_SCR=\temp\fc_scr.scr

@(
  @for /F "skip=1" %%L in (%COORDS%) do @echo color %%L floodfill
) >%FC_SCR%

%IMG7%magick ^
  %INFILE% ^
  -morphology thicken "3>:-,0,-,1,-,1,0,1,0" ^
  -morphology thicken "3>:-,0,0,1,-,0,0,1,-" ^
  -clamp ^
  -fill %COL% ^
  -draw @%FC_SCR% ^
  %OUTFILE%

endlocal
