rem Given image %1,
rem %2 same-size mask with some white pixels,
rem colour %3 [black]
rem flood-fill %1 at each white in mask, output to %4.
@rem
@rem Updated:
@rem   14-September-2022 for IM v7.
@rem

setlocal enabledelayedexpansion

set INFILE=%1
set MASK=%2
set COL=%3
set OUTFILE=%4

if "%COL%"=="." set COL=
if "%COL%"=="" set COL=black

set FC_SCR=\temp\fp_scr.scr

(
  for /F "usebackq skip=1" %%L in (`%IM7DEV%magick ^
    %MASK% ^
    -process allwhite ^
    NULL: 2^>^&1`) do @echo color %%L floodfill
) >%FC_SCR%

%IMG7%magick ^
  %INFILE% ^
  -morphology thicken "3>:-,0,-,1,-,1,0,1,0" ^
  -morphology thicken "3>:-,0,0,1,-,0,0,1,-" ^
  -alpha off -clamp ^
  -fill %COL% ^
  -draw @%FC_SCR% ^
  %OUTFILE%

endlocal
