rem Given %1 is image, whitish quadrangle on blackish background,
rem finds the four corners by blurred edges.
rem Writes enviroment variable prefix %2
rem and output image %3.
rem %4 is three (quoted) parameters for drawCircs.bat: colour, radius, strokewidth.
@rem
@rem Updated:
@rem   25-August-2022 for IM v7.
@rem


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 f4ceb


set ENV_PREF=%2
if "%ENV_PREF%"=="." set ENV_PREF=
if "%ENV_PREF%"=="" set ENV_PREF=f4cebENV

set OUTFILE=%3
if "%OUTFILE%"=="." set OUTFILE=
if /I "%OUTFILE%"=="NULL:" set OUTFILE=

set dcPARAMS=%~4
if "%dcPARAMS%"=="." set dcPARAMS=
if "%dcPARAMS%"=="" set dcPARAMS=. . .

set TMP_FILE=%BASENAME%_f4ceb.miff

call %PICTBAT%slopeMag %INFILE% %TMP_FILE%

set nFnd=0
for /F "usebackq tokens=1-4 delims=, " %%A in (`%IM7DEV%magick ^
  %TMP_FILE% ^
  -blur 0x5 ^
  -crop 2x2@ ^
  -format "offs: %%s %%X,%%Y\n"
  +write info: ^
  -process midlightest ^
  NULL: 2^>^&1`) do (
  rem echo %%A %%B %%C %%D
  if "%%A"=="offs:" (
    set /A C[%%B].offsX=%%C
    set /A C[%%B].offsY=%%D
  ) else (
    set C[!nFnd!].x=%%A
    set C[!nFnd!].y=%%B
    set /A nFnd+=1
  )
)

if not %nFnd%==4 exit /B 1

for /L %%I in (0,1,3) do (
  set /A C[%%I].x+=!C[%%I].offsX!
  set /A C[%%I].y+=!C[%%I].offsY!
)

rem set C[


set %ENV_PREF%.TL.x=!C[0].x!
set %ENV_PREF%.TL.y=!C[0].y!
set %ENV_PREF%.TR.x=!C[1].x!
set %ENV_PREF%.TR.y=!C[1].y!
set %ENV_PREF%.BL.x=!C[2].x!
set %ENV_PREF%.BL.y=!C[2].y!
set %ENV_PREF%.BR.x=!C[3].x!
set %ENV_PREF%.BR.y=!C[3].y!

if not "%OUTFILE%"=="" call %PICTBAT%drawCircs ^
  %INFILE% ^
  %OUTFILE% ^
  %dcPARAMS% ^
  %ENV_PREF%.TL %ENV_PREF%.TR %ENV_PREF%.BL %ENV_PREF%.BR

set %ENV_PREF%.

set ENV_LIST=%BASENAME%_f4ebEnv.lis
set %ENV_PREF% >%ENV_LIST%

call echoRestore

@endlocal & for /F %%L in (%ENV_LIST%) do @set %%L
