rem Given %1 is image, whitish quadrangle on blackish background,
rem finds the four corners by subimage search.
rem Writes enviroment variable prefix %2
rem and output image %3.
rem %4 is three (quoted) parameters for drawCircs.bat: colour, radius, strokewidth.
@rem
@rem Updated:
@rem   25-August-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 f4cs


set ENV_PREF=%2
if "%ENV_PREF%"=="." set ENV_PREF=
if "%ENV_PREF%"=="" set ENV_PREF=f4csENV

set OUTFILE=%3
if "%OUTFILE%"=="." set OUTFILE=
if /I "%OUTFILE%"=="NULL:" set OUTFILE=

set dcPARAMS=%~4
if "%dcPARAMS%"=="." set dcPARAMS=
if "%dcPARAMS%"=="" set dcPARAMS=. . .


set CORNER=f4cs_dcCorner.miff

set QUARTERS=f4cs_dcQuarters.miff


set SRCH_FACT=2
set SRCH_FACT=20
set SRCH_FACT=10
set SRCH_FACT=20

%IMG7%magick ^
  %INFILE% ^
  -crop 2x2@ ^
  %QUARTERS%

:: Top-left
%IMG7%magick ^
  -size 4x4 xc:Black ^
  -fill White ^
  -draw "rectangle 2,2 3,3" ^
  %CORNER%

set subSemiW=2
set subSemiH=2

call %PICTBAT%subSrchFactRep %QUARTERS%[0] %CORNER% %SRCH_FACT% F4Csub

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "%ENV_PREF%.TL.x=%%X+%%[fx:int(%F4Csub.x%+%subSemiW%+0.5)]\n%ENV_PREF%.TL.y=%%Y+%%[fx:int(%F4Csub.y%+%subSemiH%+0.5)]" ^
  %QUARTERS%[0]`) do set /A %%L

set %ENV_PREF%.TL.BAD=%F4Csub.BAD%


:: Top-right
%IMG7%magick ^
  %CORNER% ^
  -rotate 90 ^
  %CORNER%

call %PICTBAT%subSrchFactRep %QUARTERS%[1] %CORNER% %SRCH_FACT% F4Csub

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "%ENV_PREF%.TR.x=%%X+%%[fx:int(%F4Csub.x%+%subSemiW%+0.5)]\n%ENV_PREF%.TR.y=%%Y+%%[fx:int(%F4Csub.y%+%subSemiH%+0.5)]" ^
  %QUARTERS%[1]`) do set /A %%L

set %ENV_PREF%.TR.BAD=%F4Csub.BAD%


:: Bottom-right
%IMG7%magick ^
  %CORNER% ^
  -rotate 90 ^
  %CORNER%

call %PICTBAT%subSrchFactRep %QUARTERS%[3] %CORNER% %SRCH_FACT% F4Csub

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "%ENV_PREF%.BR.x=%%X+%%[fx:int(%F4Csub.x%+%subSemiW%+0.5)]\n%ENV_PREF%.BR.y=%%Y+%%[fx:int(%F4Csub.y%+%subSemiH%+0.5)]" ^
  %QUARTERS%[3]`) do set /A %%L

set %ENV_PREF%.BR.BAD=%F4Csub.BAD%


:: Bottom-left
%IMG7%magick ^
  %CORNER% ^
  -rotate 90 ^
  %CORNER%

call %PICTBAT%subSrchFactRep %QUARTERS%[2] %CORNER% %SRCH_FACT% F4Csub

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "%ENV_PREF%.BL.x=%%X+%%[fx:int(%F4Csub.x%+%subSemiW%+0.5)]\n%ENV_PREF%.BL.y=%%Y+%%[fx:int(%F4Csub.y%+%subSemiH%+0.5)]" ^
  %QUARTERS%[2]`) do set /A %%L

set %ENV_PREF%.BL.BAD=%F4Csub.BAD%


:: Create a debugging image

if not "%OUTFILE%"=="" call %PICTBAT%drawCircs ^
  %INFILE% ^
  %OUTFILE% ^
  %dcPARAMS% ^
  %ENV_PREF%.TL %ENV_PREF%.TR %ENV_PREF%.BL %ENV_PREF%.BR

set %ENV_PREF%.

set ENV_LIST=%BASENAME%_f4csEnv.lis
set %ENV_PREF% >%ENV_LIST%

call echoRestore

@endlocal & for /F %%L in (%ENV_LIST%) do @set %%L
