rem Given image %1 has a roughly vertical white line, and other noise,
rem on black background,
rem finds left and right boundaries of the vertical line.
rem %2 is 0 (find white line on black background)
rem    or 1 (find black line on white background)
@rem
@rem Returns environment variables.
@rem
@rem Updated:
@rem   29-August-2022
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 fvl

set TMP_FILE=%BASENAME%_fvl.miff

set IS_NEG=%2
if "%IS_NEG%"=="." set IS_NEG=
if "%IS_NEG%"=="" set IS_NEG=0

if %IS_NEG%==0 (
  set sNEG=
) else (
  set sNEG=-channel RGB -negate +channel
)

set XC=
for /F "usebackq delims=, " %%X in (`%IM7DEV%magick ^
  %INFILE% ^
  -scale "x1^!" ^
  -auto-level ^
  %sNEG% ^
  +write %TMP_FILE% ^
  -process onelightest ^
  NULL: 2^>^&1`) do set XC=%%X

if "%XC%"=="" exit /B 1

for /F "usebackq delims=, " %%X in (`%IM7DEV%magick ^
  %TMP_FILE% ^
  -crop +%XC%+0 +repage ^
  -channel RGB -negate +channel ^
  -process onelightest ^
  NULL: 2^>^&1`) do set /A XR=%XC%+%%X-1

for /F "usebackq delims=, " %%X in (`%IM7DEV%magick ^
  %TMP_FILE% ^
  -crop %XC%x+0+0 +repage ^
  -flop ^
  -channel RGB -negate +channel ^
  -process onelightest ^
  NULL: 2^>^&1`) do set /A XL=%XC%-%%X

echo XC=%XC% XR=%XR% XL=%XL%

if %XR% LSS 0 exit /B 1
if %XL% LSS 0 exit /B 1

call echoRestore

endlocal & set fvlXC=%XC%& set fvlXR=%XR%& set fvlXL=%XL%& set /A fvlWW=%XR%-%XL%+1
