rem Given an opaque input image %1,
rem and same-sized image %2 which is %1 composited with a watermark,
rem where watermark pixels are either fully transparent or opacity %3 (0.0 to 1.0),
rem finds the watermark image, and writes it to %4.
rem
rem Also tests the watermark by compositing over %1, compares this to %2,
rem and returns result in FW_COMP,
rem where 0.0 is perfect match, 1.0 is totally different.


@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

rem @call echoOffSave

call %PICTBAT%setInOut %1 fw

set DST=%1
set RES=%2

set ALPHA=%3
if "%ALPHA%"=="." set ALPHA=
if "%ALPHA%"=="" set ALPHA=0.5

if not "%4"=="" if not "%4"=="." set OUTFILE=%4

set TMPDIR=\temp\
set OPAC=%TMPDIR%fw_opac.png

rem Set OPAC to the opacity of the watermark image.
%IMG7%magick ^
  %RES% %DST% ^
  -compose ChangeMask -composite ^
  -alpha extract ^
  -channel RGB -evaluate Multiply %ALPHA% +channel ^
  %OPAC%


rem Implement S = (R - D(1-Sa)) / Sa

rem Calculate S, the assumed watermark.
%IMG7%magick ^
  %RES% ^
  ( %DST% -evaluate Multiply %%[fx:1-%ALPHA%] ) ^
  -compose MinusSrc -composite ^
  -evaluate Divide %ALPHA% ^
  %OPAC% ^
  -compose CopyOpacity -composite ^
  %OUTFILE%


rem Test the calculated watermark.
for /F "usebackq" %%L in (`%IMG7%magick ^
  %DST% ^
  %OUTFILE% ^
  -compose Over -composite ^
  %RES% ^
  -metric RMSE ^
  -precision 16 ^
  -format "FW_COMP=%%[distortion]" ^
  -compare ^
  info:`) do set %%L

echo %0: FW_COMP=%FW_COMP%

call echoRestore

@endlocal & set fwOUTFILE=%OUTFILE%& set FW_COMP=%FW_COMP%
