rem Given an opaque input image %1,
rem and same-sized image %2 which is %1 composited with a watermark,
rem where %3 is same-sized image of opacity for watermark (0=transparent),
rem finds the watermark image, and writes it to %4.
rem
rem Also tests the watermark by compositing over %1, compares this to %2,
rem and returns result in FW_COMP,
rem where 0.0 is perfect match, 1.0 is totally different.
@rem
@rem Updated:
@rem   6-August-2022 for IM v7
@rem


@if "%3"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

rem @call echoOffSave

call %PICTBAT%setInOut %1 fw

set DST=%1
set RES=%2

set ALPHA_IMG=%3

if not "%4"=="" if not "%4"=="." set OUTFILE=%4


rem Implement S = (R - D(1-Sa)) / Sa

rem Calculate S, the assumed watermark.
%IMG7%magick ^
  %RES% ^
  ( %DST% ^
    ( %ALPHA_IMG% -negate ) ^
    -compose Multiply -composite ^
  ) ^
  -compose MinusSrc -composite ^
  %ALPHA_IMG% ^
  -compose DivideSrc -composite ^
  %ALPHA_IMG% ^
  -alpha off ^
  -compose CopyOpacity -composite ^
  %OUTFILE%


rem Test the calculated watermark.
for /F "usebackq" %%L in (`%IMG7%magick ^
  %DST% ^
  %OUTFILE% ^
  -compose Over -composite ^
  %RES% ^
  -metric RMSE ^
  -format "FW_COMP=%%[distortion]" ^
  -compare ^
  info:`) do set %%L

echo %0: FW_COMP=%FW_COMP%

call echoRestore

@endlocal & set fwOUTFILE=%OUTFILE%& set FW_COMP=%FW_COMP%
