rem Given %1 and %2 are same-sized opaque input images without watermarks (D1 and D2),
rem %3 and %4 are those images composited with watermark (R1 and R2),
rem writes watermark to %5.

rem S = (D1*R2 + D2*R1) / (R1 - D1 - R2 + D2)

set IS_OK=0


%IMG7%magick ^
  -define "compose:clamp=off" ^
  +depth ^
  ^( %1 -set colorspace sRGB +write mpr:D1 ^) ^
  ^( %2 -set colorspace sRGB +write mpr:D2 ^) ^
  ^( %3 -set colorspace sRGB +write mpr:R1 ^) ^
  ^( %4 -set colorspace sRGB +write mpr:R2 ^) ^
  -delete 0--1 ^
  ^( mpr:D2 mpr:R1 -compose Multiply -composite ^) ^
  ^( mpr:D1 mpr:R2 -compose Multiply -composite ^) ^
  +depth ^
  -compose MinusSrc -composite ^
  ^( mpr:R1 ^
     mpr:D1 -compose MinusSrc -composite ^
     mpr:R2 -compose MinusSrc -composite ^
     mpr:D2 -compose Add -composite ^
  ^) ^
  -compose DivideSrc -composite ^
  ^( ^
     ^( mpr:D1 ^
        mpr:D2 ^
        -compose MinusSrc -composite ^
        +write mpr:D1mD2 ^
     ^) ^
     mpr:R2 -compose Plus -composite ^
     mpr:R1 -compose MinusSrc -composite ^
     mpr:D1mD2 -compose DivideSrc -composite ^
  ^) ^
  -alpha off -compose CopyOpacity -composite ^
  +depth ^
  -verbose info:


for /F "usebackq" %%L in (`%IMG7%magick ^
  -define "compose:clamp=off" ^
  +depth ^
  ^( %1 -set colorspace sRGB +write mpr:D1 ^) ^
  ^( %2 -set colorspace sRGB +write mpr:D2 ^) ^
  ^( %3 -set colorspace sRGB +write mpr:R1 ^) ^
  ^( %4 -set colorspace sRGB +write mpr:R2 ^) ^
  -delete 0--1 ^
  ^( mpr:D2 mpr:R1 -compose Multiply -composite ^) ^
  ^( mpr:D1 mpr:R2 -compose Multiply -composite ^) ^
  +depth ^
  -compose MinusSrc -composite ^
  ^( mpr:R1 ^
     mpr:D1 -compose MinusSrc -composite ^
     mpr:R2 -compose MinusSrc -composite ^
     mpr:D2 -compose Add -composite ^
  ^) ^
  -compose DivideSrc -composite ^
  ^( ^
     ^( mpr:D1 ^
        mpr:D2 ^
        -compose MinusSrc -composite ^
        +write mpr:D1mD2 ^
     ^) ^
     mpr:R2 -compose Plus -composite ^
     mpr:R1 -compose MinusSrc -composite ^
     mpr:D1mD2 -compose DivideSrc -composite ^
  ^) ^
  -alpha off -compose CopyOpacity -composite ^
  +depth ^
  -format "IS_OK=%%[fx:minima>=0.0 && maxima<=1.0?1:0]\n" ^
  +write info: ^
  %~5 `) do set %%L

if %IS_OK%==0 (
  echo %0: failed
  rem exit /B 1
)

exit /B 0