rem Animated fractal noise.

@rem %1 number of frames [5]
@rem %2 quoted string of first six parameters to fractNoise.bat [". . . . . ."]
@rem %3 prefix for frames and output gif [fna_]
@rem %4 colour variation percent per frame [0]
@rem %5 dx, pixels per frame [0]
@rem %6 dy, pixels per frame [0]
@rem %7 zoom factor per frame eg 0.998 [1]
@rem %8 power factor: 0 = all frequencies change equally. [0]
@rem
@rem Also uses:
@rem   fnA_STEP step for frame numbers given to fractNoise.
@rem
@rem Updated:
@rem   24-September-2022 for IM v7.
@rem

@rem No compulsory parameters
@rem if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 fa


set NUM_FR=%1
if "%NUM_FR%"=="." set NUM_FR=
if "%NUM_FR%"=="" set NUM_FR=5

set FN_PARAM=%~2
if "%FN_PARAM%"=="." set FN_PARAM=
if "%FN_PARAM%"=="" set FN_PARAM=. . . . . .

set PREF=%3
if "%PREF%"=="." set PREF=
if "%PREF%"=="" set PREF=fna_

set fnA_COL=%4
if "%fnA_COL%"=="." set fnA_COL=
if "%fnA_COL%"=="" set fnA_COL=0

set fnA_DX=%5
if "%fnA_DX%"=="." set fnA_DX=
if "%fnA_DX%"=="" set fnA_DX=0

set fnA_DY=%6
if "%fnA_DY%"=="." set fnA_DY=
if "%fnA_DY%"=="" set fnA_DY=0

set ZM=%7
if "%ZM%"=="." set ZM=
if "%ZM%"=="." set ZM=1

set fnA_POW_FAC=%8
if "%fnA_POW_FAC%"=="" set fnA_POW_FAC=
if "%fnA_POW_FAC%"=="" set fnA_POW_FAC=0

if "%fnA_STEP%"=="" set fnA_STEP=1


echo %~n0: FN_PARAM=%FN_PARAM%


set fnAUTO_LEVEL_EACH=0
set fnAUTO_LEVEL_END=0

set FRAME_EXT=.miff
rem set fnTXT_OUT=1

set /A LAST_FR=%NUM_FR%-1

del %PREF%_??????%FRAME_EXT% 2>nul

set fnA_FRM_NUM=0
call %PICTBAT%fnInit %FN_PARAM%
if ERRORLEVEL 1 (
  echo %0: fnInit failure
  exit /B 1
)

set FNUM=0

for /L %%I in (0,1,%LAST_FR%) do (

  set fnA_FRM_NUM=%%I

  set LZ=000000!FNUM!
  set LZ=!LZ:~-6!

  call %PICTBAT%fnOne ^
    %PREF%_!LZ!%FRAME_EXT%

  if ERRORLEVEL 1 (
    echo %0: fnOne failure
    exit /B 1
  )

  echo %~n0: %fnOUTFILE%

  set /A FNUM+=%fnA_STEP%

)

call %PICTBAT%frMinMax %PREF%_??????%FRAME_EXT% 1
if ERRORLEVEL 1 exit /B 1

call %PICTBAT%frGamma %PREF%_??????%FRAME_EXT% . 1
if ERRORLEVEL 1 exit /B 1

%IMG7%magick ^
  -loop 0 -delay 20 ^
  %PREF%_*%FRAME_EXT% ^
  %PREF%.gif


call echoRestore

@endlocal & set faOUTFILE=%OUTFILE%
