rem From image %1,
rem fill holes by using fractal noise displacement map.
@rem
@rem For pyramids, we can specify
@rem displacements as percentage of width and height, plus a small number of pixels eg 2.
@rem FIXME: Should this be percentage of _minimum_ (width,height) ?
@rem
@rem
@rem Updated:
@rem   30-September-2022 for IM v7.
@rem


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 fndf

if not "%2"=="" set OUTFILE=%2

if "%fndfDISP_FACT%"=="" set fndfDISP_FACT=0.5

if "%fndfDISP_PC%"=="" set fndfDISP_PC=5
if "%fndfDISP_ADD%"=="" set fndfDISP_ADD=5

if "%fndfMAX_ITER%"=="" set fndfMAX_ITER=100

set WW=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "WW=%%w\nHH=%%h\nWD=%%[fx:w*%fndfDISP_PC%/100+%fndfDISP_ADD%]\nHD=%%[fx:h*%fndfDISP_PC%/100+%fndfDISP_ADD%]" ^
  %INFILE%`) do set %%L
if "%WW%"=="" exit /B 1

echo %0: INFILE=%INFILE% WW=%WW% HH=%HH% WD=%WD% HD=%HD%


set nIter=0

rem The long convert gives white spots with %IM% v6.9.1-6.

:loop

rem Correction: fractNoise can't take "10c" etc.
rem call %PICTBAT%fractNoise ^
rem   %WW% %HH% 10c 100c . 1.5 fndf_dm.png

call %PICTBAT%fractNoise ^
  %WW% %HH% . . . 1.5 fndf_dm.png

if ERRORLEVEL 1 (
  echo %0: fractNoise failed
  exit /B 1
)

for /F "usebackq" %%L in (`%IMG7%magick ^
  %INFILE% ^
  ^( +clone ^
    %fnOUTFILE% ^
    -virtual-pixel Tile ^
    -compose Displace ^
      -set option:compose:args %WD%x%HD% ^
      -composite ^
    +write x.png ^
  ^) ^
  -compose DstOver -composite ^
  -write %OUTFILE% ^
  -format "OPAQ=%%[opaque]" info:`) do set %%L

set /A nIter+=1

set INFILE=%OUTFILE%

if %nIter% LSS %fndfMAX_ITER% if "%OPAQ%"=="false" goto loop

if "%OPAQ%"=="false" (
  set BUST=1
) else (
  set BUST=0
)

call echoRestore

endlocal & set fndfOUTFILE=%OUTFILE%& set fndfBUST=%BUST%
