rem Makes one fractal noise image.
rem Assumes fnInit.bat has been called.

@rem %1 output file. [fn.png]

@rem No compulsory parameters
@rem
@rem Updated:
@rem   24-September-2022 for IM v7
@rem

@setlocal enabledelayedexpansion

@call echoOffSave

rem call %PICTBAT%setInOut %1 fno


set TMP_BAT=%fnPREFIX%fn.bat
set TMP_SCR=%fnPREFIX%fn.scr
del %TMP_SCR% 2>nul

set OUTFILE=%1
if "%OUTFILE%"=="." set OUTFILE=
if "%OUTFILE%"=="" set OUTFILE=fn.png

set PREC=-precision 15

( echo %fnIM%magick
  rem echo -compose Mathematics -define compose:args=0,1,1,-0.5
  REM echo -compose Mathematics -define compose:args=0,0.5,0.5,0
  if not "%fnFILTER%"=="" echo -filter %fnFILTER%
  if not "%fnSEED%"=="" echo -seed %fnSEED%
  echo -compose Plus -virtual-pixel Tile %PREC%
) >%TMP_BAT%

if "%NUM_OCTAVES%"=="" (
  echo %0: NUM_OCTAVES has no value
  exit /B 1
)

:: ------------------ Loop through octaves------------------
set sWR_PYR=
set sRD_PYR=
set sTILE=

set PYR_FILE=%fnPREFIX%fnpyr%fnNG_EXT%
rem echo PYR_FILE=!PYR_FILE! RD_PYR=%RD_PYR% WR_PYR=%WR_PYR%

set sDBG_GRD=
set sDBG_FULL=

set BLK_SZ=%BLK_MIN%

set /A Nm1=%NUM_OCTAVES%-1

set ERROR=0

rem FIXME?: we auto-each both in sRD_PYR and after PROC_EACH.

for /L %%N in (0,1,%Nm1%) do (

  if "%RD_PYR%"=="1" (
    set sRD_PYR=%PYR_FILE%[%%N]
  ) else (
    set sRD_PYR=-size !N_BLK_W.%%N!x!N_BLK_H.%%N! xc:%sBASE_COL% %NSE% %sLIN% %sAUTO_EACH%
    if "%WR_PYR%"=="1" set sWR_PYR=+write mpr:GRD%%N
  )

  rem echo sRD_PYR=!sRD_PYR!  sWR_PYR=!sWR_PYR!

  if "%fnTILE%"=="1" (

    set FWi=
    for /F "usebackq" %%L in (`%IMG7%magick identify ^
      %PREC% ^
      -format "FWi=%%[fx:%fnWW%/!N_BLK_W.%%N!]\nFHt=%%[fx:%fnHH%/!N_BLK_H.%%N!]" ^
      xc:`) do set %%L
    if "!FWi!"=="" set ERROR=1

    set sTILE=-virtual-pixel Tile +distort SRT "0,0,!FWi!,!FHt!,0,0,0" +repage

    rem FIXME: when we get two distort SRTs, we should merge.

    rem echo sTILE=!sTILE!
  )

  set sANIM=!ccsImStr! -virtual-pixel tile -distort SRT 0,0,1,0,0,0

  if not "%fnA_FRM_NUM%"=="" (
    call xyCoord %fnWW% %fnHH% %fnA_DX% %fnA_DY%

    for /F "usebackq" %%L in (`%IMG7%magick identify ^
      %PREC% ^
      -format "ZM_F=%%[fx:pow^(%fnA_ZM%,%fnA_FRM_NUM%^)]\nDX_F=%%[fx:!xycX!*%fnA_FRM_NUM%]\nDY_F=%%[fx:!xycY!*%fnA_FRM_NUM%]" ^
      xc:`) do set %%L

    if "%fnTXT_OUT%"=="1" echo fnA_FRM_NUM=%fnA_FRM_NUM% ZM_F=!ZM_F! DX_F=!DX_F! DY_F=!DY_F!

    for /F "usebackq" %%L in (`%IMG7%magick identify ^
      %PREC% ^
      -format "COL=%%[fx:%fnA_COL%*%fnA_FRM_NUM%*!AN_AMP.%%N!]\nDX=%%[fx:!DX_F!*!AN_AMP.%%N!*!N_BLK_W.%%N!/%fnWW%]\nDY=%%[fx:!DY_F!*!AN_AMP.%%N!*!N_BLK_H.%%N!/%fnHH%]" ^
      xc:`) do set %%L

    rem echo %0: N=%%N AN_AMP.%%N=!AN_AMP.%%N!  COL=!COL! DX=!DX! DY=!DY!

    call %PICTBAT%colCyclStr %fnA_COLCYCMETH% !COL!
    if ERRORLEVEL 1 echo %0: Bad colCyclStr && exit /B 1

    set sANIM=!ccsImStr! -virtual-pixel tile -distort SRT !DX!,!DY!,1,0,0,0

    if "%fnTXT_OUT%"=="1" echo .   AN_AMP.%%N=!AN_AMP.%%N! sANIM=!sANIM!
  )

  if "%fnDEBUG%"=="1" (
    set sDBG_GRD=+write %fnPREFIX%grd_%%N.png
    set sDBG_FULL=+write %fnPREFIX%full_%%N.png
  )

  echo ^( !sRD_PYR! !sWR_PYR! !sDBG_GRD! !sANIM! !sTILE! -resize "%fnWW%x%fnHH%^^^!" !sDBG_FULL! %fnPROC_EACH% %sAUTO_EACH% %sABS% !sLEVEL.%%N! ^) >>%TMP_SCR%

  if "%fnTXT_OUT%"=="1" echo -format "levels %%N: %%%%[fx:minima] %%%%[fx:maxima]\n" +write info: >>%TMP_SCR%

  if %%N GTR 0 echo -compose Mathematics -define compose:args=0,1,1,-0.5 -composite >>%TMP_SCR%

  for /F "usebackq" %%L in (`%IMG7%magick identify ^
    %PREC% ^
    -format "BLK_SZ=%%[fx:!BLK_SZ!*%BLK_FAC%]" ^
    xc:`) do set %%L
)

(
  if "%fnTXT_OUT%"=="1" echo -format "levels before AL: %%%%[fx:minima] %%%%[fx:maxima]\n" +write info:
  if not "%sONE_CHAN%"=="" echo %sONE_CHAN%
  if not "%sDELIN%"=="" echo %sDELIN%
  if not "%sAUTO_END%"=="" echo %sAUTO_END%
  echo +depth
  echo +write %OUTFILE%

  if "%WR_PYR%"=="1" (
    echo +delete
    for /L %%N in (0,1,%Nm1%) do @(
      @echo mpr:GRD%%N
    )
    echo -write %PYR_FILE%
    echo -exit
  )
) >>%TMP_SCR%

if %ERROR%==1 (
  echo %0: ERROR is 1
  exit /B 1
)

cPrefix /p0 /i%TMP_BAT% /r" ^"
echo -script %TMP_SCR% >>%TMP_BAT%

rem type %TMP_BAT%
rem type %TMP_SCR%


call %TMP_BAT%
if ERRORLEVEL 1 exit /B 1 >>%TMP_BAT%

if "%fnTXT_OUT%"=="1" (
  echo Created %OUTFILE%
  if "%WR_PYR%"=="1" echo ... and %PYR_FILE%
)

call echoRestore

@endlocal & set fnOUTFILE=%OUTFILE%&set fnPYR_FILE=%PYR_FILE%& set fnWW=%fnWW%& set fnHH=%fnHH%& set fnNUM_OCTAVES=%NUM_OCTAVES%& set fnPOW_FAC=%POW_FAC%
