rem Finds min and max values of %1, a wildcarded filename eg frames_*.png.
@rem
@rem %2 if 1, also levels each image accordingly.
@rem
@rem Returns:
@rem   fmmMIN minimum value found in all pixels of all frames.
@rem   fmmMAX maximum value found in all pixels of all frames.
@rem   fmmMIN_PC minimum as a percentage.
@rem   fmmMAX_PC maximum as a percentage.
@rem
@rem Updated:
@rem   24-September-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 fmm


set DO_LEV=%2
if "%DO_LEV%"=="." set DO_LEV=
if "%DO_LEV%"=="" set DO_LEV=0

if "%fmmIM%"=="" set fmmIM=%IMG7%

set PREC=-precision 15

set MIN=9999
set MAX=-9999
for %%F in (%1) do (
  for /F "usebackq" %%L in (`%fmmIM%magick ^
    %%F ^
    %PREC% ^
    -format "MIN=%%[fx:min(!MIN!,minima)]\nMAX=%%[fx:max(!MAX!,maxima)]" ^
    info:`) do set %%L
)

for /F "usebackq" %%L in (`%fmmIM%magick identify ^
  %PREC% ^
  -format "MIN_PC=%%[fx:!MIN!*100]\nMAX_PC=%%[fx:!MAX!*100]" ^
  xc:`) do set %%L

if "%MIN%"=="9999" echo %0: no images & exit /B 1

if "%DO_LEV%"=="1" (
  for %%F in (%1) do %fmmIM%magick ^
    %%F ^
    -level %MIN_PC%%%,%MAX_PC%%% ^
    %%F
)

call echoRestore

@endlocal & set fmmMIN=%MIN%& set fmmMAX=%MAX%& set fmmMIN_PC=%MIN_PC%& set fmmMAX_PC=%MAX_PC%
