rem %1 "from" image
rem %2 "to" image
rem %3 percentage tolerance
rem %4 Nx1 some colours in %1
rem makes %5, Nx2, with corresonding colours in %2.
rem 
@rem CAUTION: This assumes SRC_FROM has pixels within given tolerance
@rem   of each colour in COLS_FROM.
@rem If this isn't true, we get bad colours in the second row.
@rem
@rem Updated:
@rem   26-August-2018 Added +repage after append.
@rem   4-August-2022 for IM v7.
@rem


@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 ftc


set SRC_FROM=%1
set SRC_TO=%2
set PC_TOL=%3
set COLS_FROM=%4
set COLS_TO=%5

set TMPDIR=%TEMP%\
set TMPOUT=%TMPDIR%ftc_tmp_out.miff

set TMP_SRC_FROM=%TMPDIR%ftc_tmp_src_from.miff
set TMP_SRC_TO=%TMPDIR%ftc_tmp_src_to.miff
set TMP_COLS_FROM=%TMPDIR%ftc_tmp_cols_from.miff

%IMG7%magick %SRC_FROM% %TMP_SRC_FROM%
%IMG7%magick %SRC_TO% %TMP_SRC_TO%
%IMG7%magick %COLS_FROM% %TMP_COLS_FROM%

set WW=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "WW=%%w\nHH=%%h\n" ^
  %SRC_FROM%`) do set %%L
if "%WW%"=="" exit /B 1

set CW=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "CW=%%w\nCWm1=%%[fx:w-1]\nCH=%%h\n" ^
  %COLS_FROM%`) do set %%L
if "%CW%"=="" exit /B 1

for /L %%I in (0,1,%CWm1%) do (
  echo %%I

  if %%I==0 (
    set sOUT=%TMPOUT%
  ) else (
    set sOUT=%TMPOUT% +swap +append +repage %TMPOUT%
  )

  %IMG7%magick ^
    %TMP_SRC_FROM% ^
    ^( %TMP_COLS_FROM% -crop 1x1+%%I+0 +repage -scale "%WW%x%HH%^!" ^) ^
    -compose Difference -composite ^
    -grayscale RMS -threshold %PC_TOL%%% -negate ^
    %TMP_SRC_TO% ^
    +swap ^
    -alpha off -compose CopyOpacity -composite ^
    -scale "1x1^!" ^
    -alpha off ^
    !sOUT!
)

%IMG7%magick ^
  %COLS_FROM% ^
  %TMPOUT% ^
  -append +repage ^
  %COLS_TO%

call echoRestore

endlocal & set ftcOUTFILE=%OUTFILE%
