rem From image %1,
rem makes outputs %2 (must contain XX, should allow at least 32-bit)
rem   _dct and _imag,
rem forward discrete cosine transformation.
rem Also creates environment variable prefix %3 with suffixes
rem   _ww  input image width
rem   _hh  input image height

rem FIXME: option to roll to put centre at top-left?


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 dct

set OUTFILE=%2
if "%OUTFILE%"=="." set OUTFILE=
if "%OUTFILE%"=="" set OUTFILE=%BASENAME%_dct_XX.miff

set ENV_PREF=%3
if "%ENV_PREF%"=="." set ENV_PREF=
if "%ENV_PREF%"=="" set ENV_PREF=dct

set OUT_DCT=%OUTFILE:XX=dct%
set OUT_IMAG=%OUTFILE:XX=imag%

if "%OUT_DCT%"=="%OUT_IMAG%" (
  echo Bad OUTFILE [%OUTFILE%] -- should contain XX
  exit /B 1
)

set WW=
for /F "usebackq" %%L in (`%IM%identify ^
  -format "WW=%%w\nHH=%%h\nMAX_WH=%%[fx:max(w,h)]" ^
  %INFILE%`) do set %%L
if "%WW%"=="" exit /B 1


%IMDEV%convert ^
  %INFILE% ^
  -background Black ^
  -gravity NorthWest ^
  -extent %MAX_WH%x%MAX_WH% ^
  ( +clone -flop ) +append ^
  ( +clone -flip ) -append ^
  +fft ^
  -define quantum:format=floating-point ^
  ( -clone 0 -write %OUT_DCT% +delete ) ^
  -delete 0 ^
  %OUT_IMAG%

if ERRORLEVEL 1 (
  echo No FFT
  exit /B 1
)

call echoRestore

endlocal & set %ENV_PREF%_ww=%WW%&^
set %ENV_PREF%_hh=%HH%
