@rem
@rem Updated:
@rem   21-August-2022 Upgraded for IM v7.
@rem

@echo off

rem See \prose\pictures\hex.bat

setlocal

set SRC=%1

set nRows=%3
if "%nRows%"=="" set nRows=2

set STYLE=%4
if "%STYLE%"=="" set STYLE=RESIZE

set TMPEXT=miff

FOR /F %%i IN ('%IMG7%magick identify -format "%%[fx:int(2*%Height%/sqrt(3)+0.5)]" xc:') DO set TriSide=%%i

set /A SemiTriSide=%TriSide%/2
set /A semiWi=%Width%/2
set /A wim1=%Width%-1
set /A htm1=%Height%-1
set /A TriLeft=(%Width%-%TriSide%)/2
set /A TriRight=(%Width%+%TriSide%)/2
set /A CanvasWi=%TriSide%*3
set /A CanvasSemiWi=%TriSide%*3/2
set /A Canv23=%TriSide%*2
set /A Canv13=%TriSide%

"%IMG7%magick" ^
  -size %Width%x%Height% xc:White ^
  -set colorspace RGB ^
  -fill #000 ^
  -draw "polygon 0,0 %semiWi%,0 %TriLeft%,%htm1% 0,%htm1%" ^
  -alpha off ^
  -colorspace sRGB ^
  -write %FXTEMP%hexBlankL.%TMPEXT% ^
  -flop ^
  %FXTEMP%hexBlankR.%TMPEXT%

"%IMG7%magick" ^
  -size %CanvasWi%x%Height% xc:None ^
  -gravity North ^
  %SRC% ^
  -compose Over -composite ^
  -write %FXTEMP%hexOnCanv.%TMPEXT% ^
  %FXTEMP%hexBlankR.%TMPEXT% ^
  -compose CopyOpacity -composite ^
  ( +clone -flip -write %FXTEMP%hexL3.%TMPEXT% +delete ) ^
  -virtual-pixel None ^
  -distort SRT "%CanvasSemiWi%,0 -1,1 -60 %CanvasSemiWi%,0" ^
  %FXTEMP%hexR.%TMPEXT%

"%IMG7%magick" ^
  %FXTEMP%hexOnCanv.%TMPEXT% ^
  %FXTEMP%hexBlankL.%TMPEXT% ^
  -gravity North ^
  -compose CopyOpacity -composite ^
  ( +clone -flip -write %FXTEMP%hexR3.%TMPEXT% +delete ) ^
  -virtual-pixel None ^
  -distort SRT "%CanvasSemiWi%,0 -1,1 60 %CanvasSemiWi%,0" ^
  %FXTEMP%hexL.%TMPEXT%

"%IMG7%magick" ^
  %FXTEMP%hexOnCanv.%TMPEXT% ^
  -virtual-pixel None ^
  ( +clone ^
    -distort SRT "%Canv23%,%htm1% 1,1 120 %Canv23%,%htm1%" ^
    -write %FXTEMP%hexR2.%TMPEXT% +delete ) ^
  -distort SRT "%Canv13%,%htm1% 1,1 -120 %Canv13%,%htm1%" ^
  %FXTEMP%hexL2.%TMPEXT%

"%IMG7%magick" ^
  %FXTEMP%hexOnCanv.%TMPEXT% ^
  -gravity North ^
  %FXTEMP%hexR.%TMPEXT% ^
  -composite ^
  %FXTEMP%hexR2.%TMPEXT% ^
  -composite ^
  %FXTEMP%hexL.%TMPEXT% ^
  -composite ^
  %FXTEMP%hexL2.%TMPEXT% ^
  -composite ^
  ( %FXTEMP%hexL3.%TMPEXT% -geometry -%CanvasSemiWi%+0 ) ^
  -composite ^
  ( %FXTEMP%hexR3.%TMPEXT% -geometry +%CanvasSemiWi%+0 ) ^
  -composite ^
  %FXTEMP%hexX.%TMPEXT%

rem  -crop %Width%x%Height%+0+0 ^
rem  hexXc.%TMPEXT%

rem If nRows==1, we've got it.
if %nRows%==1 goto skipMult

set sThird=
if %nRows%==3 set sThird=+clone -swap 0,1

"%IMG7%magick" ^
  %FXTEMP%hexX.%TMPEXT% ^
  ( +clone -flip ) ^
  %sThird% ^
  -append +repage ^
  %FXTEMP%hexX.%TMPEXT%

:skipMult
rem hexX.%TMPEXT% is %CanvasWi% wide, %Height% * nRows high.

set sResize=
set sCrop=
set sPad=

rem Where are these supposed to come from?
set nWi=0
set nHt=0

echo STYLE = %STYLE%
echo nWi=%nWi% nHt=%nHt%

if /I %STYLE% EQU CROP (
  echo Crop
  rem set sCrop=-gravity Center -crop %Width%x%Height%+0+0 +repage
  set /A cropWi=%Width%
  set /A cropHt=%Height%
) else if /I %STYLE% EQU RESIZE (
  echo Resize
  set sResize=-resize "%Width%x%Height%^^^! "
  set /A cropWi=0
) else if /I %STYLE% EQU CROPRESIZE (
  echo CropResize
rem FIXME
  if %nWi% EQU %nHt% (
    echo No crop
    set /A cropWi=0
  ) else if %nWi% GTR %nHt% (
    set /A cropWi=%Width%*%nHt%
    set /A cropHt=%Height%*%nHt%
  ) else (
    set /A cropWi=%Width%*%nWi%
    set /A cropHt=%Height%*%nWi%
  )
  set sResize=-resize "%Width%x%Height%^^^! "
) else if /I %STYLE% EQU RESIZEPAD (
  echo ResizePad
  set sResize=-resize "%Width%x%Height%"
  set sPad=-size %Width%x%Height% xc:%fxBackground% +swap -gravity Center -compose Over -composite
  set /A cropWi=0
) else (
  echo fxTri: Bad style [%STYLE%]
  exit /B 1
)

if not %cropWi%==0 set sCrop=-gravity Center -crop %cropWi%x%cropHt%+0+0 +repage

"%IMG7%magick" ^
  %FXTEMP%hexX.%TMPEXT% ^
  %sCrop% ^
  %sResize% ^
  %sPad% ^
  %WrFileOptions% ^
  %2

"%IMG7%magick" identify %2

@echo on
