rem Tests dcraw and eqLimit with a variety of parameters.
rem %1 is input raw file.

if "%IMH%"=="" set IMH=%IM%

set IN_RAW=%1
if not exist "%1" (
  echo %0: "%1" does not exist
  exit /B 1
)

set RAW_BASE=%~n1

set COUNT_PROC=-separate +append -process 'mkhisto norm' -fill White +opaque Black

set WEB_SIZE=-resize 300x300

set OUT_LIS=ge_gameql.lis
del %OUT_LIS% 2>nul

set TMP_SRGB=%TEMP%\ge_IM_srgb.tiff

set OUT_TIFF=%TEMP%\ge_temp.tiff
%IMG7%dcraw -v -6 -w -W -g 1 0 -o 0 -T -O %OUT_TIFF% %IN_RAW%

call %PICTBAT%gamMaxSd %OUT_TIFF% 0.05 10

call :geOne %IN_RAW% 0 . .
call :geOne %IN_RAW% 0 1 0
call :geOne %IN_RAW% 0 1 4.5
call :geOne %IN_RAW% 0 2.2222 0
call :geOne %IN_RAW% 0 2.2222 4.5
call :geOne %IN_RAW% 0 2.2222 12.92
call :geOne %IN_RAW% 0 %gmsGAM_MAX_SD% 0
call :geOne %IN_RAW% 0 4 0

call :geOne %IN_RAW% 1 . .
call :geOne %IN_RAW% 1 1 0
call :geOne %IN_RAW% 1 1 4.5
call :geOne %IN_RAW% 1 2.2222 0
call :geOne %IN_RAW% 1 2.2222 4.5
call :geOne %IN_RAW% 1 2.2222 12.92
call :geOne %IN_RAW% 1 %gmsGAM_MAX_SD% 0
call :geOne %IN_RAW% 1 4 0


rem ===============================
rem
rem Try sRGB version from IM.

%IMG7%magick ^
  ge_%RAW_BASE%_g1_0_ab.tiff ^
  -set colorspace RGB -colorspace sRGB ^
  %TMP_SRGB%

%IMG7%magick ^
  %TMP_SRGB% ^
  -format "MIN=%%[fx:minima]  MAX=%%[fx:maxima]  MEAN=%%[fx:mean]  SD=%%[fx:standard_deviation]\n" ^
  -write info: ^
  ^( +clone ^
    -colorspace HCL ^
    -format "SatMin=%%[fx:minima.g]  SatMax=%%[fx:maxima.g]  SatMean=%%[fx:mean.g]  SatSD=%%[fx:standard_deviation.g]\n" ^
    -write info: ^
    +delete ^
  ^) ^
NULL:>ge_im_srgb.lis

if ERRORLEVEL 1 exit /B 1

%IM7DEV%magick ^
  %TMP_SRGB% ^
  %COUNT_PROC% ^
  -format "hist_entries=%%[fx:mean]\n" ^
  info: >>ge_im_srgb.lis

if ERRORLEVEL 1 exit /B 1

%IMG7%magick ^
  %TMP_SRGB% ^
  -define histogram:unique-colors=false ^
  +write histogram:ge_im_srgb_hist.png ^
  %WEB_SIZE% ^
  ge_im_srgb_sm.jpg

if ERRORLEVEL 1 exit /B 1

exit /B 0


rem ============ Subroutines ===================
rem

rem Params to geOne:
rem  %1 raw filename
rem  %2 0 if -W (no auto-brighten); 1 if auto-brighten
rem  %3 first -g parameter (or "." for no -g)
rem  %4 second -g parameter

:geOne
set G_ARG=
set G_NAME=gnull
set G1=%3
set G2=%4
if not "%3"=="." (
  set G_ARG=-g %3 %4
  set G_NAME=g%G1:.=-%_%G2:.=-%
)
echo G_NAME=%G_NAME%
set W_ARG=
set AB_NAME=ab
if "%2"=="0" (
  set W_ARG=-W
  set AB_NAME=nab
)

set BASE=ge_%RAW_BASE%_%G_NAME%_%AB_NAME%
set OUT_TIFF=%BASE%.tiff
set OUT_EQL=%BASE%_eql.tiff
rem set OUT_LIS=%BASE%.lis
rem del %OUT_LIS% 2>nul

echo OUT_TIFF=%OUT_TIFF%

%IMG7%dcraw -v -H 0 -6 -w %W_ARG% %G_ARG% -o 0 -T -O %OUT_TIFF% %1
if ERRORLEVEL 1 exit /B 1

%IMG7%magick ^
  %OUT_TIFF% ^
  -format "%%f\nMIN=%%[fx:minima]  MAX=%%[fx:maxima]  MEAN=%%[fx:mean]  SD=%%[fx:standard_deviation]\n" ^
  -write info: ^
  ^( +clone ^
    -colorspace HCL ^
    -format "SatMin=%%[fx:minima.g]  SatMax=%%[fx:maxima.g]  SatMean=%%[fx:mean.g]  SatSD=%%[fx:standard_deviation.g]\n" ^
    -write info: ^
    +delete ^
  ^) ^
NULL:>>%OUT_LIS%

if ERRORLEVEL 1 exit /B 1

%IM7DEV%magick ^
  %OUT_TIFF% ^
  %COUNT_PROC% ^
  -format "hist_entries=%%[fx:mean]\n\n" ^
  info: >>%OUT_LIS%

if ERRORLEVEL 1 exit /B 1

call %PICTBAT%eqLimit %OUT_TIFF%

if ERRORLEVEL 1 exit /B 1

echo Result of eqLimit.bat: >>%OUT_LIS%

%IMG7%magick ^
  %OUT_EQL% ^
  -format "MIN=%%[fx:minima]  MAX=%%[fx:maxima]  MEAN=%%[fx:mean]  SD=%%[fx:standard_deviation]\n" ^
  -write info: ^
  ^( +clone ^
    -colorspace HCL ^
    -format "SatMin=%%[fx:minima.g]  SatMax=%%[fx:maxima.g]  SatMean=%%[fx:mean.g]  SatSD=%%[fx:standard_deviation.g]\n" ^
    -write info: ^
    +delete ^
  ^) ^
NULL:>>%OUT_LIS%

%IM7DEV%magick ^
  %OUT_EQL% ^
  %COUNT_PROC% ^
  -format "hist_entries=%%[fx:mean]\n\n\n\n" ^
  info: >>%OUT_LIS%

if ERRORLEVEL 1 exit /B 1

%IMG7%magick ^
  %OUT_TIFF% ^
  -define histogram:unique-colors=false ^
  +write histogram:%BASE%_hist.png ^
  %WEB_SIZE% ^
  %BASE%_sm.jpg

if ERRORLEVEL 1 exit /B 1

%IMG7%magick ^
  %OUT_EQL% ^
  -define histogram:unique-colors=false ^
  +write histogram:%BASE%_eql_hist.png ^
  %WEB_SIZE% ^
  %BASE%_eql_sm.jpg

if ERRORLEVEL 1 exit /B 1

rem
rem ============ End Subroutines ===================
