rem Given image %1,
rem writes %2 as Gaussian standard deviation,
rem with operation %3, default "-blur 0x1".
rem %4 is post-processing, eg "-auto-level".
rem %5 is not blank or ".", writes mean to this file.
@rem
@rem Updated:
@rem   17-December-2017 Added %5
@rem   23-January-2020 Use v7 magick; add QUANT_FP
@rem


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 gsd

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

call %PICTBAT%quantFP %OUTFILE%

set sBLUR=%~3
if "%sBLUR%"=="." set sBLUR=
if "%sBLUR%"=="" set sBLUR=-blur 0x1

set sPOST=%~4
if "%sPOST%"=="." set sPOST=

set OUT_MN=%5
if "%OUT_MN%"=="." set OUT_MN=

if "%OUT_MN%"=="" (
  set sOUT_MN=
) else (
  set sOUT_MN=+write %OUT_MN%
)

%IMG7%magick ^
  %INFILE% ^
  %QUANT_FP% ^
  ( -clone 0 ^
    -evaluate Pow 2 ^
    %sBLUR% ^
  ) ^
  ( -clone 0 ^
    %sBLUR% ^
    %sOUT_MN% ^
    -evaluate Pow 2 ^
  ) ^
  -delete 0 ^
  -alpha off ^
  -compose MinusSrc -composite ^
  -evaluate Pow 0.5 ^
  %sPOST% ^
  %OUTFILE%

call echoRestore

endlocal & set gsdOUTFILE=%OUTFILE%


