rem Given %1 is an indexed image,
rem extracts the colormap, making a clut Nx1 image %2.
@rem
@rem Updated:
@rem   25-September-2022 for IM v7.
@rem

setlocal enabledelayedexpansion

@call echoOffSave

set INFILE=%1
set OUTFILE=%2

if "%OUTFILE%"=="" set OUTFILE=gcb.png

set TMP_LIS=\temp\gcb.lis

set HASMAP=0
set INMAP=0

for /F "usebackq tokens=1-2 delims=:" %%A in (`%IMG7%magick identify ^
  -verbose %INFILE%`) do (

  set FIRST=%%A

  if !INMAP!==0 if "%%A"=="  Colormap entries" (
    set /A NUM_ENTRIES=%%B
    echo # ImageMagick pixel enumeration: !NUM_ENTRIES!,1,255,srgb >%TMP_LIS%
  )

  if !INMAP!==1 (
    if "!FIRST:~0,4!"=="    " (
      echo %%A,0: %%B >>%TMP_LIS%
    ) else (
      set INMAP=0
    )
  )
  if !INMAP!==0 if "%%A"=="  Colormap" (
    set HASMAP=1
    set INMAP=1
  )
)

if %HASMAP%==0 (
  echo Input [%INFILE%] has no colormap.
  exit /B 1
) else (
  %IMG7%magick %TMP_LIS% %OUTFILE%

  echo NUM_ENTRIES=%NUM_ENTRIES%

  %IMG7%magick identify %OUTFILE%
)

call echoRestore

@endlocal