rem Given %1 is the name of an environment variable containing coordinate pairs,
rem returns perspective parameters in structure %2.SY etc.
rem %3 is method to use: affine or perspective [default perspective]
rem
rem Updated:
rem   23-October-2018 Added %3 for method.
rem   [[5-November-2018 Changed %1 to be actual string of coords, not an env var.]]

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

rem NOTE:
rem This can give stupid results, eg for input:
rem   "0,0,5,5 100,100,105,105 70,70,65,72"
rem 
rem IM gives:
rem 
rem Affine Projection:
rem   -distort AffineProjection \
rem       '1428571428571413.200000,428571428571413.440000,-1428571428571413.200000,
rem  -428571428571413.440000,0.000000,0.000000'

set COORD_PAIRS=!%1!
rem set COORD_PAIRS=%~1
echo %0: COORD_PAIRS = %COORD_PAIRS%

set MTHD=%3
if "%MTHD%"=="." set MTHD=
if "%MTHD%"=="" set MTHD=perspective

set /A nLINE=0

for /F "usebackq tokens=*" %%L in (`%IMG7%magick ^
  xc: ^
  -precision 9 ^
  -verbose ^
  -distort %MTHD% "%COORD_PAIRS%" ^
  +verbose ^
  NULL: 2^>^&1`) do (
  set LINE=%%L
  set LINE=!LINE:^>=GREATER_THAN!
  set LINE=!LINE:^<=LESS_THAN!
  set LINES[!nLINE!]=!LINE!
  set /A nLINE+=1
  echo %0: LINE=!LINE!
)

rem echo nLINE=%nLINE%

rem echo 0: %LINES[0]%
rem echo 1: %LINES[1]%
rem echo 2: %LINES[2]%
rem echo 3: %LINES[3]%

rem echo 4: {%LINES[4]%}
rem echo 5: {%LINES[5]%}
rem echo 6: {%LINES[6]%}
rem echo 7: {%LINES[7]%}
rem echo 8: {%LINES[8]%}
rem echo 9: {%LINES[9]%}

rem We could also save the "-distort ..." command, if we wanted.

set IsPersp=0

for /F "tokens=1-4 delims=',: " %%A in ("%LINES[0]%") do (
  if /I "%%A" equ "Perspective" set IsPersp=1
)

rem echo IsPersp=%IsPersp%


if %IsPersp%==1 goto IsPersp

  rem Affine

  for /F "tokens=1-6 delims=', " %%A in ("%LINES[2]%") do (
    rem echo %%A %%B %%C %%D %%E %%F
    set SX=%%A
    set RX=%%B
    set RY=%%C
    set SY=%%D
    set TX=%%E
    set TY=%%F
    set PX=0
    set PY=0
  )
  set DIST_FX=%LINES[4]% %LINES[5]% %LINES[6]% %LINES[7]%

  set DIST_FX=%DIST_FX:'="%
  set DIST_FX=%DIST_FX:\=%

  goto endPersp

:IsPersp
  rem Perspective

  for /F "tokens=1-4 delims=', " %%A in ("%LINES[2]%") do (
    rem echo %%A %%B %%C %%D
    set SX=%%A
    set RY=%%B
    set TX=%%C
    set RX=%%D
  )

  for /F "tokens=1-4 delims=', " %%A in ("%LINES[3]%") do (
    rem echo %%A %%B %%C %%D
    set SY=%%A
    set TY=%%B
    set PX=%%C
    set PY=%%D
  )

  set DIST_FX=%LINES[5]% %LINES[6]% %LINES[7]% %LINES[8]% %LINES[9]%

  set DIST_FX=%DIST_FX:'="%
  set DIST_FX=%DIST_FX:\=%
  set DIST_FX=%DIST_FX:GREATER_THAN=^>%
  set DIST_FX=%DIST_FX:LESS_THAN=^<%

:endPersp

rem echo DIST_FX=%DIST_FX%

rem if not %IsPersp%==1 exit /B 1


@call echoRestore

@endlocal & set %2.SX=%SX%& set %2.RY=%RY%& set %2.TX=%TX%& set %2.RX=%RX%& set %2.SY=%SY%& set %2.TY=%TY%& set %2.PX=%PX%& set %2.PY=%PY%& set %2.DIST_FX=%DIST_FX%
