set xc2=xc:#abd xc:#432

%FXOLD%magick %xc2% -append +repage gfs.png

set VPIX=-virtual-pixel Black
set PREC=-precision 6
set OUTSPEC=-define quantum:format=floating-point -depth 32


echo off
(
for /F "tokens=*" %%L in (%~dp0goodfxsyntax.txt) do (
  ( %FXNEW%magick %PREC% gfs.png %VPIX% -fx "%%L" %OUTSPEC% gfs_new.miff 2^>^&1 ) |tail -5

  %FXOLD%magick %PREC% gfs.png %VPIX% -fx "%%L" %OUTSPEC% gfs_old.miff

  set cleaned=%%L
  set "cleaned=!cleaned:<=&lt;!"
  set "cleaned=!cleaned:>=&gt;!"
  set "cleaned=!cleaned:&=++amp++!"
  set "cleaned=!cleaned:%%=__!"
  set "cleaned=!cleaned:++amp++=&amp;!"

  %IMG7%magick %PREC% gfs_old.miff gfs_new.miff -metric RMSE -format "=start= '!cleaned!' distortion=%%[distortion] =end=\n" -compare info: 
)
) >fxn_gfs.lis 

echo on

cgrep /ifxn_gfs.lis /ofxn_gfs1a.lis /sdistortion= /f\s\r\n

chStrs /ifxn_gfs1a.lis /ofxn_gfs1a.lis /f"\(" /t^&lt;
chStrs /ifxn_gfs1a.lis /ofxn_gfs1a.lis /f"\)" /t^&gt;
chStrs /ifxn_gfs1a.lis /ofxn_gfs1a.lis /f"__" /t%%

chStrs /ifxn_gfs1a.lis /ofxn_gfs1b.lis /f"=start=" /t\(tr\)\(td\)
chStrs /ifxn_gfs1b.lis /ofxn_gfs1b.lis /f"distortion=" /t\(/td\)\(td\)
chStrs /ifxn_gfs1b.lis /ofxn_gfs1b.lis /f"=end=" /t\(/td\)\(/tr\)

cPrefix /ifxn_gfs1b.lis /X /t"\(tr\)\(th\)-fx input string\(/th\)\(th\)distortion\(/th\)\(/tr\)"
cPrefix /ifxn_gfs1b.lis /X /t"\(table\)" /b"\(/table\)"


echo off
(
for /F "tokens=*" %%L in (%~dp0goodfxsyntax2.txt) do (
  ( %FXNEW%magick %PREC% -size 4x4 %xc2% %VPIX% -fx "%%L" %OUTSPEC% gfs2_new.miff 2^>^&1 ) |tail -5

  %FXOLD%magick %PREC% -size 4x4 %xc2% %VPIX% -fx "%%L" %OUTSPEC% gfs2_old.miff

  set cleaned=%%L

  set cleaned=!cleaned:%%=__!

  %IMG7%magick %PREC% gfs2_old.miff gfs2_new.miff -metric RMSE -format "=start= '!cleaned!' distortion=%%[distortion] =end=\n" -compare info:
)
) >fxn_gfs2.lis

echo on

cgrep /ifxn_gfs2.lis /ofxn_gfs2a.lis /sdistortion= /f\s\r\n

chStrs /ifxn_gfs2a.lis /ofxn_gfs2b.lis /f"=start=" /t\(tr\)\(td\)
chStrs /ifxn_gfs2b.lis /ofxn_gfs2b.lis /f"distortion=" /t\(/td\)\(td\)
chStrs /ifxn_gfs2b.lis /ofxn_gfs2b.lis /f"=end=" /t\(/td\)\(/tr\)

cPrefix /ifxn_gfs2b.lis /X /t"\(tr\)\(th\)-fx input string\(/th\)\(th\)distortion\(/th\)\(/tr\)"
cPrefix /ifxn_gfs2b.lis /X /t"\(table\)" /b"\(/table\)"


echo off
(
for /F "tokens=*" %%L in (%~dp0goodBadFxSyntax.txt) do (
  ( %FXNEW%magick %PREC% -size 4x4 %xc2% %VPIX% -fx "%%L" %OUTSPEC% gfs3_new.miff 2^>^&1 ) |tail -5

  %FXOLD%magick %PREC% -size 4x4 %xc2% %VPIX% -fx "%%L" %OUTSPEC% gfs3_old.miff

  set cleaned=%%L

  set cleaned=!cleaned:%%=__!

  %IMG7%magick %PREC% gfs3_old.miff gfs3_new.miff -metric RMSE -format "=start= '!cleaned!' distortion=%%[distortion] =end=\n" -compare info:
)
) >fxn_gfs3.lis

echo on

cgrep /ifxn_gfs3.lis /ofxn_gfs3a.lis /sdistortion= /f\s\r\n

chStrs /ifxn_gfs3a.lis /ofxn_gfs3b.lis /f"=start=" /t\(tr\)\(td\)
chStrs /ifxn_gfs3b.lis /ofxn_gfs3b.lis /f"distortion=" /t\(/td\)\(td\)
chStrs /ifxn_gfs3b.lis /ofxn_gfs3b.lis /f"=end=" /t\(/td\)\(/tr\)

cPrefix /ifxn_gfs3b.lis /X /t"\(tr\)\(th\)-fx input string\(/th\)\(th\)distortion\(/th\)\(/tr\)"
cPrefix /ifxn_gfs3b.lis /X /t"\(table\)" /b"\(/table\)"
