rem From image %1 with height=1,
rem makes a graph with same width but max height=256.
@rem
@rem Optional:
@rem   %2 is background colour (default Khaki).
@rem   %3 is grid (default 0 = no grid).
@rem   %4 is output filename.
@rem   %5 border colour ("none" = no border) [blue]
@rem
@rem Updated:
@rem   11 March 2017 Simplified.
@rem   20 June 2017 Restored gradient in output.
@rem   8-August-2022 for IM v7.
@rem


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 g1d


set BACKCOL=%2
if "%BACKCOL%"=="." set BACKCOL=
if "%BACKCOL%"=="" set BACKCOL=Khaki

set GRID_SPEC=%3
if "%GRID_SPEC%"=="." set GRID_SPEC=
if "%GRID_SPEC%"=="" set GRID_SPEC=0

if not "%4"=="" if not "%4"=="." set OUTFILE=%4

set BORDCOL=%5
if "%BORDCOL%"=="." set BORDCOL=
if "%BORDCOL%"=="" set BORDCOL=blue


for /F "usebackq" %%L ^
in (`%IMG7%magick identify -format "WW=%%w\nHH=%%h" %INFILE%`) ^
do set %%L

set S_RESIZE=
if %WW% GTR 1000 (
  set S_RESIZE=-resize 1000x%HH%
  set WW=1000
)

set newH=256

if %WW% LSS 256 (
  set newH=%WW%
)

set S_GRID=
if not %GRID_SPEC%==0 (
  call %PICTBAT%grid %WW% %newH% 4 3 1
  set S_GRID=grid.png -compose Exclusion -composite
)

echo %0: WW=%WW% HH=%HH% newH=%newH% OUTFILE=%OUTFILE%

set /A newH4=4*%newH%

set BRDR=
if /I not "%BORDCOL%"=="none" set BRDR=-bordercolor %BORDCOL% -compose Over -border 1x1


%IMG7%magick ^
  %INFILE% ^
  -scale "%WW%x1^!" ^
  -scale "%WW%x%newH4%^!" ^
  +write mpr:SCLE ^
  -size %WW%x%newH4% gradient: ^
  -compose MinusDst -composite ^
  -threshold 0 ^
  -negate ^
  mpr:SCLE ^
  +swap ^
  -compose CopyOpacity -composite ^
  -resize "%WW%x%newH%^!" ^
  -background %BACKCOL% ^
  -compose Over -layers Flatten ^
  %S_GRID% ^
  %BRDR% ^
  %OUTFILE%

call echoRestore
