@rem From image %1 with height=1, makes a line graph with same width but max height=256.
@rem %2 is background colour, can be "none" (default Khaki).
@rem %3 is grid (default 0 = no grid).
@rem %4 is line colour (default Black).
@rem
@rem Updated:
@rem   25-September-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 gl

set BACKCOL=%2
if "%BACKCOL%"=="" set BACKCOL=Khaki

set GRID_SPEC=%3
if "%GRID_SPEC%"=="" set GRID_SPEC=0

set LINECOL=%4
if "%LINECOL%"=="" set LINECOL=Black

FOR /F "usebackq" %%L IN (`%IMG7%magick identify -format "WW=%%w\nHH=%%h" %INFILE%`) DO set %%L

set S_RESIZE=
if %WW% GTR 1000 (
  set S_RESIZE=-resize 1000x%HH%
  set WW=1000
)

set newH=256

if %WW% LSS 256 (
  set newH=%WW%
)

set S_GRID=
if not %GRID_SPEC%==0 (
  call %PICTBAT%grid %WW% %newH% 4 3 1
  set S_GRID=grid.png -compose Exclusion -composite
)

set /A newH4=4*%newH%

if /I %BACKCOL%==none (
  set sBACK=-alpha set -channel RGBA -evaluate set 0
) else (
  set sBACK=-fill %BACKCOL% -colorize 100
)

set sBORD=-bordercolor Black -border 1x1
set sBORD=

set LINE_IMG=-clone 0 -scale "%WW%x%newH4%^^^!" ^
    -size %WW%x%newH4% gradient: ^
    -compose MinusDst -composite ^
    -fill #fff +opaque #000 ^
    -resize "%WW%x%newH%^^^!" ^
    -morphology edgeout diamond:1 ^
    -alpha off

if /I %BACKCOL%==none (
  %IMG7%magick ^
  %INFILE% ^
  -scale "%WW%x1^!" ^
  -scale "%WW%x%newH%^!" ^
  ^( -clone 0 ^
     -fill %LINECOL% -colorize 100 ^
  ^) ^
  ^( %LINE_IMG% ^) ^
  -delete 0 ^
  -alpha off ^
  -compose CopyOpacity -composite ^
  %S_GRID% ^
  %sBORD% ^
  %OUTFILE%
) else (
  %IMG7%magick ^
  %INFILE% ^
  -scale "%WW%x1^!" ^
  -scale "%WW%x%newH%^!" ^
  ^( -clone 0 ^
     %sBack% ^
  ^) ^
  ^( -clone 0 ^
     -fill %LINECOL% -colorize 100 ^
     -alpha off ^
  ^) ^
  ^( %LINE_IMG% ^) ^
  -delete 0 ^
  -compose Over -composite ^
  %S_GRID% ^
  %sBORD% ^
  %OUTFILE%
)

:end
call echoRestore
