rem Like graphLineCol, but extended for HDR, high dynamic range.

rem %1 Nx1 input image to be graphed.
rem %2 Nx1 input image. The values in this are used only to establish scale of x-axis.
rem %3 output graph image.

@rem The region of input and output from 0% to 100% is highlighted in green.


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

set INFILE=%1
set OUTFILE=%~dpn1_glce.png

set INX=%2
if "%INX%"=="." set INX=

if not "%3"=="" if not "%3"=="." set OUTFILE=%3

set TMPDIR=\temp\
set TMPIN=%TMPDIR%glcx.miff


set FMT=^
XOMIN=%%[fx:minima]\n^
XOMAX=%%[fx:maxima]\n^
XNMIN=%%[fx:minima^<0?minima:0]\n^
XNMAX=%%[fx:maxima^>1?maxima:1]\n

for /F "usebackq" %%L in (`%IMG7%magick ^
  %INX% ^
  -precision 15 ^
  -format "%FMT%" ^
  info:`) do set %%L

set FMT=^
XFACT=%%[fx:1/(%XOMAX%-(%XOMIN%))]\n^
XOFFS=%%[fx:-(%XOMIN%)/(%XOMAX%-(%XOMIN%))]\n^
XZERO=%%[fx:-(%XOMIN%)/(%XOMAX%-(%XOMIN%))]\n^
XONE=%%[fx:(1-(%XOMIN%))/(%XOMAX%-(%XOMIN%))]\n

for /F "usebackq" %%L in (`%IMG7%magick ^
  %INX% ^
  -precision 15 ^
  -format "%FMT%" ^
  info:`) do set %%L


set FMT=^
YOMIN=%%[fx:minima]\n^
YOMAX=%%[fx:maxima]\n^
YNMIN=%%[fx:minima^<0?minima:0]\n^
YNMAX=%%[fx:maxima^>1?maxima:1]\n

for /F "usebackq" %%L in (`%IMG7%magick ^
  %INFILE% ^
  -precision 15 ^
  -write %TMPIN% ^
  -format "%FMT%" ^
  info:`) do set %%L

set FMT=^
YFACT=%%[fx:1/(%YOMAX%-(%YOMIN%))]\n^
YOFFS=%%[fx:-(%YOMIN%)/(%YOMAX%-(%YOMIN%))]\n^
YZERO=%%[fx:-(%YOMIN%)/(%YOMAX%-(%YOMIN%))]\n^
YONE=%%[fx:(1-(%YOMIN%))/(%YOMAX%-(%YOMIN%))]\n

for /F "usebackq" %%L in (`%IMG7%magick ^
  %INX% ^
  -precision 15 ^
  -format "%FMT%" ^
  info:`) do set %%L

rem See "-function polynomial" bug https://www.imagemagick.org/discourse-server/viewtopic.php?f=3&t=37520
%IM7DEV%magick ^
  %TMPIN% ^
  -precision 15 ^
  -function polynomial %YFACT%,%YZERO% ^
  -clamp ^
  -format "MIN=%%[fx:minima]\nMAX=%%[fx:maxima]\n" ^
  +write info: ^
  %TMPIN%

if ERRORLEVEL 1 exit /B 1

call %PICTBAT%graphLineCol %TMPIN% . . 0 %OUTFILE%

%IM7DEV%magick ^
  %OUTFILE% ^
  -fill #0f08 -stroke None ^
  -draw "rectangle %%[fx:%XZERO%*w],%%[fx:(1-(%YONE%))*h],%%[fx:%XONE%*w],%%[fx:(1-(%YZERO%))*h]" ^
  -fill None -stroke #88f8 ^
  -draw "line %%[fx:%XZERO%*w],0,%%[fx:%XZERO%*w],%%[fx:h-1]" ^
  -draw "line 0,%%[fx:(1-(%YZERO%))*h],%%[fx:w-1],%%[fx:(1-(%YZERO%))*h]" ^
  %OUTFILE%

if ERRORLEVEL 1 exit /B 1

set FMT=^
XOMINp=%%[fx:%XOMIN%]\n^
XOMAXp=%%[fx:%XOMAX%]\n^
YOMINp=%%[fx:%YOMIN%]\n^
YOMAXp=%%[fx:%YOMAX%]\n

for /F "usebackq" %%L in (`%IMG7%magick ^
  -precision 5 ^
  -print "%FMT%" ^
  -exit`) do set %%L

call %PICTBAT%graph4labels %OUTFILE% %OUTFILE% %XOMINp% %XOMAXp% %YOMINp% %YOMAXp%


call echoRestore

endlocal & set mhhOUTFILE=%OUTFILE%&
