rem From grayscale image %1, a Bayer-pattern mosaic,
rem write four output files named after %2 which must contain XX,
rem   where XX will be substituted by %3, %4, %5 and %6 (R, G0, G1 or B).
rem Each output will have half the dimensions of the input.
@rem
@rem Default Bayer filter pattern is:
@rem   R  G0
@rem   G1 B
@rem

setlocal enabledelayedexpansion

set INFILE=%1

set OUTNAME=%2

if "%OUTNAME%"=="." set OUTNAME=
if "%OUTNAME%"=="" exit /B 1

if "%OUTNAME:XX=zz%"=="%OUTNAME%" exit /B 1

set C0=%3
if "%C0%"=="." set C0=
if "%C0%"=="" set C0=R

set C1=%4
if "%C1%"=="." set C1=
if "%C1%"=="" set C1=G0

set C2=%5
if "%C2%"=="." set C2=
if "%C2%"=="" set C2=G1

set C3=%6
if "%C3%"=="." set C3=
if "%C3%"=="" set C3=B

%IMG7%magick ^
  %INFILE% ^
  ( -clone 0 -define sample:offset=25 -sample 50%% ^
    -set colorspace Gray ^
    -write !OUTNAME:XX=%C0%! ^
    +delete ) ^
  ( -clone 0 -define sample:offset=75x25 -sample 50%% ^
    -set colorspace Gray ^
    -write !OUTNAME:XX=%C1%! ^
    +delete ) ^
  ( -clone 0 -define sample:offset=25x75 -sample 50%% ^
    -set colorspace Gray ^
    -write !OUTNAME:XX=%C2%! ^
    +delete ) ^
  ( -clone 0 -define sample:offset=75 -sample 50%% ^
    -set colorspace Gray ^
    -write !OUTNAME:XX=%C3%! ^
  ) ^
  -delete 0 ^
  NULL:

if ERRORLEVEL 1 exit /B 1
