rem From image %1,
rem write %2 that has given crop gray-balanced by multiplying channels.
rem Crop area?
rem %3 method, one of:
rem   exact
rem   noClip
rem   maxNoClip
rem %4 crop area to be balanced WxH+X+Y [default: no crop, balance entire input]
rem %5, %6, %7 extra multipliers for R, G and B.
rem   The balance from gray balance is multiplied by %5,%6,%7.
@rem
@rem Updated:
@rem   25-September-2022 for IM v7.
@rem


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 gbm

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set method=%3
if "%method%"=="" set method=.

set CROP=%4
if "%CROP%"=="." set CROP=

set exFactR=%5
set exFfactG=%6
set exFfactB=%7

if "%exFactR%"=="." set exFactR=
if "%exFactG%"=="." set exFactG=
if "%exFactB%"=="." set exFactB=
if "%exFactR%"=="" set exFactR=1
if "%exFactG%"=="" set exFactG=1
if "%exFactB%"=="" set exFactB=1

set sCROP=
if not "%CROP%"=="" set sCROP=-crop %CROP% +repage


for /F "usebackq" %%L in (`%IMG7%magick ^
  %INFILE% ^
  -format "maxR=%%[fx:maxima.r]\nmaxG=%%[fx:maxima.g]\nmaxB=%%[fx:maxima.b]\n" ^
  +write info: ^
  %sCROP% ^
  -scale "1x1^!" ^
  -format "factRG=%%[fx:%exFactR%*u.g/u.r]\nfactBG=%%[fx:%exFactB%*u.g/u.b]" ^
  info:`) do set %%L

set factGG=%exFactG%

call %PICTBAT%colBalMult %INFILE% %OUTFILE% %factRG% %factGG% %factBG% %method%

goto end


::------------
set newMaxG=%maxG%

for /F "usebackq" %%L in (`%IMG7%magick ^
  xc: ^
  -format "newMaxR=%%[fx:%maxR%*%factRG%]\nnewMaxB=%%[fx:%maxB%*%factBG%]\n" ^
  info:`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick ^
  xc: ^
  -format "newMaxMax=%%[fx:%newMaxR%>%newMaxG%?%newMaxR%:%newMaxG%]\n" ^
  info:`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick ^
  xc: ^
  -format "newMaxMax=%%[fx:%newMaxMax%>%newMaxB%?%newMaxMax%:%newMaxB%]\n" ^
  info:`) do set %%L

if /I %method%==maxNoClip (
for /F "usebackq" %%L in (`%IMG7%magick ^
  xc: ^
  -format "factRG=%%[fx:%factRG%/%newMaxMax%]\nfactGG=%%[fx:%factGG%/%newMaxMax%]\nfactBG=%%[fx:%factBG%/%newMaxMax%]\n" ^
  info:`) do set %%L
)

%IMG7%magick ^
  %INFILE% ^
  -channel R -evaluate Multiply %factRG% ^
  -channel G -evaluate Multiply %factGG% ^
  -channel B -evaluate Multiply %factBG% ^
  +channel ^
  %OUTFILE%

:end

call echoRestore

@endlocal & set gbmOUTFILE=%OUTFILE%& set gbmFactR=%cbmFactR%& set gbmFactG=%cbmFactG%& set gbmFactB=%cbmFactB%
