rem Draws grid starting from top and/or right at given interval.
rem
rem %1 Input graph image
rem %2 Output image
rem %3 x or y or both
rem %4 interval in pixels between grid lines (can be expression for fx)
rem %5 colour for grid lines

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 gdhi

if not "%2"=="" if not "%2"=="." set OUTFILE=%1

set WHICH=%3
if "%WHICH%"=="." set WHICH=
if "%WHICH%"=="" set WHICH=both

set INTVL=%4
if "%INTVL%"=="." set INTVL=
if "%INTVL%"=="" set INTVL=10

set COL=%5
if "%COL%"=="" set COL=
if "%COL%"=="" set COL=#0f08

echo %0: %WHICH% %INTVL% %COL%

set doX=0
set doY=0
if /I %WHICH%==x (
  set doX=1
) else if /I %WHICH%==y (
  set doY=1
) else if /I %WHICH%==both (
  set doX=1
  set doY=1
) else (
  echo %0: error in WHICH [%WHICH%]
  exit /B 1
)

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 15 ^
  -format "pxINTVL=%%[fx:%INTVL%]\nWW=%%w\nHH=%%h\nWm1=%%[fx:w-1]\nHm1=%%[fx:h-1]\n" ^
  %INFILE%`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "numX=%%[fx:floor(%WW%/%pxINTVL%)]\nnumY=%%[fx:floor(%HH%/%pxINTVL%)]\n" ^
  xc:`) do set %%L

echo %0: WW=%WW% HH=%HH% pxINTVL=%pxINTVL% numX=%numX% numY=%numY%


set sLINES=

if %doX%==1 (
  echo %0: doing X
  set px=%Wm1%
  set pxi=%Wm1%

  for /L %%N in (0,1,%numX%) do (

    set FIRSTCH=!pxi:~0,5!

    if not !FIRSTCH!==- set sLINES=!sLINES! line !pxi!,0,!pxi!,%Hm1%

    for /F "usebackq" %%L in (`%IMG7%magick identify ^
      -precision 15 ^
      -format "px=%%[fx:!px!-%pxINTVL%]\npxi=%%[fx:floor(!px!-%pxINTVL%+0.5)]\n" ^
      xc:`) do set %%L
  )
)

if %doY%==1 (
  echo %0: doing Y
  set px=%Hm1%
  set pxi=%Hm1%
  set pxn=0

  for /L %%N in (0,1,%numY%) do (

    set FIRSTCH=!pxi:~0,5!

    if not !FIRSTCH!==- set sLINES=!sLINES! line 0,!pxn!,%Wm1%,!pxn!

    for /F "usebackq" %%L in (`%IMG7%magick identify ^
      -format "px=%%[fx:!px!-%pxINTVL%]\npxi=%%[fx:floor(!px!-%pxINTVL%+0.5)]\n" ^
      xc:`) do set %%L

    for /F "usebackq" %%L in (`%IMG7%magick identify ^
      -format "pxn=%%[fx:%Hm1%-!pxi!]\n" ^
      xc:`) do set %%L
  )
)

echo %1: %sLINES%

%IMG7%magick ^
  %INFILE% ^
  -stroke %COL% ^
  -draw "%sLINES%" ^
  %OUTFILE%


call echoRestore

@endlocal
