rem From image %1 and text file %2,
rem makes %guilNUM_CUTS% + 1 images,
rem named after pattern in %3, substituting XX by a sequential number from zero.
rem %4 is 0 (guillotine vertically) or 1 (guillotine horizontally).
rem %5 is 0 (discard canvas metadata) or 1 (re-calculate canvas metadata).
@rem
@rem Updated:
@rem   11-August-2022 for IM v7
@rem

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

call %PICTBAT%setInOut %1 guil

rem @call echoOffSave

set ORD_LIST=%2

set FILE_PTN=%3
if "%FILE_PTN%"=="" set FILE_PTN=
if "%FILE_PTN%"=="" set FILE_PTN=%BASENAME%_guilc_XX.png

set DIRN=%4
if "%DIRN%"=="." set DIRN=
if "%DIRN%"=="" set DIRN=0

set CALC_CANV=%4
if "%CALC_CANV%"=="." set CALC_CANV=
if "%CALC_CANV%"=="" set CALC_CANV=0

set SCR_FILE=guilc_tmp.bat

if %DIRN%==0 (
  set ROT_IN=
  set ROT_OUT=
) else (
  set ROT_IN=-rotate -90
  set ROT_OUT=-rotate 90
)

if "%guilNUM_CUTS%"=="0" (
  rem Make one image
  set OUTNAME=!FILE_PTN:XX=0!

  %IMG7%magick %1 !OUTNAME!
  if ERRORLEVEL 1 exit /B 1

  goto end
)

if not exist %INFILE% exit /B 1

if "%CALC_CANV%"==0 (
  set sCANV=+repage
) else (

  for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -format "sCANV=-repage %%P%%O^^!" ^
    %INFILE%`) do set %%L

  set sCANV=+repage
)

echo %0: sCANV=%sCANV%

echo %IMG7%magick %INFILE% %ROT_IN% >%SCR_FILE%

:: For symmetry each crop is up to and _including_ the ordinate.

set START_NEXT=0
set nCUTS=0
for /F "tokens=1 delims=, " %%X in (%ORD_LIST%) do (
  for %%A in (!nCUTS!) do set OUTNAME=!FILE_PTN:XX=%%A!
  set /A WW=%%X-!START_NEXT!+1
  echo ^( +clone -crop !WW!x+!START_NEXT!+0 +repage %ROT_OUT% %sCANV% -write !OUTNAME! +delete ^) >>%SCR_FILE%
  set /A START_NEXT=%%X+1
  set /A nCUTS+=1
)
:: And the final one.
set OUTNAME=!FILE_PTN:XX=%nCUTS%!
echo ^( +clone -crop +!START_NEXT!+0 +repage %ROT_OUT% %sCANV% -write !OUTNAME! ^) >>%SCR_FILE%

rem cPrefix /p0 /i%SCR_FILE% /r"^"

set SCR_FILE2=guilc_tmp2.bat
copy %SCR_FILE% %SCR_FILE2%
@( @for /F "tokens=*" %%L in (%SCR_FILE2%) do @echo %%L ^^) >%SCR_FILE%



echo NULL: >>%SCR_FILE%

type %SCR_FILE%
call %SCR_FILE%

if ERRORLEVEL 1 exit /B 1

:end

call echoRestore

endlocal
