rem From image %1, guillotines into pieces.
@rem
@rem %2 is pattern name for output image files (must contain XX).
@rem %3 is input background colour [default White] between pieces.
@rem %4 is fuzz percentage from declared background colour (default 0).
@rem %5 is permitted percentage of non-background pixels at cut (default 0).
@rem %6 is 0 (guillotine vertically) or 1 (guillotine horizontally).
@rem %7 is optional name of file that is to be guillotined.
@rem    %1 is used to find where the cuts should be.
@rem    The cuts are applied to %7.
@rem    %7 defaults to %1.
@rem
@rem Creates guilNUM_CUTS + 1 images, named after %2, substituting XX by a number from 0.
@rem
@rem Also sets:
@rem   guilNUM_CUTS the number possible cuts. Possibly zero.
@rem
@rem Updated:
@rem   14-April-2017  Added %7.


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 guil

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set TO_CUT=%7
if "%TO_CUT%"=="." set TO_CUT=
if "%TO_CUT%"=="" set TO_CUT=%INFILE%

call %PICTBAT%guilFind %INFILE% . %3 %4 %5 %6
if ERRORLEVEL 1 exit /B 1

call %PICTBAT%guilChop %TO_CUT% %guilOUTFILE% %OUTFILE% %6
if ERRORLEVEL 1 exit /B 1


call echoRestore

endlocal & set guilOUTFILE=%OUTFILE%& set guilNUM_CUTS=%guilNUM_CUTS%
