#include <stdio.h>
#include <stdlib.h>
#include "vsn_defines.h"

ModuleExport size_t hellowImage(Image **images,const int argc,
  const char **argv,ExceptionInfo *exception)
{
  int
    precision;

  // Prevent compilers warning about unused parameters:
  (void) images;
  (void) argc;
  (void) argv;
  (void) exception;

  precision = GetMagickPrecision();

  printf ("Greetings to wizards of the ImageMagick world!\n\n");

  printf ("MAGICKCORE_QUANTUM_DEPTH %.*g\n",
    precision, (double)MAGICKCORE_QUANTUM_DEPTH);

  printf ("QuantumRange %.*g\n",
    precision, (double)QuantumRange);
  printf ("  V/V-1 %.*g\n",
    precision, (double)QuantumRange/(double)QuantumRange-1.0);

  printf ("QuantumScale %.*g\n", precision, QuantumScale);

  printf ("MagickEpsilon %.*g\n", precision, MagickEpsilon);


  printf ("Quantum %s\n", MagickStringify(Quantum));

  printf ("sizeof:\n");
  printf ("  MagickRealType %i\n", (int)sizeof(MagickRealType));
  printf ("  MagickSizeType %i\n", (int)sizeof(MagickSizeType));
  printf ("  int %i\n", (int)sizeof(int));
  printf ("  long int %i\n", (int)sizeof(long int));
  printf ("  long long int %i\n", (int)sizeof(long long int));
  printf ("  float %i\n", (int)sizeof(float));
  printf ("  double %i\n", (int)sizeof(double));
  printf ("  long double %i\n", (int)sizeof(long double));
  printf ("  _Float128 %i\n", (int)sizeof(_Float128));
  printf ("  Image %i\n", (int)sizeof(Image));
  printf ("  ImageInfo %i\n", (int)sizeof(ImageInfo));
  printf ("  Quantum %i\n", (int)sizeof(Quantum));

  printf ("MagickSizeType [%s]\n", MagickStringify(MagickSizeType));
  printf ("MagickSizeFormat [%s]\n", MagickSizeFormat);
  printf ("QuantumFormat: [%s]\n", QuantumFormat);
  printf ("MaxMap %i\n", (int)MaxMap);

  printf ("MaxTextExtent %i\n", (int)MaxTextExtent);
#if IMV6OR7==7
  printf ("MagickPathExtent %i\n", (int)MagickPathExtent);
#endif

#if defined(MAGICKCORE_HDRI_SUPPORT)
  printf ("Includes HDRI\n");
#else
  printf ("Does not includes HDRI\n");
#endif


#if defined(MAGICKCORE_WINDOWS_SUPPORT)
  printf ("MAGICKCORE_WINDOWS_SUPPORT defined\n");
#endif

#if defined(WIN32)
  printf ("WIN32 defined\n");
#endif

#if defined(WIN64)
  printf ("WIN64 defined\n");
#endif

#if defined(MAGICKCORE_OPENMP_SUPPORT)
  printf ("MAGICKCORE_OPENMP_SUPPORT defined\n");
#endif

  return(MagickImageFilterSignature);
}
