rem Make a graph of histogram, showing mean, SD and median.

setlocal

set INFILE=%1
set OUTFILE=%2

for /F "usebackq" %%L in (`%IM7DEV%magick ^
  %INFILE% ^
  -format "COLSP=%%[colorspace]" ^
  info:`) do set %%L

if "%COLSP%"=="Gray" (
set sFMT=^
MNR=%%[fx:mean.r]\n^
SDR=%%[fx:standard_deviation.r]\n^
MEDR=%%[fx:median.r]\n
) else (
set sFMT=^
MNR=%%[fx:mean.r]\n^
SDR=%%[fx:standard_deviation.r]\n^
MEDR=%%[fx:median.r]\n^
MNG=%%[fx:mean.g]\n^
SDG=%%[fx:standard_deviation.g]\n^
MEDG=%%[fx:median.g]\n^
MNB=%%[fx:mean.b]\n^
SDB=%%[fx:standard_deviation.b]\n^
MEDB=%%[fx:median.b]\n
)

for /F "usebackq" %%L in (`%IM7DEV%magick ^
  %INFILE% ^
  -format "%sFMT%" ^
  +write info: ^
  +format ^
  -process 'mkhisto capnumbuckets 512 norm' ^
  %OUTFILE%`) do set %%L

call %PICTBAT%graphLineCol %OUTFILE% . . 0

if "%COLSP%"=="Gray" (
  %IMG7%magick ^
    %glcOUTFILE% ^
    -stroke Red ^
    -draw "stroke-dasharray 4,4 stroke-opacity 0.75 line %%[fx:%MEDR%*w],0,%%[fx:%MEDR%*w],%%[fx:h-1]" ^
    -draw "line %%[fx:%MNR%*w],0,%%[fx:%MNR%*w],%%[fx:h-1]" ^
    -draw "line %%[fx:(%MNR%-%SDR%)*w],%%[fx:h*0.1],%%[fx:(%MNR%+%SDR%)*w],%%[fx:h*0.1]" ^
    %OUTFILE%
) else (
  %IMG7%magick ^
    %glcOUTFILE% ^
    -stroke Red ^
    -draw "stroke-dasharray 4,4 stroke-opacity 0.75 line %%[fx:%MEDR%*w],0,%%[fx:%MEDR%*w],%%[fx:h-1]" ^
    -draw "line %%[fx:%MNR%*w],0,%%[fx:%MNR%*w],%%[fx:h-1]" ^
    -draw "line %%[fx:(%MNR%-%SDR%)*w],%%[fx:h*0.1],%%[fx:(%MNR%+%SDR%)*w],%%[fx:h*0.1]" ^
    -stroke Green ^
    -draw "stroke-dasharray 4,4 stroke-opacity 0.75 line %%[fx:%MEDG%*w],0,%%[fx:%MEDG%*w],%%[fx:h-1]" ^
    -draw "line %%[fx:%MNG%*w],0,%%[fx:%MNG%*w],%%[fx:h-1]" ^
    -draw "line %%[fx:(%MNG%-%SDG%)*w],%%[fx:h*0.2],%%[fx:(%MNG%+%SDG%)*w],%%[fx:h*0.2]" ^
    -stroke Blue ^
    -draw "stroke-dasharray 4,4 stroke-opacity 0.75 line %%[fx:%MEDB%*w],0,%%[fx:%MEDB%*w],%%[fx:h-1]" ^
    -draw "line %%[fx:%MNB%*w],0,%%[fx:%MNB%*w],%%[fx:h-1]" ^
    -draw "line %%[fx:(%MNB%-%SDB%)*w],%%[fx:h*0.3],%%[fx:(%MNB%+%SDB%)*w],%%[fx:h*0.3]" ^
    %OUTFILE%
)
