rem Makes identity ellipse absolute displacement map.

rem %1 WxH
rem %2 output file. This can be negative, or greater than 100%.
rem %3 CXxCY centre. Default (W-1)/2,(H-1)/2
rem %4 radius. "nearCorner" or "farCorner" or "meanCorner" or "nearEdge" or "farEdge" or "meanEdge" or RXxRY
rem %5 encoding: rhoTheta or rhoSinCos
@rem
@rem Makes a radial gradient with large radius, and divides appropriately.

@rem Option for sin and cos.

@rem No mandatory parameters
@rem @if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 ieadm

set sWH=%1
if "%sWH%"=="." set sWH=
if "%sWH%"=="" set sWH=150x100

set OUTFILE=%2
if "%OUTFILE%"=="." set OUTFILE=
if "%OUTFILE%"=="" set OUTFILE=ieadm.png

set sCent=%3
if "%sCent%"=="." set sCent=
if "%sCent%"=="" set sCent=50cx50c

set sRad=%4
if "%sRad%"=="." set sRad=
if "%sRad%"=="" set sRad=meanEdge

set mapType=%5
if "%mapType%"=="." set mapType=
if "%mapType%"=="" set mapType=rhoSinCos

call parseXxY2 150 100 WH %sWH%

set WW=%WH_X%
set HH=%WH_Y%

set TMP_FILE1=%TEMP%\iead_tmp1.miff
set TMP_FILE2=%TEMP%\iead_tmp2.miff

call %PICTBAT%ellipseGrad %sWH% %TMP_FILE1% %sCent% %sRad%
if ERRORLEVEL 1 exit /B 1

if /I %mapType%==rhoTheta (
  call %PICTBAT%ellipseSweep %egWW%x%egHH% %TMP_FILE2% %egCX%x%egCY%
  if ERRORLEVEL 1 exit /B 1

  %IMG7%magick ^
    %TMP_FILE1% ^
    %TMP_FILE2% ^
    ^( +clone -fill Black -colorize 100 ^) ^
    -combine ^
    -set polarCX %egCX% ^
    -set polarCY %egCY% ^
    -define quantum:format=floating-point -depth 32 ^
    %OUTFILE%

) else if /I %mapType%==rhoSinCos (
  call %PICTBAT%ellipseSweep %egWW%x%egHH% %TMP_FILE2% %egCX%x%egCY%
  if ERRORLEVEL 1 exit /B 1

  %IMG7%magick ^
    ^( %TMP_FILE1% -write mpr:RHO ^) ^
    ^( %TMP_FILE2% -write mpr:THETA ^) ^
    -fx "TWOPI=%%[fx:2*pi]; u*sin(v*TWOPI)" ^
    ^( mpr:RHO mpr:THETA ^
       -fx "TWOPI=%%[fx:2*pi]; -u*cos(v*TWOPI)" ^
    ^) ^
    mpr:RHO -insert 0 ^
    -colorspace Gray ^
    -combine ^
    -set polarCX %egCX% ^
    -set polarCY %egCY% ^
    -define quantum:format=floating-point -depth 32 ^
    %OUTFILE%

) else if /I %mapType%==rhoSinCos2 (
  call %PICTBAT%ellipseSweepSinCos %egWW%x%egHH% %TMP_FILE2% %egCX%x%egCY%
  if ERRORLEVEL 1 exit /B 1

  %IMG7%magick ^
    -define compose:clamp=off ^
    ^( %TMP_FILE1% -write mpr:RHO ^) ^
    %TMP_FILE2% ^
    -compose Multiply -composite ^
    -separate -delete 2 ^
    mpr:RHO -insert 0 ^
    -colorspace Gray ^
    -combine ^
    -set polarCX %egCX% ^
    -set polarCY %egCY% ^
    -define quantum:format=floating-point -depth 32 ^
    %OUTFILE%

) else (
  echo %0: Bad mapType [%mapType%]
  exit /B 1
)

if ERRORLEVEL 1 exit /B 1

call echoRestore

@endlocal & set ieadmOUTFILE=%OUTFILE%& set ieadmWW=%egWW%& set ieadmHH=%egHH%& set ieadmCX=%egCX%& set ieadmCY=%egCY%

