rem What single integral image is closest to a 2D Gaussian blur?

rem %1 Sigma

setlocal enabledelayedexpansion

set sig=%1
if "%sig%"=="." set sig=
if "%sig%"=="" set sig=10

for /F "usebackq" %%L in (`%IMG7%magick ^
  -size %%[fx:%sig%*10]x1 xc:Black ^
  -size 1x1 xc:White ^
  ^( -clone 0 ^) ^
  +append +repage ^
  -define "quantum:format=floating-point" -depth 32 ^
  -morphology Convolve Blur:0x%sig% ^
  -bordercolor Black -border 1 ^
  -trim +repage ^
  -format "MaxW=%%w\n" ^
  info:`) do set %%L

set /A nBord=(%MaxW%-1)/2

echo %0: MaxW=%MaxW% nBord=%nBord%  Blurring...

set SAVE_OCL=MAGICK_OCL_DEVICE
set MAGICK_OCL_DEVICE=true

%IMG7%magick ^
  -size 1x1 xc:White ^
  -bordercolor Black -border %nBord% ^
  -define "quantum:format=floating-point" -depth 32 ^
  +write igo_imp.miff ^
  -blur 0x%sig% ^
  igo_blr.miff

set MAGICK_OCL_DEVICE=%SAVE_OCL%

echo %0: Blurring ended.

%IM7DEV%magick ^
  igo_imp.miff ^
  -process 'integim v' ^
  -define "quantum:format=floating-point" -depth 32 ^
  igo_integ.miff

set MinDiff=1.0
set BestW=
set Bust=0

:: The process is slow, so start at somewhere plausible.
for /F "usebackq" %%L in (`%IMG7%magick ^
  xc: ^
  -format "StartMax=%%[fx:floor(%sig%*1.4)*2+1]" ^
  info:`) do set %%L


echo off

for /L %%N in (%StartMax%,2,%MaxW%) do (
  if !Bust!==0 (
    for /F "usebackq" %%L in (`%IM7DEV%magick ^
      igo_integ.miff ^
      -process 'deintegim window %%Nx%%N' ^
      igo_blr.miff ^
      -metric RMSE ^
      -precision 15 ^
      -format "Diff=%%[distortion]\n" ^
      -compare ^
      info:`) do set %%L

    for /F "usebackq" %%L in (`%IM7DEV%magick ^
      xc: ^
      -format "Better=%%[fx:!Diff!<!MinDiff!?1:0]\n" ^
      info:`) do set %%L

    echo %0: N=%%N Diff=!Diff! Better=!Better!

    if !Better!==1 (
      set MinDiff=!Diff!
      set BestW=%%N
    ) else (
      set Bust=1
    )
  )

)

rem %IMG7%magick igo_integ.miff -verbose info:

echo %0: sig=%sig% MaxW=%MaxW% MinDiff=%MinDiff% BestW=%BestW%

endlocal && set igoSigma=%sig%&&set igoMaxW=%MaxW%&&set igoBestW=%BestW%