rem %1 Input prefix for variables already calculated [default iigk_]
rem %2 Output prefix for new values [default no output]

@setlocal enabledelayedexpansion

@call echoOffSave

set Prefix=%1
if "%Prefix%"=="." set Prefix=
if "%Prefix%"=="" set Prefix=iigk_

set OutPrefix=%2
if "%OutPrefix%"=="." set OutPrefix=


echo %0: Prefix=%Prefix%

set %Prefix%

if "!%Prefix%K!" == "" (
  if not exist %Prefix%_vars.lis (
    echo Can't find file %Prefix%_vars.lis
    exit /B 1
  )
  echo %0: Reading env vars from %Prefix%_vars.lis
  @for /F %%L in (%Prefix%_vars.lis) do @set %%L

)

if "!%Prefix%K!" == "" (
  echo %0: %Prefix%K is blank.
  exit /B 1
)

set sigma=!%Prefix%Sigma!
set K=!%Prefix%K!
set /A Km1=%K%-1

set Vbottom=0

if not "%OutPrefix%"=="" (
  set %OutPrefix%K=%K%
  set %OutPrefix%Sigma=%sigma%
)

for /L %%I in (%Km1%,-1,0) do (
  rem call :WtNext %%I
  rem set /A Ip1=%%I+1
  rem set Vtop=!%Prefix%Weight[%%I]!
  rem set VBottom=!Vnext!

  set ThisWt=!%Prefix%Weight[%%I]!
  set %OutPrefix%Weight[%%I]=!ThisWt!

  for /F "usebackq" %%L in (`%IMG7%magick ^
    xc: ^
    -format "Vtop=%%[fx:!Vbottom!+!ThisWt!]\n" ^
    info:`) do set %%L


  echo %%I sigma=%sigma% Vtop=!Vtop! Vbottom=!Vbottom!

  call %PICTBAT%iiGaussSlice %sigma% !Vtop! !Vbottom!

  set %OutPrefix%Diam[%%I]=!DatBest!

  set Vbottom=!Vtop!
)

if not "%OutPrefix%"=="" (
  set %OutPrefix%

  set %OutPrefix% > %OutPrefix%_vars.lis

)


call echoRestore

@endlocal & set OutPrefix=%OutPrefix%

@for /F %%L in (%OutPrefix%_vars.lis) do @set %%L

@exit /B 0

::----------------------------------------------
:: Subroutine

:WtNext
set /A Ip1=%1+1
set WtNext=!%Prefix%Weight[%Ip1%]!
exit /B 0

