rem Blurs an image using the Stacked Integral Images (SII) method
rem from parameters calculated by iiGaussKcalc.bat.

rem %1 input image
rem %2 output image
rem %3 Prefix for variables already calculated [default iigk_]

@setlocal enabledelayedexpansion

@call echoOffSave

set INFILE=%1
set OUTFILE=%2

set Prefix=%3
if "%Prefix%"=="." set Prefix=
if "%Prefix%"=="" set Prefix=iigk_


echo %0: Prefix=%Prefix%

set %Prefix%

if "!%Prefix%K!" == "" (
  if not exist %Prefix%_vars.lis (
    echo Can't find file %Prefix%_vars.lis
    exit /B 1
  )
  echo %0: Reading env vars from %Prefix%_vars.lis
  @for /F %%L in (%Prefix%_vars.lis) do @set %%L

)

if "!%Prefix%K!" == "" (
  echo %0: %Prefix%K is blank.
  exit /B 1
)

set TMPDIR=\temp

set fDeinteg1=%TMPDIR%\%Prefix%1.txt
set fDeinteg2=%TMPDIR%\%Prefix%2.txt
set fPoly=%TMPDIR%\%Prefix%poly.txt
set fScr=%TMPDIR%\%Prefix%.scr

if "!%Prefix%K!" == "" (
  echo %0: iiGaussKcalc needs to be successfully called.
  exit /B 1
)

set K=!%Prefix%K!
set /A Km1=%K%-1

(
  for /L %%I in (0,1,%Km1%) do echo ^( -clone 0 -process 'deintegim window !%Prefix%Diam[%%I]!x1 adjedges' ^)
) >%fDeinteg1%

(
  for /L %%I in (0,1,%Km1%) do echo ^( -clone 0 -process 'deintegim window 1x!%Prefix%Diam[%%I]! adjedges' ^)
) >%fDeinteg2%

(
  for /L %%I in (0,1,%Km1%) do echo !%Prefix%Weight[%%I]!,1,
) >%fPoly%


echo %0: Writing %fScr%
(
  echo -process integim
  type %fDeinteg1%
  echo -delete 0
  echo -poly @"%fPoly%"
  echo -process integim
  type %fDeinteg2%
  echo -delete 0
  echo -poly @"%fPoly%"
  echo -write %OUTFILE%
  echo -exit
) >%fScr%

echo %0: Executing IM: INFILE=%INFILE%

type %fScr%

%IM7DEVFX3%magick %INFILE% -script %fScr%

call echoRestore

@endlocal
