rem From data calculated by iiGaussKcalc,
rem make a graph.

rem %1 Prefix for variables already calculated [default iigk_]
rem %2 output filename

@setlocal enabledelayedexpansion

@call echoOffSave

set Prefix=%1
if "%Prefix%"=="." set Prefix=
if "%Prefix%"=="" set Prefix=iigk_

set OUTFILE=%2
if "%OUTFILE%"=="." set OUTFILE=
if "%OUTFILE%"=="" set OUTFILE=iigkg.png

if "!%Prefix%K!" == "" (
  if not exist %Prefix%_vars.lis (
    echo Can't find file %Prefix%_vars.lis
    exit /B 1
  )
  echo %0: Reading env vars from %Prefix%_vars.lis
  @for /F %%L in (%Prefix%_vars.lis) do @set %%L

)

if "!%Prefix%K!" == "" (
  echo %0: %Prefix%K is blank.
  exit /B 1
)

set %Prefix%

set TMPDIR=\temp\
set TMPFILE=%TMPDIR%%Prefix%iigkg.tiff
set TMPOUT=%TMPDIR%%Prefix%iigkg_out.tiff

set K=!%Prefix%K!
set /A Km1=%K%-1

set sig=!%Prefix%Sigma!

for /F "usebackq" %%L in (`%IMG7%magick ^
  -size %%[fx:%sig%*10]x1 xc:Black ^
  -size 1x1 xc:White ^
  ^( -clone 0 ^) ^
  +append +repage ^
  -morphology Convolve Blur:0x%sig% ^
  -bordercolor Black -border 1 ^
  -trim +repage ^
  -set option:Xscale "%%[fx:w<100?6:w<200?3:1]" ^
  -scale "%%[fx:Xscale*100]x100%%" ^
  -precision 15 ^
  -set option:Vmax %%[fx:maxima*1.1] ^
  -evaluate Divide %%[fx:Vmax] ^
  -format "Xscale=%%[Xscale]\nVmax=%%[Vmax]\n" +write info: ^
  -define "quantum:format=floating-point" ^
  -depth 32 ^
  %TMPFILE%`) do set %%L

if "%Vmax%"=="" (
  echo %0: Vmax is not set. sig=%sig%
  exit /B 1
)

rem But Xscale is messed up by graphLineCol

echo %0: Vmax=%Vmax%

call %PICTBAT%graphLineCol %TMPFILE% . . 0 %TMPOUT%

for /F "usebackq" %%L in (`%IMG7%magick ^
  %TMPOUT% ^
  -gravity NorthWest -fill White -pointsize 15 -annotate +10+10 "sigma=%sig%\nK=%K%" ^
  -flip ^
  +write %TMPOUT% ^
  -format "Xscale=%%[fx:%Xscale%*%glcXscale%]\nYscale=%%[fx:h/%Vmax%]\n" ^
  info:`) do set %%L

echo %0: Xscale=%Xscale% Yscale=%Yscale%

set Cols[0]=#08f8
set Cols[1]=#4f48
set Cols[2]=#f448

set Vbottom=0

for /L %%I in (%Km1%,-1,0) do (
  set ThisWt=!%Prefix%Weight[%%I]!
  set Vtop=!Vbottom!+!ThisWt!
  set Diam=!%Prefix%Diam[%%I]!
  set /A Rad=^(!Diam!-1^)/2

  set /A ColNdx=%%I%%3
  set Col=Cols[!ColNdx!]
  set ColV=!Col!

  rem FIXME: we might adjust rectangle top or bottom to avoid overlaps.

  call :getCol %%I

  echo %0: I=%%I ThisWt=!ThisWt! Diam=!Diam! Rad=!Rad! Vbottom=!Vbottom! ColNdx=!ColNdx! Col=!Col! ColV=!ColV!

  for /F "usebackq" %%L in (`%IMG7%magick ^
    %TMPOUT% ^
    -precision 15 ^
    -set option:Vtop %%[fx:!Vtop!] ^
    -stroke None -fill !Col! ^
    -draw "rectangle %%[fx:w/2-%Xscale%*!Rad!],%%[fx:!Vbottom!*%Yscale%],%%[fx:w/2+%Xscale%*!Rad!],%%[fx:Vtop*%Yscale%]" ^
    -format "Vtop=%%[Vtop]" +write info: ^
    %TMPOUT%`) do set %%L

  set Vbottom=!Vtop!
)

%IMG7%magick ^
  %TMPOUT% ^
  -flip ^
  -bordercolor gray(50%%) -border 5 ^
  %OUTFILE%

call echoRestore

@endlocal & set iigkgOUTFILE=%OUTFILE%

exit /B 0

::-------------------------------------------------------------
:: Subroutines

:getCol
  set /A ColNdx=%1%%3
  set Col=!Cols[%ColNdx%]!

  exit /B 0

