rem What multiple iterations of integral image is closest to a 1D Gaussian blur?

rem %1 Sigma
rem %2 numIter

setlocal enabledelayedexpansion

set sig=%1
if "%sig%"=="." set sig=
if "%sig%"=="" set sig=10

set NumIter=%2
if "%%"=="." set NumIter=
if "%%"=="" set NumIter=10

for /F "usebackq" %%L in (`%IMG7%magick ^
  -size %%[fx:%sig%*10]x1 xc:Black ^
  -size 1x1 xc:White ^
  -size %%[fx:%sig%*10]x1 xc:Black ^
  +append +repage ^
  -define "quantum:format=floating-point" -depth 32 ^
  +write igo_imp.miff ^
  -morphology Convolve Blur:0x%sig% ^
  +write igo_blr.miff ^
  -bordercolor Black -border 1 ^
  -trim +repage ^
  -format "MaxW=%%w\n" ^
  info:`) do set %%L

echo MaxW=%MaxW%

%IM7DEV%magick ^
  igo_imp.miff ^
  -process 'integim v' ^
  -define "quantum:format=floating-point" -depth 32 ^
  igo_integ.miff


set MinDiff=1.0
set BestW=
set Bust=0

:: The process is slow, so start at somewhere plausible.
for /F "usebackq" %%L in (`%IMG7%magick ^
  xc: ^
  -format "StartMax=%%[fx:2*floor(0.8*%sig%)+1]" ^
  info:`) do set %%L

echo off

for /L %%N in (%StartMax%,2,%MaxW%) do if !Bust!==0 (

  set PROC=
  for /L %%I in (1,1,%NumIter%) do set PROC=!PROC! -process integim -process 'deintegim window %%Nx1'

  for /F "usebackq" %%L in (`%IM7DEV%magick ^
    igo_imp.miff ^
    !PROC! ^
    igo_blr.miff ^
    -metric RMSE ^
    -format "Diff=%%[distortion]\n" ^
    -compare ^
    info:`) do set %%L

  for /F "usebackq" %%L in (`%IM7DEV%magick ^
    xc: ^
    -format "Better=%%[fx:!Diff!<!MinDiff!?1:0]\n" ^
    info:`) do set %%L

  echo N=%%N Diff=!Diff! Better=!Better!

  if !Better!==1 (
    set MinDiff=!Diff!
    set BestW=%%N
  ) else (
    set Bust=1
  )

)

rem %IMG7%magick igo_integ.miff -verbose info:

echo sig=%sig% MaxW=%MaxW% MinDiff=%MinDiff% BestW=%BestW%

endlocal && set igoSigma=%sig%&&set igoMaxW=%MaxW%&&set igoBestW=%BestW%