rem From image %1
rem write windowed mean %2
rem and standard deviation %3
rem with window size %4 eg 20x20
rem using the process module integral image method.
@rem
@rem Updated:
@rem   8-August-2022 for IM v7.
@rem


@if "%4"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

rem @call echoOffSave

call %PICTBAT%setInOut %1 rmnsd

set OUTMEAN=%2
if "%OUTMEAN%"=="." set OUTMEAN=
if "%OUTMEAN%"=="" set OUTMEAN=

set OUTSD=%3
if "%OUTSD%"=="." set OUTSD=
if "%OUTSD%"=="" set OUTSD=

set WINDIMS=%4

if "%OUTMEAN%"=="" (
  set wrOUTMEAN=
) else (
  set wrOUTMEAN=+write %OUTMEAN%
)

if "%OUTSD%"=="" (

  %IM7DEV%magick ^
    %INFILE% ^
    -process 'integim' ^
    -process 'deintegim window %WINDIMS%' ^
    -depth 32 ^
    -define quantum:format=floating-point ^
    %wrOUTMEAN% ^
    NULL:

) else (

  %IM7DEV%magick ^
    %INFILE% ^
    -depth 32 ^
    -define quantum:format=floating-point ^
    ^( -clone 0 ^
       -evaluate Pow 2 ^
       -process 'integim' ^
       -process 'deintegim window %WINDIMS%' ^
    ^) ^
    ^( -clone 0 ^
       -process 'integim' ^
       -process 'deintegim window %WINDIMS%' ^
       %wrOUTMEAN% ^
       -evaluate Pow 2 ^
    ^) ^
    -delete 0 ^
    -alpha off ^
    -compose MinusSrc -composite ^
    -evaluate Pow 0.5 ^
    %OUTSD%
)

call echoRestore

endlocal
