rem From image %1,
rem calculates numeric mean and maximum windowed standard deviation.
rem using the process module integral image method.
rem %2 window size eg 3x3

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 wsd

set WINDIMS=%2
if "%WINDIMS%"=="." set WINDIMS=
if "%WINDIMS%"=="" set WINDIMS=3x3

for /F "usebackq" %%L in (`%IM7DEV%magick ^
    %INFILE% ^
    ^( -clone 0 ^
       -evaluate Pow 2 ^
       -process 'integim' ^
       -process 'deintegim window %WINDIMS%' ^
    ^) ^
    ^( -clone 0 ^
       -process 'integim' ^
       -process 'deintegim window %WINDIMS%' ^
       -evaluate Pow 2 ^
    ^) ^
    -delete 0 ^
    -alpha off ^
    -compose MinusSrc -composite ^
    -evaluate Pow 0.5 ^
    -format "MeanSD=%%[fx:mean]\nMaxSD=%%[fx:maxima]\n" ^
    info:`) do set %%L

call echoRestore

endlocal & set wsdMeanSD=%MeanSD%& set wsdMaxSD=%MaxSD%
