rem Given %1 is multi-image TIFF file,
rem creates TIFF %2 with same number of images, all resized to final image.
@rem
@rem Does not try to read all images into memory at once.
@rem
@rem Updated:
@rem   25-September-2022 for IM v7.
@rem

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion


set CNT=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "CNT=%%n\nisSIZE.%%s=%%wx%%h\n" ^
  %1`) do set %%L

if "%CNT%"=="" exit /B 1

set /A Nm1=%CNT%-1

set isLAST_SIZE=!isSIZE.%Nm1%!

set FILE_LIST=
for /L %%N in (0,1,%Nm1%) do (

  set TMP_TIF=it_tmp_%%N.tiff

  if !isSIZE.%%N!==%isLAST_SIZE% (
    set sRESIZE=
  ) else (
    set sRESIZE=-resize "%isLAST_SIZE%^!"
  )

  %IMG7%magick ^
    %1[%%N] ^
    !sRESIZE! ^
    !TMP_TIF!

  set FILE_LIST=!FILE_LIST! !TMP_TIF!
)

tiffcp %FILE_LIST% %2
del %FILE_LIST%

@endlocal
