rem Get statistics about an image file %1 (eg a multi-image .tiff file).
rem If %2 not blank, creates that text file and write data as HTM table.
@rem
@rem Does not try to read all images into memory at once.
@rem
@rem Updated:
@rem   5-September-2022 for IM v7.
@rem

set isCNT=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "isCNT=%%n\n" ^
  %1`) do set %%L

if "%isCNT%"=="" exit /B 1

set /A Nm1=%isCNT%-1

if not "%2"=="" (
  echo #,Size,Min,Mean,Max,SD

  for /L %%N in (0,1,%Nm1%) do @(

    for /F "usebackq" %%L in (`%IMG7%magick identify ^
      -format "isSIZE.%%s=%%wx%%h\nisMIN.%%s=%%[fx:minima]\nisMEAN.%%s=%%[fx:mean]\nisMAX.%%s=%%[fx:maxima]\nisSD.%%s=%%[fx:standard_deviation]\n" ^
      %1`) do @set %%L

    echo %%N,!isSIZE.%%N!,!isMIN.%%N!,!isMEAN.%%N!,!isMAX.%%N!,!isSD.%%N!
  )
)>%~n2.csv

rem set isLAST_SIZE=!isSIZE.%Nm1%!

if not "%2"=="" (
  call csv2tab %~n2
  rem del %~n2.csv
  rem echo ^<p class="center"^>^<tt^>isLAST_SIZE=%isLAST_SIZE%^</tt^>^</p^> >>%~n2.htm
)

