rem Repeats innerTrim until no white pixels remain,
rem making an animated gif with rectangles of different colours.
@rem
@rem Updated:
@rem   23-August-2022 Upgraded for IM v7.
@rem

@setlocal
@call echoOnSave

call %PICTBAT%setInOut %1 itr

@set BASENAME=%~n1
@set OUTFILE=%BASENAME%_itr%EXT%
@set TMP_EXT=.miff
@set TMP_FILE=%TEMP%\%BASENAME%_itr%TMP_EXT%
@set ITR_COLOURS=%TEMP%\%BASENAME%_itr_cols%EXT%
@set FRAMES_DIR=%TEMP%\frames_%BASENAME%


rd /s /q %FRAMES_DIR%
md %FRAMES_DIR%
if ERRORLEVEL 1 goto error

@set ITR_NUM_COLS=20

%IMG7%magick ^
  -size 1x%ITR_NUM_COLS% gradient: -rotate 90 ^
  ( -size 1x1 ^
    xc:red xc:yellow xc:lime xc:cyan xc:blue xc:magenta xc:red ^
    +append ^
  ) ^
  -clut ^
  %ITR_COLOURS%


@set /A colNdx=0


%IMG7%magick %INFILE% -fill #000 +opaque #fff %TMP_FILE%

set itWHITE_EDGE=1

set INNER_TRIM_RECT=

%IMG7%magick %INFILE% %OUTFILE%

set /A framNum=0

rem FIXME: We should be easily able to add border only once, at start.
set itWHITE_EDGE=1
set itDEBUG_FILE=


:loop

if "%INNER_TRIM_RECT%"=="" (
  set itrDrawRect=
  set itrWrite=
) else (
  if "%INNER_TRIM_AREA%"=="1" (
    rem IM bug can't draw rectangle 1x1
    set IT_XY=%INNER_TRIM:~4%
    rem set IT_XY=!IT_XY:+=,!
    set itrDrawRect=-draw "point !IT_XY:+=,!"
  ) else (
    set itrDrawRect=-draw "%INNER_TRIM_RECT%" 
  )
  set itrWrite=-write %TMP_FILE%
)

@rem echo itrDrawRect=%itrDrawRect%

FOR /F "usebackq tokens=1-2 delims=, " %%X ^
IN (`%IMG7%magick ^
  %TMP_FILE% ^
  -fill #000 %itrDrawRect% ^
  %itrWrite% ^
  -morphology Distance Euclidean:4 -auto-level ^
  -alpha set +transparent White sparse-color:`) ^
DO set whiteX=%%X & set whiteY=%%Y

FOR /F "usebackq" %%C ^
IN (`%IMG7%magick %ITR_COLOURS% -format "%%[pixel:p{%colNdx%,0}]" info:`) ^
DO set ONE_PIXEL=%%C

%IMG7%magick ^
  %OUTFILE% ^
  -fill %ONE_PIXEL% %itrDrawRect% ^
  %OUTFILE%

@set LZframNum=000000%framNum%
@set LZframNum=%LZframNum:~-6%

@copy /y %OUTFILE% %FRAMES_DIR%\itr_f_%LZframNum%%TMP_EXT%
if ERRORLEVEL 1 goto error

call %PICTBAT%innerTrim %TMP_FILE% %whiteX% %whiteY%
@if ERRORLEVEL 1 goto error
@echo %INNER_TRIM%  "%INNER_TRIM_RECT%"  Area: %INNER_TRIM_AREA%

@set /A framNum+=1
@set /A colNdx+=1
if %colNdx% GEQ %ITR_NUM_COLS% set /A colNdx = 0;

@if not "%INNER_TRIM_RECT%"=="" goto loop

echo Frames: %framNum%

%IMG7%magick -delay 20 %FRAMES_DIR%\itr_f_*%TMP_EXT% itr.gif

@call echoRestore
@exit /B 0

:error
@call echoRestore
echo %0 failed for %*
exit /B 1
