rem From integral %1, make image %2, the windowed mean.
rem Input should be capable of storing HDRI values.
rem %3 is optional window size, eg 5x7.
@rem
@rem Also uses:
@rem   iiREGARDALPHA if 1, uses alpha.
@rem
@rem See also integral.bat.
@rem
@rem Updated:
@rem   8-August-2022 for IM v7.
@rem


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 imn

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

call parseXxY2i 0 0 imn %3
if ERRORLEVEL 1 exit /B 1

echo %0: imn_X=%imn_X% imn_Y=%imn_Y%

set /A dx1=(%imn_X%-1)/2
set /A dx0=%imn_X%-1-%dx1%

set /A dy1=(%imn_Y%-1)/2
set /A dy0=%imn_Y%-1-%dy1%

set /A WINAREA=%imn_X%*%imn_Y%

echo %0: %dx0% %dx1%  %dy0% %dy1% WINAREA=%WINAREA%

if "%iiREGARDALPHA%"=="1" (
  set sDIVIDE=^( +clone -alpha extract ^) -compose DivideSrc -composite
  set sDIVIDE=
) else (
  set sDIVIDE=-evaluate Divide %WINAREA%
)

set sDIVIDE=-set channel RGB -evaluate Divide %WINAREA% +channel

set /A xp1=%dx0%+1
set /A yp1=%dy0%+1

set crpW=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "crpW=%%[fx:w-2*%imn_X%]\ncrpH=%%[fx:h-2*%imn_Y%]\n" ^
  %INFILE%`) do set %%L

if "%crpW%"=="" exit /B 1

set sCROP=-crop !crpW!x!crpH!+%imn_X%+%imn_Y% +repage

echo %0: sCROP=%sCROP%

%IMG7%magick ^
  %INFILE% ^
  ( -clone 0 -repage -%dx1%-%dy1% ) ^
  ( -clone 0 -repage -%dx1%+%yp1% ) ^
  ( -clone 0 -repage +%xp1%-%dy1% ) ^
  ( -clone 0 -repage +%xp1%+%yp1% ) ^
  -delete 0 ^
  -virtual-pixel Black ^
  -background None ^
  -define compose:clamp=off ^
  -alpha off ^
  ( -clone 0-1 ^
    -compose MinusSrc -layers Merge ^
    -clone 3 ^
    -compose Plus -layers Merge ^
    -clone 2 ^
    -compose MinusSrc -layers Merge ^
  ) ^
  -delete 0-3 ^
  %sCROP% ^
  %sDIVIDE% ^
  -alpha off ^
  -depth 32 ^
  -define quantum:format=floating-point ^
  %OUTFILE%

if "%iiREGARDALPHA%"=="1" (
  %IMG7%magick ^
  %INFILE% ^
  -alpha extract ^
  ^( -clone 0 -repage -%dx1%-%dy1% ^) ^
  ^( -clone 0 -repage -%dx1%+%yp1% ^) ^
  ^( -clone 0 -repage +%xp1%-%dy1% ^) ^
  ^( -clone 0 -repage +%xp1%+%yp1% ^) ^
  -delete 0 ^
  -virtual-pixel Black ^
  -background None ^
  -define compose:clamp=off ^
  -alpha off ^
  ^( -clone 0-1 ^
    -compose MinusSrc -layers Merge ^
    -clone 3 ^
    -compose Plus -layers Merge ^
    -clone 2 ^
    -compose MinusSrc -layers Merge ^
  ^) ^
  -delete 0-3 ^
  %sCROP% ^
  %sDIVIDE% ^
  -depth 32 ^
  -define quantum:format=floating-point ^
  %OUTFILE% ^
  -define compose:clamp=off ^
  -compose DivideDst -composite ^
  -define quantum:format=floating-point ^
  %OUTFILE%

)

if ERRORLEVEL 1 exit /B 1

call echoRestore

endlocal & set imnOUTFILE=%OUTFILE%
