rem From image %1
rem write windowed mean %2 and standard deviation %3
rem with window size %4
rem using the cumulhisto integral image method.
@rem
@rem Todo: reduce work if user doesn't want mean or SD.
@rem
@rem
@rem Updated:
@rem   8-August-2022 for IM v7.
@rem


@if "%4"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 imnsd

set OUTMEAN=%2
if "%OUTMEAN%"=="." set OUTMEAN=
if "%OUTMEAN%"=="" set OUTMEAN=

set OUTSD=%3
if "%OUTSD%"=="." set OUTSD=
if "%OUTSD%"=="" set OUTSD=

set WINDIMS=%4

:: Temporary mean of square, and square of mean.
set TMPDIR=\temp\
set TMP_MN_SQ=%TMPDIR%ims_ms.miff
set TMP_MN_SQ2=%TMPDIR%ims_ms2.miff
set TMP_MN_SQ3=%TMPDIR%ims_ms3.miff
set TMP_SQ_MN=%TMPDIR%ims_sm.miff

if "%OUTMEAN%"=="" (
  set wrOUTMEAN=
) else (
  set wrOUTMEAN=+write %OUTMEAN%
)

%IMG7%magick ^
  %INFILE% ^
  -evaluate Pow 2 ^
  +depth ^
  -depth 32 ^
  -define quantum:format=floating-point ^
  %TMP_MN_SQ%

if ERRORLEVEL 1 exit /B 1

call %PICTBAT%integral %TMP_MN_SQ% %TMP_MN_SQ2% %WINDIMS%
if ERRORLEVEL 1 exit /B 1

call %PICTBAT%integMean %TMP_MN_SQ2% %TMP_MN_SQ3% %WINDIMS%
if ERRORLEVEL 1 exit /B 1


call %PICTBAT%integral %INFILE% %TMP_SQ_MN% %WINDIMS%
if ERRORLEVEL 1 exit /B 1

call %PICTBAT%integMean %TMP_SQ_MN% %TMP_SQ_MN% %WINDIMS%
if ERRORLEVEL 1 exit /B 1

if ERRORLEVEL 1 exit /B 1

if "%OUTSD%"=="" (
  set sSQFORSD=NULL:
) else (
  set sSQFORSD=-evaluate Pow 2 %TMP_SQ_MN%
)


%IMG7%magick ^
  %TMP_SQ_MN% ^
  %wrOUTMEAN% ^
  %sSQFORSD%

if ERRORLEVEL 1 exit /B 1

if not "%OUTSD%"=="" %IMG7%magick ^
  %TMP_MN_SQ3% ^
  %TMP_SQ_MN% ^
  -compose MinusSrc -composite ^
  -evaluate Pow 0.5 ^
  %OUTSD%


call echoRestore

endlocal
