rem From image %1, make integral %2.
rem Output should be capable of storing HDRI values.
rem %3 is optional window size, eg 5x7.
@rem
@rem Also uses:
@rem   iiREGARDALPHA if 1, uses alpha.
@rem
@rem See also deintegral.bat.
@rem
@rem Updated:
@rem   8-August-2022 for IM v7.
@rem



@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 integ

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

call parseXxY2i 0 0 integ %3
if ERRORLEVEL 1 exit /B 1

if "%iiREGARDALPHA%"=="1" (
  set RA=regardalpha
) else (
  set RA=
)

set RA=

echo %0: integ_X=%integ_X% integ_Y=%integ_Y%

:: Setting the viewport adds the two fx: expressions as properties,
:: so this removes them.

%IM7DEV%magick ^
  %INFILE% ^
  -set colorspace sRGB ^
  -channel RGB ^
  -set option:distort:viewport ^
    "%%[fx:w+2*%integ_X%]x%%[fx:h+2*%integ_Y%]-%integ_X%-%integ_Y%" ^
  -virtual-pixel Edge ^
  -filter point ^
  +distort SRT 0 ^
  +repage ^
  -process 'cumulhisto %RA%' ^
  -rotate -90 ^
  -process 'cumulhisto %RA%' ^
  -rotate +90 ^
  +depth ^
  -define quantum:format=floating-point ^
+set fx:w+2*%integ_X% ^
+set fx:h+2*%integ_Y% ^
  +channel ^
  %OUTFILE%

if ERRORLEVEL 1 exit /B 1

call echoRestore

endlocal & set integOUTFILE=%OUTFILE%
