rem Given %1 and %2 are Nx1 images,
rem makes linearly interpolated image Nx%3 pixels,
rem named %4.
rem %5 is percentage of gradient at image top [0].
rem %6 is percentage of gradient at image bottom [100].
rem
rem Assumes magick is HDRI.

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 ic

set IMG1=%INFILE%
set IMG2=%2

set HH=%3
if "%HH%"=="." set HH=
if "%HH%"=="" set HH=10

if not "%4"=="" if not "%4"=="." set OUTFILE=%4

set PCTOP=%5
if "%PCTOP%"=="." set PCTOP=
if "%PCTOP%"=="" set PCTOP=0

set PCBOT=%6
if "%PCBOT%"=="." set PCBOT=
if "%PCBOT%"=="" set PCBOT=100

rem IM v7.0.7-28 can't handle negatives in "gradient:".
rem See https://www.imagemagick.org/discourse-server/viewtopic.php?f=3&t=36160

if "%PCTOP:~0,1%"=="-" (

  set sFMT=^
POS=%%[fx:-^(%PCTOP%^)]\n^
PCBOT=%%[fx:%PCBOT%-^(%PCTOP%^)]

  for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -precision 16 ^
    -format "!sFMT!" ^
    %IMG1%`) do set %%L

  set SUB=-evaluate subtract !POS!%%
  set PCTOP=0
) else (
  set SUB=
)

echo %0: top=%PCTOP% bot=%PCBOT% sub=%SUB%

%IMG7%magick ^
  %IMG1% ^
  -set option:MYSIZE %%[fx:w]x%HH% ^
  ( +clone ^
    -scale "%%[MYSIZE]^!" ^
    -write mpr:IMG1 ^
    +delete ^
  ) ^
  %IMG2% ^
  -define compose:clamp=off ^
  -compose MinusDst -composite ^
  -scale "%%[MYSIZE]^!" ^
  -size "%%[MYSIZE]" ^
  ( gradient:gray(%PCTOP%%%)-gray(%PCBOT%%%) ^
    %SUB% ^
  ) ^
  -compose Multiply -composite ^
  mpr:IMG1 ^
  -compose Plus -composite ^
  -define quantum:format=floating-point ^
  -depth 32 ^
  %OUTFILE%

if ERRORLEVEL 1 exit /B 1

call echoRestore

@endlocal & set icOUTFILE=%OUTFILE%


