rem Given %1 is a 2-D absolute displacement map,
rem where each row displaces horizontally and either increases or decreases but not both,
rem makes the inverse by inverting each line separately.
rem %2 is output file [mandatory]
rem %3 is channel. Default RGB.
rem %4 is 0=all rows increase or 1=all rows decrease. Default 0.
@rem
@rem Updated:
@rem   15 May 2016 use %IML% for @script.
@rem   21-August-2022 Upgraded for IM v7.
@rem   23-August-2022 Insert %2 as output [mandatory].
@rem


@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 iad

set OUTFILE=%2

set sCHANNEL=%3
if "%sCHANNEL%"=="." set sCHANNEL=
if "%sCHANNEL%"=="" set sCHANNEL=RGB

set NEG=%4
if "%NEG%"=="." set NEG=
if "%NEG%"=="" set NEG=0


rem @-files can't have drive, so can't be %TEMP%
set FSCRIPT=%~n1_iad.scr
set FGRAD=%TEMP%\%~n1_iad.miff

del /q %FSCRIPT% 2>nul

FOR /F "usebackq" %%L ^
IN (`%IMG7%magick identify -format "WW=%%w\nHH=%%h\nWm1=%%[fx:w-1]\nHm1=%%[fx:h-1]" %INFILE%`) ^
DO set %%L


set sNEG=
if %NEG%==1 set sNEG=-negate

(
  for /L %%Y in (0,1,%Hm1%) do (
    echo ^( -clone 0 -crop %WW%x1+0+%%Y +repage -scale "%WW%x%WW%^!" -clone 1 -compose MinusDst -composite -channel %sCHANNEL% -threshold 0 %sNEG% +channel -scale "1x%WW%^!" -rotate 90 ^)
  )
  echo -delete 0-1 -append
  echo -write %OUTFILE%
  echo -exit
) >%FSCRIPT%

%IMG7%magick %INFILE% -size %WW%x%WW% gradient: -script %FSCRIPT%

if ERRORLEVEL 1 (
  echo %0: magick script failed
  exit /B 1
)

%IMG7%magick identify %OUTFILE%

call echoRestore
