rem From %1, a clut image, height=1, make the inverse clut.
rem Optional %2 is output filename.
@rem
@rem Updated:
@rem   21-August-2022 Upgraded for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 icl

if not "%2"=="" set OUTFILE=%2


FOR /F "usebackq" %%L ^
IN (`%IMG7%magick identify -format "WW=%%w\nHH=%%h\nWm1=%%[fx:w-1]" %INFILE%`) ^
DO set %%L

if not %HH%==1 (
  echo %0: Expected height of 1 in %*
  exit /B 1
)

FOR /F "usebackq" %%L ^
IN (`%IMG7%magick ^
  %INFILE% ^
  -format "negR=%%[fx:p{0,0}.r>p{%Wm1%,0}.r]\nnegG=%%[fx:p{0,0}.g>p{%Wm1%,0}.g]\nnegB=%%[fx:p{0,0}.b>p{%Wm1%,0}.b]" ^
  info:`) ^
DO set %%L

set sNegR=
set sNegG=
set sNegB=
if %negR%==1 set sNegR=-channel R -negate
if %negG%==1 set sNegG=-channel G -negate
if %negB%==1 set sNegB=-channel B -negate

%IMG7%magick ^
  %INFILE% ^
  -scale "%WW%x%WW%^!" ^
  -size %WW%x%WW% gradient: ^
  -compose MinusDst -composite ^
  -channel RGB -threshold 0 ^
  %sNegR% %sNegG% %sNegB% ^
  +channel ^
  -scale "1x%WW%^!" ^
  -rotate 90 ^
  %OUTFILE%

call echoRestore

@endlocal & set iclOUTFILE=%OUTFILE%
