rem Inverse of logPolar.bat
rem
rem From image %1, a log-polar image,
rem creates output ordinary image %2.
rem %3 is 0 or -1.
rem %4 is required height of output. Can be percentage or proportion of input height.
@rem
@rem Updated:
@rem   24-August-2022 for IM v7.
@rem

if "%2%"=="" exit /B 1

setlocal

set INFILE=%1
set OUTFILE=%2

set lpTYPE=%3
if "%lpTYPE%"=="." set lpTYPE=
if "%lpTYPE%"=="" set lpTYPE=-1

set WW=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "WW=%%w\nHH=%%h" ^
  %INFILE%`) do set %%L
if "%WW%"=="" exit /B 1

set REQ_H=%4
if "%REQ_H%"=="" set REQ_H=.

call parseNum %REQ_H% %HH% OUT_HH

set sRESIZE=
if %OUT_HH% NEQ %HH% set sRESIZE=-resize "%WW%x%OUT_HH%^^^!"

goto skip

set INV_IDENT=^
0,0,#0f8,^
%%[fx:w-1],0,#ff8,^
0,%%[fx:h-1],#008,^
%%[fx:w-1],%%[fx:h-1],#f08

%IM7DEV%magick ^
  %INFILE% ^
  ( +clone ^
    -sparse-color bilinear "%INV_IDENT%" ^
+write x0.png ^
    -separate ^
    ( -clone 1 ^
      -fx "ln(h*u.g+0.1)" ^
      -auto-level ^
      -negate ^
      -rotate -90 ^
      -process invclut ^
      -rotate 90 ^
      -auto-level ^
+write x1.png ^
    ) ^
    -swap 1,3 ^
    -delete 3 ^
+write x2.png ^
    -combine ^
+write x3.png ^
  ) ^
  -compose distort -set option:compose:args 100%%x100%% -composite ^
+write x4.png ^
  %sRESIZE% ^
  -distort polar %lpTYPE% ^
  +depth ^
  %OUTFILE%

:skip

%IM7DEV%magick ^
  %INFILE% ^
  ( ( -size %HH%x%WW% gradient:black-white -rotate -90 ) ^
    ( -size 1x%HH% gradient:white-black ^
      -fx "ln(h*u.g+1)" ^
      -auto-level ^
      -negate ^
      -rotate -90 ^
      -process 'mkhisto cumul norm' ^
      -rotate 90 ^
      -scale "%WW%x%HH%^!" ) ^
    ( -size %WW%x%HH% xc:#888 ) ^
    -combine ^
+write y0.png ^
  ) ^
  -compose distort -set option:compose:args 100%%x100%% -composite ^
+write x4.png ^
  %sRESIZE% ^
  -distort polar %lpTYPE% ^
  +depth ^
  %OUTFILE%

endlocal
