rem From %1,
rem a single-row clut image that represents a parallel relative displacement map,
rem make the inverse clut.
@rem
@rem Updated:
@rem   21-August-2022 Upgraded for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 irc

FOR /F "usebackq" %%L ^
IN (`%IMG7%magick identify -format "WW=%%w\nHH=%%h\nWm1=%%[fx:w-1]" %INFILE%`) ^
DO set %%L

if not %HH%==1 (
  echo %0: Expected height of 1 in %*
  exit /B 1
)

FOR /F "usebackq" %%L ^
IN (`%IMG7%magick ^
  %INFILE% ^
  -format "negR=%%[fx:p{0,0}.r>p{%Wm1%,0}.r]\nnegG=%%[fx:p{0,0}.g>p{%Wm1%,0}.g]\nnegB=%%[fx:p{0,0}.b>p{%Wm1%,0}.b]" ^
  info:`) ^
DO set %%L

set sNegR=
set sNegG=
set sNegB=
if %negR%==1 set sNegR=-channel R -negate
if %negG%==1 set sNegG=-channel G -negate
if %negB%==1 set sNegB=-channel B -negate


if "%ircDEBUG%"=="1" (
  set wr0=-write irc0.png
  set wr1=-write irc1.png
) else (
  set wr0=
  set wr1=
)

%IMG7%magick ^
  %INFILE% ^
  ( -size 1x%WW% gradient: -rotate 90 -write mpr:GRAD ) ^
  -compose Mathematics -define compose:args=0,1,1,-0.5 -composite ^
  %wr0% ^
  -scale "%WW%x%WW%^!" ^
  -size %WW%x%WW% gradient: ^
  -compose MinusDst -composite ^
  -channel RGB -threshold 0 ^
  %sNegR% %sNegG% %sNegB% ^
  +channel ^
  -scale "1x%WW%^!" ^
  -rotate 90 ^
  %wr1% ^
  mpr:GRAD ^
  -compose Mathematics -define compose:args=0,-1,1,0.5 -composite ^
  %OUTFILE%

if "%ircDEBUG%"=="1" (
  call %PICTBAT%graph1d irc0.png
  call %PICTBAT%graph1d irc1.png

  %IMG7%magick ^
    rose: ^
    ^( +clone ^
      irc0.png -clut ^
      irc1.png -clut ^
    ^) ^
    -metric RMSE ^
    -format "irc0.png to irc1.png: %%[distortion]\n" ^
    -compare info:

  rem %IMG7%magick identify %OUTFILE%

  call %PICTBAT%graph1d %OUTFILE%
)

call echoRestore
