rem Given image %1 is black "sea" with some non-black islands,
rem finds one tallest peak per island.
rem %2 output, white at a peak, otherwise black.
@rem
@rem Updated:
@rem   11-August-2022 for IM v7
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 ipk

if not "%2"=="" if not "%2"=="" set OUTFILE=%2

set TMPEXT=.miff
set ISL_BW=%OUTBASE%_ipk_bw%TMPEXT%
set ISL_MSKS=%OUTBASE%_ipk_imsk_XX%TMPEXT%

%IMG7%magick ^
  %INFILE% ^
  -fill White +opaque Black ^
  +write %ISL_BW% ^
  -fill Black -colorize 100 ^
  %OUTFILE%

call %PICTBAT%connCompMsks %ISL_BW% %ISL_MSKS%

echo %0: cmCNT=%cmCNT%

if "%cmCNT%"=="" exit /B 1
if %cmCNT% LSS 2 exit /B 1

:: Assume number 0 is the sea, and ignore it.

set /A CNTm1=%cmCNT%-1

rem FIXME: Can this cope with multiple equal peaks?

for /L %%I in (1,1,%CNTm1%) do (
  set sMASK=!ISL_MSKS:XX=%%I!

  %IMG7%magick ^
    %INFILE% ^
    !sMASK! ^
    -compose Darken -composite ^
    -auto-level ^
    -fill Black +opaque White ^
    %OUTFILE% ^
    -compose Lighten -composite ^
    %OUTFILE%

  del !sMASK!
)

%IMG7%magick ^
  %OUTFILE% ^
  -morphology Thinning:-1 skeleton -clamp ^
  -morphology Thinning:-1 LineEnds -clamp ^
  %OUTFILE%


call echoRestore

endlocal & set ipkOUTFILE=%OUTFILE%
