#version 3.7;
global_settings { assumed_gamma 1.0 } 

#include "colors.inc"
#include "textures.inc"
#include "shapes.inc"
#include "metals.inc"
#include "glass.inc"
#include "woods.inc"         

camera {
   location <0, 0, -1000>
   // angle 45 // direction <0, 0,  1.7>
   right x*image_width/image_height
   look_at <0,0,0>
}

// Uncomment the area lights only if you've got lots of time.
#declare Dist=80.0;

light_source {< -600, +300, -900> color White*2
//     fade_distance Dist fade_power 2
   area_light <-40, 0, -40>, <40, 0, 40>, 3, 3
   adaptive 1
   jitter
}

//light_source {< -500, 250, -500> color White
//     fade_distance Dist fade_power 2
//   area_light <-40, 0, -40>, <40, 0, 40>, 3, 3
//   adaptive 1
//   jitter
//}

light_source {< 500, -100, -40> color Gray30
     fade_distance Dist fade_power 2
     area_light <-20, 0, -20>, <20, 0, 20>, 3, 3
     adaptive 1
     jitter
}
light_source {< 0, -1000,  0> color Gray30
     fade_distance Dist fade_power 2
//   area_light <-30, 0, -30>, <30, 0, 30>, 3, 3
//   adaptive 1
//   jitter
}

//sky_sphere {
//    pigment {
//        gradient y
//        color_map {
//            [0, 1  color Gray50 color Gray80]
//        }
//    }
//}

#declare M_Wood18B =
colour_map {
    [0.00 0.25   color rgbf < 0.50, 0.26, 0.12, 0.10>
                 color rgbf < 0.54, 0.29, 0.13, 0.20>]
    [0.25 0.40   color rgbf < 0.54, 0.29, 0.13, 0.20>
                 color rgbf < 0.55, 0.28, 0.10, 0.70>]
    [0.40 0.50   color rgbf < 0.55, 0.28, 0.10, 0.70>
                 color rgbf < 0.50, 0.23, 0.15, 0.95>]
    [0.50 0.70   color rgbf < 0.50, 0.23, 0.15, 0.95>
                 color rgbf < 0.56, 0.29, 0.17, 0.70>]
    [0.70 0.98   color rgbf < 0.56, 0.29, 0.17, 0.70>
                 color rgbf < 0.54, 0.29, 0.13, 0.20>]
    [0.98 1.00   color rgbf < 0.54, 0.29, 0.13, 0.20>
                 color rgbf < 0.50, 0.26, 0.12, 0.10>]
}


#declare Floor_Texture =
    texture { pigment { P_WoodGrain18A color_map { M_Wood18A }}}
    texture { pigment { P_WoodGrain12A color_map { M_Wood18B }}}
    texture {
        pigment { P_WoodGrain12B color_map { M_Wood18B }}
        finish { reflection 0.25 }
    }

#declare Floor =
plane { y,0
    texture { Floor_Texture
        scale 0.5
        rotate y*90
        rotate <10, 0, 15>
        translate z*4
    }
}

#declare WhiteFloor =
plane { z,0
  pigment { color White }
  translate z*200
}

#declare CheckerFloor =
plane { z,0
  pigment { checker color White, color Gray scale 100 }
  translate z*1000
}






#ifndef (RopeRad)
#declare RopeRad=5;
#end

#declare reef_a =
sphere_sweep {
  b_spline
  15,
  <375,-800,0>, RopeRad
  <375,-700,0>, RopeRad // on curve
  <325,-550,0>, RopeRad
  <265,-400,0>, RopeRad
  <265,-300,0>, RopeRad // on curve
  <265,-225,0>, RopeRad
  <310,-125,75>, RopeRad
  <250,-125,75>, RopeRad // on curve
  <190,-125,75>, RopeRad
  <225,-225,0>, RopeRad
  <225,-300,0>, RopeRad // on curve
  <225,-350,0>, RopeRad
  <225,-450,0>, RopeRad
  <205,-500,0>, RopeRad // on curve
  <195,-520,0>, RopeRad
  pigment { color <1, 0.25, 0.25> }
}

#declare reef_test_a =
union {
  sphere { <375,-700,0> 20 }
  sphere { <265,-300,0> 20 }
  sphere { <250,-125,75> 20 }
  sphere { <225,-300,0> 20 }
  sphere { <205,-500,0> 20 }
  pigment { color Red }
}

#declare reef_b =
sphere_sweep {
  b_spline
  18,
  <280,100,-50>, RopeRad
  <280,0,-50>, RopeRad // on curve
  <280,-25,-50>, RopeRad
  <280,-75,-50>, RopeRad
  <280,-125,-50>, RopeRad // on curve
  <270,-150,-50>, RopeRad
  <250,-175,100>, RopeRad
  <230,-200,100>, RopeRad // on curve
  <215,-250,125>, RopeRad
  <125,-300,-50>, RopeRad
  <250,-300,-50>, RopeRad // on curve
  <330,-300,-50>, RopeRad
  <330,-225,50>,  RopeRad
  <250,-225,50>,  RopeRad // on curve
  <225,-225,50>, RopeRad
  <225,-225,50>, RopeRad
  <100,-225,50>, RopeRad // on curve
  <150,-225,50>, RopeRad
  pigment { color rgb <0.25, 0.25, 1> }
}

#declare reef_test_b =
union {
  sphere { <280,0,-50> 20 }
  sphere { <280,-125,-50> 20 }
  sphere { <230,-200,100> 20 }
  sphere { <250,-300,-50> 20 }
  sphere { <250,-225,50> 20 }
  sphere { <100,-225,50> 20 }
  pigment { color Blue }
}

#declare reef_knot =
union {
  object { reef_a }
  object { reef_b }
  translate <-250,225,0>
}

#declare reef_knot_chk =
union {
  object { reef_a }
  object { reef_test_a }
  object { reef_b }
  object { reef_test_b }
  translate <-250,225,0>
}

