rem From image %1
rem and lith screen template %2,
rem and CSV file %3
rem make layered halftone output %4.
rem %5 is resampling factor [default 1, no resampling]
rem %6 power for input [1]
@rem
@rem Updated:
@rem   6-August-2022 for IM v7
@rem

@if "%3"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 lh

set LITH_SCRN=%2

set DATA_FILE=%3

if not "%4"=="" if not "%4"=="." set OUTFILE=%4

set RESAMP=%5
if "%RESAMP%"=="." set RESAMP=
if "%RESAMP%"=="" set RESAMP=1

set POW=%6
if "%POW%"=="." set POW=
if "%POW%"=="" set POW=1

set TMPDIR=%TEMP%
set TMPEXT=.miff

set TMP_IN=%TMPDIR%\lh_in%TMPEXT%
set TMP_SCRN=%TMPDIR%\lh_scrn%TMPEXT%
set TMP_LAYER_PREF=%TMPDIR%\lh_layer_
set TMP_CUMUL=%TMPDIR%\lh_cumul%TMPEXT%

:: FIXME: multiply wave specs.

if %RESAMP%==1 (
  set SAMP_UP=
  set SAMP_DN=
) else (
  for /F "usebackq tokens=*" %%L in (`%IMG7%magick identify ^
    -format "SAMP_UP=-resize %%[fx:100*%RESAMP%]%%%% \nSAMP_DN=-resize %%[fx:100/%RESAMP%]%%%% \n" ^
    xc:`) do set %%L
)

if "%POW%"=="1" (
  set sPOW=
) else (
  set sPOW=-evaluate Pow %POW%
)


%IMG7%magick %INFILE% %sPOW% %SAMP_UP% %TMP_IN%
if ERRORLEVEL 1 exit /B 1

%IMG7%magick %LITH_SCRN% %SAMP_UP% %TMP_SCRN%
if ERRORLEVEL 1 exit /B 1

set COUNT=0
for /F "tokens=1-6 delims=, " %%A in (%DATA_FILE%) do (

  set LAYER_F=%TMP_LAYER_PREF%!COUNT!%TMPEXT%

  echo !COUNT!: %%A, %%B, %%C, %%D, %%E, %%F  !LAYER_F!

  set ANGLE=%%D
  if "!ANGLE!"=="." set ANGLE=
  if "!ANGLE!"=="" set ANGLE=0

  set WAVEAMP=%%E
  if "!WAVEAMP!"=="." set WAVEAMP=
  if "!WAVEAMP!"=="" set WAVEAMP=0

  set WAVELEN=%%F
  if "!WAVELEN!"=="." set WAVELEN=
  if "!WAVELEN!"=="" set WAVELEN=100

  if not %RESAMP%==1 (
    for /F "usebackq tokens=*" %%L in (`%IMG7%magick identify ^
      -format "WAVEAMP=%%[fx:!WAVEAMP!*%RESAMP%]\nWAVELEN=%%[fx:!WAVELEN!*%RESAMP%]%%%% \n" ^
      xc:`) do set %%L
  )

  call %PICTBAT%restrictScreen %%A %%B %%C lsRESTRICT

  call %PICTBAT%lithScreen ^
    %TMP_IN% %TMP_SCRN% !LAYER_F! !ANGLE! !WAVEAMP! !WAVELEN! 1

  if !COUNT!==0 (
    %IMG7%magick !LAYER_F! %TMP_CUMUL%
  ) else (
    %IMG7%magick %TMP_CUMUL% !LAYER_F! -compose Darken -composite %TMP_CUMUL%
  )

  set /A COUNT+=1
)

%IMG7%magick %TMP_CUMUL% %SAMP_DN% %OUTFILE%
if ERRORLEVEL 1 exit /B 1


call echoRestore

@endlocal & set lhOUTFILE=%OUTFILE%
