rem Makes a mask from LBD, difference from light blur resulting in monochrome RMS.
rem White or light where there is detail; black or dark where there isn't.
rem
rem %2 is blur sigma in pixels.
@rem
@rem See also ltBlrDiff.
@rem
@rem Updated:
@rem   26-July-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 lbdm

set BLUR_SIG=%2
if "%BLUR_SIG%"=="" set BLUR_SIG=4

%IMG7%magick ^
  %INFILE% ^
  ^( +clone -blur 0x%BLUR_SIG% ^) ^
  -compose Difference -composite ^
  -grayscale RMS ^
  -auto-level ^
  -auto-gamma ^
  -blur 0x20 ^
  -contrast-stretch 25x25%% ^
  %OUTFILE%

call echoRestore

@endlocal
