rem Given %1 and %2 are two images,
rem where %1 has more detail than %2
rem make a difference mask, white where there is more detail,
rem and re-constituted image of %1 plus the extra detail.
rem %3 is prefix for outputs.
rem %4 is radius for smoothing.
@rem
@rem Updated:
@rem   11-August-2022 for IM v7
@rem

@if "%3"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 ldld


if "%ldEXT%"=="" set ldEXT=png

if "%ldTHRESH%"=="" set ldTHRESH=90

set MASK=%3_ldm.%ldEXT%
set NEWPIX=%3_ldd.%ldEXT%
set RECON=%3_x.%ldEXT%

if "%4"=="" (
  set SMOOTH=
) else (
  set SMOOTH=-morphology Smooth Disk:%4
)


%IMG7%magick ^
  %2 %1 ^
  ( -clone 0-1 ^
    -compose Difference -composite ^
    -grayscale RMS -contrast-stretch %ldTHRESH%%%x0 -fill White +opaque Black ^
    %SMOOTH% ^
    +write %MASK% ^
  ) ^
  ( -clone 1-2 ^
    -compose CopyOpacity -composite ^
    +write %NEWPIX% ^
  ) ^
  -delete 1-2 ^
  -compose Over -composite ^
  %RECON%

rem The mask could be further processed before use:
rem - remove small black specks within white
rem - remove small white specks
rem - merge adjacent white marks
rem The limits will depend on the brush size at this detail.

call echoRestore

@endlocal
