rem from image %1
rem and %2 images with prefix %3,
rem makes mask and detail images.
rem 
rem Then builds the reconstruction images.
@rem
@rem Updated:
@rem   11-August-2022 for IM v7
@rem

@if "%3"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

rem @call echoOffSave

call %PICTBAT%setInOut %1 ldps


set /A CNT=%2
set /A CNTm1=%2-1

set PREFIX=%3

if "%ldEXT%"=="" set ldEXT=png

goto skip
for /L %%i in (0,1,%CNTm1%) do (
  set /A Ip1=%%i+1
  set IN0=%PREFIX%_%%i.%ldEXT%
  set IN1=%PREFIX%_!Ip1!.%ldEXT%
  if %%i==0 set IN0=%INFILE%
  call %PICTBAT%ldLevDet !IN0! !IN1! %PREFIX%_%%i 1
)
:skip

rem Make the reconstructions.

set OPTS=

for /L %%i in (%CNTm1%,-1,0) do (
  set /A Ip1=%%i+1
  set IN0=%PREFIX%_%%i.%ldEXT%
  set IN1=%PREFIX%_!Ip1!.%ldEXT%
  if %%i==0 set IN0=%INFILE%
  call %PICTBAT%ldLevDet !IN0! !IN1! %PREFIX%_%%i 1

  echo i=%%i
  set INNAME=%PREFIX%_%%i_ldd.%ldEXT%
  set OUTNAME=%PREFIX%_%%i_ldr.%ldEXT%
  set OPTS=!OPTS! ^( +clone 0 !INNAME! -composite +write !OUTNAME! ^)
)
echo !OPTS!

%IMG7%magick %PREFIX%_%CNT%.%ldEXT% !OPTS! NULL:


if "%LD_DEBUG%"=="1" (

echo on

  rem Make a stacked illustration.

  for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -format "WW=%%w\nHH=%%h\nDX=%%[fx:int(w/4.5+0.5)]\nDY=%%[fx:int(w/6.5+0.5)]" ^
    %INFILE%`) do set %%L

  echo DX,DY=!DX!,!DY!

  set OPTS=

  for /L %%i in (%CNTm1%,-1,0) do (
    echo i=%%i
    set /A RX=^(!CNT!-%%i^)*!DX!
    set /A RY=^(!CNT!-%%i^)*!DY!
    set FNAME=%PREFIX%_%%i_ldd.%ldEXT%
    set OPTS=!OPTS! ^( !FNAME! -repage +!RX!+!RY! ^)
  )
  echo !OPTS!

  %IMG7%magick %PREFIX%_%CNT%.%ldEXT% !OPTS! -layers merge %PREFIX%_dbg.%ldEXT%
)
