@rem Given 4 level parameters,
@rem px1, px2, py1, py2,
@rem two of which are question marks,
@rem calculates the missing two.
@rem The script does _not_ check for degenerate cases.
@rem
@rem Updated:
@rem   5-August-2022 for IM v7.
@rem

@if "%4"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave


set PX1=%1
set PX2=%2
set PY1=%3
set PY2=%4

set FLAGS=0

if "%PX1%"=="?" set /A FLAGS=1
if "%PX2%"=="?" set /A FLAGS ^|=2
if "%PY1%"=="?" set /A FLAGS ^|=4
if "%PY2%"=="?" set /A FLAGS ^|=8

if %FLAGS%==3 (
  for /F "usebackq" %%L in (`%IMG7%magick identify
    -precision 15 ^
    -format "PX1=%%[fx:100*(%PY1%)/((%PY1%)-(%PY2%))]\nPX2=%%[fx:100*(%PY1%-100)/((%PY1%)-(%PY2%))]" ^
    xc:`) do set %%L
) else if %FLAGS%==5 (
  for /F "usebackq" %%L in (`%IMG7%magick identify
    -precision 15 ^
    -format "PX1=%%[fx:(10000-(%PY2%)*(%PX2%))/(100-(%PY2%))]\nPY1=%%[fx:(10000-(%PY2%)*(%PX2%))/(100-(%PX2%))]" ^
    xc:`) do set %%L
) else if %FLAGS%==9 (
  for /F "usebackq" %%L in (`%IMG7%magick identify
    -precision 15 ^
    -format "PX1=%%[fx:((%PY1%)*(%PX2%))/((%PY1%)-100)]\nPY2=%%[fx:(100*(100-(%PY1%))+(%PY1%)*(%PX2%))/(%PX2%)]" ^
    xc:`) do set %%L
) else if %FLAGS%==6 (
  for /F "usebackq" %%L in (`%IMG7%magick identify
    -precision 15 ^
    -format "PX2=%%[fx:(100*(100-(%PX1%))+(%PX1%)*(%PY2%))/(%PY2%)]\nPY1=%%[fx:((%PX1%)*(%PY2%))/((%PX1%)-100)]" ^
    xc:`) do set %%L
) else if %FLAGS%==10 (
  for /F "usebackq" %%L in (`%IMG7%magick identify
    -precision 15 ^
    -format "PX2=%%[fx:(%PX1%)*((%PY1%)-100)/(%PY1%)]\nPY2=%%[fx:(%PY1%)*((%PX1%)-100)/(%PX1%)]" ^
    xc:`) do set %%L
) else if %FLAGS%==12 (
  for /F "usebackq" %%L in (`%IMG7%magick identify
    -precision 15 ^
    -format "PY1=%%[fx:100*(%PX1%)/((%PX1%)-(%PX2%))]\nPY2=%%[fx:100*((%PX1%)-100)/((%PX1%)-(%PX2%))]" ^
    xc:`) do set %%L
) else (
  echo Need two numbers and two "?" question marks.
  exit /B 1
)


echo %PX1% %PX2% %PY1% %PY2%

call echoRestore

@endlocal
