rem Make masks where red has the greatest local mean
rem and where green has the greatest mean.
rem Use these masks to select one of R,G or B channels
rem to replace L of Lab.
rem %1 input image
rem %2 output sRGB image
rem %3 window size, eg 15x15
rem %4 blend percentage of lightness channel [100]
rem %5 adjust overall lightness:
rem   0 no adjustment
rem   1 crude log/log
rem   2 accurate but slow
@rem
@rem Also uses:
@rem   lccDBG_PREF if set, writes debugging files/
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 lcc

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set WIN=%3
if "%WIN%"=="." set WIN=
if "%WIN%"=="" set WIN=15x15

set BLR=-blur 0x2
set BLR=

set PROCMASK=-threshold 0
set PROCMASK=-auto-level

set BLEND_PC=%4
if "%BLEND_PC%"=="." set BLEND_PC=
if "%BLEND_PC%"=="" set BLEND_PC=100

if "%lccDBG_PREF%"=="" (
  set WRREDMSK=
  set WRGRNMSK=
  set WRBLUMSK=
  set WRL0=
  set WRL1=
  set WRL2=
) else (
  set WRREDMSK=+write %lccDBG_PREF%redmsk.png
  set WRGRNMSK=+write %lccDBG_PREF%grnmsk.png
  set WRBLUMSK=+write %lccDBG_PREF%blumsk.png
  set WRL0=+write %lccDBG_PREF%l0.png
  set WRL1=+write %lccDBG_PREF%l1.png
  set WRL2=+write %lccDBG_PREF%l2.png
)

%IM7DEV%magick ^
  %INFILE% +write mpr:INIMG ^
  -process integim ^
  -process 'deintegim window %WIN%' ^
  -channel RGB -separate +channel +write mpr:CHANS ^
  -delete 0 ^
  -compose Lighten -composite ^
  mpr:CHANS[0] ^
  -compose MinusDst -composite ^
  %PROCMASK% ^
  %BLR% ^
  %WRREDMSK% ^
  -write mpr:REDMASK +delete ^
  mpr:CHANS[0] mpr:CHANS[2] ^
  -compose Lighten -composite ^
  mpr:CHANS[1] ^
  -compose MinusDst -composite ^
  %PROCMASK% ^
  %BLR% ^
  %WRGRNMSK% ^
  -write mpr:GRNMASK +delete ^
  mpr:CHANS[0] mpr:CHANS[1] ^
  -compose Lighten -composite ^
  mpr:CHANS[2] ^
  -compose MinusDst -composite ^
  %PROCMASK% ^
  %BLR% ^
  %WRBLUMSK% ^
  -write mpr:BLUMASK +delete ^
  mpr:INIMG ^
  ( +clone ^
    -colorspace Lab ^
    -channel R -separate +channel ^
    %WRL0% ^
    -write mpr:LABL ^
    +delete ^
  ) ^
  -channel RGB -separate +channel +write mpr:CHANS ^
  -delete 0--1 ^
  mpr:LABL ^
  mpr:CHANS[2] ^
  mpr:BLUMASK ^
  -compose Over -composite ^
  mpr:CHANS[1] ^
  mpr:GRNMASK ^
  -compose Over -composite ^
  mpr:CHANS[0] ^
  mpr:REDMASK ^
  -compose Over -composite ^
  mpr:LABL ^
  +swap ^
  -define compose:args=%BLEND_PC% -compose blend -composite ^
  +write mpr:ADJL ^
  +delete ^
  mpr:INIMG ^
  -colorspace Lab ^
  -channel RGB -separate +channel ^
  mpr:ADJL ^
  -set option:POW %%[fx:log(u[0].mean)/log(u[3].mean)] ^
  ( +clone ^
    %WRL1% ^
    -evaluate Pow %%[POW] ^
    %WRL2% ^
  ) ^
  +swap +delete ^
  -insert 0 ^
  -delete 1 ^
  -combine ^
  -set colorspace Lab ^
  -colorspace sRGB ^
  %OUTFILE%

call echoRestore

@endlocal & set lccOUTFILE=%OUTFILE%
