rem %1 input image
rem %2 output sRGB image
rem replacing L of Lab with channel that has greatest SD.
rem %3 blend percentage of lightness channel [100]


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

rem @call echoOffSave

call %PICTBAT%setInOut %1 lsc

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set BLEND_PC=%3
if "%BLEND_PC%"=="." set BLEND_PC=
if "%BLEND_PC%"=="" set BLEND_PC=100

set SDR=standard_deviation.r
set SDG=standard_deviation.g
set SDB=standard_deviation.b

set FMT=^
VR=%%[fx:%SDR%]\n^
VG=%%[fx:%SDG%]\n^
VB=%%[fx:%SDB%]\n^
MAXSD=%%[fx:max(max(%SDR%,%SDG%),%SDB%)]\n

for /F "usebackq" %%L in (`%IM7DEV%magick ^
  %INFILE% +write mpr:INIMG ^
  -format "%FMT%" ^
  info:`) do set %%L

set CH=
if %VR%==%MAXSD% set CH=0
if %VG%==%MAXSD% set CH=1
if %VB%==%MAXSD% set CH=2

if "%CH%"=="" exit /B 1

echo CH=%CH%

%IM7DEV%magick ^
  %INFILE% ^
  ( +clone ^
    -channel %CH% -separate ^
    -write mpr:CHAN ^
    +delete ^
  ) ^
  -colorspace Lab ^
  -channel RGB -separate ^
  ( -clone 0 ^
    mpr:CHAN ^
    -define compose:args=%BLEND_PC% -compose blend -composite ^
  ) ^
  -swap 0,3 ^
  +delete ^
  -combine ^
  -set colorspace Lab ^
  -colorspace sRGB ^
  %OUTFILE%  

call echoRestore

@endlocal & set lscOUTFILE=%OUTFILE%
