rem Linear regression of 2 images.
rem %1 image: independent variable
rem %2 image: dependent variable
rem %3 prefix for output environment variables. Returns %3_gain_R, %3_bias_R etc.
@rem
@rem Images must be same size. (Script doesn't check this.)
@rem

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@call echoOffSave

for /F "usebackq" %%L in (`%IMG7%magick ^
  %1 ^
  %2 ^
  -precision 15 ^
  -define "compose:clamp=off" ^
  ^( -clone 0 ^
    -scale "1x1^!" ^
    -write mpr:MnX ^
    -evaluate Pow 2 ^
    -write mpr:MnXMnX ^
    +delete ^
  ^) ^
  ^( -clone 0 ^
    -evaluate Pow 2 ^
    -scale "1x1^!" ^
    -write mpr:MnXX ^
    +delete ^
  ^) ^
  ^( -clone 1 ^
    -scale "1x1^!" ^
    -write mpr:MnY ^
    +delete ^
  ^) ^
  ^( -clone 0-1 ^
    -compose Multiply -composite ^
    -scale "1x1^!" ^
    -write mpr:MnXY ^
    +delete ^
  ^) ^
  -delete 0-1 ^
  ^( mpr:MnX mpr:MnY ^
    -compose Multiply -composite ^
    mpr:MnXY ^
    -compose Mathematics -define "compose:args=0,1,-1,0" -composite ^
    -write mpr:NUMER ^
    +delete ^
  ^) ^
  ^( mpr:MnXX mpr:MnXMnX ^
    -compose Mathematics -define "compose:args=0,-1,1,0" -composite ^
    mpr:NUMER ^
    -compose DivideDst -composite ^
    -write mpr:SLOPE ^
    -format "%3_gain_R=%%[fx:mean.r]\n%3_gain_G=%%[fx:mean.g]\n%3_gain_B=%%[fx:mean.b]\n" ^
    -write info: ^
    +delete ^
  ^) ^
  ^( mpr:SLOPE mpr:MnX ^
    -compose Multiply -composite ^
    mpr:MnY ^
    -compose Mathematics -define "compose:args=0,1,-1,0" -composite ^
    -write mpr:INTR ^
    -format "%3_bias_R=%%[fx:mean.r]\n%3_bias_G=%%[fx:mean.g]\n%3_bias_B=%%[fx:mean.b]\n" ^
    -write info: ^
    +delete ^
  ^) ^
  NULL:`) do set %%L
  
call echoRestore

