rem Given %1 is prefix for an environment variable with intercept and slope,
rem %2 is width and height in form WxH
rem %3 is X-offset
rem %4 is Y-offset
rem sets .A.x, .A.y, .B.x, .B.y
@rem
@rem Updated:
@rem   22-July-2022 Upgraded for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave


set PREF=%1

call parseXxY2 !%PREF%.nPoints! 10 WH %2

set offsX=%3
if "%offsX%"=="." set offsX=
if "%offsX%"=="" set offsX=0

set offsY=%4
if "%offsY%"=="." set offsY=
if "%offsY%"=="" set offsY=0

set %PREF%
set WH

set /A A.x=%offsX%
set /A B.x=%offsX%+%WH_X%-1

set FORMAT4=^
A.y=%%[fx:%offsY%+%WH_Y%*(1-(!%PREF%.intercept!))]\n^
B.y=%%[fx:%offsY%+%WH_Y%*(1-(!%PREF%.intercept!)-(!%PREF%.slope!))]

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "%FORMAT4%" ^
  xc:`) do set %%L

rem call echoRestore

endlocal & set %PREF%.A.x=%A.x%& set %PREF%.A.y=%A.y%& set %PREF%.B.x=%B.x%& set %PREF%.B.y=%B.y%
