rem Given %1 is text file with lines (eg from pointsDist.bat)
rem writes squares to text file %2 [default l2c.lis]
rem of radius %3 [10]
rem centred on mid-points of coordinate-pairs from %1.

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave


set INFILE=%1

if not exist %INFILE% exit /B 1


set OUTFILE=%2
if "%OUTFILE%"=="." set OUTFILE=
if "%OUTFILE%"=="" set OUTFILE=l2c.lis

set RAD=%3
if "%RAD%"=="." set RAD=
if "%RAD%"=="" set RAD=10

(for /F "tokens=2-5 delims=, " %%A in (%INFILE%) do (
  set /A X0=^(%%A+%%C^)/2-%RAD%
  set /A Y0=^(%%B+%%D^)/2-%RAD%
  set /A X1=^(%%A+%%C^)/2+%RAD%
  set /A Y1=^(%%B+%%D^)/2+%RAD%
  echo rectangle !X0!,!Y0! !X1!,!Y1!
)) >%OUTFILE%


call echoRestore

endlocal
