rem From image %1
rem and lith screen template %2,
rem make output %3.
rem %4 is screen rotation angle, degrees clockwise [default 0, no rotation].
rem %5 is wave amplitude [default 0, no wave]
rem %6 is wave wavelength
rem %7 is resampling factor [default 1, no resampling]
@rem
@rem Also uses:
@rem   lsRESTRICT if set, issues this (see restrictScreen.bat)
@rem
@rem Last updated:
@rem   8-June-2017 implemented wave, resampling and lsRESTRICT.
@rem   6-August-2022 for IM v7
@rem



@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 ls

set LITH_TMPLT=%2

if not "%3"=="" if not "%3"=="." set OUTFILE=%3

set ANGLE=%4
if "%ANGLE%"=="." set ANGLE=
if "%ANGLE%"=="" set ANGLE=0

set WAVEAMP=%5
if "%WAVEAMP%"=="." set WAVEAMP=
if "%WAVEAMP%"=="" set WAVEAMP=0

set WAVELEN=%6
if "%WAVELEN%"=="." set WAVELEN=
if "%WAVELEN%"=="" set WAVELEN=100

set RESAMP=%7
if "%RESAMP%"=="." set RESAMP=
if "%RESAMP%"=="" set RESAMP=1

if %RESAMP%==1 (
  set SAMP_UP=
  set SAMP_DN=
) else (
  for /F "usebackq tokens=*" %%L in (`%IMG7%magick identify ^
    -format "SAMP_UP=-resize %%[fx:100*%RESAMP%]%%%% \nSAMP_DN=-resize %%[fx:100/%RESAMP%]%%%% \n" ^
    xc:`) do set %%L

  for /F "usebackq tokens=*" %%L in (`%IMG7%magick identify ^
    -format "WAVEAMP=%%[fx:!WAVEAMP!*%RESAMP%]\nWAVELEN=%%[fx:!WAVELEN!*%RESAMP%]%%%% \n" ^
    xc:`) do set %%L
)

if %WAVELEN%==0 (
  set sWAVE=
) else (
  set sWAVE=+distort SRT "1,%%[fx:-(%ANGLE%)]" -wave %WAVEAMP%x%WAVELEN% +distort SRT "1,%ANGLE%"
)

%IMG7%magick ^
  %INFILE% ^
  %SAMP_UP% ^
  -set option:distort:viewport "%%[fx:w+h+2*%WAVEAMP%]x%%[fx:w+h+2*%WAVEAMP%]+0+0" ^
  ( %LITH_TMPLT% ^
    %SAMP_UP% ^
    -virtual-pixel tile -distort SRT "1,%ANGLE%" ^
    %sWAVE% ^
    -auto-level ^
    %lsRESTRICT% ^
  ) ^
  -gravity Center ^
  -compose MinusSrc -composite ^
  -fill gray(100%%) +opaque gray(0) ^
  %SAMP_DN% ^
  %OUTFILE%

if ERRORLEVEL 1 exit /B 1

call echoRestore

@endlocal & set lsOUTFILE=%OUTFILE%
