rem Given image %1, white points on black background, entirely opaque,
rem where groups of 4- or 8-connected points form zero or more non-crossing lines,
rem writes text file %2 of the points.
rem starting from coord %3,%4 [0,0]
@rem
@rem This will ignore loops.
@rem If we have two lines each with only one end, it won't work properly.
@rem This won't process line-crossings (ie junctions) as I want.
@rem
@rem Updated:
@rem   14-September-2022 for IM v7.
@rem

@rem FIXME: option to supress header.
@rem FIXME: add black border?


@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 l2p

set OUTFILE=%2


set TMPDIR=\temp\
if not exist %TMPDIR% md %TMPDIR%

set TMPEXT=.miff

set TMPIN=%TMPDIR%l2p_tmp_in%TMPEXT%
set ENDS=%TMPDIR%l2p_ends%TMPEXT%
set ONELNPTS=%TMPDIR%l2p_oneln.lis

set CONV=%IMDEV%convert


set numEnds=

for /F "usebackq" %%L in (`%IMG7%magick ^
  %INFILE% ^
  -alpha off ^
  ^( +clone ^
     -channel RGB ^
       -negate ^
       -evaluate Add 1 ^
     +channel ^
     -write %TMPIN% ^
     +delete ^
  ^) ^
  -bordercolor Black -border 1 ^
  -morphology HMT LineEnds ^
  -shave 1x1 ^
  -format "numEnds=%%[fx:int(mean*w*h+0.5)]\nnumLines=%%[fx:int(mean*w*h/2+0.5)]" ^
  +write info: ^
  %ENDS%`) do set %%L

if "%numEnds%"=="" exit /B 1

echo numLines=%numLines% >%OUTFILE%

if %numLines%==0 (
  echo %0: numLines is zero. INFILE=%INFILE%
  goto end
)

set lastX=%3
set lastY=%4

if "%lastX%"=="." set lastX=
if "%lastX%"=="" set lastX=0

if "%lastY%"=="." set lastY=
if "%lastY%"=="" set lastY=0

set actEnds=0

:: FIXME: BUG: This loop can be endless, when darkestpntpnt has start and end above threshold.

:loop

set INTRO=

for /F "usebackq tokens=1-3 delims=:, " %%A in (`%IM7DEV%magick ^
  %ENDS% ^
  -process 'nearestwhite cx %lastX% cy %lastY%' ^
  NULL: 2^>^&1`) do (
  set INTRO=%%A
  set firstX=%%B
  set firstY=%%C
)

if not "%INTRO%"=="nearestwhite" exit /B 1
if "%firstX%"=="none" goto noMore

:: FIXME: BUG in darkestpntpnt for v7??

%IM7DEV%magick ^
  %TMPIN% ^
  -process 'darkestpntpnt s %firstX%,%firstY% e %firstX%,%firstY% t 0.5 no_end print file stdout data' ^
  NULL: >%ONELNPTS%

set numPts=0
for /F %%L in (%ONELNPTS%) do set /A numPts+=1

echo line >>%OUTFILE%
echo numPts=%numPts% >>%OUTFILE%
for /F "tokens=1,2 delims=, " %%X in (%ONELNPTS%) do (
  set lastX=%%X
  set lastY=%%Y
  echo %%X,%%Y >>%OUTFILE%
)

echo %0: firstX=%firstX% firstY=%firstY% lastX=%lastX% lastY=%lastY%

rem 15-September-2022 also do this in TMPIN to avoid repeating same lastXY ??
%IMG7%magick ^
  %ENDS% ^
  -fill Black ^
  -draw "point %firstX%,%firstY% point %lastX%,%lastY%" ^
  %ENDS%

set /A actEnds+=2

goto loop

:noMore

if not %numEnds%==%actEnds% (
  echo %0: numEnds is %numEnds% but actEnds is %actEnds%
  rem 15-September-2022 warning, not error.
)

:end

call echoRestore

@endlocal & set l2pOUTFILE=%OUTFILE%&set l2pNumPts=%numPts%& set l2pLastX=%lastX%& set l2pLastY=%lastY%
