rem From image %1 blurred,
rem from the lowest and highest intensities.
rem Put those coordinates into LO_XY, HI_XY.
rem Put those colours into LO_COL, HI_COL.
@rem
@rem Updated:
@rem   12-August-2022 for IM v7.
@rem


set lhcSRC=%1

set TMP_IMG=\temp\lhc.miff

set LO_XY=
set HI_XY=

for /F "usebackq" %%X in (`%IM7DEV%magick ^
  %lhcSRC% ^
  -blur 0x3 ^
  -process midlightest ^
  -negate ^
  -process midlightest ^
  %TMP_IMG% 2^>^&1`) do (
  if "!LO_XY!"=="" set LO_XY=%%X
  set HI_XY=%%X
)

echo %LO_XY% %HI_XY%

set sFMT=^
LO_COL=srgb(%%[fx:100*p{%LO_XY%}.r]\%%,%%[fx:100*p{%LO_XY%}.g]\%%,%%[fx:100*p{%LO_XY%}.b]\%%)\n^
HI_COL=srgb(%%[fx:100*p{%HI_XY%}.r]\%%,%%[fx:100*p{%HI_XY%}.g]\%%,%%[fx:100*p{%HI_XY%}.b]\%%)\n


for /F "usebackq" %%L in (`%IMG7%magick ^
  %TMP_IMG% ^
  -precision 9 ^
  -format "%sFMT%" ^
  info:`) do set %%L

set sFMT=^
ROW=%%[fx:1/(3*p{%HI_XY%}.r)],%%[fx:1/(3*p{%HI_XY%}.g)],%%[fx:1/(3*p{%HI_XY%}.b)])\n

for /F "usebackq" %%L in (`%IMG7%magick ^
  %TMP_IMG% ^
  -precision 9 ^
  -format "%sFMT%" ^
  info:`) do set %%L

