rem From image %1,
rem creates output %2 that is log-polar version.
rem %3 is 0 or -1.
rem %4 is required height of output. Can be percentage or proportion of input height.
@rem
@rem Updated:
@rem   24-August-2022 for IM v7.
@rem

if "%2%"=="" exit /B 1

setlocal

set INFILE=%1
set OUTFILE=%2

set lpTYPE=%3
if "%lpTYPE%"=="." set lpTYPE=
if "%lpTYPE%"=="" set lpTYPE=-1

set WW=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "WW=%%w\nHH=%%h" ^
  %INFILE%`) do set %%L
if "%WW%"=="" exit /B 1

set REQ_H=%4
if "%REQ_H%"=="" set REQ_H=.

call parseNum %REQ_H% %HH% OUT_HH

set sRESIZE=
if %OUT_HH% NEQ %HH% set sRESIZE=-resize "%WW%x%OUT_HH%^^^!"

goto skip

set INV_IDENT=^
0,0,#0f8,^
%%[fx:w-1],0,#ff8,^
0,%%[fx:h-1],#008,^
%%[fx:w-1],%%[fx:h-1],#f08

%IMG7%magick ^
  %INFILE% ^
  -background Blue -virtual-pixel background ^
  -distort depolar %lpTYPE% ^
  %sRESIZE% ^
  ( +clone ^
    -sparse-color bilinear "%INV_IDENT%" ^
    -channel G ^
    -fx "ln(h*u.g+0.1)" ^
    -auto-level ^
    -negate ^
    +channel ^
  ) ^
  -compose distort -set option:compose:args 100%%x100%% -composite ^
  +depth ^
  %OUTFILE%

:skip
%IMG7%magick ^
  %INFILE% ^
  -distort depolar %lpTYPE% ^
  %sRESIZE% ^
  ( ( -size %OUT_HH%x%WW% gradient:black-white -rotate -90 ) ^
    ( -size 1x%OUT_HH% gradient:white-black ^
      -fx "ln(h*u.g+1)" ^
      -auto-level ^
      -negate ^
      -scale "%WW%x%OUT_HH%^!" ) ^
    ( -size %WW%x%OUT_HH% xc:#888 ) ^
    -combine ^
+write y0.png ^
  ) ^
  -compose distort -set option:compose:args 100%%x100%% -composite ^
  +depth ^
  %OUTFILE%

endlocal
