rem Difference from light blur, resulting in monochrome RMS.
rem
rem %2 is blur sigma in pixels.
@rem
@rem See also hvyBlrDiff and lbdMask.
@rem
@rem Updated:
@rem   2-August-2022 for IM v7 magick.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 lbd

set BLUR_SIG=%2
if "%BLUR_SIG%"=="" set BLUR_SIG=4

%IMG7%magick ^
  %INFILE% ^
  ^( +clone -blur 0x%BLUR_SIG% ^) ^
  -compose Difference -composite ^
  -grayscale RMS ^
  -auto-level ^
  -auto-gamma ^
  %OUTFILE%

call echoRestore

@endlocal
