rem From %1 input image, make 6 preset luminosity masks.
rem %2 is template name for masks, must contain "XX".
@rem
@rem Reference:
@rem   https://www.gimp.org/tutorials/Luminosity_Masks/
@rem
@rem This is the same as luminosityMasks.bat, but more direct.
@rem
@rem
@rem Updated:
@rem   13-August-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 lm


set TEMPLATE=%2
if "%TEMPLATE%"=="." set TEMPLATE=
if "%TEMPLATE%"=="" set TEMPLATE=lm_XX.tiff

set L1=%TEMPLATE:XX=L1%
set L2=%TEMPLATE:XX=L2%
set L3=%TEMPLATE:XX=L3%
set M1=%TEMPLATE:XX=M1%
set M2=%TEMPLATE:XX=M2%
set M3=%TEMPLATE:XX=M3%
set D1=%TEMPLATE:XX=D1%
set D2=%TEMPLATE:XX=D2%
set D3=%TEMPLATE:XX=D3%
set COMB=%TEMPLATE:XX=COMB%

echo L1=%L1%

%IMG7%magick ^
  %INFILE% ^
  -colorspace Gray ^
  +write %L1% +write mpr:L1 ^
  -channel RGB -negate +channel ^
  +write %D1% +write mpr:D1 ^
  +delete ^
  ( mpr:L1 -level 50,100%% ^
    +write %L2% +write mpr:L2 ^
    +delete ^
  ) ^
  ( mpr:L1 -level 66.6667,100%% ^
    +write %L3% +write mpr:L3 ^
    +delete ^
  ) ^
  ( mpr:D1 -level 50,100%% ^
    +write %D2% +write mpr:D2 ^
    +delete ^
  ) ^
  ( mpr:D1 -level 66.6667,100%% ^
    +write %D3% +write mpr:D3 ^
    +delete ^
  ) ^
  ( mpr:L1 -solarize 50%% ^
    +write %M1% +write mpr:M1 ^
    -level 0,50%% ^
    +write %M2% +write mpr:M2 ^
    +delete ^
  ) ^
  ( mpr:M1 ^
    -level 0,33.3333%% ^
    +write %M3% +write mpr:M3 ^
    +delete ^
  ) ^
  -bordercolor #330 ^
  ( mpr:L1 mpr:M1 mpr:D1 -resize 200x200^> -border 1 +append ) ^
  ( mpr:L2 mpr:M2 mpr:D2 -resize 200x200^> -border 1 +append ) ^
  ( mpr:L3 mpr:M3 mpr:D3 -resize 200x200^> -border 1 +append ) ^
  -append +repage ^
  +write %COMB% ^
  NULL:

call echoRestore

@endlocal
