rem Makes a tiled diamond gradient mask.
rem %1 is output filename.
rem %2 and %3 are overall width and height.
rem %4 and %5 are repetitions horizontally and vertically (default 1).
@rem
@rem Updated:
@rem   5-August-2022 for IM v7.
@rem

set outName=%1
if "%outName%"=="" set outName=diamondMask.png

set numWi=%4
if "%numWi%"=="" set numWi=1

set numHt=%5
if "%numHt%"=="" set numHt=1

set /A oneWi=%2/%numWi%
set /A oneHt=%3/%numHt%

echo %oneWi% %oneHt%

set /A outWi=%numWi%*%oneWi%
set /A outHt=%numHt%*%oneHt%

echo %outWi% %outHt%

set /A semiHt=%oneHt%/2
set /A oneHt=%semiHt%*2
set /A semiWi=%oneWi%/2
set /A outHt=%numHt%*%oneHt%

echo %outWi% %outHt%

set /A oneWim1=%oneWi%-1
set /A oneHtm1=%oneHt%-1

%IMG7%magick ^
  -size %oneWi%x%oneHt% ^
  xc:White ^
  -fill Black ^
  -draw ^"polygon %semiWi%,0 %oneWim1%,%semiHt% %semiWi%,%oneHtm1% 0,%semiHt%^" ^
  +repage ^
  %TEMP%\dmMask.png


rem We could use -crop 1x2@ instead of two clones and crops, but we want exact control of the size.

%IMG7%magick ^
  -size %oneWi%x%oneHt% ^
  gradient: ^
  -write %TEMP%\dm0.png ^
  ( -clone 0 -crop %oneWi%x%semiHt%+0+%semiHt% ) ^
  ( -clone 0 -crop %oneWi%x%semiHt%+0+0 ) ^
  -delete 0 ^
  -append ^
  +repage ^
  %TEMP%\dm1.png

%IMG7%magick ^
  %TEMP%\dm0.png ^
  ( %TEMP%\dm1.png -alpha set %TEMP%\dmMask.png -alpha off -compose Copy-Opacity -composite ) ^
  -compose Over -composite ^
  %TEMP%\dmOne.png

rem This starts tiling top-left, so any partial tiles will be at right and bottom.
rem We could use -tile-offset, or generate over-size then trim.

%IMG7%magick ^
  -size %2x%3 ^
  tile:%TEMP%\dmOne.png ^
  %outName%
