rem Makes elliptical mask, with gradation.
rem %1 output file
rem %2 WWxHH image width and height, pixels, eg 1920x1080
rem %3 quoted CX,CY ellipse centre
rem %4 ERXxERY ellipse radius width and height, pixels, eg 150x100
rem %5 angle of rotation of ellipse, degrees [0]
rem %6 RF, thickness of gradation, 0.0 < RF <= 1.0 [0.5]

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

rem @call echoOffSave

set OUTFILE=%1

set IMGSIZE=%2
if "%IMGSIZE%"=="." set IMGSIZE=
if "%IMGSIZE%"=="" set IMGSIZE=600x400
call parseXxY2 600 400 mem_ %IMGSIZE%

set ELL_CENT=%3
if [%ELL_CENT%]==[.] set ELL_CENT=
if [%ELL_CENT%]==[] (
  set /A CX=%mem__X%/2
  set /A CY=%mem__Y%/2
  set ELL_CENT="!CX!,!CY!"
)
call parseCommaList %ELL_CENT% mem_argc mem_argv
if ERRORLEVEL 1 exit /B 1
call propOf %mem__X% %mem_argv[0]% mem_argv[0]
if ERRORLEVEL 1 exit /B 1
call propOf %mem__Y% %mem_argv[1]% mem_argv[1]
if ERRORLEVEL 1 exit /B 1

set ELL_RAD=%~4
if "%ELL_RAD%"=="." set ELL_RAD=
if "%ELL_RAD%"=="" (
  set /A RX=%mem__X%/4
  set /A RY=%mem__Y%/4
  set ELL_RAD=!RX!x!RY!
)
call parseXxY2 %mem__X% %mem__Y% mem_er_ %ELL_RAD%

set ANG=%5
if "%ANG%"=="." set ANG=
if "%ANG%"=="0.0" set ANG=0
if "%ANG%"=="" set ANG=0

if "%ANG%"=="" (
  set ROT=
) else (
  set ROT=-distort SRT 1,%ANG%
  set ROT=-define gradient:angle=%ANG%
)

set RF=%6
if "%RF%"=="." set RF=
if "%RF%"=="" set RF=0.5

set mem_

%IMG7%magick ^
  -size %mem__X%x%mem__Y% ^
  -define gradient:center=%mem_argv[0]%,%mem_argv[1]% ^
  -define gradient:radii=%mem_er__X%,%mem_er__Y% ^
  %ROT% ^
  radial-gradient: ^
  -level 0,%%[fx:QuantumRange*%RF%] ^
  %OUTFILE%

call echoRestore

@endlocal
