rem Make a mask white at point, black at edges.
rem %1 output file
rem %2 WWxHH image width and height, pixels, eg 1920x1080
rem %3 quoted CX,CY centre
rem %4 composite method [gm]
rem %5 smoothing: none, start, end, or both [none]
rem %6 L1, percentage start of gradation [0]
rem %7 L2, percentage start of gradation [100]

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 pem

set OUTFILE=%1

set IMGSIZE=%2
if "%IMGSIZE%"=="." set IMGSIZE=
if "%IMGSIZE%"=="" set IMGSIZE=600x400
call parseXxY2 600 400 pem_ %IMGSIZE%

set CENT=%3
if [%CENT%]==[.] set CENT=
if [%CENT%]==[] (
  set CX=0.5
  set CY=0.5
  set CENT="!CX!,!CY!"
)
call parseCommaList %CENT% pem_argc pem_argv
if ERRORLEVEL 1 exit /B 1
call propOfProp %pem__X% %pem_argv[0]% pem_argv[0]
if ERRORLEVEL 1 exit /B 1
call propOfProp %pem__Y% %pem_argv[1]% pem_argv[1]
if ERRORLEVEL 1 exit /B 1

set WW=%pem__X%
set HH=%pem__Y%

set CX=%pem_argv[0]%
set CY=%pem_argv[1]%

set pem_

set P1h=%CX%
set S1h=1/%CX%
set S2h=1/(%CX%-1)

set P1v=%CY%
set S1v=1/%CY%
set S2v=1/(%CY%-1)

set MTHD=%4
if "%MTHD%"=="." set MTHD=
if "%MTHD%"=="" set MTHD=gm

set SMTH=%5
if "%SMTH%"=="." set SMTH=
if "%SMTH%"=="" set SMTH=none

set L1=%6
if "%L1%"=="." set L1=
if "%L1%"=="" set L1=0

set L2=%7
if "%L2%"=="." set L2=
if "%L2%"=="" set L2=100

set sLEV=
if %L1% NEQ 0 if %L2% NEQ 100 (
  set sLEV=-level %L1%%%,%L2%%%
)

if /I "%MTHD%"=="Darken" (
  set COMPOS=-compose Darken -composite
) else if /I "%MTHD%"=="Lighten" (
  set COMPOS=-compose Lighten -composite
) else if /I "%MTHD%"=="Mean" (
  set COMPOS=-evaluate-sequence Mean
) else if /I "%MTHD%"=="Multiply" (
  set COMPOS=-compose Multiply -composite
) else if /I "%MTHD%"=="gm" (
  set COMPOS=-compose Multiply -composite -evaluate Pow 0.5
) else (
  echo %0: Bad MTHD [%MTHD%]
  exit /B 1
)

if /I "%SMTH%"=="none" (
  set sSMTH=
) else if /I "%SMTH%"=="start" (
  set sSMTH=-function sinusoid 0.25,-90,1,1
) else if /I "%SMTH%"=="end" (
  set sSMTH=-function sinusoid 0.25,0,1,0
) else if /I "%SMTH%"=="both" (
  set sSMTH=-function sinusoid 0.5,-90,0.5,0.5
) else (
  echo %0: Bad SMTH [%SMTH%]
  exit /B 1
)

%IMG7%magick ^
  ( -size 1x%WW% gradient: -rotate 90 ^
    -fx "u<%P1h%?u*%S1h%:1+(u-%P1h%)*%S2h%" ^
    %sSMTH% ^
    -scale "%WW%x%HH%^!" ^
  ) ^
  ( -size 1x%HH% gradient: -flip ^
    -fx "u<%P1v%?u*%S1v%:1+(u-%P1v%)*%S2v%" ^
    %sSMTH% ^
    -scale "%WW%x%HH%^!" ^
  ) ^
  %COMPOS% ^
  %sLEV% ^
  %OUTFILE%

call echoRestore

@endlocal
