rem From image %1 and mask %2, make video that reveals the image.
rem %3 is initial colour
rem %4 is number of frames in revelation
rem %5 is number of frames to pause
rem %6 is identifying string
rem
rem This creates: pause, revelation, pause, derevelation, pause.
@rem
@rem Updated:
@rem   14-August-2020 for IM v7.
@rem

@if "%5"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

rem @call echoOffSave

set INFILE=%1
set EXT=%~x1
set MASK=%2

set nREVEL=%4
if "%nREVEL%"=="" set nREVEL=100

set nPAUSE=%5
if "%nPAUSE%"=="" set nPAUSE=10

set ID_STR=%6
if "%ID_STR%"=="" set ID_STR=mpv

set ID_STR2=%ID_STR%_v2

set VIDEO=%ID_STR%.mpg

set TMPDIR=%TEMP%\pnt
if not exist %TMPDIR% md %TMPDIR%

set /A nREVELm1=%nREVEL%-1

del %TMPDIR%\%ID_STR%_*%EXT%

call %PICTBAT%pntMaskReveal ^
  %INFILE% ^
  %MASK% ^
  %TMPDIR%\%ID_STR% %3 %nREVEL%

del %TMPDIR%\%ID_STR2%*.png 2>nul

call %PICTBAT%mFrLink ^
  %TMPDIR%\%ID_STR% ^
  %TMPDIR%\%ID_STR2% %EXT% ^
  0 0 0 %nPAUSE%

set /A NEXT=%nPAUSE%

call %PICTBAT%mFrLink ^
  %TMPDIR%\%ID_STR% ^
  %TMPDIR%\%ID_STR2% %EXT% ^
  0 %nREVELm1% %NEXT%

set /A NEXT+=%nREVEL%

call %PICTBAT%mFrLink ^
  %TMPDIR%\%ID_STR% ^
  %TMPDIR%\%ID_STR2% %EXT% ^
  %nREVELm1% %nREVELm1% %NEXT% %nPAUSE%

set /A NEXT+=%nPAUSE%

call %PICTBAT%mFrLink ^
  %TMPDIR%\%ID_STR% ^
  %TMPDIR%\%ID_STR2% %EXT% ^
  %nREVELm1% 0 %NEXT%

set /A NEXT+=%nREVEL%

call %PICTBAT%mFrLink ^
  %TMPDIR%\%ID_STR% ^
  %TMPDIR%\%ID_STR2% %EXT% ^
  0 0 %NEXT% %nPAUSE%

set /A NEXT+=%nPAUSE%


del /q %VIDEO%
%IMG7%ffmpeg -an -r 25 -i %TMPDIR%\%ID_STR2%_%%06d%EXT% -q 4 -r 25 %VIDEO%


call echoRestore

endlocal
