rem Make Random Line.
rem Each point is previous + offset + R, where R is random, 0 <= R < fact.
rem Generated points will not reach x=0 or y=0.
rem Does not generate repeated points.
rem
rem %1 XxY initial coordinates. [Default 0,0]
rem %2 WidthxHeight. Stops when either is reached. [600x400]
rem %3 OffsetXxOffsetY [-1x-1]
rem %4 FactXxFactY [3x3]
rem %5 stop after generating N points. [10]
rem %6 output environment variable. [sRANDLINE]
@rem
@rem Also uses:
@rem   mrlSEED if non-blank, use this as seed.
@rem
@rem
@rem Updated:
@rem   8-August-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

rem call %PICTBAT%setInOut %1 mrl


call parseXxY2 0 0 Init %1
call parseXxY2 600 400 WWHH %2
call parseXxY2 -1 -1 Offset %3
call parseXxY2 3 3 Fact %4

set maxPnts=%5
if "%maxPnts%"=="." set maxPnts=
if "%maxPnts%"=="" set maxPnts=10

set ENVVAR=%6
if "%ENVVAR%"=="." set ENVVAR=
if "%ENVVAR%"=="" set ENVVAR=sRANDLINE

if "%mrlSEED%"=="" (
  set sSEED=
) else (
  set sSEED=-seed %mrlSEED%
)

set sPOINTS=%Init_X%,%Init_Y%

set X=%Init_X%
set Y=%Init_Y%
set nPnts=0
set END_IT=0

:: Setting a %sSEED% gives same result in all calls to rand().


:loop

if "%mrlSEED%"=="" (

  for /F "usebackq tokens=*" %%L in (`%IMG7%magick identify ^
    -format "newX=%%[fx:int(%Offset_X%+%X%+rand()*%Fact_X%)]\nnewY=%%[fx:int(%Offset_Y%+%Y%+rand()*%Fact_Y%)]" ^
    xc:`) do set %%L

) else (

  for /F "usebackq tokens=*" %%L in (`%IMG7%magick identify ^
    %sSEED% ^
    -precision 19 ^
    -format "newX=%%[fx:int(%Offset_X%+%X%+rand()*%Fact_X%)]\nsSEED=-seed %%[fx:rand()*1e+9]" ^
    xc:`) do set %%L

  for /F "usebackq tokens=*" %%L in (`%IMG7%magick identify ^
    !sSEED! ^
    -precision 19 ^
    -format "newY=%%[fx:int(%Offset_Y%+%Y%+rand()*%Fact_Y%)]\nsSEED=-seed %%[fx:rand()*1e+9]" ^
    xc:`) do set %%L
)

set OUT_IT=1
if %newX%==%X% if %newY%==%Y% set OUT_IT=0
if %newX% LEQ 0 set OUT_IT=0
if %newY% LEQ 0 set OUT_IT=0
if %newX% GEQ %WWHH_X% set END_IT=1
if %newY% GEQ %WWHH_Y% set END_IT=1
if %OUT_IT%==1 (
  set X=%newX%
  set Y=%newY%
  set sPOINTS=%sPOINTS% !X!,!Y!
  rem echo !nPnts! !X!,!Y!
  set /A nPnts+=1
)

if %END_IT%==0 if %nPnts% LSS %maxPnts% goto loop


call echoRestore

@endlocal& set %ENVVAR%=%sPOINTS%
