rem %1 output filename
rem %2 output width, pixels [4096]
rem %3 a, an input fraction [0.5]
rem %4 b, an output fraction [0.5]
rem %5 s, slope at both ends
rem %6 E, contrast strength, > 0
@rem       1 for straight line,
@rem      >1 increases contrast at mid point
@rem      <1 decreases contrast at mid point
@rem      Values v and 1/v are symmetrical.
@rem
@rem   Inflection is at (a,b).
@rem
@rem Also uses:
@rem   mscPREPROC IM process applied to input linear grayscale
@rem   mscPOSTPROC IM process applied to output
@rem
@rem Updated:
@rem   24-August-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 msc

if not "%1"=="" if not "%1"=="." set OUTFILE=%1

set WW=%2
if "%WW%"=="." set WW=
if "%WW%"=="" set WW=4096

set a=%3
if "%a%"=="." set a=
if "%a%"=="" set a=0.5

set b=%4
if "%b%"=="." set b=
if "%b%"=="" set b=0.5

set s=%5
if "%s%"=="." set s=
if "%s%"=="" set s=1

set E=%6
if "%E%"=="." set E=
if "%E%"=="" set E=3

set a1=(1-%a%)
set s1=(1-%s%)
set sa=%s%*%a%
set sa1=%s%*%a1%
set LR=log(%b%)/log(%a%)
set LR1=log(1-%b%)/log(1-%a%)

for /F "usebackq" %%L in (`%IMG7%magick identify
  -precision 15 ^
  -format "a1=%%[fx:%a1%]\ns1=%%[fx:%s1%]\nsa=%%[fx:%sa%]\nsa1=%%[fx:%sa1%]" ^
  xc:`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick identify
  -precision 15 ^
  -format "LR=%%[fx:%LR%]\nLR1=%%[fx:%LR1%]" ^
  xc:`) do set %%L

%IMG7%magick -size 1x%WW% gradient: -rotate 90 ^
  %mscPREPROC% ^
  -fx "u<%a%?pow(%s1%*u+%sa%*pow(u/%a%,%E%),%LR%):1-pow(%s1%*(1-u)+%sa1%*pow((1-u)/%a1%,%E%),%LR1%)" ^
  %mscPOSTPROC% ^
  %OUTFILE%

rem call %PICTBAT%graph1d %OUTFILE%

call echoRestore

@endlocal
