rem Given image %1, creates marked-up version %2 with a rectangle.
rem %3 x0
rem %4 y0
rem %5 x1
rem %6 y1
rem %7 w
rem %8 h
rem Caller should supply either x1 and y1, or w and h.
@rem
@rem Also uses:
@rem   mrSTROKE  eg "-strokewidth=10" to get thick strokes
@rem
@rem Updated:
@rem   13-August-2022 for IM v7.
@rem

@if "%5"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 m1r

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set x0=%3
set y0=%4
set x1=%5
set y1=%6
set w=%7
set h=%8

if "%x0%"=="." set x0=
if "%y0%"=="." set y0=
if "%x1%"=="." set x1=
if "%y1%"=="." set y1=
if "%w%"=="." set w=
if "%h%"=="." set h=

if "%x0%"=="" set x0=0
if "%y0%"=="" set y0=0

if not "%w%"=="" set /A x1=%x0%+%w%
if not "%h%"=="" set /A y1=%y0%+%h%

if "%x1%"=="" (
  echo Can't calculate x1.
  exit /B 1
)

if "%y1%"=="" (
  echo Can't calculate y1.
  exit /B 1
)

echo From (%x0%,%y0%) to (%x1%,%y1%)

set sRECT=rectangle %x0%,%y0%,%x1%,%y1%

%IMG7%magick ^
  %INFILE% ^
  -stroke #f00 -strokewidth 1 -fill None ^
  %mrSTROKE% ^
  -draw "%sRECT%" ^
  %OUTFILE%

@call echoRestore

@endlocal & set m1rOUTFILE=%OUTFILE%
