rem Creates a marked-up version of the CIE xy 1931 horseshoe diagram.
rem %1 input raster verson of the diagram,
rem   to which mark-ups will be added.
rem   If %1 is "." or mising, will be created from scratch.
rem %2 output raster image.
rem %3 quoted list of pairs of x,y coordinates, to be joined by lines.
rem ?? pair of x,y coordinates eg for white point.
rem ?? colour for symbols and lines.
rem ?? character for symbols eg x or o.

set INFILE=%1
if "%INFILE%"=="." set INFILE=
if "%INFILE%"=="" set INFILE=CIExy1931.svg

set OUTFILE=%2
if "%OUTFILE%"=="." set OUTFILE=
if "%OUTFILE%"=="" set OUTFILE=mcxy.png

%IMG7%magick ^
  -background None ^
  CIExy1931t.svg ^
  annot.png

%IMG7%magick ^
  -background None ^
  CIExy1931msk.svg ^
  -channel RGB -evaluate set 100%% ^
  -channel A -negate ^
  +channel ^
  msk.png

set Yval=20%%

%IMG7%magick ^
  -define compose:clamp=off ^
  -size 410x461 xc: ^
  -sparse-color bilinear "0,0,rgb(0,90%%,%Yval%),0,460,rgb(0,0,%Yval%),409,460,rgb(80%%,0,%Yval%)" ^
+write x0.png ^
  -set colorspace xyY ^
  -colorspace sRGB ^
-format "min1=%%[minima]\n" +write info: ^
  ( msk.png -fill White -colorize 100 ) ^
  +swap ^
  -geometry +47.8+30 ^
  -compose Over -composite ^
+write x1.png ^
  msk.png ^
  -compose Over -composite ^
  annot.png ^
  -compose Over -composite ^
-format "min2=%%[minima]\n" +write info: ^
  -colorspace XYZ ^
+write z.jpg ^
-format "min3=%%[minima]\n" +write info: ^
  -profile %ICCPROF%\XYZ-D50-Identity-elle-V4.icc ^
-format "min4=%%[minima]\n" +write info: ^
  +write x.miff ^
-format "" +write info: ^
  x.jpg


set ScaleX=409.6/0.8
set ScaleY=460.8/0.9

set OffsX=47.8
set OffsY=30

call %PICTBAT%setInkPath

set x=0.3
set y=0.4

%IMG7%magick ^
  %INFILE% ^
  ( -background None label:O -trim +repage ^
    -repage +%%[fx:%x%*%ScaleX%+%OffsX%-w/2]+%%[fx:(0.9-%y%)*%ScaleY%+%OffsY%-h/2] ^
  ) ^
+write info: ^
  -layers Flatten ^
  %OUTFILE%

