typedef enum {
  swEntire,
  swRandom,
  swSkip
} SearchWhatT;


typedef struct {

  ssize_t
    ref_rows,       // Size of reference image.
    ref_columns,
    matchRadX,      // >= 0
    matchRadY,      // >= 0
    limSrchRadX,
    limSrchRadY,
    limLeft,  // Each limit is for top-left of window (in reference), not the centre of the window.
    limTop,
    limRight,
    limBot,
    nLimitCnt; // countdown before we can use the limit

  double
    LimSrchRad,
    simThreshold,
    simThresholdSq,
    dissimThreshold,
    dissimThresholdSq,
    autoCorrectThreshold,
    autoCorrectThresholdSq,
    RandSearchesF,
    SkipNumF;

  SearchWhatT
    searchWhat;

  MagickBooleanType
    Refine,  // Whether to refine random and skip searches
    SearchToEdges,
    AutoLs,
    SetAutoLimit,
    UseAutoLimit,
    LimSrchRad_IsPc,
    RandSearches_IsPc,
    SkipNum_IsPc,
    DissimOn,
    DoSubTransTest;

  int
    RandSearchesI,
    SkipNumI;

  // Results are written here:
  // bestX and bestY are for centre of window in reference.
  ssize_t
    bestX,
    bestY;

  double
    bestScore;

} MatchT;


typedef struct {
  ssize_t
    j0,
    j1,
    i0,
    i1;
} RangeT;
