rem Makes version of image %1 with L of Lab histogram that matches a Gaussian distribution.
rem Optional %2 is output file.
@rem
@rem Can also use:
@rem   mgGAUSS eg width 65536 sd 20%% zeroize
@rem
@rem Updated:
@rem    15-May-2021 IM v7. Output is %2 instead of %3.
@rem


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 mg

if not "%2"=="" if not "%2"=="." set OUTFILE=%2


set TEMPEXT=miff


if "%mgGAUSS%"=="" set mgGAUSS=width 65536 sd 20%% zeroize

set mgGAUSS=mkgauss %mgGAUSS% cumul norm

%IM7DEV%magick ^
  ( %INFILE% ^
    -colorspace LAB -channel 0 -separate -set colorspace sRGB ^
    -process 'mkhisto cumul norm' ^
    +depth +write mg_w_i1_L_chist.%TEMPEXT% ^
    +delete ^
  ) ^
  ( xc: ^
    -process '%mgGAUSS%' ^
    -delete 0 ^
    -process 'mkhisto cumul norm' ^
    +write mg_gauss.%TEMPEXT% ^
  ) ^
  NULL:

%IMG7%magick ^
  mg_w_i1_L_chist.%TEMPEXT% ^
  mg_gauss.%TEMPEXT% ^
  -clut ^
  mg_w_t_L_ixt.%TEMPEXT%

%IMG7%magick ^
  %INFILE% ^
  -colorspace Lab -channel 0 ^
  mg_w_t_L_ixt.%TEMPEXT% ^
  -clut ^
  +channel -colorspace sRGB ^
  %OUTFILE%


call echoRestore

@endlocal & set mgOUTFILE=%OUTFILE%
