rem Makes version of image %1 with histogram that matches the histogram of image %2.
rem Optional %3 is output file.
@rem
@rem Can also use:
@rem   mhCOL_SP_IN eg -colorspace Lab -channel R
@rem   mhCOL_SP_OUT eg +channel -colorspace sRGB
@rem   mhDEBUG if 1, makes a file of the clut used.
@rem
@rem Updated:
@rem   27-July-2022 for IM v7.
@rem


@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 mh

if not "%3"=="" set OUTFILE=%3

set DBG_NAME=
set WR_CLUT=
set DBG_H1=
set DBG_H2=
set WR_DBG_H1=
set WR_DBG_H2=

if "%mhDEBUG%"=="1" (
  set DBG_NAME=%INNAME%_mhcl.miff
  set WR_CLUT= ^( +clone +write %INNAME%_mhcl.miff +delete ^)
) else if "%mhDEBUG%"=="2" (
  set DBG_NAME=%INNAME%_mhcl.miff
  set WR_CLUT= ^( +clone +write %INNAME%_mhcl.miff +delete ^)
  set DBG_H1=%INNAME%_h1.miff
  set WR_DBG_H1=+write !DBG_H1!
  set DBG_H2=%INNAME%_h2.miff
  set WR_DBG_H2=+write !DBG_H2!
)

%IM7DEV%magick ^
  %INFILE% ^
  %mhCOL_SP_IN% ^
  ( -clone 0 ^
    -process 'mkhisto cumul norm v' ^
    %WR_DBG_H1% ^
  ) ^
  ( %2 ^
    %mhCOL_SP_IN% ^
    -process 'mkhisto cumul norm v' ^
    %WR_DBG_H2% ^
    -process 'mkhisto cumul norm v' ^
  ) ^
  ( -clone 1-2 -clut ) ^
  -delete 1-2 ^
  %WR_CLUT% ^
  -clut ^
  %mhCOL_SP_OUT% ^
  %OUTFILE%

if ERRORLEVEL 1 exit /B1

if not "%DBG_NAME%"=="" (
  echo Also created %DBG_NAME%
  call %PICTBAT%graphLineCol %DBG_NAME%
)

if not "%DBG_H1%"=="" (
  echo Also created %DBG_H1%
  call %PICTBAT%graphLineCol %DBG_H1%
)

if not "%DBG_H2%"=="" (
  echo Also created %DBG_H2%
  call %PICTBAT%graphLineCol %DBG_H2%
)

call echoRestore

@endlocal & set mhOUTFILE=%OUTFILE%

