rem From pyramid %1,
rem creates pyramid where histogram of each grid (not final difference)
rem matches same in reference pyramid %2.
rem Output images will be same sizes as %1 images.
rem %3 is number of octaves.
rem %4 is optional output file.
@rem
@rem Updated:
@rem   5-September-2022 for IM v7.
@rem


@if "%3"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

rem @call echoOffSave

call %PICTBAT%setInOut %1 mhp

set REF_P=%2

if not "%4"=="" set OUTFILE=%4

set /A Nm1=%NUM_OCTAVES%-1

set FILE_LIST=
for /L %%N in (0,1,%Nm1%) do (

  %IM7DEV%magick ^
    %INFILE%[%%N] ^
    -colorspace Lab ^
    ^( -clone 0 ^
       -process 'mkhisto cumul norm' ^
    ^) ^
    ^( %REF_P%[%%N] ^
       -colorspace Lab ^
       -process 'mkhisto cumul norm' ^
       -process 'mkhisto cumul norm' ^
    ^) ^
    ^( -clone 1-2 -clut ^) ^
    -delete 1-2 ^
    -clut ^
    -colorspace sRGB ^
    mhp_%%N.miff

  set FILE_LIST=!FILE_LIST! mhp_%%N.miff
)

%IMG7%magick %FILE_LIST% %REF_P%[%NUM_OCTAVES%] %OUTFILE%

call echoRestore

@endlocal & set mhpOUTFILE=%OUTFILE%
