rem From image %1,
rem writes %2 with maximised local contrast.
rem %3 sigma to find the local mean.
rem %4 sigma to find local maxima.
rem %5 blend percentage
rem %6 Col or Gray [default Col]
rem %7 Post-process, eg -auto-level
@rem
@rem Reference:
@rem   http://im.snibgo.com/maxloccont.htm
@rem
@rem Updated:
@rem   23-December-2017 Replaced oogPower.bat with "-process oogbox".
@rem   28-November-2019 Use v7 magick
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

rem @call echoOffSave

call %PICTBAT%setInOut %1 mlc


set INFILE=%~1

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set SIG1=%3
if "%SIG1%"=="." set SIG1=
if "%SIG1%"=="" set SIG1=2

set SIG2=%4
if "%SIG2%"=="." set SIG2=
if "%SIG2%"=="" set SIG2=%SIG1%

set BLENDPC=%5
if "%BLENDPC%"=="." set BLENDPC=
if "%BLENDPC%"=="" set BLENDPC=100

set COLGR=%6
if "%COLGR%"=="." set COLGR=
if "%COLGR%"=="" set COLGR=Col

set POST_PROC=%7
if "%POST_PROC%"=="." set POST_PROC=

set TMPDIR=\temp\
set GRAY=%TMPDIR%mlc_gray.miff
set BLR=%TMPDIR%mlc_blr.miff
set MINBLR=%TMPDIR%mlc_minblr.miff
set AVG=%TMPDIR%mlc_minblr_avg.miff
set DIV=%TMPDIR%mlc_minblr_div.miff
set MAXC=%TMPDIR%mlc_maxc.miff


set "sHDRI=-depth 32 -define compose:clamp^=off -define quantum:format^=floating-point"

if %BLENDPC%==100 (
  set WR_GRAY=
) else (
  set WR_GRAY=+write %GRAY%
)

%IMG7%magick ^
  %INFILE% ^
  %sHDRI% ^
  -colorspace Lab ^
  -channel 0 -separate +channel ^
  -set colorspace sRGB ^
  %WR_GRAY% ^
  ( +clone ^
    -blur 0x%SIG1% ^
    +write %BLR% ^
  ) ^
  -compose MinusSrc -composite ^
  %MINBLR%

for /F "usebackq" %%L in (`%IMG7%magick ^
  %MINBLR% ^
  %sHDRI% ^
  -precision 19 ^
  -evaluate Abs 0 ^
  -format "maxA=%%[fx:maxima]\n" ^
  +write info: ^
  -blur 0x%SIG2% ^
  +write %AVG% ^
  -format "maxB=%%[fx:maxima]\n" ^
  info:`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 19 ^
  -format "mult=%%[fx:%maxA%/%maxB%]\n"
  xc:`) do set %%L

echo %0: maxA=%maxA% maxB=%maxB% mult=%mult%

%IM7DEV%magick ^
  %MINBLR% ^
  -channel RGB ^
  %sHDRI% ^
  ( %AVG% ^
    -evaluate Multiply %mult% ^
  ) ^
  -compose DivideSrc -composite ^
  -evaluate Divide 2 ^
  -evaluate Add 50%% ^
  -process 'oogbox' ^
  +channel ^
  %DIV%

%IM7DEV%magick ^
  %BLR% ^
  -channel RGB ^
  %sHDRI% ^
  %DIV% ^
  -compose Mathematics ^
    -define compose:args=0,1.0,1.0,-0.5 ^
  -composite ^
  -process 'oogbox' ^
  +channel ^
  %MAXC%

if %BLENDPC%==100 (
  set CHAN_L=%MAXC%
) else (
  set CHAN_L=%GRAY% %MAXC% -compose blend -define compose:args=%BLENDPC% -composite
)

if /I %COLGR%==Col (

  %IMG7%magick ^
    %INFILE% ^
    %sHDRI% ^
    -colorspace Lab ^
    -channel RGB -separate +channel ^
    ^( %CHAN_L% ^) ^
    -swap 0,3 ^
    +delete ^
    -combine ^
    -set colorspace Lab ^
    -colorspace sRGB ^
    %POST_PROC% ^
    %OUTFILE%

) else if /I %COLGR%==Gray (

  %IMG7%magick ^
    %sHDRI% ^
    %CHAN_L% ^
    %POST_PROC% ^
    %OUTFILE%

) else (
  echo Bad COLGR [%COLGR%]
  exit /B 1
)


call echoRestore

@endlocal & set mlcOUTFILE=%OUTFILE%& set mlcAVG=%AVG%
