rem From array %1 with %2 elements returns mean and standard deviation.
rem Array %3 is 1 where element is to be ignored.
@rem
@rem Updated:
@rem   4-October-2022 for IM v7.
@rem

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

set ARR=%1
set /A nLAST=%2-1

set IGNORE=%3

set sigV=0
set sigV2=0
set nVAL=0
for /L %%i in (0,1,%nLAST%) do (
  rem echo %ARR%[%%i]=!%ARR%[%%i]!

  if not "!%IGNORE%[%%i]!"=="1" (
    set VAL=!%ARR%[%%i]!

    for /F "usebackq" %%L in (`%IMG7%magick identify ^
      -precision 9 ^
      -format "sigV=%%[fx:!sigV!+!VAL!]\nsigV2=%%[fx:!sigV2!+!VAL!*!VAL!]" ^
      xc:`) do set %%L

    set /A nVAL+=1
  )
)

echo nVAL=%nVAL% sigV=%sigV% sigV2=%sigV2%

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 9 ^
  -format "mean=%%[fx:%sigV%/%nVAL%]" ^
  xc:`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 9 ^
  -format "sd=%%[fx:sqrt(%sigV2%/%nVAL%-(%mean%)*(%mean%))]" ^
  xc:`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 9 ^
  -format "sdSamp=%%[fx:sqrt((%sigV2%-(%mean%)*(%sigV%))/(%nVAL%-1))]" ^
  xc:`) do set %%L

echo mean=%mean% sd=%sd% sdSamp=%sdSamp%

@call echoRestore

@endlocal & set msdMEAN=%mean%& set msdSTD_DEV=%sd%& set msdSTD_DEV_SAMP=%sdSamp%
