rem From image %1,
rem writes No-Reference Perceptual Blur Metric
rem to environment variable %2 [default mb_score].
rem %3 is prefix for debugging images. Default: no images.
@rem
@rem Reference: http://im.snibgo.com/measblur.htm


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 mb

set ENVVAR=%2
if "%ENVVAR%"=="." set ENVVAR=
if "%ENVVAR%"=="" set ENVVAR=mb_score

set DBG_PREF=%3

if "%DBG_PREF%"=="" (
  set WR_F=
  set WR_BHOR=
  set WR_BVER=
  set WR_D_FVER=
  set WR_D_FHOR=
  set WR_D_BVER=
  set WR_D_BHOR=
  set WR_D_VVER=
  set WR_D_VHOR=
) else (
  set WR_F=+write %DBG_PREF%_f
  set WR_BHOR=+write %DBG_PREF%_bhor
  set WR_BVER=+write %DBG_PREF%_bver
  set WR_D_FVER=+write %DBG_PREF%_d_fver
  set WR_D_FHOR=+write %DBG_PREF%_d_fhor
  set WR_D_BVER=+write %DBG_PREF%_d_bver
  set WR_D_BHOR=+write %DBG_PREF%_d_bhor
  set WR_D_VVER=+write %DBG_PREF%_d_vver
  set WR_D_VHOR=+write %DBG_PREF%_d_vhor
)

set TMPDIR=\temp\

for /F "usebackq" %%L in (`%IMG7%magick ^
  %INFILE% ^
  -colorspace Gray ^
  %WR_F% ^
  +write mpr:F ^
  ^( +clone ^
    -statistic Mean 9x1 ^
    %WR_BHOR% ^
    +write mpr:bhor ^
    +delete ^) ^
  ^( +clone ^
    -statistic Mean 1x9 ^
    %WR_BVER% ^
    +write mpr:bver ^
    +delete ^) ^
  ^( +clone ^) ^
  -geometry +0-1 ^
  -compose Difference -composite ^
  -geometry +0+0 ^
  %WR_D_FVER% ^
  +write mpr:d_fver ^
  +delete ^
  mpr:F ^( +clone ^) ^
  -geometry -1+0 ^
  -compose Difference -composite ^
  -geometry +0+0 ^
  %WR_D_FHOR% ^
  +write mpr:d_fhor ^
  +delete ^
  mpr:bver ^( +clone ^) ^
  -geometry +0-1 ^
  -compose Difference -composite ^
  -geometry +0+0 ^
  %WR_D_BVER% ^
  +write mpr:d_bver ^
  +delete ^
  mpr:bhor ^( +clone ^) ^
  -geometry -1+0 ^
  -compose Difference -composite ^
  -geometry +0+0 ^
  %WR_D_BHOR% ^
  +write mpr:d_bhor ^
  +delete ^
  mpr:d_fver mpr:d_bver ^
  -compose MinusSrc -composite -clamp ^
  %WR_D_VVER% ^
  +write mpr:d_vver ^
  +delete ^
  mpr:d_fhor mpr:d_bhor ^
  -compose MinusSrc -composite -clamp ^
  %WR_D_FHOR% ^
  +write mpr:d_vhor ^
  +delete ^
  ^( mpr:d_vver mpr:d_fver ^
    -scale "1x1^!" ^
    -compose DivideSrc -composite ^
  ^) ^
  ^( mpr:d_vhor mpr:d_fhor ^
    -scale "1x1^!" ^
    -compose DivideSrc -composite ^
  ^) ^
  -compose Darken -composite ^
  -negate ^
  -precision 16 ^
  -format "SCORE=%%[fx:mean]\n" ^
  info:`) do set %%L

call echoRestore

@endlocal & set mbOUTFILE=%OUTFILE%& set %ENVVAR%=%SCORE%
