rem Assemble images with Minimum Error Boundary Cut.

@rem %1 is input files with XX, eg cr_XX.png, XX will be substituted with an integer.
@rem   Any offsets in inputs will be overridden.
@rem %2 is number of image columns
@rem %3 is number of image rows
@rem %4 is horizontal overlap in pixels (can be suffixed)
@rem %5 is vertical overlap in pixels (can be suffixed)
@rem %6 is output
@rem
@rem Updated:
@rem   18-July-2022 for IM v7.
@rem

@rem Inputs are assumed to be the same size.

@if "%5"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 mebct


set INFILES=%1

set /A Wm1=%2-1
set /A Hm1=%3-1

set overX=%4
set overY=%5

if not "%6"=="" set OUTFILE=%6

set FIRST_IN=%INFILES:XX=0%

set WW=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "WW=%%w\nHH=%%h" ^
  %FIRST_IN%`) do set %%L
if "%WW%"=="" exit /B 1

call xyCoord %WW% %HH% %overX% %overY%

echo xycXi=%xycXi% xycYi=%xycYi%

set overX=%xycXi%
set overY=%xycYi%

set TEMP_OUT=mebct.miff
del %TEMP_OUT% 2>nul

set CNT=0
for /L %%y in (0,1,%Hm1%) do (

  for /L %%x in (0,1,%Wm1%) do (
    set INONE=%INFILES:XX=!CNT!%

    rem for /F "usebackq" %%L in (`%IMG7%magick identify ^
    rem   -format "offX=%%X\noffY=%%Y" ^
    rem   !INONE!`) do set %%L

    %IMG7%magick ^
      !INONE! ^
      -set page "+%%[fx:%%x*(%WW%-%overX%)]+%%[fx:%%y*(%HH%-%overY%)]" ^
      !INONE!

    call %PICTBAT%mebcOne %TEMP_OUT% !INONE! %overX% %overY%

    if ERRORLEVEL 1 exit /B 1

    set /A CNT+=1
  )
)

%IMG7%magick %TEMP_OUT% %OUTFILE%

call echoRestore

endlocal & set mebctOUTFILE=%OUTFILE%
