rem Given image %1,
rem finds middle colour and a fuzz percentage that includes all the pixels.
rem %2 is prefix for output environment variable.
rem %3 is extra fuzz percentage. Default zero (no extra fuzz).
@rem
@rem Updated:
@rem   11-August-2022 for IM v7
@rem

setlocal

set INFILE=%1

rem echo %0: INFILE=%INFILE%

set ENV_PREF=%2
if "%ENV_PREF%"=="." set ENV_PREF=
if "%ENV_PREF%"=="" set ENV_PREF=mf_

set EXTRA_FUZZ=%3
if "%EXTRA_FUZZ%"=="." set EXTRA_FUZZ=
if "%EXTRA_FUZZ%"=="" set EXTRA_FUZZ=0


set FMT=^
RNG_R=%%[fx:maxima.r-minima.r]\n^
RNG_G=%%[fx:maxima.g-minima.g]\n^
RNG_B=%%[fx:maxima.b-minima.b]\n^
MID_R=%%[fx:50*(maxima.r+minima.r)]\n^
MID_G=%%[fx:50*(maxima.g+minima.g)]\n^
MID_B=%%[fx:50*(maxima.b+minima.b)]\n

for /F "usebackq" %%L in (`%IMG7%magick ^
  %INFILE% ^
  -set colorspace sRGB ^
  -format "%FMT%" ^
  info:`) do set %%L

set FMT=^
FUZZ=%%[fx:100*sqrt((%RNG_R%*%RNG_R%+%RNG_G%*%RNG_G%+%RNG_B%*%RNG_B%)/3)+(%EXTRA_FUZZ%)]

rem echo %0: FMT=%FMT%

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "%FMT%" ^
  xc:`) do set %%L

rem echo %0: FUZZ=%FUZZ%

endlocal & set %ENV_PREF%MID=sRGB(%MID_R%%%,%MID_G%%%,%MID_B%%%)& set %ENV_PREF%FUZZ=%FUZZ%%%
