rem Given image %1
rem mask %2 (white boundary margin on black),
rem find the point-to-point path of minimum %1 within the boundary margin,
rem Output %3, white shape in black background.
rem
rem (This is simplified variation of shapeDp.bat)
@rem
@rem Updated:
@rem   14-July-2022 for IM v7.
@rem


@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 mdp

set BND_MSK=%2

if not "%3"=="" if not "%3"=="." set OUTFILE=%3

for /F "usebackq tokens=1-3 delims=:=, " %%A in (`%IM7DEV%magick ^
  %BND_MSK% ^
  -fuzz 0.0001%% ^
  -process onewhite ^
  -format "sdpWW=%%w\nsdpHH=%%h" ^
  info: 2^>^&1`) do (
  if "%%A"=="onewhite" (
    set A=%%A
    set /A sdpX=%%B
    set /A sdpY1=%%C
  ) else (
    set %%A=%%B
  )
)
if not "%A%"=="onewhite" exit /B 1

echo %0: %sdpWW% %sdpHH% %sdpX% %sdpY1%

set /A ColHt=%sdpHH%-%sdpY1%

for /F "usebackq tokens=3 delims=:=, " %%A in (`%IM7DEV%magick ^
  %BND_MSK% ^
  -crop 1x%ColHt%+%sdpX%+%sdpY1% +repage ^
  -negate ^
  -fuzz 0.0001%% ^
  -process onewhite ^
  NULL: 2^>^&1`) do (
    set sdpY2=%%A
)

set /A sdpY2+=%sdpY1%

:: New 30-Oct-16
set /A sdpY1+=(%sdpY2%-%sdpY1%)/2

echo %0: %sdpWW% %sdpHH% %sdpX% %sdpY1% %sdpY2%

set /A sdpWWm1=%sdpWW%-1

rem set /A sdpX=%sdpWW%/2

set /A sdpXm2=%sdpX%-2
set /A sdpXm1=%sdpX%-1
set /A sdpXp1=%sdpX%+1
set /A sdpY1p1=%sdpY1%+1
set /A sdpY1p2=%sdpY1%+2

echo %0: start_at %sdpXm1%,%sdpY1% end_at %sdpXp1%,%sdpY1%

goto skip

%IM7DEV%magick ^
  %INFILE% ^
  %BND_MSK% ^
  -alpha off ^
  -compose CopyOpacity -composite ^
  -background White ^
+write x0.png ^
  -compose Over -layers flatten ^
  -alpha off ^
  -clamp ^
+write x1.png ^
  -fuzz 0.0001%% -fill gray(200%%) -opaque White -fuzz 0 ^
  -strokewidth 1 ^
  -stroke gray(200%%) ^
  -draw "line %sdpX%,0 %sdpX%,%sdpY2%" ^
  -fuzz 0.0001%% -fill gray(200%%) -opaque White -fuzz 0 ^
+write x2.png ^
  -process 'darkestpntpnt start_at %sdpXm1%,%sdpY1% end_at %sdpXp1%,%sdpY1% t 1.5 v' ^
  -fill White ^
  -draw "point %sdpX%,%sdpY1%" ^
  -draw "color %sdpX%,%sdpY1p1% floodfill" ^
  %OUTFILE%

:skip

%IM7DEV%magick ^
  %INFILE% ^
  ( %BND_MSK% -alpha off -negate ) ^
  -alpha off ^
  -compose Lighten -composite ^
  -alpha off ^
  -clamp ^
  -fuzz 0.0001%% -fill gray(200%%) -opaque White -fuzz 0 ^
  -strokewidth 1 ^
  -stroke gray(200%%) ^
  -draw "line %sdpX%,0 %sdpX%,%sdpY2%" ^
  -fuzz 0.0001%% -fill gray(200%%) -opaque White -fuzz 0 ^
  -process 'darkestpntpnt start_at %sdpXm1%,%sdpY1% end_at %sdpXp1%,%sdpY1% t 1.5 v' ^
  -fill White ^
  -draw "point %sdpX%,%sdpY1%" ^
  -draw "color %sdpX%,%sdpY1p1% floodfill" ^
  %OUTFILE%

call echoRestore

endlocal & set mdpOUTFILE=%OUTFILE%
