rem Given %1 to %4 are left, top, right and bottom pieces for a frame,
rem creates output %5 with mitred corners.
rem The pieces will _not_ be rotated.

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

set OUTFILE=%5
if "%OUTFILE%"=="" exit /B 1

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "LW=%%w\nLH=%%H\n" ^
  %1`) do set %%L

call :getdims %1 LW LH
if ERRORLEVEL 1 exit /B 1

call :getdims %2 TW TH
if ERRORLEVEL 1 exit /B 1

call :getdims %3 RW RH
if ERRORLEVEL 1 exit /B 1

call :getdims %4 BW BH
if ERRORLEVEL 1 exit /B 1

if %LH% NEQ %RH% (
  echo %0: left and right have different heights
)

if %TW% NEQ %BW% (
  echo %0: top and bottom have different widths
)


%IMG7%magick ^
  -size %TW%x%LH% xc:None ^
  %1 -gravity West -compose Over -composite ^
  %3 -gravity East -compose Over -composite ^
  ( %2 ^
    ( +clone ^
      -fill Black -colorize 100 ^
      -fill White -draw "polygon 0,0 %%[fx:%TW%-1],0 %%[fx:%TW%-1-%RW%],%%[fx:%TH%-1] %%[fx:%LW%],%%[fx:%TH%-1]" ^
    ) ^
    -alpha off -compose CopyOpacity -composite ^
  ) -gravity North -compose Over -composite ^
  ( %4 ^
    ( +clone ^
      -fill Black -colorize 100 ^
      -fill White -draw "polygon 0,%%[fx:%BH%-1] %%[fx:%LW%],0 %%[fx:%BW%-1-%RW%],0 %%[fx:%BW%-1],%%[fx:%BH%-1]" ^
    ) ^
    -alpha off -compose CopyOpacity -composite ^
  ) -gravity South -compose Over -composite ^
  %OUTFILE%

call echoRestore

@endlocal

@exit /B 0

::------------------------------------------
:: Subroutines

:getdims

set %2=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "%2=%%w\n%3=%%H\n" ^
  %1`) do set %%L

if "!%2!"=="" exit /B 1

exit /B 0
