rem %1 output file
rem %2 clut width [1024]
rem %3 quoted x,y of intersection, 0 < x,y < 1.
rem %4 sigma for blur, as proportion of width. 0 = no blur.
@rem
@rem Also uses:
@rem   mc2sPREPROC IM process applied to input linear grayscale
@rem   mc2sPOSTPROC IM process applied to output

set OUTFILE=%1
if "%OUTFILE%"=="." set OUTFILE=
if "%OUTFILE%"=="" set OUTFILE=mc2s.png

set WW=%2
if "%WW%"=="." set WW=
if "%WW%"=="" set WW=1024

set XY=%3
if [%XY%]==[.] set XY=
if [%XY%]==[] set XY=0.5,0.5

set BLR=%4
if "%BLR%"=="." set BLR=
if "%BLR%"=="" set BLR=0

call parseCommaList %XY% CntList NumList

set CntList
set NumList

if not %CntList%==2 (
  %0: Needs "x,y"
  exit /B 1
)

set XX=%NumList[0]%
set YY=%NumList[1]%

set FMT=^
G0=%%[fx:%YY%/%XX%]\n^
G1=%%[fx:(1-%YY%)/(1-%XX%)]\n^
WX=%%[fx:%WW%*%XX%]\n^
BX=%%[fx:%WW%*%XX%/2]\n^
BW=%%[fx:%WW%*(0.5+%XX%/2)-%WW%*%XX%/2]\n^
BS=%%[fx:%WW%*%BLR%]\n

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 15 ^
  -format "%FMT%" ^
  xc:`) do set %%L

if %BLR%==0 (
  set sBLR=
) else (
  set sBLR=-region %BW%x1+%BX%+0 -morphology Convolve Blur:0x%BS% +region
)

%IMG7%magick ^
  -size %WW%x1 gradient:black-white ^
  %mc2sPREPROC% ^
  -fx "u<%XX%?%G0%*u:%YY%+(u-%XX%)*%G1%" ^
  %sBLR% ^
  %mc2sPOSTPROC% ^
  %OUTFILE%
