rem From image %1, make Gaussian pyramid %2.
@rem %2 should be capable of containing multiple images, eg type TIFF.
@rem %3 %4 %5 %6 parameters to mkPyrComm
@rem
@rem Also uses:
@rem   mkpDEBUG if 1, creates other image files (full and diff).
@rem   mkpHTM if 1, creates HTM file
@rem
@rem Updated:
@rem   5-September-2022 for IM v7. Remove %IML%.
@rem

@rem For some purposes,
@rem resizing down to the grid might be good enough if we use "-scale?


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 mkgp


if "%pyWEIGHTING%"=="" set pyWEIGHTING=max

call %PICTBAT%mkPyrComm %1 %2 %3 %4 %5 %6
if ERRORLEVEL 1 exit /B 1

echo %INFILE% +write mpr:SRC +delete >%MK_SCR%

:: Could be optimised.
:: If DEBUG, we need to enlarge and find DIFF.
:: If octave 0 isn't full-size, we need DIFF_0
:: If neither of these, we don't need to enlarge and do maths,
:: and could create final DIFF as solid gray 50%.

for /L %%N in (%LAST_OCT%,-1,0) do (

  set GRD_FILE=%pyPREFIX%grd_%%N%fnNG_EXT%

  rem echo N_BLK_W.%%N=!N_BLK_W.%%N! N_BLK_H.%%N=!N_BLK_H.%%N! AMP.%%N=!AMP.%%N! M1AMP.%%N=!M1AMP.%%N!


  set DO_RES=1
  if !N_BLK_W.%%N!==%WW% if !N_BLK_H.%%N!==%HH% set DO_RES=0

  set WRDIFF=1
  if not %%N==0 if not "%mkpDEBUG%"=="1" set WRDIFF=0

  ( echo mpr:SRC
    if !DO_RES!==1 echo -resize "!N_BLK_W.%%N!x!N_BLK_H.%%N!^!"
    if "%mkpDEBUG%"=="1" echo +write !GRD_FILE!
    echo +write mpr:GRD%%N
    if !DO_RES!==1 echo -resize "%WW%x%HH%^!"
    if "%mkpDEBUG%"=="1" echo +write %pyPREFIX%full_%%N%fnNG_EXT%
    echo mpr:SRC
    echo -compose Mathematics -define compose:args=0,1,-1,0.5 -composite
    if "%mkpDEBUG%"=="1" echo +write %pyPREFIX%diff_%%N%fnNG_EXT%
    echo +write mpr:DIFF%%N
    echo +delete
  )>>%MK_SCR%

  if "%mkpHTM%"=="1" (
    echo ^<tr^>
    echo ^<td^>%%N^</td^>
    echo ^<td^>^<img src="!GRD_FILE!%EXTEXT%" /^>^</td^>
    echo ^<td^>^<img src="%pyPREFIX%full_%%N%fnNG_EXT%%EXTEXT%" /^>^</td^>
    echo ^<td^>^<img src="%pyPREFIX%full_%%N_h_glc.png" /^>^</td^>
    echo ^<td^>^<img src="%pyPREFIX%diff_%%N%fnNG_EXT%%EXTEXT%" /^>^</td^>
    echo ^</tr^>
  )>>%HTM_TAB%
)

:: List the MPRs, ready to write to pyramid file.
(
  for /L %%N in (0,1,%LAST_OCT%) do @(
    @echo mpr:GRD%%N
  )
  echo mpr:DIFF0
  echo +depth
  echo -write %PYR_FILE%
  echo -exit
)>>%MK_SCR%

:: Add final difference, and delinear, to reconstruction.
set DO_RES=1
if !N_BLK_W.0!==%WW% if !N_BLK_H.0!==%HH% set DO_RES=0

(
  echo %PYR_FILE%[0]
  if !DO_RES!==1 echo -resize "%WW%x%HH%^!"
  echo %PYR_FILE%[%NUM_OCTAVES%]
  echo -compose Mathematics -define compose:args=0,1,1,-0.5 -composite %sDELIN%
  echo -write %RECON_FILE%
  echo -exit
)>%RECON_SCR%

if "%mkpHTM%"=="1" echo ^</table^> >>%HTM_TAB%

if "%pyIM%"=="" (
  set pyIM=%IMG7%
)
if "%pyIM%"=="" (
  echo %0: pyIM not set
  exit /B 1
)

%pyIM%magick ^
  -script %MK_SCR%

if "%mkpHTM%"=="1" (
  for /L %%N in (0,1,%LAST_OCT%) do @(
    %IM7DEV%magick ^
      %pyPREFIX%full_%%N%fnNG_EXT% ^
      -process 'mkhisto capnumbuckets 512 norm' ^
      %pyPREFIX%full_%%N_h%fnNG_EXT%

    call %PICTBAT%graphLineCol %pyPREFIX%full_%%N_h%fnNG_EXT% . . 0
  )
)

call echoRestore

@endlocal & set mkgpOUTFILE=%PYR_FILE%& set mkgpNUM_OCTAVES=%NUM_OCTAVES%& set mkgpRECON_FILE=%RECON_FILE%
