rem From image %1,
rem makes Haar wavelet pyramid %2.
@rem
@rem Updated:
@rem   12-August-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 mkhp

if not "%2"=="" set OUTFILE=%2

set TMP_EXT=.miff
set TMP_PREF=%TEMP%\mkhp_

set NUM_OCT=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "NUM_OCT=%%[fx:ceil(log(max(h,w))/log(2))]\n" ^
  %INFILE%`) do set %%L

if "%NUM_OCT%"=="" exit /B 1

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "EXT_DIM=%%[fx:2^%NUM_OCT%]\n" ^
  %INFILE%`) do set %%L

echo NUM_OCT=%NUM_OCT% EXT_DIM=%EXT_DIM%

%IMG7%magick ^
  %INFILE% ^
  -extent %EXT_DIM%x%EXT_DIM% ^
  %TMP_PREF%img%TMP_EXT%

set LEV_IN=%TMP_PREF%img%TMP_EXT%

set FILE_LIST=
for /L %%I in (1,1,%NUM_OCT%) do (
  echo %%I

  call %PICTBAT%haar4bb !LEV_IN! %TMP_PREF%_l%%I%TMP_EXT%

  set FILE_LIST=!FILE_LIST! %TMP_PREF%_l%%I_ahvd%TMP_EXT%

  set LEV_IN=%TMP_PREF%_l%%I_a%TMP_EXT%
)

%IMG7%magick ^
  %FILE_LIST% ^
  -layers merge ^
  %OUTFILE%

call echoRestore

endlocal & set mkhpOUTFILE=%OUTFILE%
