rem Draw a histogram, coping with pixel values outside 0 to 100%.
rem %1 input, possibly HDRI, possibly with pixel values outside 0 to 100%
rem %2 output
rem %3 (quoted) options for "-process mkhisto".
@rem
@rem The region of input from 0% to 100% is highlighted in green.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

set INFILE=%1
set OUTFILE=%~dpn1_mhh.png

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set MKHISTOPT=%~3
if "%MKHISTOPT%"=="" set MKHISTOPT=


set TMPDIR=\temp\
set TMPIN=%TMPDIR%mhh.miff

set FMT=^
OMIN=%%[fx:minima]\n^
OMAX=%%[fx:maxima]\n^
NMIN=%%[fx:minima^<0?minima:0]\n^
NMAX=%%[fx:maxima^>1?maxima:1]\n

for /F "usebackq" %%L in (`%IMG7%magick ^
  %INFILE% ^
  -precision 15 ^
  -write %TMPIN% ^
  -format "%FMT%" ^
  info:`) do set %%L

set FMT=^
FACT=%%[fx:1/(%OMAX%-%OMIN%)]\n^
OFFS=%%[fx:-%OMIN%/(%OMAX%-%OMIN%)]\n^
ZERO=%%[fx:-%NMIN%/(%NMAX%-%NMIN%)]\n^
ONE=%%[fx:(1-%NMIN%)/(%NMAX%-%NMIN%)]\n

for /F "usebackq" %%L in (`%IMG7%magick ^
  -precision 15 ^
  -print "%FMT%" ^
  -exit`) do set %%L

set NBUCK=768

set sPROC=-process 'mkhisto capnumbuckets %NBUCK% norm %MKHISTOPT% v'

rem See "-function polynomial" bug https://www.imagemagick.org/discourse-server/viewtopic.php?f=3&t=37520
%IM7DEV%magick ^
  %TMPIN% ^
  -precision 15 ^
  -function polynomial %FACT%,%ZERO% ^
  -clamp ^
  -format "MIN=%%[fx:minima]\nMAX=%%[fx:maxima]\n" ^
  +write info: ^
  %sPROC% ^
  %TMPIN%

call %PICTBAT%graphLineCol %TMPIN% . . 0 %OUTFILE%

%IM7DEV%magick ^
  %OUTFILE% ^
  -fill #0f08 -stroke None ^
  -draw "rectangle %%[fx:%ZERO%*w],0,%%[fx:(%ONE%-%ZERO%)*w],%%[fx:h-1]" ^
  %OUTFILE%

for /F "usebackq" %%L in (`%IMG7%magick ^
  -precision 5 ^
  -print "OMINp=%%[fx:%OMIN%]\nOMAXp=%%[fx:%OMAX%]\n" ^
  -exit`) do set %%L

call %PICTBAT%graph4labels %OUTFILE% %OUTFILE% %OMINp% %OMAXp%

call echoRestore

endlocal & set mhhOUTFILE=%OUTFILE%&
