rem Makes a clut from hermite curve, given value and gradient at each end.

rem %1 output file
rem %2 v1, percentage of QuantumRange
rem %3 v2, percentage of QuantumRange
rem %4 required width of output
rem %5 g1, gradient at v1
rem %6 g2, gradient at v2
rem %7 gradient type, GRAD_TYPE. Default: perpixel.
rem %8 if "chop", chops one off at the end.

@rem Reference: http://im.snibgo.com/ckbkClut#hermite
@rem
@rem Beware: "-function polynomial" is buggy with old v7 versions of IM.


@if "%4"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

set OUTFILE=%1

set v1=(%2/100)
set v2=(%3/100)

set GRAD_TYPE=%7
if "%GRAD_TYPE%"=="." set GRAD_TYPE=
if "%GRAD_TYPE%"=="" set GRAD_TYPE=perpixel

echo %0 %1 %2 %3 %4 %5 %6 %GRAD_TYPE% %8

if "%8"=="chop" (
  set CHOP=-gravity East -chop 1x0+0+0
) else (
  set CHOP=
)

if "%GRAD_TYPE%"=="perimage" (
  set GRAD_MULT=
) else if "%GRAD_TYPE%"=="perpercent" (
  set GRAD_MULT=100
) else if "%GRAD_TYPE%"=="perpixel" (
  set GRAD_MULT=w
) else (
  echo %0: Bad GRAD_TYPE [%GRAD_TYPE%]
  exit /B 1
)

if "%GRAD_MULT%"=="" (
  set g1=^(%5/100^)
  set g2=^(%6/100^)
) else (
  set g1=^(%5*%GRAD_MULT%/100^)
  set g2=^(%6*%GRAD_MULT%/100^)
)

%IMG7%magick ^
  -size %4x1 gradient:black-white ^
  -function polynomial ^
    %%[fx:2*%v1%+%g1%-2*%v2%+%g2%],%%[fx:-3*%v1%-2*%g1%+3*%v2%-%g2%],%%[fx:%g1%],%%[fx:%v1%] ^
  %CHOP% ^
  -define quantum:format=floating-point ^
  -depth 32 ^
  %OUTFILE%

call echoRestore

@endlocal & set mhcOUTFILE=%OUTFILE%
