rem Makes a clut from hermite curve, given value and gradient at each end.
rem This works by making temporary images.
rem It is much slower than mkHermiteClut, which should generally be used instead.

rem %1 output file
rem %2 v1, percentage of QuantumRange
rem %3 v2, percentage of QuantumRange
rem %4 required width of output
rem %5 g1, gradient at v1
rem %6 g2, gradient at v2
rem %7 gradient type, GRAD_TYPE
rem %8 if "chop", chops one off at the end.

@rem Reference: http://im.snibgo.com/ckbkClut#hermite


@if "%4"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

rem @call echoOffSave

set OUTFILE=%1

:: Creating images then calling interpClutHermite then rotating gives poor performance.
:: This will change, moving simplified code from interpClutHermite to here.

set TMPDIR=\temp

%IMG7%magick ^
  -size 1x1 ^
  -define quantum:format=floating-point ^
  -depth 32 ^
  xc:gray(%2%%)  -write %TMPDIR%\cl_herm_v1.miff +delete ^
  xc:gray(%3%%)  -write %TMPDIR%\cl_herm_v2.miff +delete ^
  xc:gray(%5%%)  -write %TMPDIR%\cl_herm_g1.miff +delete ^
  xc:gray(%6%%) -write %TMPDIR%\cl_herm_g2.miff +delete ^
  NULL:

set ichChopEnd=
if "%8"=="chop" set ichChopEnd=1

call %PICTBAT%interpClutHermite ^
  %TMPDIR%\cl_herm_v1.miff %TMPDIR%\cl_herm_v2.miff ^
  %4 ^
  %TMPDIR%\cl_herm_h.miff ^
  . . ^
  %TMPDIR%\cl_herm_g1.miff %TMPDIR%\cl_herm_g2.miff ^
  %7

if ERRORLEVEL 1 exit /B 1

set ichChopEnd=

%IMG7%magick %TMPDIR%\cl_herm_h.miff -rotate -90 %OUTFILE%

call echoRestore

@endlocal & set mhcOUTFILE=%OUTFILE%
