rem Makes a pyramid %1 with uniformly-distributed noise in all levels,
rem and gray(50%) in final difference.
@rem
@rem Assumes NUM_OCTAVES etc is valid.
@rem
@rem Updated:
@rem   15 May 2016 use %IML% for @script.
@rem   5-September-2022 for IM v7. Remove %IML%.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

rem @call echoOffSave

call %PICTBAT%setInOut %1 mnp

set OUTFILE=%1

set TMP_SCR=mnp_tmp.scr

if "%NUM_OCTAVES%"=="" (
  echo %0: NUM_OCTAVES not set
)

if "%mnpSEED%"=="" (
  set sSEED=
) else (
  set sSEED=-seed %mnpSEED%
)


( @for /L %%N in (0,1,%NUM_OCTAVES%) do @(

    if %%N==%NUM_OCTAVES% (
      echo ^( -size %IMG_WW%x%IMG_HH% xc:gray^(50%%^) ^)
    ) else (
      echo ^( -size !N_BLK_W.%%N!x!N_BLK_H.%%N! xc:rgb^(50%%,50%%,50%%^) +noise Random ^)
    )

  )
  echo -write %OUTFILE%
  echo -exit
) >%TMP_SCR%

type %TMP_SCR%

%IMG7%magick %sSEED% -script %TMP_SCR% 

call echoRestore

@endlocal & set mnpOUTFILE=%OUTFILE%
