rem Common processing for making Laplacian or Gaussian pyramids.
rem %1 is input image
rem %2 is output filename
rem %3 to %6 are block parameters
@rem
@rem Updated:
@rem   5-September-2022 for IM v7.
@rem

if "%pyIM%"=="" set pyIM=%IMG7%

if "%pyPREFIX%"=="" set pyPREFIX=mkp_
if "%pyPYR_EXT%"=="" set pyPYR_EXT=.tiff
if "%fnNG_EXT%"=="" set fnNG_EXT=.miff

if "%fnNG_EXT%"==".miff" (
  set EXTEXT=jpg
) else (
  set EXTEXT=
)

if not exist %INFILE% (
  echo %0: Can't find INFILE [%INFILE%]
  exit /B 1
)

set PYR_FILE=%2
if "%PYR_FILE%"=="." set PYR_FILE=
if "%PYR_FILE%"=="" set PYR_FILE=%pyPREFIX%%sioCODE%%pyPYR_EXT%

:: The sioCODE was set by the caller.

set TMP_BAT=%pyPREFIX%%sioCODE%.bat
set MK_SCR=%pyPREFIX%%sioCODE%_mk.scr
set HTM_TAB=%pyPREFIX%%sioCODE%.htm
set RECON_SCR=%pyPREFIX%%sioCODE%_recon.scr
set BLK_LIS=%pyPREFIX%blk.lis
set RECON_FILE=%pyPREFIX%%sioCODE%_recon.miff

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "WW=%%w\nHH=%%h" ^
  %INFILE%`) do set %%L

set NUM_OCTAVES=

call %PICTBAT%mkpVar %WW% %HH% %3 %4 %5 %6
if ERRORLEVEL 1 (
  echo %0: mkpVar failed
  exit /B 1
)

rem if not exist %BLK_LIS% (
rem   echo %0: Can't find BLK_LIS [%BLK_LIS%]
rem   exit /B 1
rem )

del %RECON_SCR% 2>nul

rem
rem for /F "tokens=*" %%L in (%BLK_LIS%) do set %%L

if "%NUM_OCTAVES%"=="" (
  echo %0: NUM_OCTAVES has no value
  exit /B 1
)

set BAD_DIMS=1
if "%WW%"=="%IMG_WW%" if "%HH%"=="%IMG_HH%" set BAD_DIMS=0
if %BAD_DIMS%==1 (
  echo %0: Dimensions don't match: "%WW%" neq "%IMG_WW%" or "%HH%" neq "%IMG_HH%"
  exit /B 1
)

( echo %INFILE%
  echo +write mpr:SRC %sLIN%
) >%MK_SCR%

if "%mkpHTM%"=="1" (
  echo ^<table^>
  echo ^<th^>Octave^</th^>^<th^>Grid^</th^>^<th^>Grid, resized up^</th^>^<th^>Histogram of resized grid^</th^>^<th^>Difference^</th^>
)>%HTM_TAB%

set /A LAST_OCT=%NUM_OCTAVES%-1

set DONE_FIRST=0

set PREV_DIFF=SRC

exit /B 0
