rem From colour image %1,
rem makes mosaiced (Bayer) image, same size.
rem %2 %3 %4 and %5 are divisors for R G0 G1 and B channels.
rem %6 is optional output file.
@rem
@rem Also uses:
@rem   mosPREPROC eg "-colorspace RGB"
@rem
@rem Assumes Bayer filter pattern is:
@rem   R  G0
@rem   G1 B
@rem
@rem Updated:
@rem   6-August-2022 for IM v7
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

rem call echoOffSave

call %PICTBAT%setInOut %1 mos


if not "%6"=="" if not "%6"=="." set OUTFILE=%6

set WW=
for /F "usebackq" %%L ^
in (`%IMG7%magick identify -format "WW=%%w\nHH=%%h" %INFILE%`) ^
do set /A %%L
if "%WW%"=="" exit /B 1

set DIV_R=
set DIV_G0=
set DIV_G1=
set DIV_B=

if not "%2"=="" if not "%2"=="." set DIV_R=-evaluate divide %2
if not "%3"=="" if not "%3"=="." set DIV_G0=-evaluate divide %3
if not "%4"=="" if not "%4"=="." set DIV_G1=-evaluate divide %4
if not "%5"=="" if not "%5"=="." set DIV_B=-evaluate divide %5

%IMG7%magick ^
  -size 2x2 xc:black ^
  -fill White -draw "point 1,0" ^
  -fill None ^
  +write mpr:SQR_G0 ^
  -roll +0+1 +write mpr:SQR_B ^
  -roll -1+0 +write mpr:SQR_G1 ^
  +delete ^
  %INFILE% ^
  -set colorspace sRGB ^
  %mosPREPROC% ^
  -channel RGB ^
  -separate ^
  -compose Over ^
  ( -clone 0,1 ^
    ( +clone ^
      -tile mpr:SQR_G0 ^
      -draw "color 0,0 reset" ^
    ) ^
    -alpha off -composite ^
  ) ^
  ( -clone 3,1 ^
    ( +clone ^
      -tile mpr:SQR_G1 ^
      -draw "color 0,0 reset" ^
    ) ^
    -alpha off -composite ^
  ) ^
  ( -clone 4,2 ^
    ( +clone ^
      -tile mpr:SQR_B ^
      -draw "color 0,0 reset" ^
    ) ^
    -alpha off -composite ^
  ) ^
  -delete 0--2 ^
  +depth ^
  -compress None ^
  %OUTFILE%

if ERRORLEVEL 1 exit /B 1

call echoRestore

endlocal & set mosOUTFILE=%OUTFILE%
