rem Moves one point, while pinning all edge pixels.
rem See pinorpush.htm#move1pnt

rem %1 input image
rem %2 output
rem %3 X1xY1 move colour from this location
rem %4 X2xY2 move colour to this location
rem %5 optional process to apply to the gradient

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

rem @call echoOffSave

call %PICTBAT%setInOut %1 m1pe

if not "%2"=="" set OUTFILE=%2

set sXY1=%3
if "%sXY1%"=="." set sXY1=
if "%sXY1%"=="" set sXY1=65cx55c

set sXY2=%4
if "%sXY2%"=="." set sXY2=
if "%sXY2%"=="" set sXY2=40cx45c

set sProcGrad=%~5

echo sProcGrad is [%sProcGrad%]

for /F "usebackq" %%A in (`%IMG7%magick ^
  %INFILE% -format "WW=%%w\nHH=%%h\n" ^
  info:`) do set %%A

call parseXxY2 !WW! !HH! xy1 %sXY1%
call parseXxY2 !WW! !HH! xy2 %sXY2%


echo xy1: %xy1_X%,%xy1_Y%
echo xy2: %xy2_X%,%xy2_Y%

%IMG7%magick ^
  %INFILE% +write mpr:INP ^
  -fill White -colorize 100 ^
  -virtual-pixel Black ^
  -distort DePolar -1,0,%xy2_X%,%xy2_Y% ^
  -set option:MYSIZE %%wx%%h ^
  ( -size %%[MYSIZE] ^
    gradient:Black-White ^
  ) ^
  ( -clone 0 ^
    -crop 0x+0+1 +repage ^
    -scale "x1^!" ^
    -scale "%%[MYSIZE]^!" ^
  ) ^
  -delete 0 ^
  -compose DivideSrc -composite ^
  -clamp ^
  -virtual-pixel Edge ^
  -distort Polar -1,0,%xy2_X%,%xy2_Y% ^
  -negate ^
  %sProcGrad% ^
  -write mpr:GRAD +delete ^
  mpr:INP ^
  -sparse-color Bilinear ^
0,0,#000,^
%%[fx:w-1],0,#f00,^
0,%%[fx:h-1],#0f0,^
%%[fx:w-1],%%[fx:h-1],#ff0 ^
  +write mpr:IDENT_MAP ^
  ( +clone ^
  -channel R ^
  -evaluate pow ^
    %%[fx:log(%xy1_X%/(w-1))/log(%xy2_X%/(w-1))] ^
  -channel G ^
  -evaluate pow ^
    %%[fx:log(%xy1_Y%/(h-1))/log(%xy2_Y%/(h-1))] ^
  +channel ^
  ) ^
  +write mpr:MOVE_MAP ^
  mpr:GRAD ^
  -alpha off ^
  -compose Over -composite ^
  +write mpr:BLND_MAP ^
  mpr:INP ^
  +swap ^
  -compose Distort -composite ^
  %OUTFILE%

if ERRORLEVEL 1 exit /B 1

call echoRestore

@endlocal & set m1peOUTFILE=%OUTFILE%

