@rem  %1 Degrees, may be floating-point, zero is "5R".
@rem  %2 Name for environment value for output.
@rem  Calculates the munsell hue name for the given degrees.
@rem
@rem  For reverse, see munsHue2Degs.bat

@echo off

@setlocal enabledelayedexpansion

set DEGS=%1

for /F "usebackq" %%L in (`%IMG7%magick ^
  xc: ^
  -format "DD=%%[fx:DD=%DEGS%-18; DD<0?DD+360:DD]" ^
  info:`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick ^
  xc: ^
  -format "REM=%%[fx:(%DD%)%%36]" ^
  info:`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick ^
  xc: ^
  -format "DIV=%%[fx:((%DD%)-%REM%)/36]" ^
  info:`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick ^
  xc: ^
  -format "PREF=%%[fx:(%REM%)/3.6]" ^
  info:`) do set %%L

rem This would give 0 when should be 10 of prev, so: ...
rem
if %PREF%==0 (
  set PREF=10
  set DIV-=1
  if !DIV! LSS 0 set /A DIV+=10
)

set HUE=
if %DIV%==0 set HUE=YR
if %DIV%==1 set HUE=Y
if %DIV%==2 set HUE=GY
if %DIV%==3 set HUE=G
if %DIV%==4 set HUE=BG
if %DIV%==5 set HUE=B
if %DIV%==6 set HUE=PB
if %DIV%==7 set HUE=P
if %DIV%==8 set HUE=RP
if %DIV%==9 set HUE=R

if "%DIV%"=="" (
  echo %0: error in DIV [%DIV%]
)

echo Mansell hue is %PREF%%HUE%

endlocal & set %2=%PREF%%HUE%