@rem  %1 Munsell hue name, eg "5R" or "2.3RP"
@rem  %2 Name for environment value for output.
@rem Calculates the angle, where "5R" is zero degrees.
@rem Angle will be in [0,360), floating-point.
@rem
@rem  For reverse, see munsDegs2Hue.bat

@echo off

setlocal enabledelayedexpansion

set HUE=%~1

rem Final one or two letters must be one of:
rem   R YR Y GY G BG B PB P RP

set FINAL=%HUE:~-2%

rem echo FINAL=%FINAL%

if /I %FINAL%==YR (
  set ABASE=36
) else if /I %FINAL%==GY (
  set ABASE=108
) else if /I %FINAL%==BG (
  set ABASE=180
) else if /I %FINAL%==PB (
  set ABASE=252
) else if /I %FINAL%==RP (
  set ABASE=324
)

if "%ABASE%"=="" (
  set FINAL=%HUE:~-1%

  rem echo FINAL=%FINAL%

  if /I !FINAL!==R (
    set ABASE=0
  ) else if /I !FINAL!==Y (
    set ABASE=72
  ) else if /I !FINAL!==G (
    set ABASE=144
  ) else if /I !FINAL!==B (
    set ABASE=216
  ) else if /I !FINAL!==P (
    set ABASE=288
  )

  if "!ABASE!"=="" (
    echo Bad FINAL=!FINAL!
  )

  set NUM=%HUE:~0,-1%

) else (
  set NUM=%HUE:~0,-2%
)

rem echo NUM=%NUM%
rem echo ABASE=%ABASE%

for /F "usebackq" %%L in (`%FXNEW%magick ^
  xc: ^
  -format "DD=%%[fx:DD=%ABASE%+(%NUM%-5)*3.6;DD<0?DD+360:DD]" ^
  info:`) do set %%L

rem echo DD=%DD%

rem echo on

endlocal & set %2=%DD%
