rem %1 is ext .MVG file, with definitions of lines.
rem %2 is prefix for environment variables.
rem Reads the line ends, and calculates the intersections.
rem Returns only the intersections that occur within non-extended lines.

echo off

setlocal enabledelayedexpansion

set INFILE=%1

set PREF=%2
if "%PREF%"=="." set PREF=
if "%PREF%"=="" set PREF=mvgi_

set cnt=0
for /F "eol=# tokens=1-5 delims=, " %%A in (%INFILE%) do (
  if "%%A"=="line" (
    set %PREF%_line[!cnt!].A.x=%%B
    set %PREF%_line[!cnt!].A.y=%%C
    set %PREF%_line[!cnt!].B.x=%%D
    set %PREF%_line[!cnt!].B.y=%%E
    set /A cnt+=1
  )
)
echo %0: %cnt% lines found

set /A cntM1=%cnt%-1
set /A cntM2=%cnt%-2

set cntIntsct=0

for /L %%I in (0,1,%cntM2%) do (
  set /A nxt=%%I+1
  for /L %%J in (!nxt!,1,%cntM1%) do (
    rem echo I=%%I J=%%J
    call %PICTBAT%lineIntersect %PREF%_line[%%I] %PREF%_line[%%J] outline
    rem set outline
    if !outline.liNeedExtend!==0 (
      set %PREF%_intsct[!cntIntsct!].x=!outline.x!
      set %PREF%_intsct[!cntIntsct!].y=!outline.y!
      set /A cntIntsct+=1
    )
  )
)

set %PREF%

echo %0: %cntIntsct% intersections found

endlocal
