rem From image %1,
rem find the nearest aspect ratio from a list.
rem %2 output cropped image. Default no output.
rem %3 is the aspect ratio list, eg "1:1,7:5,1:3,5:7,3:1,2:3,3:2"
rem   Numbers in the AR do not need to be integers, eg "1.5:0.9" is okay.
rem %4 prefix for output environment variable names
rem "Nearest" means the AR that results in a crop removing the fewest pixels.

@if "%~3"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 nasp

set OUTFILE=%2
if "%OUTFILE%"=="." set OUTFILE=
if "%OUTFILE%"=="" set OUTFILE=NULL:

set ARLIST=%~3

set ENVPREF=%4
if "%ENVPREF%"=="." set ENVPREF=
if "%ENVPREF%"=="" set ENVPREF=nasp_

if "%ARLIST%"=="" (
  echo %0: arguments: infile outfile aspect_ratio_list env_prefix
  exit /B 1
)

set TMPINP=%TEMP%\nearAspRat.miff

if /I %OUTFILE%==NULL: (
  set WrOut=0
) else (
  set WrOut=1
)

for /F "usebackq" %%L in (`%IMG7%magick ^
   %INFILE% ^
  -precision 15 ^
  +write %TMPINP% ^
  -format "inptArea=%%[fx:w*h]\n" ^
  info:`) do set %%L

set SML_DIFF=99999999
set SML_AR=

for %%A in (%ARLIST%) do (

  for /F "usebackq" %%L in (`%IMG7%magick ^
    -precision 15 ^
    %TMPINP% ^
    -crop %%A+0+0 +repage ^
    -format "diff=%%[fx:%inptArea%-w*h]\nWW=%%w\nHH=%%h\n" ^
    info:`) do set %%L

  if !SML_DIFF! GTR !diff! (
    set SML_DIFF=!diff!
    set SML_AR=%%A
    set SML_WW=!WW!
    set SML_HH=!HH!
  )
)

if "%SML_AR%"=="" (
  echo %0: Something bad happened.
  exit /B 1
)

if %WrOut%==1 %IMG7%magick ^
  %TMPINP% ^
  -crop %SML_AR%+0+0 +repage ^
  %OUTFILE%

echo SML_DIFF=%SML_DIFF% SML_AR=%SML_AR% SML_WW=%SML_WW% SML_HH=%SML_HH%

call echoRestore

endlocal & set %ENVPREF%_DIFF=%SML_DIFF%& set %ENVPREF%_AR=%SML_AR%& ^
set %ENVPREF%_WW=%SML_WW%& set %ENVPREF%_HH=%SML_HH%

