rem From %1, a camera-raw NEF file,
rem make floating-point TIFF outputs with prefix %2:
rem   _lin.tiff   Rec2020 linear
rem   _sRGB.tiff  sRGB
rem %3 dcraw options, eg "-H2".
rem %4:
rem   "transclipHi" makes highlight clipped pixels transparent
rem   "transclipLo" makes shadow clipped pixels transparent
rem   "transclip" makes all clipped pixels transparent
rem %5 Process before first save, eg "-autolevel".
@rem
@rem Updated:
@rem   24-August-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 n2l


set OUTPREF=n2l

if not "%2"=="" if not "%2"=="." set OUTPREF=%2

set DCROPT=%3
if "%DCROPT%"=="." set DCROPT=

set TEST_LO=.
set TEST_HI=.
set TRANSCLIP=0
if /I "%4"=="transclipHi" (
  set TRANSCLIP=1
  set TEST_LO=0
) else if /I "%4"=="transclipLo" (
  set TRANSCLIP=1
  set TEST_HI=0
) else if /I "%4"=="transclip" (
  set TRANSCLIP=1
) else if /I "%4"=="" (
  set TRANSCLIP=0
) else if /I "%4"=="." (
  set TRANSCLIP=0
) else (
  echo Bad transclip [%4]
  exit /B 1
)

set PROC=%5
if "%PROC%"=="." set PROC=

set TMPDIR=\temp\
set TMPFILE=%TMPDIR%%OUTPREF%_n2l.tiff
set CLPMSK=%TMPDIR%%OUTPREF%_tc.tiff

set WHTBAL=-w

%DCRAW% -v -4 %WHTBAL% -o 5 %DCROPT% -T -O %TMPFILE% %INFILE%

rem copy /Y %TMPFILE% n2l.tiff

set DO_MASK=
if %TRANSCLIP%==1 (
  %DCRAW% -v -4 %WHTBAL% -o 0 %DCROPT% -T -O %CLPMSK% %INFILE%

  call %PICTBAT%clip2trans %CLPMSK% %CLPMSK% mask %TEST_LO% %TEST_HI%

  set DO_MASK=%CLPMSK% -alpha off -compose CopyOpacity -composite
)

%IM7DEV%magick ^
  %TMPFILE% ^
  -set colorspace XYZ ^
  -profile %ICCPROF%\Rec2020-elle-v4-g10.icc ^
  %DO_MASK% ^
  %PROC% ^
  -define quantum:format=floating-point ^
  -depth 32 ^
  +write %OUTPREF%_lin.tiff ^
  -profile %ICCPROF%\sRGB-elle-v4-srgbtrc.icc ^
  %OUTPREF%_sRGB.tiff

call echoRestore

@endlocal & set n2lOUTFILE=%OUTFILE%
