rem Given %1 is a white noisy quadrangle on a black backround,
rem %2 is the prefix of an environment variable,
rem calculates the linear regression of the four edges.
rem %3 is outfile.
@rem
@rem Updated:
@rem   22-July-2022 Upgraded for IM v7.
@rem

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

rem @setlocal enabledelayedexpansion

rem @call echoOffSave

@rem This assumes "enabledelayedexpansion" is in effect.
set TESTDEL=abc
if not !TESTDEL!==abc exit /B 1


set nqlr4INFILE=%1

set nqlr4ENV_PREF=%2

set nqlr4OUTFILE=%3
if "%nqlr4OUTFILE%"=="." set nqlr4OUTFILE=
if "%nqlr4OUTFILE%"=="" set nqlr4OUTFILE=NULL:

set EXT=.miff
set TMP_ROT=nqlr4%EXT%

set nqlr4WW=
for /f "usebackq" %%L in (`%IMG7%magick ^
  %nqlr4INFILE% ^
  -format "nqlr4WW=%%w\nnqlr4HH=%%h" ^
  +write info: ^
  -rotate 90 +repage ^
  %TMP_ROT%`) do set %%L

if "%nqlr4WW%"=="" exit /B 1

echo nqlr4WW=%nqlr4WW% nqlr4HH=%nqlr4HH%


:: Do top edge.

call %PICTBAT%nqlrTop %nqlr4INFILE% %nqlr4ENV_PREF%.topLine
if ERRORLEVEL 1 exit /B 1


:: Do left edge.

call %PICTBAT%nqlrTop %TMP_ROT% nqlr4
if ERRORLEVEL 1 exit /B 1

set %nqlr4ENV_PREF%.leftLine.A.x=%nqlr4.A.y%
call :doCalc %nqlr4ENV_PREF%.leftLine.A.y "%nqlr4HH%-1-(%nqlr4.A.x%)"

set %nqlr4ENV_PREF%.leftLine.B.x=%nqlr4.B.y%
call :doCalc %nqlr4ENV_PREF%.leftLine.B.y "%nqlr4HH%-1-(%nqlr4.B.x%)"


:: Do right edge.

%IMG7%magick ^
  %nqlr4INFILE% ^
  -rotate -90 +repage ^
  %TMP_ROT%

call %PICTBAT%nqlrTop %TMP_ROT% nqlr4
if ERRORLEVEL 1 exit /B 1

set %nqlr4ENV_PREF%.rightLine.A.y=%nqlr4.A.x%
call :doCalc %nqlr4ENV_PREF%.rightLine.A.x "%nqlr4WW%-1-(%nqlr4.A.y%)"

set %nqlr4ENV_PREF%.rightLine.B.y=%nqlr4.B.x%
call :doCalc %nqlr4ENV_PREF%.rightLine.B.x "%nqlr4WW%-1-(%nqlr4.B.y%)"


:: Do bottom edge.

%IMG7%magick ^
  %nqlr4INFILE% ^
  -rotate 180 +repage ^
  %TMP_ROT%

call %PICTBAT%nqlrTop %TMP_ROT% nqlr4
if ERRORLEVEL 1 exit /B 1

call :doCalc %nqlr4ENV_PREF%.bottomLine.A.x "%nqlr4WW%-1-(%nqlr4.A.x%)"
call :doCalc %nqlr4ENV_PREF%.bottomLine.A.y "%nqlr4HH%-1-(%nqlr4.A.y%)"

set %nqlr4ENV_PREF%.bottom.B.y=%nqlr4.B.x%
call :doCalc %nqlr4ENV_PREF%.bottomLine.B.x "%nqlr4WW%-1-(%nqlr4.B.x%)"
call :doCalc %nqlr4ENV_PREF%.bottomLine.B.y "%nqlr4HH%-1-(%nqlr4.B.y%)"


set sLINES=^
line ^
!%nqlr4ENV_PREF%.leftLine.A.x!,!%nqlr4ENV_PREF%.leftLine.A.y!,^
!%nqlr4ENV_PREF%.leftLine.B.x!,!%nqlr4ENV_PREF%.leftLine.B.y! ^
line ^
!%nqlr4ENV_PREF%.topLine.A.x!,!%nqlr4ENV_PREF%.topLine.A.y!,^
!%nqlr4ENV_PREF%.topLine.B.x!,!%nqlr4ENV_PREF%.topLine.B.y! ^
line ^
!%nqlr4ENV_PREF%.rightLine.A.x!,!%nqlr4ENV_PREF%.rightLine.A.y!,^
!%nqlr4ENV_PREF%.rightLine.B.x!,!%nqlr4ENV_PREF%.rightLine.B.y! ^
line ^
!%nqlr4ENV_PREF%.bottomLine.A.x!,!%nqlr4ENV_PREF%.bottomLine.A.y!,^
!%nqlr4ENV_PREF%.bottomLine.B.x!,!%nqlr4ENV_PREF%.bottomLine.B.y!

if not "%nqlrOUTFILE%"=="NULL:" (
  %IMG7%magick ^
    %nqlr4INFILE% ^
    -stroke Orange ^
    -draw "%sLINES%" ^
    %nqlr4OUTFILE%
)

exit /B 0

::----------------------------------------------------
:: Subroutine

:doCalc
set %1=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 19 -format "%1=%%[fx:%~2]" ^
  xc:`) do set %%L

rem echo %1 is !%1!

if "!%1!"=="" exit /B 1

exit /B 0
