rem Given %1 is a white noisy quadrangle on a black backround,
rem %2 is the prefix of an environment variable,
rem calculates the linear regression of the top edge.
@rem
@rem Updated:
@rem   22-July-2022 Upgraded for IM v7.
@rem

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

set nqlrtINFILE=%1

set nqlrtENV_PREF=%2

set nqlrtTEMP=nqlrt_clut.miff

:: Don't +repage.
::
for /F "usebackq" %%L in (`%IMG7%magick ^
  %nqlrtINFILE% ^
  -alpha off ^
  -gravity North ^
  -crop x50%%+0+0 ^
-threshold 50%% ^
  -bordercolor Black -border 1 ^
  -trim ^
  -format "nqlrtWW=%%w\nnqlrtHH=%%h\nnqlrtOFFX=%%X-1\nnqlrtOFFY=%%Y-1" ^
  +write info: ^
  +repage ^
  -background Black ^
  -splice 0x1+0+0 ^
  -set colorspace sRGB ^
  -fill Red ^
  -draw "color 0,0 floodfill" ^
  -chop 0x1+0+0 ^
  -fill White -opaque Black ^
  -fill Black -opaque Red ^
  -scale "x1^!" ^
  -alpha off ^
  %nqlrtTEMP%`) do set /A %%L

call %PICTBAT%clut2LinReg %nqlrtTEMP% %nqlrtENV_PREF%
if ERRORLEVEL 1 exit /B 1

call %PICTBAT%linReg2xy %nqlrtENV_PREF% %nqlrtWW%x%nqlrtHH% %nqlrtOFFX% %nqlrtOFFY%
if ERRORLEVEL 1 exit /B 1

exit /B 0