rem Given image %1 is whitish noisy quadrangle on blackish background,
rem find coordinates of the corners.
rem %2 is output image file. Use NULL: if none required.
rem %3 is prefix for environment variable for corner coordinates.
rem %4 is minimum line length.
rem %5 badness threshold for intersection.
@rem
@rem Also uses:
@rem   nqcSTROKE_WIDTH } for output image
@rem   nqcCIRCLE_RAD   }
@rem
@rem This calls edgeLine.bat
@rem
@rem
@rem Updated:
@rem   24-August-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 nqc

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set ENV_PREF=%3
if "%ENV_PREF%"=="." set ENV_PREF=
if "%ENV_PREF%"=="" set ENV_PREF=CORNERS

set MIN_LEN=%4
if "%MIN_LEN%"=="" set MIN_LEN=.

if "%MIN_LEN%"=="." for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "MIN_LEN=%%[fx:int(min(w,h)*0.25)]" ^
  %INFILE%`) do set %%L

set BAD_THRESH=%5
if "%BAD_THRESH%"=="" set BAD_THRESH=.



if "%nqcSTROKE_WIDTH%"=="" set nqcSTROKE_WIDTH=1
set sSTROKEW=-strokewidth %nqcSTROKE_WIDTH%

if "%nqcCIRCLE_RAD%"=="" set nqcCIRCLE_RAD=20

set ENV_LIST=nqcEnv.lis

call %PICTBAT%edgeLine %INFILE% %MIN_LEN% 0 leftLine
if ERRORLEVEL 1 exit /B 1
set leftLine

call %PICTBAT%edgeLine %INFILE% %MIN_LEN% 90 topLine
if ERRORLEVEL 1 exit /B 1
set topLine

call %PICTBAT%edgeLine %INFILE% %MIN_LEN% 180 rightLine
if ERRORLEVEL 1 exit /B 1
set rightLine

call %PICTBAT%edgeLine %INFILE% %MIN_LEN% 270 bottomLine
if ERRORLEVEL 1 exit /B 1
set bottomLine


call %PICTBAT%lineIntersect leftLine topLine %ENV_PREF%.TL %BAD_THRESH%
if ERRORLEVEL 1 exit /B 1

call %PICTBAT%lineIntersect rightLine topLine %ENV_PREF%.TR %BAD_THRESH%
if ERRORLEVEL 1 exit /B 1

call %PICTBAT%lineIntersect leftLine bottomLine %ENV_PREF%.BL %BAD_THRESH%
if ERRORLEVEL 1 exit /B 1

call %PICTBAT%lineIntersect rightLine bottomLine %ENV_PREF%.BR %BAD_THRESH%
if ERRORLEVEL 1 exit /B 1

set %ENV_PREF% >%ENV_LIST%


if not %OUTFILE%==NULL: %IMG7%magick ^
  %INFILE% ^
  -stroke Orange %sSTROKEW% ^
  -fill None ^
  -draw "line %leftLine.A.x%,%leftLine.A.y% %leftLine.B.x%,%leftLine.B.y%" ^
  -draw "line %topLine.A.x%,%topLine.A.y% %topLine.B.x%,%topLine.B.y%" ^
  -draw "line %rightLine.A.x%,%rightLine.A.y% %rightLine.B.x%,%rightLine.B.y%" ^
  -draw "line %bottomLine.A.x%,%bottomLine.A.y% %bottomLine.B.x%,%bottomLine.B.y%" ^
  -draw "translate !%ENV_PREF%.TL.x!,!%ENV_PREF%.TL.y! circle 0,0 0,%nqcCIRCLE_RAD%" ^
  -draw "translate !%ENV_PREF%.TR.x!,!%ENV_PREF%.TR.y! circle 0,0 0,%nqcCIRCLE_RAD%" ^
  -draw "translate !%ENV_PREF%.BL.x!,!%ENV_PREF%.BL.y! circle 0,0 0,%nqcCIRCLE_RAD%" ^
  -draw "translate !%ENV_PREF%.BR.x!,!%ENV_PREF%.BR.y! circle 0,0 0,%nqcCIRCLE_RAD%" ^
  %OUTFILE%

call echoRestore

@endlocal & for /F %%L in (%ENV_LIST%) do @set %%L
