rem Given image %1 and percentage offset (%2,%3),
rem intended range (-50,-50) to (50,50),
rem creates image %4
rem with centre shifted by the offset.
rem Optional %5 %6 %7 %8 %9: extra parameters for magick.
@rem
@rem Updated:
@rem   5-August-2022 for IM v7.
@rem

rem SETLOCAL

FOR /F "tokens=1,2" %%i IN ('%IMG7%magick identify -ping -format "%%w %%h" %1') DO (
  set wi=%%i
  set ht=%%j
)

set opts=%5 %6 %7 %8 %9
rem eg rem -filter Point -interpolate Integer

set /A offX=%2
set /A offY=%3

set /A wim1=%wi%-1
set /A htm1=%ht%-1

set /A cx=%wi%/2
set /A cy=%ht%/2

set /A cxpo=%wi%/2+offX*%wi%/100
set /A cypo=%ht%/2+offY*%ht%/100

echo %cxpo%
echo %cypo%

set pinL=0
set pinT=0
set pinR=0
set pinB=0

if %offX% geq 0 set pinL=1
if %offY% geq 0 set pinT=1
if %offX% leq 0 set pinR=1
if %offY% leq 0 set pinB=1

set /A pinTL=%pinT%+%pinL%
set /A pinTR=%pinT%+%pinR%
set /A pinBL=%pinB%+%pinL%
set /A pinBR=%pinB%+%pinR%

echo %pinTL% %pinTR% %pinBL% %pinBR%

rem We pin the 4 corners, the centre-edges, and the edges at cxpo and cypo.

set pin=%cx%,%cy%,%cxpo%,%cypo%

rem Do corners
if %pinTL% gtr 0 set pin=%pin% 0,0,0,0
if %pinTR% gtr 0 set pin=%pin% %wim1%,0,%wim1%,0
if %pinBL% gtr 0 set pin=%pin% 0,%htm1%,0,%htm1%
if %pinBR% gtr 0 set pin=%pin% %wim1%,%htm1%,%wim1%,%htm1%

rem Do edges
if %pinL% gtr 0 set pin=%pin% 0,%cypo%,0,%cypo% 0,%cy%,0,%cy%
if %pinT% gtr 0 set pin=%pin% %cxpo%,0,%cxpo%,0 %cx%,0,%cx%,0
if %pinR% gtr 0 set pin=%pin% %wim1%,%cypo%,%wim1%,%cypo% %wim1%,%cy%,%wim1%,%cy%
if %pinB% gtr 0 set pin=%pin% %cxpo%,%htm1%,%cxpo%,%htm1% %cx%,%htm1%,%cx%,%htm1%

echo %pin%

%IMG7%magick ^
  %1 ^
  %opts% ^
  -distort Shepards ^"%pin%^" ^
  %4

rem ENDLOCAL
