rem Given image %1 in any colorspace,
rem colours %2 and %3 in same colorspace,
rem makes same size output:
rem   black where pixels were within colorspace defined by the colours,
rem   otherwise white.
rem Output to %4.
rem
rem Needs HDRI.
@rem
@rem Updated:
@rem   21-August-2022 Upgraded for IM v7.
@rem

for /F "usebackq skip=1 tokens=1,6 delims=,:() " %%A in (`%IMG7%magick ^
  xc:%2 ^
  xc:%3 ^
  ^( -clone 0-1 ^
     -evaluate-sequence min ^
  ^) ^
  ^( -clone 0-1 ^
     -evaluate-sequence max ^
  ^) ^
  -delete 0-1 ^
  ^( -clone 0-1 ^
     -compose MinusDst -composite ^
  ^) ^
  +append ^
  txt:`) do (
  echo %%A %%B

  set COL_%%A=%%B
)

%IMG7%magick ^
  -define compose:clamp=off ^
  %1 ^
  ( +clone ^
    -fill %COL_0% -colorize 100 ) ^
  -compose MinusSrc -composite ^
  ( +clone ^
    -fill %COL_2% -colorize 100 ) ^
  -compose Divide_Src -composite ^
  -verbose ^
  +depth ^
  +write info: ^
  ( +clone -clamp ) ^
  -compose Difference -composite ^
  -fill White +opaque Black ^
  %4
