@rem From %1, a floating-point image that may contain values out of 0 to 100%,
@rem makes output %2 with all values within 0 to 100%.
@rem %3 limit for lower transformation.
@rem %4 limit for upper transformation.
@rem
@rem Assumes "magick" is HDRI.
@rem
@rem Updated:
@rem   6-August-2022 for IM v7
@rem


@if [%1]==[] findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

rem call %PICTBAT%setInOut %1 olin


set INFILE=%~1

set OUTFILE=%2
if "%OUTFILE%"=="." set OUTFILE=
if "%OUTFILE%"=="" set OUTFILE=NULL:

set P0=%3
if "%P0%"=="." set P0=
if "%P0%"=="" set P0=0.1

set P1=%4
if "%P1%"=="." set P1=
if "%P1%"=="" set P1=0.9

set X0=
for /F "usebackq" %%L in (`%IM7DEV%magick ^
  %INFILE% ^
  -precision 16 ^
  -format "X0=%%[fx:minima]\nX1=%%[fx:maxima]\n" ^
  info:`) do set %%L
if "%X0%"=="" exit /B 1

:: FIXME: if X0 > -epsilon, don't calc a and b.
:: FIXME: if X1 < 1+epsilon, don't calc c and d.

set DO_LO=0
set DO_HI=0

set EPS=1e-5

set FMT=^
DO_LO=%%[fx:%X0%^<-%EPS%?1:0]\n^
DO_HI=%%[fx:%X1%^>1+%EPS%?1:0]\n

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "%FMT%" ^
  xc:`) do set %%L

set FMT=^
a=%%[fx:(-%P0%)/(%X0%-(%P0%))]\n^
b=%%[fx:%P0%*(%X0%)/(%X0%-(%P0%))]\n

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 16 ^
  -format "%FMT%" ^
  xc:`) do set %%L

set FMT=^
c=%%[fx:(1-%P1%)/(%X1%-%P1%)]\n^
d=%%[fx:%P1%*(%X1%-1)/(%X1%-%P1%)]\n

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 16 ^
  -format "%FMT%" ^
  xc:`) do set %%L


echo P0=%P0% P1=%P1%
echo DO_LO=%DO_LO% DO_HI=%DO_HI%
echo X0=%X0% X1=%X1%
echo a=%a% b=%b% c=%c% d=%d%

goto skip

%IM7DEV%magick ^
  %INFILE% ^
  ( -clone 0 ^
    -function Polynomial %c%,%d% ^
  ) ^
  ( -clone 0 ^
    -function Polynomial %a%,%b% ^
  ) ^
  ( -clone 0,1 ^
    -compose Darken -composite ^
  ) ^
  -delete 0,1 ^
  -compose Lighten -composite ^
  -depth 32 ^
  -define quantum:format=floating-point ^
  %OUTFILE%

:skip

set POLY_HI=
set POLY_LO=

if %DO_HI%==1 set POLY_HI=^
  ( -clone 0 ^
    -function Polynomial %c%,%d% ^
  ) ^
  -compose Darken -composite

if %DO_LO%==1 set POLY_LO=^
  ( -clone 0 ^
    -function Polynomial %a%,%b% ^
  ) ^
  -compose Lighten -composite

%IMG7%magick ^
  %INFILE% ^
  -define compose:clamp=off ^
  %POLY_HI% ^
  %POLY_LO% ^
  -depth 32 ^
  -define quantum:format=floating-point ^
  %OUTFILE%


call echoRestore

@endlocal & set olinOUTFILE=%OUTFILE%
