@rem Applies oogLinear independently to three channels.
@rem Assumes "magick" is HDRI.
@rem
@rem Updated:
@rem   6-August-2022 for IM v7
@rem

@if [%1]==[] findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

rem call %PICTBAT%setInOut %1 olin


set INFILE=%~1

set OUTFILE=%2
if "%OUTFILE%"=="." set OUTFILE=
if "%OUTFILE%"=="" set OUTFILE=NULL:

set P0=%3
if "%P0%"=="." set P0=
if "%P0%"=="" set P0=0.1

set P1=%4
if "%P1%"=="." set P1=
if "%P1%"=="" set P1=0.9

set TMP_FILE=\temp\ooglin3_%%d.miff
set TMP0=\temp\ooglin3_0.miff
set TMP1=\temp\ooglin3_1.miff
set TMP2=\temp\ooglin3_2.miff


for /F "usebackq" %%L in (`%IMG7%magick ^
  %INFILE% ^
  -format "COLSP=%%[colorspace]\n" ^
  +write info: ^
  -channel RGB ^
  -separate ^
  +channel ^
  -depth 32 ^
  -define "quantum:format=floating-point" ^
  +adjoin ^
  %TMP_FILE%`) do set %%L

call %PICTBAT%oogLinear %TMP0% %TMP0% %P0% %P1%
if ERRORLEVEL 1 exit /B 1
call %PICTBAT%oogLinear %TMP1% %TMP1% %P0% %P1%
if ERRORLEVEL 1 exit /B 1
call %PICTBAT%oogLinear %TMP2% %TMP2% %P0% %P1%
if ERRORLEVEL 1 exit /B 1

%IMG7%magick ^
  %TMP0% %TMP1% %TMP2% ^
  -combine ^
  -set colorspace %COLSP% ^
  -depth 32 ^
  -define "quantum:format=floating-point" ^
  %OUTFILE%

call echoRestore

@endlocal & set olinOUTFILE=%OUTFILE%
