@rem From %1, a floating-point image that may contain values out of 0 to 100%,
@rem makes output %2 with all values within 0 to 100%.
@rem %3 limit for lower transformation.
@rem %4 limit for upper transformation.
@rem
@rem Note that "-process oogbox' is much faster.
@rem
@rem Assumes "magick" is HDRI.
@rem
@rem Updated:
@rem   6-August-2022 for IM v7
@rem


@if [%1]==[] findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

rem call %PICTBAT%setInOut %1 opow


set INFILE=%~1

set OUTFILE=%2
if "%OUTFILE%"=="." set OUTFILE=
if "%OUTFILE%"=="" set OUTFILE=NULL:

set P0=%3
if "%P0%"=="." set P0=
if "%P0%"=="" set P0=0.1

set P1=%4
if "%P1%"=="." set P1=
if "%P1%"=="" set P1=0.9

set X0=
for /F "usebackq" %%L in (`%IMG7%magick ^
  %INFILE% ^
  -precision 16 ^
  -format "X0=%%[fx:minima]\nX1=%%[fx:maxima]\n" ^
  info:`) do set %%L
if "%X0%"=="" exit /B 1

set DO_LO=0
set DO_HI=0

set EPS=1e-5

set FMT=^
DO_LO=%%[fx:%X0%^<-%EPS%?1:0]\n^
DO_HI=%%[fx:%X1%^>1+%EPS%?1:0]\n

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "%FMT%" ^
  xc:`) do set %%L

set FMT=^
B0=%%[fx:(%P0%-(%X0%))/(%P0%)]\n^
B1=%%[fx:(%X1%-(%P1%))/(1-(%P1%))]\n

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 16 ^
  -format "%FMT%" ^
  xc:`) do set %%L

if ERRORLEVEL 1 exit /B 1

set FMT=^
A0=%%[fx:(%P0%)/pow(%P0%-(%X0%),%B0%)]\n^
A1=%%[fx:(1-%P1%)/pow(%X1%-%P1%,%B1%)]\n

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 16 ^
  -format "%FMT%" ^
  xc:`) do set %%L


echo P0=%P0% P1=%P1%
echo DO_LO=%DO_LO% DO_HI=%DO_HI%
echo X0=%X0% X1=%X1%
echo A0=%A0% B0=%B0% A1=%A1% B1=%B1%

:: Only do each end if OOG.

set DO_BOTH=0
if %DO_LO%==1 if %DO_HI%==1 set DO_BOTH=1

if %DO_BOTH%==1 (
  set "sFX=u<%P0%?%A0%*pow(u-(%X0%),%B0%):u>%P1%?1-%A1%*pow(%X1%-u,%B1%):u"
) else if %DO_LO%==1 (
  set "sFX=u<%P0%?%A0%*pow(u-(%X0%),%B0%):u"
) else if %DO_HI%==1 (
  set "sFX=u>%P1%?1-%A1%*pow(%X1%-u,%B1%):u"
) else (
  set sFX=u
)

%IMG7%magick ^
  %INFILE% ^
  -precision 16 ^
  -fx "%sFX%" ^
  -clamp ^
  -depth 32 ^
  -define quantum:format=floating-point ^
  -format "min=%%[fx:minima]  max=%%[fx:maxima]\n" ^
  +write info: ^
  %OUTFILE%

call echoRestore

@endlocal & set opowOUTFILE=%OUTFILE%
