rem From image(s) %1 (eg *.jpg), creates orientated versions.
rem exiftool tells us the orientation.
rem jpegtran does the work.
@rem
@rem Updated:
@rem   13-August-2022 for IM v7.
@rem

rem @echo off
setlocal enabledelayedexpansion

if "%1"=="" goto Bad

set JT=

rem For each file that needs re-orienting:
rem   copy it to .\backup
rem   %JT%jpegtran from .\backup to here
rem   exiftool copy all the tags from .\backup to here, changing the orientation to 1.


rem Note: filenames containing commas might cause problems.

set TMPFILE=%TEMP%\orient.jpg

exiftool -p "$FileName,$Orientation#" %1>orient.lis

type orient.lis

rem 1 Horizontal (normal)
rem 2 Mirror horizontal
rem 3 Rotate 180
rem 4 Mirror vertical
rem 5 Mirror horizontal and rotate 270 CW
rem 6 Rotate 90 CW
rem 7 Mirror horizontal and rotate 90 CW
rem 8 Rotate 270 CW

rem Note: untested for all values except 1, 6 and 8.

if not exist backup md backup

for /F "tokens=1,2 delims=," %%a ^
in (orient.lis) ^
do (
  set FileName=%%a
  set /A Orient=%%b
  if !Orient! gtr 1 (
    copy /Y !FileName! backup\
    exiftool -n -Orientation=1 backup\!FileName!
  )
  set ERR=0
  if !Orient! equ 2 (
    echo !FileName! !Orient! flip horizontal
    %JT%jpegtran -perfect -flip horizontal -outfile !FileName! backup\!FileName!
    if ERRORLEVEL 1 %IMG7%magick backup\!FileName! -flop !FileName!
  ) else if !Orient! equ 3 (
    echo !FileName! !Orient! rotate 180
    %JT%jpegtran -perfect -rotate 180 -outfile !FileName! backup\!FileName!
    if ERRORLEVEL 1 %IMG7%magick backup\!FileName! -rotate 180 !FileName!
  ) else if !Orient! equ 4 (
    echo !FileName! !Orient! flip vertical
    %JT%jpegtran -perfect -flip vertical -outfile !FileName! backup\!FileName!
    if ERRORLEVEL 1 %IMG7%magick backup\!FileName! -flip !FileName!
  ) else if !Orient! equ 5 (
    echo !FileName! !Orient! flip horizontal, rotate 270
    %JT%jpegtran -perfect -flip horizontal -outfile %TMPFILE% backup\!FileName!
    if ERRORLEVEL 1 set ERR=1
    if !ERR!==0 (
      %JT%jpegtran -perfect -rotate 270 -outfile !FileName! %TMPFILE%
      if ERRORLEVEL 1 set ERR=1
    )
    if !ERR!==1 %IMG7%magick backup\!FileName! -rotate 90 -flop !FileName!
  ) else if !Orient! equ 6 (
    echo !FileName! !Orient! rotate 90
    %JT%jpegtran -perfect -rotate 90 -outfile !FileName! backup\!FileName!
    if ERRORLEVEL 1 %IMG7%magick backup\!FileName! -rotate 90 !FileName!
  ) else if !Orient! equ 7 (
    echo !FileName! !Orient! flip horizontal, rotate 90
    %JT%jpegtran -perfect -flip horizontal -outfile %TMPFILE% backup\!FileName!
    if ERRORLEVEL 1 set ERR=1
    if !ERR!==0 (
      %JT%jpegtran -perfect -rotate 90 -outfile !FileName! %TMPFILE%
      if ERRORLEVEL 1 set ERR=1
    )
    if !ERR!==1 %IMG7%magick backup\!FileName! -rotate -90 -flop !FileName!
  ) else if !Orient! equ 8 (
    echo !FileName! !Orient! rotate 270
    %JT%jpegtran -perfect -rotate 270 -outfile !FileName! backup\!FileName!
    if ERRORLEVEL 1 %IMG7%magick backup\!FileName! -rotate -90 !FileName!
  )
  if !Orient! gtr 1 (
    exiftool -tagsFromFile backup\!FileName! -n -Orientation=1 !FileName!
    del !FileName!_original
  )
)

if exist backup\*.jp* (
  echo Original files are in .\backup
) else (
  echo Removing possibly empty backup directory.
  rd backup
)

goto :end


:Bad
echo Call with %%1=filename
echo %%1 can contain wilcards, eg *.jpg

:end
endlocal
@echo on
