rem %1 input image
rem %2 output image
rem %3 blur operation, eg "-blur 0x20"
rem %4 sharpen operation, eg "-unsharp 0x2"
rem %5 combine operation between blur and sharpen, eg "-evaluate-sequence Mean"
rem %6 mask for final blend, eg None or an image or percentage effect, eg mpr:INP -colorspace Gray -negate -auto-level
rem   Mask should usually start with "+clone" or "mpr:INP".
rem %7 filename for debug output files, must include XX. Default: no debug files.

@rem Also uses:
@rem   OrtColSpIn
@rem   OrtColSpOut

set INFILE=%1
set OUTFILE=%2

set BlurOp=%~3
if "%BlurOp%"=="." set BlurOp=

set ShpOp=%~4
if "%ShpOp%"=="." set ShpOp=

set CombineOp=%~5
if "%CombineOp%"=="." set CombineOp=
if "%CombineOp%"=="" set CombineOp=-evaluate-sequence Mean -auto-level

set Mask=%~6
if "%Mask%"=="." set Mask=

set DbgFmt=%7
if "%DbgFmt%"=="." set DbgFmt=

if "%DbgFmt%"=="" (
  set WrBlr=
  set WrShp=
  set WrMsk=
) else (
  if "%OrtColSpOut%"=="" (
    set WrBlr=+write %DbgFmt:XX=blr%
    set WrShp=+write %DbgFmt:XX=shp%
    set WrMsk=+write %DbgFmt:XX=msk%
  ) else (
    set WrBlr=^( +clone %OrtColSpOut% -write %DbgFmt:XX=blr% +delete ^)
    set WrShp=^( +clone %OrtColSpOut% -write %DbgFmt:XX=shp% +delete ^)
    set WrMsk="(" +clone %OrtColSpOut% -write %DbgFmt:XX=msk% +delete ")"
  )
)

if "%Mask%"=="" (
  set sMask=
) else (
  set sMask=mpr:INP +swap ^( %Mask%  %WrMsk% ^) -compose Over -composite
)


%IMG7%magick ^
  %INFILE% ^
  %OrtColSpIn% ^
  -write mpr:INP ^
  -set option:MYSIZE %%wx%%h ^
  -define compose:clamp=off ^
  %BlurOp% ^
  %WrBlr% ^
  ( mpr:INP %ShpOp% %WrShp% ) ^
  %CombineOp% ^
  %sMask% ^
  %OrtColSpOut% ^
  %OUTFILE%

if ERRORLEVEL 1 exit /B 1

exit /B 0