rem Parses %4, default %1 and %2. Returns %3_X and %3_Y.
@rem
@rem %1 and %2 can be expressions such as "600-1".
@rem
@rem %4 is one of these formats:
@rem   {blank}
@rem   .
@rem   {number}
@rem   {number}x
@rem   x{number}
@rem   {number}x{number}
@rem
@rem Each number can be suffixed with %, c or p or C or P.
@rem
@rem Updated:
@rem   4-October-2022 for IM v7.
@rem   20-August-2023 Put %1 and %2 in parentheses so they can be expressions.
@rem

@set pxxy=%4
@set pxxyFirst=%pxxy:~0,1%
@rem echo pxxyFirst=%pxxyFirst%

@if "%pxxyFirst%"=="x" set pxxy=%1%pxxy%

@if "%pxxy%"=="." set pxxy=
@if "%pxxy%"=="" set pxxy=%1x%2

@for /F "usebackq tokens=1-2 delims=xX" %%X in ('%pxxy%') do @(
  @rem echo %%X,%%Y
  @set pxxyX=%%X
  @set pxxyY=%%Y
)
@if "%pxxyY%"=="" set pxxyY=%2


set CH_LAST=%pxxyX:~-1%

if "%CH_LAST%"=="^%" set CH_LAST=c

if /I "%CH_LAST%"=="c" (
  for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -precision 19 ^
    -format "pxxyX=%%[fx:(%1)*%pxxyX:~0,-1%/100]" ^
    xc:`) do set %%L

) else if /I "%CH_LAST%"=="p" (
  for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -precision 19 ^
    -format "pxxyX=%%[fx:(%1)*%pxxyX:~0,-1%]" ^
    xc:`) do set %%L
)


set CH_LAST=%pxxyY:~-1%

if "%CH_LAST%"=="^%" set CH_LAST=c

if /I "%CH_LAST%"=="c" (
  for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -precision 19 ^
    -format "pxxyY=%%[fx:(%2)*%pxxyY:~0,-1%/100]" ^
    xc:`) do set %%L

) else if /I "%CH_LAST%"=="p" (
  for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -precision 19 ^
    -format "pxxyY=%%[fx:(%2)*%pxxyY:~0,-1%]" ^
    xc:`) do set %%L
)


@rem echo pxxyX=%pxxyX% pxxyY=%pxxyY%

set %3_X=%pxxyX%
set %3_Y=%pxxyY%
