rem Given %1 is an image
rem %2 is name of output from skel2Parts from skeleton of %1
rem makes %3 output name.
@rem
@rem Updated:
@rem   6-August-2022 for IM v7.
@rem   27-September-2022 insert "-set colorspace sRGB" twice.
@rem

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 p2fc

set FILE_FMT=%2

if not "%3"=="" if not "%3"=="." set OUTFILE=%3

for /F %%F in ("%FILE_FMT%") do (
  set IMG_COMPST=%%~nF_compst%%~xF
  set IMG_COMPSF=%%~nF_compsf%%~xF
  set IMG_GRAYS=%%~nF_grays%%~xF
  set IMG_2XN=%%~nF_2xn%%~xF

  set TMP_SCRA=%%~nF_p2fca.scr
  set TMP_SCRB=%%~nF_p2fcb.scr
)

del %IMG_2XN% 2>nul

echo ^
  %IMG_COMPSF% -set colorspace sRGB ^
  ( %INFILE% -colorspace RGB ) ^
  +write mpr:IMGS -delete 0-1 ^
  -fill White -background Black >%TMP_SCRA%

for /F "usebackq skip=1 tokens=3" %%C in (`%IMG7%magick ^
  %IMG_GRAYS% ^
  txt:`) do (
  echo %%C

  echo ^( ^
mpr:IMGS[0] ^
+transparent "%%C" ^
-colorize 100 ^
-compose Over -layers flatten ^
mpr:IMGS[1] ^
+swap ^
-alpha off ^
-compose CopyOpacity -composite -scale "1x1^!" +depth ^) >>%TMP_SCRA%
)

echo -alpha off -append +repage ( %IMG_GRAYS% -rotate 90 ) +swap -colorspace sRGB +append +repage +depth >>%TMP_SCRA%

rem type %TMP_SCRA%

:: Next is okay for v6. But v7 needs "-script".
:: %IM%convert @%TMP_SCRA% %IMG_2XN%

echo -write %IMG_2XN% -exit >>%TMP_SCRA%
%IMG7%magick -script %TMP_SCRA%

if not exist %IMG_2XN% (
  echo %0: IMG_2XN [%IMG_2XN%] not created
  exit /B 1
)

%IMG7%magick identify %IMG_2XN%


echo %IMG_COMPSF% -set colorspace sRGB >%TMP_SCRB%

set HasTrans=0
for /F "usebackq skip=1 tokens=3" %%C in (`%IMG7%magick ^
  %IMG_2XN% ^
  txt:`) do (
  rem echo %%C
  if !HasTrans!==0 (
    set HasTrans=1
    set GRAY=%%C
  ) else (
    set HasTrans=0
    echo !GRAY! to %%C
    echo -fill "%%C" -opaque "!GRAY!" >>%TMP_SCRB%
  )
)

if %HasTrans%==1 (
  echo HasTrans=%HasTrans%
  exit /B 1
)

rem type %TMP_SCRB%

echo %0: TMP_SCRB=%TMP_SCRB%

:: Next is okay for v6. But v7 needs "-script".
:: %IM%convert @%TMP_SCRB% %OUTFILE%

echo -write %OUTFILE% -exit >>%TMP_SCRB%
%IMG7%magick -script %TMP_SCRB%


call echoRestore

endlocal & set p2fcOUTFILE=%OUTFILE%
