rem Finds the failed nearest-neighbour rate of the MP7 dataset by FFT rotation.
rem
rem %1 is the NxM cumulative image to be searched.
rem %2 is the directory of the Nx1 images.
@rem
@rem Updated:
@rem   2-October-2022 for IM v7.
@rem

if "%2"=="" exit /B 1

setlocal enabledelayedexpansion

set BIG_IMG=%1
set SML_IMG_DIR=%2

call %PICTBAT%setMp7Env

set Wm1=
for /F "usebackq" %%L in (`%IMG7%magick identify -format "Wm1=%%[fx:w-1]" %BIG_IMG%`) do set %%L
if "%Wm1%"=="" exit /B 1


set N_MAT=0
set nErrNMLo=0
set hiMat=0
set loNonMat=9999

for /F "tokens=1,2 delims=, " %%A in (%IMG_NDX%) do (

  call %PICTBAT%srchMp7 %BIG_IMG% %SML_IMG_DIR%\%%B%DATAEXT% nnfrFnd %%A %Wm1%

  for /F "usebackq tokens=2 delims=, " %%N in (`cSelect ^
    /p0 /i%IMG_NDX% /o- /k0 /w!nnfrFnd.ndx!`) do set NBR_NAME=%%N

  for /F "delims=-" %%T in ("%%B") do set THIS_NAME=%%T
  for /F "delims=-" %%T in ("!NBR_NAME!") do set NBR_NAME=%%T

  echo %%A %%B [!THIS_NAME!] nearest neighbour is !nnfrFnd.ndx!  RMSE=!nnfrFnd.rmse! NBR_NAME=!NBR_NAME!

  if !THIS_NAME! EQU !NBR_NAME! (
    set /A N_MAT+=1

    for /F "usebackq" %%L in (`%IMG7%magick identify ^
      -format "hiMat=%%[fx:!hiMat!<!nnfrFnd.rmse!?!nnfrFnd.rmse!:!hiMat!]" ^
      xc:`) do set %%L

  ) else (
    set /A nErrNMLo+=1

    for /F "usebackq" %%L in (`%IMG7%magick identify ^
      -format "loNonMat=%%[fx:!loNonMat!>!nnfrFnd.rmse!?!nnfrFnd.rmse!:!loNonMat!]" ^
      xc:`) do set %%L

  )

  echo N_MAT=!N_MAT! nErrNMLo=!nErrNMLo! hiMat=!hiMat! loNonMat=!loNonMat!
)

echo N_MAT=%N_MAT% nErrNMLo=%nErrNMLo% hiMat=%hiMat% loNonMat=%loNonMat%

endlocal
