rem Creates output CSV files with best results.
rem %1 is name format, must contain XX.
rem XX will be replaced with 1, 2, 3 or 4.

setlocal

call %PICTBAT%setPhEnv

set OUT_FMT=%1

set USE_COLS=threshold,truePos,trueNeg,falsePos,falseNeg,FPrate,FNrate,FPFN,MCC,colorspace

rem ------------------------------------------------
rem One colorspace.

goto skip1

set OUTFILE=%OUT_FMT:XX=1%

del phbest21*.csv 2>nul

for %%C in (%COLSPACES%) do (
  call %PICTBAT%phCombin %%C
  if ERRORLEVEL 1 exit /B 1

  set INCSV=%PH_CSVDIR%\idPh!PH_COMBIN!.csv

  set OUTCSV=phbest!PH_COMBIN!.csv

  call %PICTBAT%phpThreshCsvBest !INCSV! !OUTCSV! !PH_PLUS!
  if ERRORLEVEL 1 exit /B 1
)

cat phbest21*.csv >%OUTFILE%

cSort    /p0 /i%OUTFILE% /o%OUTFILE% /u /r
cProject /p0 /i%OUTFILE% /o%OUTFILE% /h /k%USE_COLS%
cSort    /p0 /i%OUTFILE% /o%OUTFILE% /h /kMCC /r

type %OUTFILE%

:skip1


rem ------------------------------------------------
rem Combinations of two colorspaces.

goto skip2

set OUTFILE=%OUT_FMT:XX=2%

del phbest42*.csv 2>nul

for %%C in (%COLSPACES%) do (
  for %%D in (%COLSPACES%) do (
    if /I %%C LSS %%D (

      call %PICTBAT%phCombin %%C %%D
      if ERRORLEVEL 1 exit /B 1

      set INCSV=%PH_CSVDIR%\idPh!PH_COMBIN!.csv

      set OUTCSV=phbest!PH_COMBIN!.csv

      call %PICTBAT%phpThreshCsvBest !INCSV! !OUTCSV! !PH_PLUS!
      if ERRORLEVEL 1 exit /B 1
    )
  )
)

cat phbest42*.csv >%OUTFILE%

cSort /p0 /i%OUTFILE% /o%OUTFILE% /u /r
cSort /p0 /i%OUTFILE% /o%OUTFILE% /h /kMCCzero

cProject /p0 /i%OUTFILE% /o%OUTFILE% /h /k%USE_COLS%

type %OUTFILE%

:skip2


rem ------------------------------------------------
rem Combinations of three colorspaces.

goto skip3

set OUTFILE=%OUT_FMT:XX=3%

del phbest63*.csv 2>nul

for %%C in (%COLSPACES%) do (
  for %%D in (%COLSPACES%) do (
    if /I %%C LSS %%D (
      for %%E in (%COLSPACES%) do (
        if /I %%D LSS %%E (

          call %PICTBAT%phCombin %%C %%D %%E
          if ERRORLEVEL 1 exit /B 1

          set INCSV=%PH_CSVDIR%\idPh!PH_COMBIN!.csv

          set OUTCSV=phbest!PH_COMBIN!.csv

          call %PICTBAT%phpThreshCsvBest !INCSV! !OUTCSV! !PH_PLUS!
          if ERRORLEVEL 1 exit /B 1
        )
      )
    )
  )
)

cat phbest63*.csv >%OUTFILE%

cSort /p0 /i%OUTFILE% /o%OUTFILE% /u /r
cSort /p0 /i%OUTFILE% /o%OUTFILE% /h /kMCCzero

cProject /p0 /i%OUTFILE% /o%OUTFILE% /h /k%USE_COLS%

type %OUTFILE%

:skip3

rem ------------------------------------------------
rem Combinations of four colorspaces.

rem goto skip4

set OUTFILE=%OUT_FMT:XX=4%

del phbest84*.csv 2>nul

for %%C in (%COLSPACES%) do (
  for %%D in (%COLSPACES%) do (
    if /I %%C LSS %%D (
      for %%E in (%COLSPACES%) do (
        if /I %%D LSS %%E (
          for %%F in (%COLSPACES%) do (
            if /I %%E LSS %%F (

              call %PICTBAT%phCombin %%C %%D %%E %%F
              if ERRORLEVEL 1 exit /B 1

              set INCSV=%PH_CSVDIR%\idPh!PH_COMBIN!.csv

              set OUTCSV=phbest!PH_COMBIN!.csv

              call %PICTBAT%phpThreshCsvBest !INCSV! !OUTCSV! !PH_PLUS!
              if ERRORLEVEL 1 exit /B 1
            )
          )
        )
      )
    )
  )
)

cat phbest84*.csv >%OUTFILE%

cSort /p0 /i%OUTFILE% /o%OUTFILE% /u /r
cSort /p0 /i%OUTFILE% /o%OUTFILE% /h /kMCCzero

cProject /p0 /i%OUTFILE% /o%OUTFILE% /h /k%USE_COLS%

type %OUTFILE%

:skip4


endlocal
