rem From image %1, mask %2, prefix %3, initial colour %4, %5 frames >=2,
rem makes frames of image revealed by the mask.
@rem
@rem First frame will be entirely initial colour;
@rem last frame will be entirely image.
@rem
@rem Also uses:
@rem   pmrOVERLAP
@rem
@rem Updated:
@rem   14-August-2020 for IM v7.
@rem

@if "%5"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave


set INFILE=%1
set EXT=%~x1
set MASK=%2
set PREFIX=%3
set INIT_COL=%4
set nFRAMES=%5

if %nFRAMES% LSS 2 exit /B 1

set /A nFRAMESm1=%nFRAMES%-1

set EXTPREF=
if /I %EXT%==.png set EXTPREF=PNG24:

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "INTVL=%%[fx:100/%nFRAMESm1%]\nINTVL_2=%%[fx:50/%nFRAMESm1%]" ^
  xc:`) do set %%L

for /L %%i in (0,1,%nFRAMESm1%) do (

  set LZ=00000%%i
  set LZ=!LZ:~-6!

  for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -format "THRESHpc=%%[fx:100-%INTVL%*%%i]\nLEV1=%%[fx:100-%INTVL%*(%%i+0.5)]\nLEV2=%%[fx:100-%INTVL%*(%%i-0.5)]" ^
    xc:`) do set %%L

  echo %%i !LZ! THRESHpc=!THRESHpc! LEV1=!LEV1! LEV2=!LEV2!

  if %%i==0 (
    set THRESH=-evaluate set 0
  ) else if %%i==%nFRAMESm1% (
    set THRESH=-evaluate set 100%%
  ) else (
    set THRESH=-level !LEV1!,!LEV2!%%
  )

  %IMG7%magick ^
    %INFILE% ^
    ^( +clone -fill %INIT_COL% -colorize 100 ^) ^
    +swap ^
    ^( %MASK% ^
      !THRESH! ^
    ^) ^
    -composite ^
    -type Truecolor ^
    %EXTPREF%%PREFIX%_!LZ!%EXT%
)


call echoRestore

endlocal
