@rem
@rem Updated:
@rem   5-October-2022 for IM v7.
@rem

if "%IMCROP%"=="" (
  echo IMCROP not set
  exit /B 1
)

setlocal enabledelayedexpansion

set START=1
set END=72

set FRAMES=%START%..%END%
set FILEPREF=c:\tmp\pntp

del %FILEPREF%_*.png
del %FILEPREF%_*.miff

%BLENDER% -b ^
  %BLUSR%pntp1.blend ^
  -P setsize.py ^
  -x 1 ^
  -o %FILEPREF%_null_######.png ^
  -f %FRAMES%

if ERRORLEVEL 1 exit /B 1

%BLENDER% -b ^
  %BLUSR%pntp1.blend ^
  -P setsize.py ^
  -P setshirtwt.py ^
  -x 1 ^
  -o %FILEPREF%_ord_######.png ^
  -f %FRAMES%

if ERRORLEVEL 1 exit /B 1

%BLENDER% -b ^
  %BLUSR%pntp1.blend ^
  -P setsize.py ^
  -P setbackblack.py ^
  -P setobjblack.py ^
  -P setshirtwt.py ^
  -P setshadeless.py ^
  -x 1 ^
  -o %FILEPREF%_mask_######.png ^
  -f %FRAMES%

if ERRORLEVEL 1 exit /B 1

%BLENDER% -b ^
  %BLUSR%pntp1.blend ^
  -P setsize.py ^
  -P setbackblack.py ^
  -P setobjblack.py ^
  -P setshirtwt.py ^
  -P setshadeless.py ^
  -P setshirtmap.py ^
  -P setnoantialias.py ^
  -x 1 ^
  -o %FILEPREF%_dispmap_######.png ^
  -f %FRAMES%

if ERRORLEVEL 1 exit /B 1

%BLENDER% -b ^
  %BLUSR%pntp1.blend ^
  -P setsize.py ^
  -P setbackblack.py ^
  -P setobjblack.py ^
  -P setshirtwt.py ^
  -P setshirthigh.py ^
  -x 1 ^
  -o %FILEPREF%_high_######.png ^
  -f %FRAMES%

if ERRORLEVEL 1 exit /B 1


pushd c:\tmp

:: We crop all except the _null images.

%IMG7%magick mogrify -format miff pntp_null_*.png
%IMG7%magick mogrify %IMCROP% -format miff pntp_ord_*.png
%IMG7%magick mogrify %IMCROP% -format miff pntp_mask_*.png
%IMG7%magick mogrify %IMCROP% -evaluate max 50%% -format miff pntp_high_*.png
%IMG7%magick mogrify %IMCROP% -format miff pntp_dispmap_*.png

:: Extend the dispmap slightly into the black.

for /L %%I in (%START%,1,%END%) do (
  set LZ=000000%%I
  set LZ=!LZ:~-6!
  echo LZ=!LZ!

  %IMG7%magick ^
    pntp_dispmap_!LZ!.miff ^
    -transparent Black ^
    ^( +clone ^
       -blur 0x0.5 ^
       -channel A -threshold 90%% +channel ^
    ^) ^
    -compose DstOver -composite ^
    -background Black ^
    -compose Over -layers Flatten ^
    pntp_dispmap_!LZ!.miff
)


popd

