rem Given %1 is text file containing integer coordinates separated by comma and optional spaces,
rem   one point per line,
rem outputs lines to text file %2 (can be same name as %1)
rem %3 is a floating-point poximity threshold,
rem   finds all pairs of points that are less than or equal to the given threshold.
@rem
@rem Updated:
@rem   2-October-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave


set INFILE=%1

if not exist %INFILE% exit /B 1



set OUTFILE=%2
if "%OUTFILE%"=="." set OUTFILE=
if "%OUTFILE%"=="" set OUTFILE=pd.lis


set GAP_LIMIT=%3
if "%GAP_LIMIT%"=="." set GAP_LIMIT=
if "%GAP_LIMIT%"=="" set GAP_LIMIT=10

rem type %INFILE%

set II=0
for /F "tokens=1,2 delims=, " %%X in (%INFILE%) do (
  rem echo %%X,%%Y
  set lineEnd[!II!].x=%%X
  set lineEnd[!II!].y=%%Y
  set /A II+=1
)

set /A numPnts=%II%
set /A lastEnd=%II%-1
set /A lastEndm1=%II%-2

rem set lineEnd

(for /L %%A in (0,1,%lastEnd%m1) do (
  set nA=%%A
  set /A X0=lineEnd[!nA!].x
  set /A Y0=lineEnd[!nA!].y
  set /A firstB=%%A+1

  for /L %%B in (!firstB!,1,%lastEnd%) do (
    set nB=%%B
    set /A X1=lineEnd[!nB!].x
    set /A Y1=lineEnd[!nB!].y

    rem echo !X0!,!Y0!, !X1!,!Y1!

    for /F "usebackq" %%L in (`%IMG7%magick identify ^
      -format "DO_IT=%%[fx:hypot(!X1!-!X0!,!Y1!-!Y0!)<=%GAP_LIMIT%?1:0]" ^
      xc:`) do set %%L

    if !DO_IT!==1 echo line !X0!,!Y0! !X1!,!Y1!
  )
)) >%OUTFILE%

type %OUTFILE%


call echoRestore

endlocal & set pdOUTFILE=%OUTFILE%& set pdNUM_PNTS=%numPnts%
