rem Given %1 is white points on black background,
rem %2 is CSV text file of those coordinates,
rem outputs %3 text file containing pairs of points that are close.
rem %4 is proximity threshold.
@rem
@rem Output file may be empty (returns prdxNUM_PNTS=0).
@rem
@rem Updated:
@rem   6-August-2022 for IM v7
@rem

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave


set INFILE=%1

if not exist %INFILE% exit /B 1


set CSVFILE=%2

if not exist %CSVFILE% exit /B 1

set OUTFILE=%3
if "%OUTFILE%"=="." set OUTFILE=
if "%OUTFILE%"=="" set OUTFILE=prdx.lis

set GAP_LIMIT=%4
if "%GAP_LIMIT%"=="." set GAP_LIMIT=
if "%GAP_LIMIT%"=="" set GAP_LIMIT=10

set CRP_FILE=prdxCrop.miff
set OTHERS_CSV=prdxCrop.csv
set OTHERS_CSV2=prdxCrop2.csv

set TEMP_IN=prdx.miff

%IMG7%magick %INFILE% %TEMP_IN%
if ERRORLEVEL 1 exit /B 1

set /A CWH=2*%GAP_LIMIT%+1

set II=0
(for /F "tokens=1,2 delims=, " %%X in (%CSVFILE%) do (
  rem echo %%X,%%Y
  set CW=%CWH%
  set CH=%CWH%
  set CX=%GAP_LIMIT%
  set CY=%GAP_LIMIT%
  set /A XL=%%X-%GAP_LIMIT%
  set /A YT=%%Y-%GAP_LIMIT%
  if !XL! LSS 0 (
    set /A CW+=!XL!
    set /A CX+=!XL!
    set XL=0
  )
  if !YT! LSS 0 (
    set /A CH+=!YT!
    set /A CY+=!YT!
    set YT=0
  )

  for /F "usebackq" %%L in (`%IMG7%magick ^
    %TEMP_IN% ^
    -crop !CW!x!CH!+!XL!+!YT! +repage ^
    -fill Black ^
    -draw "color !CX!,!CY! point" ^
    -format "MAX=%%[fx:maxima]" ^
    +write info:^
    -transparent Black ^
    sparse-color:%OTHERS_CSV%`) do set %%L

  if not !MAX!==0 (
    rem echo %%X,%%Y

    rem %IMG7%magick %CRP_FILE% -transparent Black sparse-color:|sed -e 's/ /\n/g' >%OTHERS_CSV%

    sed -e 's/ /\n/g' %OTHERS_CSV% >%OTHERS_CSV2%

    for /F "tokens=1,2 delims=, " %%A in (%OTHERS_CSV2%) do (
      set /A X1=!XL!+%%A
      set /A Y1=!YT!+%%B
      set DOIT=1
      if !Y1! LSS %%Y set DOIT=0
      if !Y1! EQU %%Y if !X1! LSS %%X set DOIT=0
      if !X1! EQU %%X if !Y1! EQU %%Y set DOIT=0
      if !DOIT!==1 (
        for /F "usebackq" %%L in (`%IMG7%magick identify ^
          -format "DOIT=%%[fx:hypot(!X1!-%%X,!Y1!-%%Y)<=%GAP_LIMIT%?1:0]" ^
          xc:`) do set %%L
      )
      if !DOIT!==1 (
        echo line %%X,%%Y,!X1!,!Y1!

        set /A II+=1
      )
    )
  )
)
) >%OUTFILE%

:: Note: When a line is short, its two line-ends are close, so will be joined.

echo %0: II=%II%
call echoRestore

endlocal & set prdxOUTFILE=%OUTFILE%& set prdxNUM_PNTS=%numPnts%
