rem From image %1,
rem make output %2
rem that is smoothed by Poisson-pasting with guidance field
rem that is the div of the slope
rem set to zero where the slope is within %3 percent of zero.
@rem
@rem Updated:
@rem   24-July-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 psm

if not "%2"=="." if not "%2"=="" set OUTFILE=%2

set SLP_LIM_PC=%3
if "%SLP_LIM_PC%"=="." set SLP_LIM_PC=
if "%SLP_LIM_PC%"=="" set SLP_LIM_PC=10

set TMPDIR=\temp\
set SXY=%TMPDIR%psm_sxy.miff
set SXY2=%TMPDIR%psm_sxy2.miff
set DIV=%TMPDIR%psm_div.miff
set MASK=%TMPDIR%psm_msk.miff


call %PICTBAT%slopeXY %INFILE% %SXY%

if ERRORLEVEL 1 exit /B 1

%IMG7%magick ^
  %SXY% ^
  -fuzz %SLP_LIM_PC%%% -fill Black -opaque Black ^
  -define quantum:format=floating-point ^
  -depth 32 ^
  %SXY2%

call %PICTBAT%slopeXYdiv %SXY2% %DIV%

if ERRORLEVEL 1 exit /B 1

%IMG7%magick ^
  %INFILE% ^
  -fill White -colorize 100 ^
  -gravity Center ^
  -shave 1x1 ^
  -bordercolor Black -border 1 ^
  %MASK%

call %PICTBAT%poissonPaste ^
  %INFILE% . %MASK% ^
  %OUTFILE% ^
  . %DIV%

if ERRORLEVEL 1 exit /B 1


call echoRestore

endlocal & set psmOUTFILE=%OUTFILE%
