rem Given image %1,
rem unrolls it, does some procesing, and rolls back.
rem %2, %3 coords of central point  [default center of %1]
rem   Each coord may be suffixed with "%", for percentage of width or height.
rem %4 factor for supersamping [1]
rem %5 optional output file.
rem
rem The processing is given in environment variable pdDISTORT.
@rem
@rem Also uses:
@rem   pdIM if set, uses this insead of %IMG7% for location of IM programs.
@rem
@rem
@rem Updated:
@rem   22-August-2022 Upgraded for IM v7.
@rem


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 pd

if not "%5"=="" set OUTFILE=%5

if "%pdIM%"=="" set pdIM=%IMG7%

set CENT_X=%2
set CENT_Y=%3
set SUP_SAMP=%4

if "%CENT_X%"=="." set CENT_X=
if "%CENT_Y%"=="." set CENT_Y=

set BLANK_CENT=0
if "%CENT_X%"=="" if "%CENT_Y%"=="" set BLANK_CENT=1

if "%CENT_X%"=="" set CENT_X=50%%
if "%CENT_Y%"=="" set CENT_Y=50%%

echo CENT_X=%CENT_X%  CENT_Y=%CENT_Y%

set X_SUFFIX=%CENT_X:~-1%
if "%X_SUFFIX%"=="%%" (
  set nX=%CENT_X:~0,-1%
  set X_MULT=w/100
) else (
  set nX=%CENT_X%
  set X_MULT=1
)

set Y_SUFFIX=%CENT_Y:~-1%
if "%Y_SUFFIX%"=="%%" (
  set nY=%CENT_Y:~0,-1%
  set Y_MULT=h/100
) else (
  set nY=%CENT_Y%
  set Y_MULT=1
)

if "%SUP_SAMP%"=="." set SUP_SAMP=
if "%SUP_SAMP%"=="" set SUP_SAMP=1

for /F "usebackq" %%L in (`%pdIM%magick identify ^
  -format "WW=%%w\nHH=%%h\nnX=%%[fx:%nX%*%SUP_SAMP%*%X_MULT%]\nnY=%%[fx:%nY%*%SUP_SAMP%*%Y_MULT%]"
  %INFILE%`) do set %%L

echo WW=%WW%  HH=%HH%  nX=%nX%  nY=%nY%


set sCENT=,%nX%,%nY%
if %BLANK_CENT%==1 set sCENT=

if %SUP_SAMP%==1 (
  set sSUP_UP=
  set sSUP_DN=
) else (
  for /F "usebackq tokens=*" %%L in (`%pdIM%magick identify ^
    -format "sSUP_UP=-resize %%[fx:100*%SUP_SAMP%]%%%%"
    xc:`) do set %%L

  set sSUP_DN=-resize "%WW%x%HH%^^^!"
)

echo sSUP_UP=%sSUP_UP%  sSUP_DN=%sSUP_DN%

for /F "usebackq" %%L in (`%pdIM%magick identify ^
  -format "ssW_2=%%[fx:w*%SUP_SAMP%/2]\nssH_2=%%[fx:h*%SUP_SAMP%/2]"
  %INFILE%`) do set %%L

set pdd=
if not defined pdDISTORT goto skip_pdd
  set pdd=%pdDISTORT:[ssW_2]=!ssW_2!%
  set pdd=%pdd:[ssH_2]=!ssH_2!%
:skip_pdd

%pdIM%magick ^
  %INFILE% ^
  %sSUP_UP% ^
  -distort depolar -1,0%sCENT% ^
  %pdd% ^
  -distort polar -1,0%sCENT% ^
  %sSUP_DN% ^
  %OUTFILE%

if ERRORLEVEL 1 exit /B 1

call echoRestore

@endlocal & set pdOUTFILE=%OUTFILE%
