@rem Given %1 is an image,
@rem %2 is output file,
@rem %3 is an input mid-value, (X1)
@rem %4 is a set of quoted output shadow, mid and highlight values
rem      (Y0, Y1, Y2),
@rem all values typically 0.0 to 1.0.
@rem %5 if a filename, also writes debugging graph image.
@rem
@rem Updated:
@rem   6-August-2022 for IM v7
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 psmh

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set X1=%3
if "%X1%"=="." set X1=
if "%X1%"=="" set X1=0.5

set OUTVALS=%~4
if "%OUTVALS%"=="." set OUTVALS=
if "%OUTVALS%"=="" set OUTVALS=0,0.5,1.0

set DEBUG=%5
if "%DEBUG%"=="." set DEBUG=

for /F "tokens=1-3 delims=, " %%A in ("%OUTVALS%") do (
  set Y0=%%A
  set Y1=%%B
  set Y2=%%C
)

if "%Y0%"=="." set Y0=
if "%Y0%"=="" set Y0=0

if "%Y2%"=="." set Y2=
if "%Y2%"=="" set Y2=1

if "%Y1%"=="." set Y1=
if "%Y1%"=="" set Y1=((%Y0%)+(%Y2%))/2.0

set FMT=^
Y0=%%[fx:%Y0%]\n^
Y1=%%[fx:%Y1%]\n^
Y2=%%[fx:%Y2%]

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 16 ^
  -format "%FMT%" ^
  xc:`) do set %%L

echo %0: X1 = %X1%
echo %0: Y0 = %Y0%, Y1 = %Y1%,  Y2 = %Y2%

set b=%Y0%

set FMT=^
a=%%[fx:%Y2%-(%Y0%)]\n^
p=%%[fx:log((%Y1%-(%Y0%))/(%Y2%-(%Y0%)))/log(%X1%)]

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 16 ^
  -format "%FMT%" ^
  xc:`) do set %%L

echo %0: a = %a%,  b = %b%,  p = %p%

set FMT=^
xAtZero=%%[fx:pow(-(%b%)/(%a%),1/(%p%))]\n^
xAtOne=%%[fx:pow((1-(%b%))/(%a%),1/(%p%))]\n

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 16 ^
  -format "%FMT%" ^
  xc:`) do set %%L

echo %0: xAtZero = %xAtZero%
echo %0: xAtOne = %xAtOne%



%IMG7%magick ^
  %INFILE% ^
  -evaluate Pow %p% ^
  -function Polynomial %a%,%b% ^
  %OUTFILE%

if not "%DEBUG%"=="" (
  %IMG7%magick ^
    -size 1x256 gradient: -rotate 90 ^
    -evaluate Pow %p% ^
    -function Polynomial %a%,%b% ^
    %DEBUG%

  call %PICTBAT%graphLineCol %DEBUG% . . 0 %DEBUG%
)


call echoRestore

@endlocal & set psmhOUTFILE=%OUTFILE%

