rem From images %1 and %2, makes Laplacian pyramid with four parameters %3,
rem applies IM processing %4 (which should create one image from two),
rem collapses pyramid into output %5.
@rem
@rem Updated:
@rem   15 May 2016 use %IML% for @script.
@rem   5-September-2022 for IM v7.
@rem

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 p2lp

set INFILE2=%2

set PYR_PARAM=%~3
if "%PYR_PARAM%"=="." set PYR_PARAM=
if "%PYR_PARAM%"=="" set PYR_PARAM=. . . .

set IM_PROC=%~4
if "%IM_PROC%"=="." set IM_PROC=
if "%IM_PROC%"=="" set IM_PROC=+write info:

if not "%5"=="" set OUTFILE=%5

set TMPDIR=%TEMP%

set pyPREFIX=p2lp_
call %PICTBAT%mkLapPyr %INFILE2% %pyPREFIX%pyr2.tiff %PYR_PARAM%
call %PICTBAT%mkLapPyr %INFILE% %pyPREFIX%pyr1.tiff %PYR_PARAM%

set FILE_LIST=

for /L %%i in (0,1,%mklpNUM_OCTAVES%) do (

  %IMG7%magick ^
    %pyPREFIX%pyr1.tiff[%%i] ^
    %pyPREFIX%pyr2.tiff[%%i] ^
    %IM_PROC% ^
    %TMPDIR%\%pyPREFIX%out_%%i.tiff

  set FILE_LIST=!FILE_LIST! %TMPDIR%\%pyPREFIX%out_%%i.tiff
)

%IMG7%magick %FILE_LIST% %pyPREFIX%pyr1.tiff

%IMG7%magick -script %pyPREFIX%mklp_recon.scr

%IMG7%magick %mklpRECON_FILE% %OUTFILE%

if ERRORLEVEL 1 exit /B 1

call echoRestore

endlocal & set p2lpOUTFILE=%OUTFILE%
