rem From images %1 and %2 and mask %3,
rem   makes Laplacian pyramid of first two
rem   and Gaussian pyramid of third, with four parameters %4,
rem applies IM processing %5 (which should create one image from two),
rem collapses pyramid into output %6.
@rem
@rem Updated:
@rem   15 May 2016 use %IML% for @script.
@rem   5-September-2022 for IM v7.
@rem

@if "%3"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

rem @call echoOffSave

call %PICTBAT%setInOut %1 p3lp

set INFILE2=%2
set MSKFILE=%3

set PYR_PARAM=%~4
if "%PYR_PARAM%"=="." set PYR_PARAM=
if "%PYR_PARAM%"=="" set PYR_PARAM=. . . .

set IM_PROC=%~5
if "%IM_PROC%"=="." set IM_PROC=
if "%IM_PROC%"=="" set IM_PROC=+write info:

if not "%6"=="" set OUTFILE=%6

set TMPDIR=%TEMP%

set pyPREFIX=p3lp_
call %PICTBAT%mkGausPyr %MSKFILE% %pyPREFIX%msk.tiff %PYR_PARAM%
call %PICTBAT%mkLapPyr %INFILE2% %pyPREFIX%pyr2.tiff %PYR_PARAM%
call %PICTBAT%mkLapPyr %INFILE% %pyPREFIX%pyr1.tiff %PYR_PARAM%

set FILE_LIST=

for /L %%i in (0,1,%mklpNUM_OCTAVES%) do (

  %IMG7%magick ^
    %pyPREFIX%pyr1.tiff[%%i] ^
    %pyPREFIX%pyr2.tiff[%%i] ^
    %pyPREFIX%msk.tiff[%%i] ^
    %IM_PROC% ^
    %TMPDIR%\%pyPREFIX%out_%%i.tiff

  set FILE_LIST=!FILE_LIST! %TMPDIR%\%pyPREFIX%out_%%i.tiff
)

%IMG7%magick %FILE_LIST% %pyPREFIX%pyr1.tiff

%IMG7%magick -script %pyPREFIX%mklp_recon.scr

%IMG7%magick %mklpRECON_FILE% %OUTFILE%

if ERRORLEVEL 1 exit /B 1

call echoRestore

endlocal & set p3lpOUTFILE=%OUTFILE%
