rem From image %1, makes Laplacian pyramid with four parameters %2,
rem applies IM processing %3,
rem collapses pyramid into output %4.
@rem
@rem Updated:
@rem   5-September-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 plp


set PYR_PARAM=%~2
if "%PYR_PARAM%"=="." set PYR_PARAM=
if "%PYR_PARAM%"=="" set PYR_PARAM=. . . .

set IM_PROC=%~3
if "%IM_PROC%"=="." set IM_PROC=
if "%IM_PROC%"=="" set IM_PROC=+write info:

if not "%4"=="" set OUTFILE=%4

set TMPDIR=%TEMP%

set pyPREFIX=plp_
call %PICTBAT%mkLapPyr %INFILE% %pyPREFIX%pyr.tiff %PYR_PARAM%

set FILE_LIST=

for /L %%i in (0,1,%mklpNUM_OCTAVES%) do (

  %IMG7%magick ^
    %pyPREFIX%pyr.tiff[%%i] ^
    %IM_PROC% ^
    %TMPDIR%\%pyPREFIX%out_%%i.tiff

  set FILE_LIST=!FILE_LIST! %TMPDIR%\%pyPREFIX%out_%%i.tiff
)

%IMG7%magick %FILE_LIST% %pyPREFIX%pyr.tiff

%IMG7%magick -script %pyPREFIX%mklp_recon.scr

%IMG7%magick %mklpRECON_FILE% %OUTFILE%

if ERRORLEVEL 1 exit /B 1


call echoRestore

endlocal & set plpOUTFILE=%OUTFILE%
