rem Like propOf.bat but result is proportion of %1.

rem Given %1 is a number,
rem %2 is a number possibly suffixed with % or c or p or C or P,
rem sets variable %3 to result.
@rem All can be floating-point.
@rem
@rem Eg if %1 is 300
@rem then %2 might be 60 or 20% or 20c or 0.2p, and the result is 0.2.
@rem
@rem Updated:
@rem   4-October-2022 for IM v7.
@rem

setlocal

set VAR_S=%2
set OUTV=%VAR_S%
set CH_LAST=%VAR_S:~-1%

if "%CH_LAST%"=="^%" set CH_LAST=c

if /I "%CH_LAST%"=="c" (
  for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -precision 16 ^
    -format "OUTV=%%[fx:%VAR_S:~0,-1%/100]" ^
    xc:`) do set %%L

) else if /I "%CH_LAST%"=="p" (
  set OUTV=%VAR_S:~0,-1%
) else (
  for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -precision 16 ^
    -format "OUTV=%%[fx:%VAR_S%/%1]" ^
    xc:`) do set %%L
)

echo OUTV=%OUTV%

@endlocal & set %3=%OUTV%
