rem From image of white lines on black background,
rem writes output %2
rem joining line-ends that are within proximity threshold %3.
@rem
@rem Also uses:
@rem   skelLineEnds if 1, skeletonises the output.
@rem   threshLineEnds if 1, thresholds the output at 50%.
@rem
@rem Updated:
@rem   6-August-2022 for IM v7
@rem


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 ple

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set PROX_THRESH=%3
if "%PROX_THRESH%"=="" set PROX_THRESH=.

call %PICTBAT%skelPS ^
  %INFILE% %BASENAME%_%sioCODE%.png
if ERRORLEVEL 1 exit /B 1

call %PICTBAT%pointsRdx ^
  %spsENDS% ^
  %spsCSVFILE% %BASENAME%_lines_%sioCODE%.scr %PROX_THRESH%
if ERRORLEVEL 1 exit /B 1

echo %0: prdxOUTFILE=%prdxOUTFILE%

if "%skelLineEnds%"=="1" (
  set sSKEL=-morphology Thinning:-1 skeleton -clamp
) else (
  set sSKEL=
)

if "%threshLineEnds%"=="1" (
  set sTHRESH=-threshold 50%%
) else (
  set sTHRESH=
)

%IMG7%magick ^
  %INFILE% ^
  +antialias ^
  -stroke White ^
  -strokewidth %spsLINE_THK_INT% ^
  -draw "@%prdxOUTFILE%" ^
  %sSKEL% %sTHRESH% ^
  %OUTFILE%
if ERRORLEVEL 1 exit /B 1

call echoRestore

@endlocal & set %sioCODE%OUTFILE=%OUTFILE%
