rem Given %1 and %2 are quadrangles,
rem creates %3 with ordinates ordered for "-distort perspective"
rem and %4 with parameter for "-crop" (assuming second quadrangle is a rectangle).
@rem
@rem Updated:
@rem   24-August-2022 for IM v7.
@rem

set q2pTest=abc
if not "!q2pTest!"=="abc" (
  echo %0: required enabledelayed expansion
  exit /B 1
)

if "%4%"=="" (
  echo %0: needs 4 parameters
  exit /B 1
)

if "!%1.TL.x!"=="" (
  echo %0: %1.TL.x is blank
  exit /B 1
)

if "!%2.TL.x!"=="" (
  echo %0: %2.TL.x is blank
  exit /B 1
)

set %3=

if not "!%1.TL.BAD!"=="1" (
  set %3=!%1.TL.x!,!%1.TL.y!,!%2.TL.x!,!%2.TL.y!,
)
if not "!%1.TR.BAD!"=="1" (
  set %3=!%3!!%1.TR.x!,!%1.TR.y!,!%2.TR.x!,!%2.TR.y!,
)
if not "!%1.BL.BAD!"=="1" (
  set %3=!%3!!%1.BL.x!,!%1.BL.y!,!%2.BL.x!,!%2.BL.y!,
)
if not "!%1.BR.BAD!"=="1" (
  set %3=!%3!!%1.BR.x!,!%1.BR.y!,!%2.BR.x!,!%2.BR.y!,
)

if "!%3!"=="" exit /B 1

:: Remove final comma
set %3=!%3:~0,-1!

echo %3 is [!%3!]

if "%4"=="" exit /B 0

call :doCalc q2pW int(!%2.TR.x!-!%2.TL.x!+1.5)
call :doCalc q2pH int(!%2.BL.y!-!%2.TL.y!+1.5)
call :doCalc q2pX int(!%2.TL.x!+0.5)
call :doCalc q2pY int(!%2.TL.y!+0.5)

set %4=%q2pW%x%q2pH%+%q2pX%+%q2pY%
set %4_W=%q2pW%x+%q2pX%+0

exit /B 0

::----------------------------------------------------
:: Subroutine

:doCalc
set %1=
for /F "usebackq" %%L in (`%IMG7%magick identify -precision 19 -format "%1=%%[fx:%~2]" xc:`) do set %%L

rem echo %1 is !%1!

if "!%1!"=="" exit /B 1

exit /B 0
