rem Given image %1 is roughly vertical white line on black background,
rem creates image with random horizontal shifts of entire rows.
@rem
@rem   %2 is blur sigma of noise [10]
@rem   %3 is displacement [%2 * 3]
@rem   %4 is blur sigma for smoothing the line,
@rem      and joining points in nearly horizontal lines
@rem   %5 is output file, or "." for same as input file
@rem
@rem Updated:
@rem   18-August-2022 for IM v7.
@rem


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

rem @call echoOffSave

call %PICTBAT%setInOut %1 rhsl


set BlurSig=%2
if "%BlurSig%"=="." set BlurSig=
if "%BlurSig%"=="" set BlurSig=10

set DISP=%3
if "%DISP%"=="." set DISP=
if "%DISP%"=="" set /A DISP=BlurSig*3

set BlurSig2=%4
if "%BlurSig2%"=="." set BlurSig2=
if "%BlurSig2%"=="" set BlurSig2=3

if not "%5"=="" set OUTFILE=%5
if "%OUTFILE%"=="." set OUTFILE=%INFILE%

if "%blurSig2%" == "" (
  set sBLUR2=
) else (
  set sBLUR2=-blur 0x%blurSig2%
)

if "%rhslDEBUG%"=="1" (
  set CH_IN=-channel RG
  set CH_OUT=+channel
) else (
  set CH_IN=
  set CH_OUT=
)

set WW=
for /F "usebackq" %%L in (`%IMG7%magick identify -format "WW=%%w\nHH=%%h" %INFILE%`) do set %%L
if "%WW%"=="" exit /B 1

set sNORM=-auto-level -auto-gamma

:: For possible bug replace "-morphology Thinning:-1 Skeleton:2"
:: with "-morphology Thinning:-1 3x1:0,-,1;3x1:0,-,1 -clamp".
::
%IMG7%magick ^
  %INFILE% ^
  ( +clone ^
    +noise Random ^
    -virtual-pixel Tile ^
    -blur 0,%blurSig% ^
    -modulate 100,0,100 ^
    -crop 1x0+0+0 +repage -scale "%WW%x%HH%^!" ^
    %sNORM% ^
    ( +clone ^
      -sparse-color bilinear ^
0,0,#000,^
%%[fx:w-1],0,#f00,^
0,%%[fx:h-1],#0f0,^
%%[fx:w-1],%%[fx:h-1],#ff0 ^
    ) ^
    -compose Mathematics ^
      -define compose:args=0,-0.5,0.5,0.5 ^
      -composite ^
  ) ^
  -compose Displace ^
    -set option:compose:args %DISP%x0 ^
    -composite ^
+write a.png ^
  %sBLUR2% ^
  -fill White +opaque Black ^
+write a2.png ^
  %CH_IN% ^
  -morphology Thinning:-1 3x1:0,-,1;3x1:1,-,0 -clamp ^
+write a3.png ^
  %CH_OUT% ^
  -morphology Thinning:-1 LineEnds -clamp ^
  %OUTFILE%

if ERRORLEVEL 1 exit /B 1


call echoRestore

endlocal & set rhslOUTFILE=%OUTFILE%
