rem from %1 a Haar wavelet pyramid, reconstruct an image %2.
@rem
@rem Updated:
@rem   12-August-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 rhp

if not "%2"=="" set OUTFILE=%2


set PREF=rhp_
set TMP_EXT=.miff

set NUM_OCT=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "NUM_OCT=%%[fx:ceil(log(max(h,w))/log(2))]\n" ^
  %INFILE%`) do set %%L

if "%NUM_OCT%"=="" exit /B 1

echo %0: NUM_OCT=%NUM_OCT%

set IN_AVG=
set DIM=1
set FILE_LIST=
for /L %%I in (1,1,%NUM_OCT%) do (
  echo %%I DIM=!DIM!

  %IMG7%magick ^
    %INFILE% ^
    ^( -clone 0 ^
        -crop !DIM!x!DIM!+0+0 +repage +write %PREF%_%%I_a%TMP_EXT% ^
        +delete ^) ^
    ^( -clone 0 ^
       -crop !DIM!x!DIM!+!DIM!+0 +repage +write %PREF%_%%I_h%TMP_EXT% ^
        +delete ^) ^
    ^( -clone 0 ^
        -crop !DIM!x!DIM!+0+!DIM! +repage +write %PREF%_%%I_v%TMP_EXT% ^
        +delete ^) ^
    ^( -clone 0 ^
        -crop !DIM!x!DIM!+!DIM!+!DIM! +repage +write %PREF%_%%I_d%TMP_EXT% ^
        +delete ^) ^
    NULL:

  if %%I GTR 1 (
    %IMG7%magick !IN_AVG! %PREF%_%%I_a%TMP_EXT%
  )

  call %PICTBAT%haar4bbi %PREF%_%%I%TMP_EXT% %PREF%_%%I_rcn%TMP_EXT%

  set IN_AVG=%PREF%_%%I_rcn%TMP_EXT%

  set /A DIM*=2
)

%IMG7%magick %IN_AVG% %OUTFILE%

call echoRestore

endlocal & set rhpOUTFILE=%OUTFILE%
