rem From input image %1,
rem makes output image %2 with 8 colours,
rem being the corners of a rectangular cuboid that contains all the colours.
rem %3 is optional crop of %1, eg 34x45+10+20.
rem %4 is optional pre-processing, applied to the cropped area.

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

rem @call echoOffSave

call %PICTBAT%setInOut %1 rcc

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set CROP=%3
if "%CROP%"=="." set CROP=

set PREPROC=%4
if "%PREPROC%"=="." set PREPROC=

if "%CROP%"=="" (
  set sCROP=
) else (
  set sCROP=-crop %CROP% +repage
)


set FMT=^
POIN_COLSP=%%[colorspace]\n^
POIN_MINR=%%[fx:minima.r*100]\n^
POIN_MAXR=%%[fx:maxima.r*100]\n^
POIN_MING=%%[fx:minima.g*100]\n^
POIN_MAXG=%%[fx:maxima.g*100]\n^
POIN_MINB=%%[fx:minima.b*100]\n^
POIN_MAXB=%%[fx:maxima.b*100]\n

for /F "usebackq" %%L in (`%IMG7%magick ^
  %INFILE% ^
  %sCROP% ^
  %PREPROC% ^
  -precision 16 ^
  -format "%FMT%" ^
  info:`) do set %%L

set POIN_ 

set c0=rgb(%POIN_MINR%%%,%POIN_MING%%%,%POIN_MINB%%%)
set c1=rgb(%POIN_MAXR%%%,%POIN_MING%%%,%POIN_MINB%%%)
set c2=rgb(%POIN_MINR%%%,%POIN_MAXG%%%,%POIN_MINB%%%)
set c3=rgb(%POIN_MINR%%%,%POIN_MING%%%,%POIN_MAXB%%%)
set c4=rgb(%POIN_MINR%%%,%POIN_MAXG%%%,%POIN_MAXB%%%)
set c5=rgb(%POIN_MAXR%%%,%POIN_MING%%%,%POIN_MAXB%%%)
set c6=rgb(%POIN_MAXR%%%,%POIN_MAXG%%%,%POIN_MINB%%%)
set c7=rgb(%POIN_MAXR%%%,%POIN_MAXG%%%,%POIN_MAXB%%%)

%IMG7%magick ^
  xc:%c0% xc:%c1% xc:%c2% xc:%c3% xc:%c4% xc:%c5% xc:%c6% xc:%c7% ^
  +append +repage ^
  -set colorspace %POIN_COLSP% ^
  %OUTFILE%



call echoRestore

@endlocal
