rem Replaces part of image %1 with image %2, using rectangular boundary from dark paths.
@rem %3: output image (%2, with cut margins, composited over %1)
@rem %4 %5:  xy coords in %1 for top-left of %2.
@rem %6: string of up to 4 numbers, space-separated:
@rem   sizes of margins left, top, right, bottom.
@rem   each number can be suffixed c or % or p.
@rem   Any number can instead be a dot (.) for default.
@rem
@rem Updated:
@rem   15-July-2022 for IM v7.

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 rdr


set SRC1=%1
set SRC2=%2

if not "%3"=="" set OUTFILE=%3

set DX=%4
if "%DX%"=="." set DX=
if "%DX%"=="" set DX=0

set DY=%5
if "%DY%"=="." set DY=
if "%DY%"=="" set DY=0

set MARG_PARM=%~6
if "%MARG_PARM%"=="." set MARG_PARM=
if "%MARG_PARM%"=="" set MARG_PARM=. . . .

echo six is [%~6]
echo MARG_PARM=[%MARG_PARM%]

set TMP_IMG=rdr_tmp.miff

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "WW=%%w\nHH=%%h" ^
  %SRC2%`) do set %%L

if ERRORLEVEL 1 exit /B 1

rem DX and DY may contain a sign. Does this cause problems?

%IMG7%magick ^
  %SRC1% ^
  -crop %WW%x%HH%+%DX%+%DY% +repage ^
  %TMP_IMG%

if ERRORLEVEL 1 exit /B 1

call %PICTBAT%rectDp %TMP_IMG% %SRC2% %TMP_IMG% %MARG_PARM%

if ERRORLEVEL 1 exit /B 1

%IMG7%magick ^
  %SRC1% ^
  %TMP_IMG% ^
  -set colorspace sRGB ^
  -geometry +%DX%+%DY% ^
  -compose Over -composite ^
  %OUTFILE%

if ERRORLEVEL 1 exit /B 1


call echoRestore

endlocal & set rdrOUTFILE=%OUTFILE%
