rem From CSV file %1, writes CSV file %2 without outliers.
rem %3, %4, %5, %6 ...:
rem    %3, %5,.. are the columns to be examined for outliers.
rem    %4, %6,.. are 0 or 1 for removeOutliers.bat
rem
rem First column is numbered one.
@rem
@rem Also uses:
@rem   rcoAPPEND_NUM if 1, appends line number as extra column.
@rem   rcoDEBUG_FILE if set, echos debugging text to this file


@if "%4"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave


set INFILE=%1
set OUTFILE=%2

if not exist %INFILE% (
  echo %0: can't find %INFILE%
  exit /B 1
)


if "%rcoAPPEND_NUM%"=="" set rcoAPPEND_NUM=0

if "%rcoDEBUG_FILE%"=="" set rcoDEBUG_FILE=+

if not "%rcoDEBUG_FILE%"=="+" (
  set SaveroDEBUG_FILE=%roDEBUG_FILE%
  set roDEBUG_FILE=%rcoDEBUG_FILE%
)


set nVAL=0
for /F "tokens=%3 delims=, " %%V in (%INFILE%) do (
  set /A nVAL+=1
)
call zeroArray OUTLIERS %nVAL%

:loop
if not "%rcoDEBUG_FILE%"=="+" echo %~n0: Column=%3 IsAbs=%4 >>%rcoDEBUG_FILE%

rem Read the array
set nVAL=0
for /F "tokens=%3 delims=, " %%V in (%INFILE%) do (
  rem echo %%V
  set VALUES[!nVAL!]=%%V
  set /A nVAL+=1
)

call removeOutliers VALUES %nVAL% OUTLIERS %4

shift /3
shift /3
if not "%3"=="" goto loop

set /A nLAST=%nVAL%-1

rem for /L %%i in (0,1,%nLAST%) do echo !OUTLIERS[%%i]!


rem Write the non-outliers.
del %OUTFILE% 2>nul
set nVAL=0
for /F "tokens=*" %%L in (%INFILE%) do (
  set /A ISOUTLIER=OUTLIERS[!nVal!]
  echo ISOUTLIER=!ISOUTLIER!
  if not !ISOUTLIER!==1 (
    if %rcoAPPEND_NUM%==0 (
      echo %%L >>%OUTFILE%
    ) else (
      echo %%L, !nVAL! >>%OUTFILE%
    )
  )
  set /A nVAL+=1
)

if not "%rcoDEBUG_FILE%"=="+" (
  echo %~n0: nVAL=%nVAL% >>%rcoDEBUG_FILE%

  set roDEBUG_FILE=%SaveroDEBUG_FILE%
)

echo %0: nVAL=%nVAL%

@call echoRestore

@endlocal
