rem From array %1 with %2 elements, removes outliers.
rem Array %3 is already 1 where element is to be ignored.
rem Sets %3 elements to 1 where element is outlier (so we can't use setlocal).
rem %4 is optional, 1=take abs (so remove high or low outliers) 0=no abs (so remove only high outliers). Default=1.
@rem See http://www.mne.psu.edu/me345/Lectures/Outliers.pdf
@rem
@rem Also uses:
@rem   roDEBUG_FILE if set, echos debugging text to this file
@rem
@rem Updated:
@rem   4-October-2022 for IM v7.
@rem

@if "%3"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@rem @setlocal enabledelayedexpansion

@rem @call echoOffSave

echo %0 [%1] [%2] [%3] [%4]


if %2 LSS 3 (
  exit /B 0
)

set DO_ABS=%4
if "%DO_ABS%"=="" set DO_ABS=1

if %DO_ABS%==1 (
  set FUNC=abs
) else (
  set FUNC=
)

echo DO_ABS=%DO_ABS%

set ARR=%1

if "%roDEBUG_FILE%"=="" set roDEBUG_FILE=+

set /A nLAST=%2-1
set IGNORE=%3

:loop

call meanStdDev %1 %2 %3

set HIGH_DEV=0
set nHIGH=0
set nVALS=0

for /L %%i in (0,1,%nLAST%) do (
  if not "!%IGNORE%[%%i]!"=="1" (
    set VAL=!%ARR%[%%i]!

    if "!VAL!"=="" exit /B 1

    for /F "usebackq" %%L in (`%IMG7%magick identify ^
      -precision 9 ^
      -format "DEVIATION=%%[fx:%FUNC%(!VAL!-%msdMEAN%)]" ^
      xc:`) do set %%L

    for /F "usebackq" %%L in (`%IMG7%magick identify ^
      -format "IS_HIGHER=%%[fx:!DEVIATION!>=!HIGH_DEV!?1:0]" ^
      xc:`) do set %%L

    if !IS_HIGHER!==1 (
      set HIGH_DEV=!DEVIATION!
      set nHIGH=%%i
    )
    set /A nVALS+=1
  )  
)


echo HIGH_DEV=%HIGH_DEV% nHIGH=%nHIGH%

call getModThoTau %nVALS%

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "IS_OUTLIER=%%[fx:%HIGH_DEV%>=%gmttTAU%*%msdSTD_DEV_SAMP%?1:0]" ^
  xc:`) do set %%L

rem echo IS_OUTLIER=%IS_OUTLIER%

if %IS_OUTLIER%==1 (
  set %IGNORE%[%nHIGH%]=1
  if not "%roDEBUG_FILE%"=="+" echo %~n0: removed %nHIGH% >>%roDEBUG_FILE%
  goto loop
)


@rem @call echoRestore

@rem @endlocal
