rem From image %1 with transparency,
rem fill holes by resizing.
@rem
@rem Optional:
@rem   %2 resize factor > 1 eg 1.5 (default 2)
@rem   %3 output filename
@rem
@rem Updated:
@rem   15 May 2016 use %IML% for @script.
@rem   8-September-2022 for IM v7.
@rem
@rem  An equivalent compiled program wouldn't need to save images
@rem    between iterations, so would be faster.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 rf


set SCR_FILE=rf_%~n1_scr.scr

set RES_FACT=%2
if "%RES_FACT%"=="." set RES_FACT=
if "%RES_FACT%"=="" set RES_FACT=2

if not "%3"=="" set OUTFILE=%3

set WW=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 19 ^
  -format "WW=%%w\nHH=%%h\nMAXDIM=%%[fx:max(w,h)]\nRES_PC=%%[fx:100/%RES_FACT%]" ^
  %INFILE%`) do set %%L
if "%WW%"=="" exit /B 1

set SIZ=1
set CNT=0
:loop
set /A CNT+=1
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "SIZ=%%[fx:!SIZ!*%RES_FACT%]\nDONE=%%[fx:!SIZ!>%MAXDIM%?1:0]" ^
  xc:`) do set %%L

rem echo SIZ=!SIZ! CNT=%CNT% DONE=!DONE!

if %DONE%==0 goto loop

echo CNT=%CNT%


rem ( for /L %%I in (0,1,%CNT%) do @echo ^( +clone -resize %RES_PC%%% +write x_%%I.png ^) ) >%SCR_FILE%

set RESIZES=
for /L %%I in (0,1,%CNT%) do set RESIZES=!RESIZES! "(" +clone -resize %RES_PC%%% +write x_%%I.png ")"

set CONV_IN=%INFILE%

set CNT=0
:loop2
for /F "usebackq" %%L in (`%IMG7%magick ^
  %CONV_IN% ^
-alpha set ^
-background red -alpha background -virtual-pixel background ^
  %RESIZES% ^
  -layers RemoveDups ^
  -filter Gaussian -resize "%WW%x%HH%^!" ^
  -background None ^
  -compose DstOver -layers merge ^
  -format "OPAQ=%%[opaque]" +write info: ^
  %OUTFILE%`) do set %%L
if "%OPAQ%"=="" exit /B 1

set CONV_IN=%OUTFILE%

set /A CNT+=1
if "%OPAQ%"=="false" if %CNT% LSS 10 goto loop2


call echoRestore

endlocal & set rfOUTFILE=%OUTFILE%
