rem From image %1
rem write windowed mean %2
rem and standard deviation %3
rem with window size %4
rem using the resize method.
@rem
@rem Also uses:
@rem   rmnsdFILTER
@rem
@rem
@rem Updated:
@rem   5-August-2022 for IM v7.
@rem


@if "%4"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 rmnsd

set OUTMEAN=%2
if "%OUTMEAN%"=="." set OUTMEAN=
if "%OUTMEAN%"=="" set OUTMEAN=

set OUTSD=%3
if "%OUTSD%"=="." set OUTSD=
if "%OUTSD%"=="" set OUTSD=

set WINDIMS=%4

set WW=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "WW=%%w\nHH=%%h\n" ^
  %INFILE%`) do set %%L
if "%WW%"=="" exit /B 1


call parseXxY2 %WW% %HH% rmnsd %WINDIMS%

echo %0: rmnsd_X=%rmnsd_X% rmnsd_Y=%rmnsd_Y%

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "RW=%%[fx:int(%WW%/2/%rmnsd_X%+0.5)]\nRH=%%[fx:int(%HH%/2/%rmnsd_Y%+0.5)]\n" ^
  xc:`) do set %%L

if %RW%==0 set RW=1
if %RH%==0 set RH=1

echo %0: rmnsd_X=%rmnsd_X% rmnsd_Y=%rmnsd_Y% RW=%RW% RH=%RH%

if "%OUTMEAN%"=="" (
  set wrOUTMEAN=
) else (
  set wrOUTMEAN=+write %OUTMEAN%
)

if "%rmnsdFILTER%"=="" (
  set sFILT=
) else (
  set sFILT=-filter %rmnsdFILTER%
)

if "%OUTSD%"=="" (

  %IMG7%magick ^
    %INFILE% ^
    %sFILT% ^
    -resize "%RW%x%RH%^!" -resize "%WW%x%HH%^!" ^
    %wrOUTMEAN% ^
    NULL:

) else (

  %IMG7%magick ^
    %INFILE% ^
    %sFILT% ^
    ^( -clone 0 ^
       -evaluate Pow 2 ^
       -resize "%RW%x%RH%^!" -resize "%WW%x%HH%^!" ^
    ^) ^
    ^( -clone 0 ^
       -resize "%RW%x%RH%^!" -resize "%WW%x%HH%^!" ^
       %wrOUTMEAN% ^
       -evaluate Pow 2 ^
    ^) ^
    -delete 0 ^
    -alpha off ^
    -compose MinusSrc -composite ^
    -evaluate Pow 0.5 ^
    %OUTSD%
)

call echoRestore

endlocal
