rem Given %1 is input name including XX representing %3, %4, %5 and %6 (R, G0, G1 and B),
rem makes output %2 grayscale of twice the dimensions, a Bayer image.
@rem
@rem Updated:
@rem   22-August-2019 Added "-alpha off -compress None" so raw readers don't get confused.
@rem   26-June-2021 Changed method to improve performance.
@rem   19-March-2022 Removed "+write msk.png" prior to "-write mpr:MSK2 +delete".
@rem

setlocal enabledelayedexpansion

set INNAME=%1
set OUTFILE=%2

set C0=%3
if "%C0%"=="." set C0=
if "%C0%"=="" set C0=R

set C1=%4
if "%C1%"=="." set C1=
if "%C1%"=="" set C1=G0

set C2=%5
if "%C2%"=="." set C2=
if "%C2%"=="" set C2=G1

set C3=%6
if "%C3%"=="." set C3=
if "%C3%"=="" set C3=B

%IMG7%magick ^
  -background None ^
  ( !INNAME:XX=%C0%! ^
    -scale 200%% ^
  ) ^
  ( -size 1x1 ^
    ( xc:Black xc:White +append +repage ) ^
    ( xc:Black xc:Black +append +repage ) ^
    -append ^
    -write mpr:MSK +delete ^
    -clone 0 ^
    -tile mpr:MSK ^
    -draw "color 0,0 reset" ^
    -write mpr:MSK2 +delete ^
  ) ^
  ( !INNAME:XX=%C1%! ^
    -scale 200%% ^
    mpr:MSK2 ^
    -alpha off ^
    -compose CopyAlpha -composite ^
  ) ^
  ( !INNAME:XX=%C2%! ^
    -scale 200%% ^
    ( mpr:MSK2 -roll +1+1 ) ^
    -alpha off ^
    -compose CopyAlpha -composite ^
  ) ^
  ( !INNAME:XX=%C3%! ^
    -scale 200%% ^
    ( mpr:MSK2 -roll +0+1 ) ^
    -alpha off ^
    -compose CopyAlpha -composite ^
  ) ^
  -compose Over -layers Flatten ^
  -alpha off -compress None ^
  -define quantum:format=integer -depth 16 ^
  %OUTFILE%
