rem Similar to rggb2gray.bat, but using "-fx".

rem Given %1 is input name including XX representing %3, %4, %5 and %6 (R, G0, G1 and B),
rem makes output %2 grayscale of twice the dimensions, a Bayer image.
@rem
@rem Updated:
@rem   22-August-2019 Added "-alpha off -compress None" so raw readers don't get confused.
@rem   26-June-2021 Changed method to improve performance.
@rem   19-March-2022 Removed "+write msk.png" prior to "-write mpr:MSK2 +delete".
@rem

setlocal enabledelayedexpansion

set INNAME=%1
set OUTFILE=%2

set C0=%3
if "%C0%"=="." set C0=
if "%C0%"=="" set C0=R

set C1=%4
if "%C1%"=="." set C1=
if "%C1%"=="" set C1=G0

set C2=%5
if "%C2%"=="." set C2=
if "%C2%"=="" set C2=G1

set C3=%6
if "%C3%"=="." set C3=
if "%C3%"=="" set C3=B

%FXNEW%magick ^
  !INNAME:XX=%C0%! !INNAME:XX=%C1%! !INNAME:XX=%C2%! !INNAME:XX=%C3%! ^
  -size %%[fx:w*2]x%%[fx:h*2] xc: ^
  -colorspace Gray ^
  -insert 0 ^
  -fx "u[1 + i%%2 + 2*(j%%2)].p{floor(i/2),floor(j/2)}" ^
  -alpha off -compress None ^
  -define quantum:format=integer -depth 16 ^
  %OUTFILE%

