@rem
@rem Updated:
@rem   29-August-2022 for IM v7.
@rem

set INFILE=%1
set OUTFILE=%2

set A_START=5
set A_END=355
set A_STEP=10


set SQ_DIM=
for /F "usebackq" %%L in (`%IMG7%magick ^
  %INFILE% ^
  -format "SQ_DIM=%%[fx:w/4]" ^
  info:`) do set %%L
if "%SQ_DIM%"=="" exit /B 1

echo SQ_DIM=%SQ_DIM%


set /A SQ_DIM2=2*%SQ_DIM%
set /A SQ_DIM3=3*%SQ_DIM%
set /A SQ_DIM4=4*%SQ_DIM%
set /A SQ_DIM_2=%SQ_DIM%/2

set DEPTH=60
set TRANS=tx-%SQ_DIM_2%,ty-%SQ_DIM_2%,tz+%SQ_DIM_2%,ry_XX_,rx-30
set PERSP=f 700

del rca_tmp_*.miff 2>nul

for /L %%A in (%A_START%,%A_STEP%,%A_END%) do @(
  set LZ=00%%A
  set LZ=!LZ:~-3!
  echo !LZ!

  set TMP_OUT=rca_tmp_!LZ!.miff

  set TRANS_STR=%TRANS:_XX_=!LZ!%
  echo TMP_OUT=!TMP_OUT!  TRANS_STR=!TRANS_STR!

  %IM7DEV%magick ^
    %INFILE% ^
    -virtual-pixel None -mattecolor None ^
    ^( -clone 0 -crop %SQ_DIM%x%SQ_DIM%+0+%SQ_DIM% +repage ^
       -process 'srt3d transform tx-1p,ry-90,!TRANS_STR! %PERSP% r' ^
    ^) ^
    ^( -clone 0 -crop %SQ_DIM%x%SQ_DIM%+%SQ_DIM%+0 +repage ^
       -process 'srt3d transform ty-1p,rx90,!TRANS_STR! %PERSP% r' ^
    ^) ^
    ^( -clone 0 -crop %SQ_DIM%x%SQ_DIM%+%SQ_DIM%+%SQ_DIM% +repage ^
       -process 'srt3d transform !TRANS_STR! %PERSP% r' ^
    ^) ^
    ^( -clone 0 -crop %SQ_DIM%x%SQ_DIM%+%SQ_DIM%+%SQ_DIM2% +repage ^
       -process 'srt3d transform rx-90,ty%SQ_DIM%,!TRANS_STR! %PERSP% r' ^
    ^) ^
    ^( -clone 0 -crop %SQ_DIM%x%SQ_DIM%+%SQ_DIM2%+%SQ_DIM% +repage ^
       -process 'srt3d transform ry90,tx%SQ_DIM%,!TRANS_STR! %PERSP% r' ^
    ^) ^
    ^( -clone 0 -crop %SQ_DIM%x%SQ_DIM%+%SQ_DIM3%+%SQ_DIM% +repage ^
       -process 'srt3d transform ry180,tx%SQ_DIM%,tz-%SQ_DIM%,!TRANS_STR! %PERSP% r' ^
    ^) ^
    -delete 0 ^
    -background White -layers merge ^
    !TMP_OUT!
)

%IMG7%magick ^
  null: ^
  -virtual-pixel None -mattecolor None ^
  rca_tmp_*.miff ^
  -layers trim-bounds ^
  ^( -clone 1--1 ^
     -layers mosaic ^
     -alpha Transparent ^
  ^) ^
  -insert 0 ^
  -layers Composite ^
  -set dispose Background ^
  %OUTFILE%

del rca_tmp_*.miff 2>nul

