rem %1 input grayscale saliency map
rem %2 maximum crop width
rem %3 maximum crop height
rem %4 sub-sample factor [default: 1]
rem %5 prefix for output environment variable names

@if "%3"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave


set SALMAP=%1
set WW=%2
if "%WW%"=="." set WW=

set HH=%3
if "%HH%"=="." set HH=

set SSFACT=%4
if "%SSFACT%"=="." set SSFACT=
if "%SSFACT%"=="" set SSFACT=1

set ENVPREF=%5
if "%ENVPREF%"=="." set ENVPREF=
if "%ENVPREF%"=="" set ENVPREF=smc_

:: Reduce WW and HH by SSFACT.
::
if not "%WW%"=="" for /F "usebackq" %%L in (`%IMG7%magick xc: ^
  -format "WW=%%[fx:%WW%/%SSFACT%]" ^
  info:`) do set %%L

if not "%HH%"=="" for /F "usebackq" %%L in (`%IMG7%magick xc: ^
  -format "HH=%%[fx:%HH%/%SSFACT%]" ^
  info:`) do set %%L

set TMPINP=%TEMP%\aspRat.miff

if %SSFACT%==1 (
  set SUBSAMP=
) else (
  set SUBSAMP=-resize "%%[fx:w/%SSFACT%]x%%[fx:h/%SSFACT%]"
)

for /F "usebackq" %%L in (`%IMG7%magick ^
  %SALMAP% ^
  %SUBSAMP% ^
  -precision 15 ^
  +write %TMPINP% ^
  -format "WWin=%%w\nHHin=%%h\ninpSal=%%[fx:mean*w*h]\ninpArea=%%[fx:w*h]\n" ^
  info:`) do set %%L

if "%WW%"=="" set WW=%WWin%

if "%HH%"=="" set HH=%HHin%

:: Search for the highest score.

set BestScore=0
set BestW=
set BestH=
set BestF=

set F0=10
set F3=100

call :tryOne %F0% 0
set score0=%score%

call :tryOne %F3% 3
set score3=%score%

set DiffLim=1

:: Or we might stop when the crops are equal.

:loop

for /F "usebackq" %%L in (`%IMG7%magick xc: ^
  -precision 15 ^
  -format "F1=%%[fx:!F0!+(!F3!-!F0!)/3]\nF2=%%[fx:!F0!+2*(!F3!-!F0!)/3]\nAGAIN=%%[fx:!F3!-!F0!>1?1:0]" ^
  info:`) do set %%L

echo %0: F: !F0! !F1! !F2! !F3!

call :tryOne !F1! 1
set score1=!score!

call :tryOne !F2! 2
set score2=!score!

:: For case !BestF!==!F1! we assume score0 is the new best score
:: For case !BestF!==!F2! we assume score3 is the new best score

set Calc0or3=0

if !BestF!==!F0! (
  echo 0 is best. Move 1 to 3.
  set F3=!F1!
  set score3=!score1!
  set W3=%W1%
  set H3=%H1%
  set X3=%X1%
  set Y3=%Y1%
) else if !BestF!==!F1! (
  echo 1 is best. Move 2 to 3.
  set F3=!F2!
  set score3=!score2!
  set W3=%W2%
  set H3=%H2%
  set X3=%X2%
  set Y3=%Y2%
  set Calc0or3=1
) else if !BestF!==!F2! (
  echo 2 is best. Move 1 to 0.
  set F0=!F1!
  set score0=!score1!
  set W0=%W1%
  set H0=%H1%
  set X0=%X1%
  set Y0=%Y1%
  set Calc0or3=1
) else if !BestF!==!F3! (
  echo 3 is best. Move 2 to 0.
  set F0=!F2!
  set score0=!score2!
  set W0=%W2%
  set H0=%H2%
  set X0=%X2%
  set Y0=%Y2%
) else (
  echo Error:  BestF = !BestF!  BestScore = !BestScore!
  exit /B 1
)

if %Calc0or3%==1 (

  for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -precision 15 ^
    -format "Which=%%[fx:!score0! < !score3! ? 3 : 0]\n" ^
    xc:`) do set %%L

  if !Which!==0 (
    set BestScore=%score0%
    set BestW=%W0%
    set BestH=%H0%
    set BestX=%X0%
    set BestY=%Y0%
    set BestF=%F0%
  ) else (
    set BestScore=%score3%
    set BestW=%W3%
    set BestH=%H3%
    set BestX=%X3%
    set BestY=%Y3%
    set BestF=%F3%
  )
)

if not %SSFACT%==1 (
for /F "usebackq" %%L in (`%IMG7%magick xc: ^
  -format "BestW=%%[fx:%BestW%*%SSFACT%]\nBestH=%%[fx:%BestH%*%SSFACT%]\nBestX=%%[fx:%BestX%*%SSFACT%]\nBestY=%%[fx:%BestY%*%SSFACT%]\n" ^
  info:`) do set %%L
)

echo BestScore=%BestScore%  BestF=%BestF%

if %AGAIN%==1 goto loop

set BestCrop=%BestW%x%BestH%+%BestX%+%BestY%

echo %0: BestCrop = %BestCrop%

call echoRestore

@endlocal & set %ENVPREF%BestCrop=%BestCrop%& set %ENVPREF%BestScore=%BestScore%

@exit /B 0

::-------------------------------------------------------------------------------
:: Subroutine

:tryOne

  set FRAC=%1
  set Ndx=%2

  for /F "usebackq tokens=*" %%L in (`%IM7DEV%magick ^
    -precision 15 ^
    %TMPINP% ^
    ^( +clone ^
       -sample "%%[fx:%WW%*%FRAC%/100]x%%[fx:%HH%*%FRAC%/100]^!" -fill White -colorize 100 ^
       -format "ws=%%[fx:u.w]\nhs=%%[fx:u.h]\n" ^
       +write info: ^
    ^) ^
    -process 'srchimg file stdout' +repage ^
    -format "score=%%[fx:u.mean*u.w*u.h*(%inpArea%-u.w*u.h)]\n" ^
    info:`) do (
    set outstr=%%L
    set FIRSTCH=!outstr:~0,1!
    if !FIRSTCH!==0 (
      for /F "tokens=1-4 delims=, " %%A in ("!outstr!") do (
        set ThisX=%%C
        set ThisY=%%D
      )
    ) else (
      set %%L
    )
  )

  set W!Ndx!=!ws!
  set H!Ndx!=!hs!
  set X!Ndx!=!ThisX!
  set Y!Ndx!=!ThisY!

  echo %0: FRAC=%FRAC%  Score !score!  Crop !ws!x!hs!+!ThisX!+!ThisY!

  for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -precision 15 ^
    -format "BestScore=%%[fx:!BestScore! < !score! ? !score! : !BestScore!]\n" ^
    xc:`) do set %%L

  if !BestScore!==!score! (
    set BestW=!ws!
    set BestH=!hs!
    set BestX=!ThisX!
    set BestY=!ThisY!
    set BestF=%FRAC%
  )

exit /B 0

