rem From image %1
rem make mask output %2
rem centre %3,%4 (X,Y)
rem sigma %5
rem %6 colorspace
rem Make mask of area, selected on a* and b* channels of L*a*b*
rem (or last two channels of any colorspace, eg YCbCr).
@rem
@rem Updated:
@rem   21-August-2022 Upgraded for IM v7.
@rem

set INFILE=%1
set OUTFILE=%2
set SX=%3
set SY=%4
set SIGMA=%5

set COLSP=%6
if "%COLSP%"=="." set COLSP=
if "%COLSP%"=="" set COLSP=Lab

:: 4 because that's what we do, * 1.414 because we have only 2 channels.
set MULT=6


set FMT=^
WW=%%w\nHH=%%h\n^
MULT2=%%[fx:%MULT%*2]\n^
CX=%%[fx:%SX%-3*%SIGMA%]\n^
CY=%%[fx:%SY%-3*%SIGMA%]\n^
CW=%%[fx:6*%SIGMA%]\n^
CH=%%[fx:6*%SIGMA%]\n


set WW=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "%FMT%" ^
  %INFILE%`) do set %%L
if "%WW%"=="" exit /B 1


%IMG7%magick ^
  %INFILE% ^
  -colorspace %COLSP% ^
  -channel R -evaluate set 50%% +channel ^
  -set colorspace sRGB ^
  ( +clone ^
    -crop %CW%x%CH%+%CX%+%CY% +repage ^
    -blur 0x%SIGMA% ^
    -gravity Center ^
    -crop 1x1+0+0 +repage ^
    -scale "%WW%x%HH%^!" ^
  ) ^
  -compose Difference -composite ^
  -grayscale RMS ^
  -evaluate Multiply %MULT% ^
  -negate ^
  -evaluate Pow 4 ^
  -clamp ^
  %OUTFILE%
