rem From image %1
rem make mask output %2
rem window %3 (WxH)
rem centre %4,%5 (X,Y)
rem Make mask of area, selected on mean and standard deviation.
@rem
@rem Updated:
@rem   6-August-2022 for IM v7
@rem

set INFILE=%1
set OUTFILE=%2
set WIND=%3
set SX=%4
set SY=%5

set TMPDIR=\temp\
set SELA_MN=%TMPDIR%sela_mn.miff
set SELA_SD=%TMPDIR%sela_sd.miff

set MULT=4

set WW=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "WW=%%w\nHH=%%h\nMULT2=%%[fx:%MULT%*2]" ^
  %INFILE%`) do set %%L
if "%WW%"=="" exit /B 1

call %PICTBAT%iiMeanSd ^
  %INFILE% ^
  %SELA_MN% ^
  %SELA_SD% ^
  %WIND%

%IMG7%magick ^
  %SELA_MN% ^
  ( +clone ^
    -crop 1x1+%SX%+%SY% +repage ^
    -scale "%WW%x%HH%^!" ^
  ) ^
  -compose Difference -composite ^
  -grayscale RMS ^
  -evaluate Multiply %MULT% ^
  -clamp ^
  sela_mnd.png

%IMG7%magick ^
  %SELA_SD% ^
  ( +clone ^
    -crop 1x1+%SX%+%SY% +repage ^
    -scale "%WW%x%HH%^!" ^
  ) ^
  -compose Difference -composite ^
  -grayscale RMS ^
  -evaluate Multiply %MULT2% ^
  -clamp ^
  sela_sdd.png

%IMG7%magick ^
  sela_mnd.png ^
  sela_sdd.png ^
  -compose blend ^
    -define compose:args=50 ^
    -composite ^
  -negate ^
  -evaluate Pow 3 ^
  +write sela_bl.png ^
  -threshold 50%% ^
  sela_blt.png
