rem Makes a mask, white around selected coordinates, otherwise black.
rem %1 output name.
rem %2 dimensions, WxH. [default 600x400]
rem %3 quoted list of bounding boxes.
@rem
@rem Updated:
@rem   15-August-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 do


set OUTFILE=%1
if "%OUTFILE%"=="." set OUTFILE=
if "%OUTFILE%"=="" set OUTFILE=sc_out.png

set DIMS=%~2
if "%DIMS%"=="." set DIMS=
if "%DIMS%"=="" set DIMS=600x400

set BBLIST=%~3
if "%BBLIST%"=="." set BBLIST=
if "%BBLIST%"=="" set BBLIST=10x10+40+50

call parseCommaList "%BBLIST%" nBbList BbList

set /A nBbm1=%nBbList%-1


set sQuads=
for /L %%i in (0,1,%nBbm1%) do (
  echo %%i  !BbList[%%i]!

  for /F "usebackq tokens=1-4 delims=x+" %%A in ('!BbList[%%i]!') do (
    echo %%A %%B %%C %%D

    for /F "usebackq" %%L in (`%IMG7%magick identify ^
      -format "%%[fx:%%C+%%A/2],%%[fx:%%D+%%B/2],%%[fx:%%A/2],%%[fx:%%B/2]" ^
      xc:`) do set sQuads=!sQuads! %%L
  )
)

echo sQuads=[%sQuads%]

call %PICTBAT%selCoords %OUTFILE% %DIMS% "%sQuads%"

call echoRestore

@endlocal scOUTFILE=%OUTFILE%

