rem From image %1, creates output %2 setting the mean by the "bias" method
rem (adding to channel values).
@rem
@rem New mean is either %3 only (all 3 channels)
@rem or %3, %4 and %5 (each channel separately).
@rem New means should generally be in range 0.0 to 1.0.
@rem
@rem Updated:
@rem   4-August-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 sma

set OUTF=%2
if "%OUTF%"=="." set OUTF=
if "%OUTF%"=="" set OUTF=%OUTFILE%
set OUTFILE=%OUTF%

set new_mn_R=%3
set new_mn_G=%4
set new_mn_B=%5

if "%new_mn_R%"=="." set new_mn_R=0.5
if "%new_mn_G%"=="." set new_mn_G=0.5
if "%new_mn_B%"=="." set new_mn_B=0.5

if "%new_mn_R%"=="" set new_mn_R=0.5
if "%new_mn_G%"=="" set new_mn_G=%new_mn_R%
if "%new_mn_B%"=="" set new_mn_B=%new_mn_R%

echo new_mn_R=%new_mn_R% new_mn_G=%new_mn_G% new_mn_B=%new_mn_B%

set sFMT=^
bias_R=%%[fx:100*(%new_mn_R%-p{0.0}.r)]\n^
bias_G=%%[fx:100*(%new_mn_G%-p{0.0}.g)]\n^
bias_B=%%[fx:100*(%new_mn_B%-p{0.0}.b)]

for /F "usebackq" %%L in (`%IMG7%magick ^
  %INFILE% ^
  -precision 19 ^
  -scale "1x1^!" ^
  -format "%sFMT%" ^
  info:`) do set %%L

%IMG7%magick ^
  %INFILE% ^
  -channel R -evaluate Add %bias_R%%% ^
  -channel G -evaluate Add %bias_G%%% ^
  -channel B -evaluate Add %bias_B%%% ^
  +channel ^
  %OUTFILE%


call echoRestore

endlocal & set smaOUTFILE=%OUTFILE%
