rem From image %1, creates output %2 setting the mean by the "gain" method
rem (multiplying channel values).
@rem
@rem New mean is either %3 only (all 3 channels)
@rem or %3, %4 and %5 (each channel separately).
@rem New means should generally be in range 0.0 to 1.0.
@rem
@rem If any channel has mean of zero, this will fail with division by zero.
@rem
@rem Updated:
@rem   4-August-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 smg

set OUTF=%2
if "%OUTF%"=="." set OUTF=
if "%OUTF%"=="" set OUTF=%OUTFILE%
set OUTFILE=%OUTF%

set new_mn_R=%3
set new_mn_G=%4
set new_mn_B=%5

if "%new_mn_R%"=="." set new_mn_R=0.5
if "%new_mn_G%"=="." set new_mn_G=0.5
if "%new_mn_B%"=="." set new_mn_B=0.5

if "%new_mn_R%"=="" set new_mn_R=0.5
if "%new_mn_G%"=="" set new_mn_G=%new_mn_R%
if "%new_mn_B%"=="" set new_mn_B=%new_mn_R%

echo new_mn_R=%new_mn_R% new_mn_G=%new_mn_G% new_mn_B=%new_mn_B%

set sFMT=^
gn_R=%%[fx:%new_mn_R%/p{0.0}.r]\n^
gn_G=%%[fx:%new_mn_G%/p{0.0}.g]\n^
gn_B=%%[fx:%new_mn_B%/p{0.0}.b]

set gn_R=
set gn_G=
set gn_B=

for /F "usebackq" %%L in (`%IMG7%magick ^
  %INFILE% ^
  -precision 19 ^
  -scale "1x1^!" ^
  -format "%sFMT%" ^
  info:`) do set %%L

if "%gn_R%"=="" exit /B 1
if "%gn_G%"=="" exit /B 1
if "%gn_B%"=="" exit /B 1

%IMG7%magick ^
  %INFILE% ^
  -channel R -evaluate Multiply %gn_R% ^
  -channel G -evaluate Multiply %gn_G% ^
  -channel B -evaluate Multiply %gn_B% ^
  +channel ^
  %OUTFILE%

if ERRORLEVEL 1 exit /B 1


call echoRestore

endlocal & set smgOUTFILE=%OUTFILE%

