rem From image %1 and reference image %2.
rem changes channel means of %1 to match %2,
rem writing to output %3.
rem %4 is optional keyword for method: gain or bias or pow or neggain (and case).
@rem
@rem Updated:
@rem   4-August-2022 for IM v7.
@rem

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 smi

set REF_IMG=%2

set OUTF=%3
if "%OUTF%"=="." set OUTF=
if "%OUTF%"=="" set OUTF=%OUTFILE%
set OUTFILE=%OUTF%

set METH=%4
if "%METH%"=="." set METH=
if "%METH%"=="" set METH=gain


set mn_R=
set sFMT=^
mn_R=%%[fx:p{0.0}.r]\n^
mn_G=%%[fx:p{0.0}.g]\n^
mn_B=%%[fx:p{0.0}.b]

for /F "usebackq" %%L in (`%IMG7%magick ^
  %REF_IMG% ^
  -precision 19 ^
  -scale "1x1^!" ^
  -format "%sFMT%" ^
  info:`) do set %%L
if "%mn_R%"=="" exit /B 1

if /I "%METH%"=="gain" (
  call %PICTBAT%setMeanGain %INFILE% %OUTFILE% %mn_R% %mn_G% %mn_B%
  if ERRORLEVEL 1 exit /B 1
) else if /I "%METH%"=="bias" (
  call %PICTBAT%setMeanBias %INFILE% %OUTFILE% %mn_R% %mn_G% %mn_B%
  if ERRORLEVEL 1 exit /B 1
) else if /I "%METH%"=="pow" (
  call %PICTBAT%setMeanPow %INFILE% %OUTFILE% %mn_R% %mn_G% %mn_B%
  if ERRORLEVEL 1 exit /B 1
) else if /I "%METH%"=="neggain" (
  call %PICTBAT%setMeanNegGain %INFILE% %OUTFILE% %mn_R% %mn_G% %mn_B%
  if ERRORLEVEL 1 exit /B 1
) else (
  exit /B 1
)

call echoRestore

endlocal & set smiOUTFILE=%OUTFILE%
