rem From image %1, creates output %2 setting the mean by the "power" method
rem (raising channel values be a power).
@rem
@rem New mean is either %3 only (all 3 channels)
@rem or %3, %4 and %5 (each channel separately).
@rem New means should generally be in range 0.0 to 1.0.
@rem
@rem If any channel has mean of zero, this will fail with division by zero.
@rem
@rem Updated:
@rem   4-August-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 smp

set OUTF=%2
if "%OUTF%"=="." set OUTF=
if "%OUTF%"=="" set OUTF=%OUTFILE%
set OUTFILE=%OUTF%

set new_mn_R=%3
set new_mn_G=%4
set new_mn_B=%5

if "%new_mn_R%"=="." set new_mn_R=0.5
if "%new_mn_G%"=="." set new_mn_G=0.5
if "%new_mn_B%"=="." set new_mn_B=0.5

if "%new_mn_R%"=="" set new_mn_R=0.5
if "%new_mn_G%"=="" set new_mn_G=%new_mn_R%
if "%new_mn_B%"=="" set new_mn_B=%new_mn_R%

set sFMT=^
pow_R=%%[fx:log(%new_mn_R%)/log(p{0.0}.r)]\n^
pow_G=%%[fx:log(%new_mn_G%)/log(p{0.0}.g)]\n^
pow_B=%%[fx:log(%new_mn_B%)/log(p{0.0}.b)]

set pow_R=
set pow_G=
set pow_B=

for /F "usebackq" %%L in (`%IMG7%magick ^
  %INFILE% ^
  -precision 19 ^
  -scale "1x1^!" ^
  -format "%sFMT%" ^
  info:`) do set %%L

if "%pow_R%"=="" exit /B 1
if "%pow_G%"=="" exit /B 1
if "%pow_B%"=="" exit /B 1

%IMG7%magick ^
  %INFILE% ^
  -channel R -evaluate Pow %pow_R% ^
  -channel G -evaluate Pow %pow_G% ^
  -channel B -evaluate Pow %pow_B% ^
  +channel ^
  %OUTFILE%

if ERRORLEVEL 1 exit /B 1


call echoRestore

endlocal & set smgOUTFILE=%OUTFILE%

