rem Given %1 is white shape on black background,
rem replaces shape with each line gradient
rem with black at left of shape, white at right of shape.
rem %2 output.
rem %3 rotate degrees clockwise before processing (and de-rotate after).
@rem
@rem Updated:
@rem   5-August-2022 for IM v7.
@rem


@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 s2g

if not "%2"=="" set OUTFILE=%2

set nROT=%3
if "%nROT%"=="." set nROT=
if "%nROT%"=="" set nROT=0

if %nROT%==0 (
  set IN_ROT=
  set OUT_ROT=
) else (
  set IN_ROT=-rotate %nROT% +repage
  set OUT_ROT=-rotate -%nROT% +repage
  set OUT_ROT=!OUT_ROT:--=!
)

set TMP_IMG=s2g_tmp.miff

%IMG7%magick ^
  %INFILE% ^
  -background Black ^
  %IN_ROT% ^
  +depth ^
  %TMP_IMG%

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "WW=%%w\nHH=%%h" ^
  %TMP_IMG%`) do set %%L

%IMG7%magick ^
  %TMP_IMG%^
  ( +clone ^
    -sparse-color Bilinear ^
      "0,0,Black %%[fx:w-1],0,White" ^
  ) ^
  +swap ^
  -alpha off ^
  -compose CopyOpacity -composite ^
  ( +clone ^
    -scale "1x%HH%^!" ^
    -scale "%WW%x%HH%^!" ^
    -alpha Opaque ^
  ) ^
  -compose DstOver -composite ^
  -crop x1 ^
  -auto-level ^
  -append ^
  +repage ^
  -background Black ^
  %OUT_ROT% ^
  %OUTFILE%

call echoRestore

@endlocal & set s2gOUTFILE=%OUTFILE%
