#include <stdio.h>
#include <stdlib.h>
#include "vsn_defines.h"


ModuleExport size_t shellImage(Image **images,const int argc,
  const char **argv,ExceptionInfo *exception)
{
  char * sCmd = NULL;

  int i;
  for (i=0; i < argc; i++) {
    if (i) {
      if (!ConcatenateString (&sCmd, " ")) return -1;
    }

    if (!ConcatenateString (&sCmd, argv[i])) return -1;
  }

  MagickBooleanType verbose =
    (GetImageArtifact (*images,"verbose") != (const char *) NULL);

  if (verbose)
    fprintf (stderr, "shell: sCmd = [%s]\n", sCmd);

  if (sCmd && *sCmd) {
    int r = system (sCmd);
    if (r==-1) {
      fprintf (stderr, "shell: Failed to create shell process.\n");
    } else {
      if (verbose) {
        fprintf (stderr, "shell: status %i.\n", r);
      }
    }

    sCmd = DestroyString (sCmd);
  }

  return(MagickImageFilterSignature);
}
