rem From image %1 with transparency,
rem shifts to fill in transparent holes.
@rem
@rem Optional:
@rem   %2 maximum shift in form XxY (default: W=width and Y=height)
@rem      If X or Y is zero, it won't shift in that direction.
@rem   %3 output filename
@rem   sfSTART initial shift. Default 1.
@rem   sfFLAT_COL
@rem   sfPOST_PROC post-processing applied to just the filler eg -blur 0x1
@rem   sfFAST if 1, multiplies by 2 instead of adding 1 at each iteration.
@rem   sfLTRB any of l, t, r, b.
@rem
@rem Updated:
@rem   11-July-2016 Added sfPOST_PROC
@rem   25-July-2016 Default is slower but better. Added sfFAST for old behaviour.
@rem   29-July-2020 for IM v7.

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 sf


set MAX_SHFT=%2
if "%MAX_SHFT%"=="." set MAX_SHFT=

if not "%3"=="" set OUTFILE=%3

set WW=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "WW=%%w\nHH=%%h\nmaxWH=%%[fx:max(w,h)]" ^
  %INFILE%`) do set %%L

if "%WW%"=="" exit /B 1

call parseXxY2 %WW% %HH% sfXY %MAX_SHFT%

set MAX_SHFT_W=%sfXY_X%
set MAX_SHFT_H=%sfXY_Y%

if "%sfFLAT_COL%"=="." set sfFLAT_COL=
if "%sfFLAT_COL%"=="" set sfFLAT_COL=White

if "%sfLTRB%"=="" set sfLTRB=LTRB
call %PICTBAT%getLtrb %sfLTRB%


echo %0: MAX_SHFT_W=%MAX_SHFT_W% MAX_SHFT_H=%MAX_SHFT_H%

set TMP_SCR=sf_tmp.scr

if "%sfSTART%"=="" set sfSTART=1

echo %INFILE% +write mpr:ORIG -compose DstOver >%TMP_SCR%


if "%sfFAST%"=="1" (
  set IMG=^^^( -clone 0 ^^^)
) else (
  set IMG=mpr:ORIG
)

set MAX_ITER=%maxWH%
set nITER=0
set N_SHIFT=%sfSTART%
:loop

set DONEONE=0

if %N_SHIFT% LEQ %MAX_SHFT_W% (
  if %ltrbR%==1 echo %IMG% -geometry +%N_SHIFT%+0 -composite >>%TMP_SCR%
  if %ltrbL%==1 echo %IMG% -geometry -%N_SHIFT%+0 -composite >>%TMP_SCR%
  set DONEONE=1
)

if %N_SHIFT% LEQ %MAX_SHFT_H% (
  if %ltrbB%==1 echo %IMG% -geometry +0+%N_SHIFT% -composite >>%TMP_SCR%
  if %ltrbT%==1 echo %IMG% -geometry +0-%N_SHIFT% -composite >>%TMP_SCR%
  set DONEONE=1
)

set /A nITER+=1

if "%sfFAST%"=="1" (
  set /A N_SHIFT*=2
) else (
  set /A N_SHIFT+=1
)

if %nITER% LSS %MAX_ITER% if %DONEONE%==1 goto loop

echo %0: nITER=%nITER%

if "%IM_VSN_6or7%"=="" call %PICTBAT%isIm6or7

echo %sfPOST_PROC% mpr:ORIG -background %sfFLAT_COL% -compose Over -composite >>%TMP_SCR%


if "%IM_VSN_6or7%"=="6" (
  echo +write %OUTFILE% >>%TMP_SCR%
  %IM%convert @%TMP_SCR% NULL:
) else (
  set OUTFILE2=!OUTFILE:\=\\!
  echo +write !OUTFILE2! >>%TMP_SCR%
  echo -exit >>%TMP_SCR%
  %IMG7%magick -script %TMP_SCR%
)

if ERRORLEVEL 1 exit /B 1

call echoRestore

endlocal & set sfOUTFILE=%OUTFILE%
