rem Like shp2grad.bat but puts gradient outside the shape.

rem %1 input image, white shape on black background.
rem %2 output, replacing white with gradient from white at the centre to black at edge of shape.
rem "Centre" is point at furthest distance from shape edge.
@rem
@rem Also uses:
@rem   shp2goProcBW process for the black and white image, eg -blur 0x3 -auto-level
@rem
@rem Updated:
@rem   4-March-2023 changed Euclidean:4 to Euclidean:7
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

rem @call echoOffSave

call %PICTBAT%setInOut %1 shp2g

if not "%2"=="" set OUTFILE=%2

set CX=

for /F "usebackq tokens=1,4,5 delims=:, " %%A in (`%IMG7%magick ^
  %INFILE% ^
  -morphology Distance Euclidean:7 ^
  -auto-level ^
  -define "identify:locate=maximum" ^
  -define "identify:limit=1" ^
  -identify ^
  NULL:`) do (
  echo %%A %%B %%C
  if /I "%%A"=="Gray" (
    set CX=%%B
    set CY=%%C
  )
)

if "%CX%"=="" (
  echo %0: no peak white
  exit /B 1
)

rem echo %0: CX=%CX% CY=%CY%

rem We want to make black into gray(50%), but keep white as white.
rem v'  = v/2 + 0.5

%IMG7%magick ^
  %INFILE% ^
  -function polynomial "0.5,0.5" ^
  -virtual-pixel Black ^
  -distort DePolar -1,0,%CX%,%CY% ^
  -virtual-pixel Edge ^
  -set option:MYSIZE %%wx%%h ^
  ( -clone 0 ^
    -evaluate Multiply 2 -clamp ^
    %shp2goProcBW% ^
    ( -size %%[MYSIZE] ^
      gradient:Black-White ^
    ) ^
    ( -clone 0 ^
      -crop 0x+0+1 +repage ^
      -scale "x1^!" ^
      -scale "%%[MYSIZE]^!" ^
    ) ^
    -delete 0 ^
    -compose DivideSrc -composite ^
    -clamp ^
    -negate ^
  ) ^
  ( -clone 0 ^
    -flip -negate ^
    -evaluate Multiply 2 -clamp ^
    %shp2goProcBW% ^
    ( -size %%[MYSIZE] ^
      gradient:Black-White ^
    ) ^
    ( -clone 0 ^
      -crop 0x+0+1 +repage ^
      -scale "x1^!" ^
      -scale "%%[MYSIZE]^!" ^
    ) ^
    -delete 0 ^
    -compose DivideSrc -composite ^
    -clamp ^
    -flip ^
  ) ^
  -delete 0 ^
  -fx "u/(u-v+1)" ^
  -virtual-pixel Edge ^
  -distort Polar -1,0,%CX%,%CY% ^
  %OUTFILE%