rem %1 input image, white image on black background
rem %2 centre: "furthest" or "centroid" or "boundingbox"
rem      or "XxY" where X and Y are numbers, both possibly suffixed by %% or c or p.
rem      Default is coordinate at furthest distance from shape edge.
rem %3 prefix for environment variables _CX and _CY

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 shpc

set sCent=%2
if "%sCent%"=="." set sCent=
if "%sCent%"=="" set sCent=furthest

set EnvPref=%3
if "%EnvPref%"=="." set EnvPref=
if "%EnvPref%"=="" set EnvPref=shpc

if /I "%sCent%"=="furthest" (

  for /F "usebackq tokens=1,4,5 delims=:, " %%A in (`%IMG7%magick ^
    %INFILE% ^
    -colorspace Gray ^
    -morphology Distance Euclidean:7 ^
    -alpha off -auto-level ^
    -define "identify:locate=maximum" ^
    -define "identify:limit=1" ^
    -identify ^
    NULL:`) do (
    if /I "%%A"=="Gray" (
      set CX=%%B
      set CY=%%C
    )
  )

) else if /I "%sCent%"=="centroid" (

  for /F "usebackq skip=1 tokens=3-6 delims=, " %%A in (`%IMG7%magick ^
    %INFILE% -alpha off -threshold 50% ^
    -define "connected-components:verbose=true" ^
    -connected-components 8 ^
    NULL:`) do (
    if "%%D"=="gray(255)" (
      set CX=%%A
      set CY=%%B
    )
  )

) else if /I "%sCent%"=="boundingbox" (

  for /F "usebackq" %%L in (`%IMG7%magick ^
    %INFILE% -alpha off -threshold 50% ^
    -trim ^
    -format "CX=%%[fx:(w-1)/2+page.x]\nCY=%%[fx:(h-1)/2+page.y]\n" ^
    info:`) do set %%L

) else (
  for /F "usebackq" %%A in (`%IMG7%magick ^
    %INFILE% -format "WW=%%w\nHH=%%h\n" ^
    info:`) do set %%A

  call parseXxY2 !WW! !HH! acw %sCent%

  set CX=!acw_X!
  set CY=!acw_Y!
)

echo %0: CX=%CX% CY=%CY%

if "!CX!"=="" (
  echo %0: sCent=%sCent%  no CX
  exit /B 1
)

if ERRORLEVEL 1 exit /B 1

call echoRestore

endlocal & set %EnvPref%_CX=%CX%& set %EnvPref%_CY=%CY%
