rem Downsampling with halo minimization.
rem   %1 is input image.
rem   %2 is resize, eg 50% or 800x800, etc.
rem   %3 output filename
rem   %4 is sharpen amount (0=none, 50=default)

@rem This is a simplification of resampHM,
@rem for downsampling with sharpening, with no deconvolution.

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 shsh

if not "%3"=="" if not "%3"=="." set OUTFILE=%3

set mSize=%2
if "%mSize%"=="." set mSize=
if "%mSize%"=="" set mSize=100%

set shpAmount=%4
if "%shpAmount%"=="." set shpAmount=
if "%shpAmount%"=="" set shpAmount=50

@rem If working in AdobeRGB1998, replace the next two lines with:
@rem
@rem   set colspIn=-evaluate Pow 2.19921875
@rem   set colspOut=-evaluate Pow 0.4547069271758437
@rem
@rem For images with embedded profiles, use:
@rem
@rem   set colspIn=-write IMprofile.icc -profile sRGB.icc -set colorspace sRGB -colorspace RGB
@rem   set colspOut=-set colorspace RGB -colorspace sRGB -profile IMprofile.icc

set colspIn=-colorspace RGB
set colspOut=-set colorspace RGB -colorspace sRGB


%IMG7%magick ^
  %INFILE% ^
  ( +clone -alpha extract ^
    -resize %mSize% -write mpr:ALP +delete ^
  ) ^
  -alpha off ^
  -colorspace RGB ^
  -define filter:c=0.1601886205085204 -filter Cubic -distort Resize %mSize% ^
  ( -clone 0 ^
    -evaluate Pow %%[fx:1/3] ^
    -define convolve:scale=%shpAmount%%%,100 -morphology Convolve DoG:3,0,0.4981063336734057 ^
    -evaluate Pow 3 ^
  ) ^
  ( -clone 0 ^
    -define convolve:scale=%shpAmount%%%,100 -morphology Convolve DoG:3,0,0.4981063336734057 ^
  ) ^
  -delete 0 ^
  ( -clone 1 -colorspace gray -auto-level ) ^
  -compose over -composite ^
  -set colorspace RGB -colorspace sRGB ^
  mpr:ALP -compose CopyOpacity -composite ^
  +depth ^
  %OUTFILE%


call echoRestore

@endlocal & set shshOUTFILE=%OUTFILE%
