rem From image %1,
rem %2 is operation, either colors or posterize,
rem simplifies with -colors N or -posterize N
rem for N=%3 to %4.
rem Creates html table %5.
rem %6 is colorspace.
rem %7 channel (R or G or B) to set to 50%. If blank or dot, don't set any to 50%.
@rem
@rem Updated:
@rem   6-August-2022 for IM v7
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 sc

set sOperation=%2
if "%sOperation%"=="." set sOperation=
if "%sOperation%"=="" set sOperation=colors

set nLo=%3
if "%nLo%"=="." set nLo=
if "%nLo%"=="" set nLo=1

set nHi=%4
if "%nHi%"=="." set nHi=
if "%nHi%"=="" set nHi=10

set HTMFILE=%5
if "%HTMFILE%"=="." set HTMFILE=
if "%HTMFILE%"=="" set HTMFILE=sc_htm.htm

set COLSP=%6
if "%COLSP%"=="." set COLSP=
if "%COLSP%"=="" set COLSP=sRGB

set CH50=%7
if "%CH50%"=="." set CH50=

if "%COLSP%"=="sRGB" (
  set sCOLSP_IN=
  set sCOLSP_OUT=
) else (
  set sCOLSP_IN=-colorspace %COLSP% -set colorspace sRGB
  set sCOLSP_OUT=-set colorspace %COLSP% -colorspace sRGB
)

if "%CH50%"==""  (
  set sCH50=
  set sLEVEL=
) else (
  set sCH50=-channel %CH50% -evaluate set 50%%%% +channel
  set sLEVEL=-channel RGB -auto-level +channel
)

for /F %%L in ("%HTMFILE%") do set FILEBASE=%%~nL

set CSVFILE=%FILEBASE%.csv

echo N,RMSE,Image,nCol >%CSVFILE%

set ERR=0

( for /L %%N in (%nLo%,1,%nHi%) do (

  set FNAME=%FILEBASE%_sc_%sOperation%_%%N.png

  set UNIQ=
  for /F "usebackq" %%L in (`%IMG7%magick ^
    %INFILE% ^
    %sCOLSP_IN% ^
    %sCH50% ^
    +dither ^
    -%sOperation% %%N ^
    %sCOLSP_OUT% ^
    %sLEVEL% ^
    +write !FNAME! ^
    -format "UNIQ=%%k\n" ^
    +write info: ^
    NULL:`) do set %%L

  if "!UNIQ!"=="" set ERR=1

  for /F "usebackq" %%L in (`%IMG7%magick ^
    %INFILE% ^
    !FNAME! ^
    -metric RMSE ^
    -compare ^
    -format "DIST=%%[distortion]\n" ^
   info:`) do set %%L

  if "!DIST!"=="" set ERR=1

  rem echo ^<tr^>^<td^>%%N^</td^>^<td^>!DIST!^</td^>^<td^>^<img src="!FNAME!" /^>^</td^>^<td^>!UNIQ!^</td^>^</tr^>

  echo %%N,!DIST!,^<img src="!FNAME!" /^>,!UNIQ!
)
) >>%CSVFILE%

call csv2tab %FILEBASE%

call echoRestore

@if %ERR%==1 exit /B 1

@endlocal
