rem Given %1 is a white 4-connected skeleton enclosing black components,
rem %2 is output name
rem creates:
rem   _compst image where each component is different shade of gray, with transparent boundaries
rem   _compsf likewise, with boundaries filled (by shift right and down)
rem   _grays  Nx1 image of the gray colours
@rem
@rem Updated:
@rem   6-August-2022 for IM v7
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 s2p

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set FILE_FMT=%OUTFILE%

for /F %%F in ("%FILE_FMT%") do (
  set IMG_COMPST=%%~dpnF_compst%%~xF
  set IMG_COMPSF=%%~dpnF_compsf%%~xF
  set IMG_GRAYS=%%~dpnF_grays%%~xF
)

del %IMG_COMPST% 2>nul
del %IMG_COMPSF% 2>nul
del %IMG_GRAYS% 2>nul

set COMPLIST=s2p_complist.lis

%IMG7%magick ^
  %INFILE% ^
  -colorspace Gray ^
  -alpha off ^
  -negate ^
  -define "connected-components:verbose=true" ^
  -connected-components 4 ^
  NULL: >%COMPLIST%

if ERRORLEVEL 1 exit /B 1

set HAS_ANY=0
set CH_COLS=
set CH_EXCL=
set nFnd=0
set nExcl=0
for /F "skip=1 tokens=1-5 delims=: " %%A in (%COMPLIST%) do (
  set HAS_ANY=1
  set /A nFnd+=1

  set ID=%%A
  set BND_BOX=%%B
  set CENTROID=%%C
  set AREA=%%D
  set COL=%%E

  if /I "!COL!"=="gray(0)" (
    set CH_EXCL=!CH_EXCL!,!ID!
    set /A nExcl+=1
  )
)

if %HAS_ANY%==0 (
  echo ** No components?? **
  exit /B 1
)

:: remove leading comma
set CH_EXCL=%CH_EXCL:~1%
echo %0: CH_EXCL=%CH_EXCL%

:: FIXME? not necessarily an error.
if "%CH_EXCL%"=="" exit /B 1

%IMG7%magick ^
  %INFILE% ^
  -define "connected-components:remove=%CH_EXCL%" ^
  -connected-components 4 ^
  -background Black -alpha Background ^
  -auto-level ^
  +write %IMG_COMPST% ^
  -compose DstOver ^
  ( -clone 0 ) -geometry +1+0 -composite ^
  ( -clone 0 ) -geometry +0+1 -composite ^
  ( -clone 0 ) -geometry +2+0 -composite ^
  ( -clone 0 ) -geometry +0+2 -composite ^
  -compose Over ^
  +write %IMG_COMPSF% ^
  -unique-colors ^
  +write %IMG_GRAYS% ^
  %OUTFILE%

call echoRestore

endlocal & set s2pOUTFILE=%OUTFILE%
