rem From %1, white 4-connected skeleton on black bacground,
rem make %2 a partition boundary image.
rem %3 is threshold for proximity [Default 12]
rem %4 is threshold for extending [Default 2 * prox_threshold]
rem %5 is length for pruning [Default 0]
rem %6 is threshold for t-junctions [Default ext_threshold]
@rem
@rem Updated:
@rem   6-August-2022 for IM v7
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 s2bd

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set PROX_TH=%3
if "%PROX_TH%"=="." set PROX_TH=
if "%PROX_TH%"=="" set PROX_TH=12

set EXT_TH=%4
if "%EXT_TH%"=="." set EXT_TH=
if "%EXT_TH%"=="" set /A EXT_TH=2*%PROX_TH%

set nPRUNE=%5
if "%nPRUNE%"=="." set nPRUNE=
if "%nPRUNE%"=="" set nPRUNE=0

set TJ_TH=%6
if "%TJ_TH%"=="." set TJ_TH=
if "%TJ_TH%"=="" set TJ_TH=%EXT_TH%

set TMP_OUT=%BASENAME%_%sioCODE%.tiff

set skelLineEnds=1

echo %0: proxLineEnds %PROX_TH% ...
call %PICTBAT%proxLineEnds ^
  %INFILE% ^
  %TMP_OUT% ^
  %PROX_TH%

if ERRORLEVEL 1 exit /B 1

set /A EXT_TH_2=(%EXT_TH%+1)/4

echo %0: extLineEnds EXT_TH=%EXT_TH% EXT_TH_2=%EXT_TH_2% ...

if %EXT_TH_2% LSS %EXT_TH% (

  echo %0: extLineEnds first %EXT_TH_2% ...

  call %PICTBAT%extLineEnds ^
    %TMP_OUT% ^
    %TMP_OUT% ^
    %EXT_TH_2%

  if ERRORLEVEL 1 exit /B 1
)

echo %0: extLineEnds second %EXT_TH% ...

call %PICTBAT%extLineEnds ^
  %TMP_OUT% ^
  %TMP_OUT% ^
  %EXT_TH%

if ERRORLEVEL 1 exit /B 1

echo %0: extLineEnds finished

rem %IMG7%magick ^
rem   %TMP_OUT% ^
rem   ( +clone ^
rem     -morphology HMT 3x3:1,1,1,1,0,1,1,1,1 ) ^
rem   -compose Lighten -composite -compose Over ^
rem   -morphology Thinning:-1 Skeleton ^
rem   -threshold 50% ^
rem   -morphology Close Disk:2 ^
rem   -threshold 50%% ^
rem   -morphology Thinning:-1 Skeleton ^
rem   %TMP_OUT%

%IMG7%magick ^
  %TMP_OUT% ^
  -clamp ^
  -morphology Close Disk:2 ^
  -alpha off ^
  -threshold 50%% ^
  -morphology Thinning:-1 Skeleton -clamp ^
  -alpha off ^
  %TMP_OUT%

if ERRORLEVEL 1 exit /B 1

echo %0: prune %nPRUNE% %nPRUNE%...
if not %nPRUNE%==0 call %PICTBAT%pruneStubs ^
  %TMP_OUT% ^
  %TMP_OUT% ^
  %nPRUNE%

if ERRORLEVEL 1 exit /B 1

%IMG7%magick ^
  %TMP_OUT% ^
  -clamp ^
  -bordercolor White -border 1 ^
  %TMP_OUT%

if ERRORLEVEL 1 exit /B 1

echo %0: TjuncLineEnds %TJ_TH%...
call %PICTBAT%TjuncLineEnds ^
  %TMP_OUT% ^
  %TMP_OUT% ^
  %TJ_TH%

if ERRORLEVEL 1 exit /B 1

%IMG7%magick ^
  %TMP_OUT% ^
  -clamp ^
  -shave 1 ^
  -morphology Close Disk:2 ^
  -alpha off ^
  -threshold 50%% ^
  -morphology Thinning:-1 Skeleton -clamp ^
  -alpha off ^
  -threshold 50%% ^
  %TMP_OUT%

if ERRORLEVEL 1 exit /B 1

echo %0: pruneStubsRep...
call %PICTBAT%pruneStubsRep ^
  %TMP_OUT% ^
  %OUTFILE% ^
  all

if ERRORLEVEL 1 exit /B 1


call echoRestore

endlocal & set s2bdOUTFILE=%OUTFILE%
