rem Slope magnitude
rem 
rem Returns the magnitude of the slope.
@rem
@rem  If %2 is given, uses this as the output filename.
@rem
@rem Also uses:
@rem   smAUTO if 0, doesn't "-auto-level -auto-gamma"
@rem
@rem Updated:
@rem   14-July-2022 for IM v7.
@rem   26-July-2022 Replace "-evaluate Pow 2 -compose plus -composite -evaluate Pow 0.5" by "-fx hypot(u,v)"
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 sm

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

if "%smAUTO%"=="0" (
  set AUTO=
) else (
  set AUTO=-auto-level -auto-gamma
  set AUTO=-auto-level
)

%IMG7%magick ^
  %INFILE% ^
  -alpha off ^
  -define convolve:scale="50%%^!" -bias 50%% ^
  ( -clone 0 -morphology Convolve Sobel:0 ) ^
  ( -clone 0 -morphology Convolve Sobel:90 ) ^
  -delete 0 ^
  -solarize 50%% -level 50,0%% ^
  +level 0,70.71067811865475%% ^
  -fx "hypot(u,v)" ^
  -separate -evaluate-sequence Max ^
  %AUTO% ^
  +depth ^
  -define quantum:format=integer ^
  %OUTFILE%

if ERRORLEVEL 1 exit /B 1

call echoRestore

endlocal & set smOUTFILE=%OUTFILE%
