rem Like slopeMag.bat, but for multi-image files.
@rem
@rem Updated:
@rem   26-July-2022 replace "-evaluate Pow 2 -compose plus -composite -evaluate Pow 0.5" by "-fx hypot(u,v)"
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 sms

if not "%2"=="" set OUTFILE=%2

set TMP_PREF=sm_%~n1

if "%smAUTO%"=="0" (
  set AUTO=
) else (
  set AUTO=-auto-level -auto-gamma
)

rem This works best with Q32 HDRI.

set isNm1=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "isNm1=%%[fx:n-1]\n" ^
  %INFILE%`) do set %%L

if "%isNm1%"=="" exit /B 1

set FACT=1
set FILE_LIST=
for /L %%N in (0,1,%isNm1%) do (
  %IM7DEV%magick ^
  %INFILE%[%%N] ^
  -alpha off ^
  -define convolve:scale="50%%^!" -bias 50%% ^
  ^( -clone 0 -morphology Convolve Sobel:0 ^) ^
  ^( -clone 0 -morphology Convolve Sobel:90 ^) ^
  -delete 0 -solarize 50%% -level 50,0%% ^
  +level 0,70.71067811865475%% ^
  -fx "hypot(u,v)" ^
  -separate -evaluate-sequence Max ^
  %AUTO% ^
  -evaluate Multiply !FACT! ^
  -depth 64 ^
  -define quantum:format=floating-point ^
  %TMP_PREF%_%%N.tiff

  for /F "usebackq" %%L in (`%IMG7%magick identify ^
    -format "FACT=%%[fx:!FACT!*1.414]\n" ^
    xc:`) do set %%L

  set FILE_LIST=!FILE_LIST! %TMP_PREF%_%%N.tiff
)

rem %IMG7%magick %FILE_LIST% %OUTFILE%

tiffcp %FILE_LIST% %OUTFILE%
if ERRORLEVEL 1 exit /B 1

del %FILE_LIST%

call echoRestore

endlocal & set smOUTFILE=%OUTFILE%
