rem From colour image %1,
rem find slope of RGB channels.
rem Write output to _two_ images %2: first is x-slope, second is y-slope.
rem %3 is optional pre-process.
rem In output, 0% means no slope, > 0% value increases rightwards or downwards.
@rem Assumes IM is HDRI.
@rem
@rem Updated:
@rem   12-July-2022 Upgraded for IM v7.

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 sxy

if not "%2"=="" set OUTFILE=%2

set PREPROC=%~3
if "%PREPROC%"=="." set PREPROC=

%IMG7%magick ^
  %INFILE% ^
  %PREPROC% ^
  -alpha off ^
  -virtual-pixel Edge ^
  ( -clone 0 -morphology Convolve 3x1:1,0,-1 ) ^
  ( -clone 0 -morphology Convolve 1x3:1,0,-1 ) ^
  -delete 0 ^
  +depth ^
  -depth 32 ^
  -define "quantum:format=floating-point" ^
  %OUTFILE%

if ERRORLEVEL 1 exit /B 1

call echoRestore

endlocal & set sxyOUTFILE=%OUTFILE%
