rem Given %1 is slopeXY structure (thus contains 2 images)
rem returns %2 scalar image, the divergence of %1.
@rem
@rem The divergence of %1 is the x-slope of the x component,
@rem plus the y-slope of the y component.
@rem See Perez and https://en.wikipedia.org/wiki/Divergence.
@rem (Yeah, I think this is weird.)
@rem We find slope in the same way as slopeXY.bat.
@rem Assumes IM is HDRI.
@rem
@rem Updated:
@rem   25-June-2017 Removed bias 50%.
@rem   12-July-2022 Upgraded for IM v7.

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 sxyd

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

%IMG7%magick ^
  -define compose:clamp=off ^
  ( %INFILE%[0] ^
    -alpha off ^
    -morphology Convolve 3x1:0.5,0,-0.5 ^
  ) ^
  ( %INFILE%[1] ^
    -alpha off ^
    -morphology Convolve 1x3:0.5,0,-0.5 ^
  ) ^
  -compose Mathematics -define compose:args=0,0.5,0.5,0 -composite ^
  +depth ^
  -depth 32 ^
  -define "quantum:format=floating-point" ^
  %OUTFILE%

if ERRORLEVEL 1 (
  echo %0: Failed
  exit /B 1
)

call echoRestore

endlocal & set sxydOUTFILE=%OUTFILE%

