rem Given %1 is slopeXY structure (thus contains 2 images),
rem returns %2 conventional RGB image
rem with channels set to magnitude.
rem %3 if AUTOLEV, auto-levels the output.
@rem
@rem Assumes magick is HDRI.
@rem
@rem Updated:
@rem   25-June-2017 Removed 50% bias
@rem   22-July-2022 Upgraded for IM v7.
@rem   26-July-2022 Replace "-evaluate Pow 2 -compose plus -composite -evaluate Divide 2 -evaluate Pow 0.5" by "-fx sqrt((u*u+v*v)/2)"
@rem

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 sxym

if not "%2"=="" set OUTFILE=%2

set AUTOLEV=%3
if /I "%AUTOLEV%"=="AUTOLEV" (
  set sAUTOLEV=-auto-level
) else (
  set sAUTOLEV=
)

goto skip

%IMG7%magick ^
  %INFILE% ^
  -channel RGB ^
  -evaluate Pow 2 ^
  -separate ^
  -define compose:clamp=off ^
  ( -clone 0,3 -compose plus -composite ) ^
  ( -clone 1,4 -compose plus -composite ) ^
  ( -clone 2,5 -compose plus -composite ) ^
  -delete 0-5 ^
  -evaluate Divide 2 ^
  -evaluate Pow 0.5 ^
  -combine ^
  %sAUTOLEV% ^
  +depth ^
  -depth 32 ^
  -define "quantum:format=floating-point" ^
  %OUTFILE%

%IMG7%magick ^
  %INFILE% ^
  -channel RGB ^
  -evaluate Pow 2 ^
  -define compose:clamp=off ^
  -compose plus -composite ^
  -evaluate Divide 2 ^
  -evaluate Pow 0.5 ^
  %sAUTOLEV% ^
  +depth ^
  -depth 32 ^
  -define "quantum:format=floating-point" ^
  %OUTFILE%

:skip

%IMG7%magick ^
  %INFILE% ^
  -channel RGB ^
  -fx "sqrt((u*u+v*v)/2)" ^
  %sAUTOLEV% ^
  +depth ^
  -depth 32 ^
  -define "quantum:format=floating-point" ^
  %OUTFILE%

if ERRORLEVEL 1 exit /B 1

call echoRestore

endlocal & set sxymOUTFILE=%OUTFILE%
