rem Given %1 and %2 are slopeXY structures (thus contain 2 images each)
rem returns %3 a slopeXY structure, each channel is half (%2 minus %1.)
@rem
@rem Assumes magick is HDRI.
@rem
@rem Updated:
@rem   25-June-2017 Removed 50% bias.
@rem   22-July-2022 Upgraded for IM v7.


@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 sxyd

if not "%3"=="" if not "%3"=="." set OUTFILE=%3

set IN_A=%INFILE%
set IN_B=%2

%IMG7%magick ^
  -define compose:clamp=off ^
  ( %IN_A%[0] ^
    %IN_B%[0] ^
    -compose Mathematics -define compose:args=0,0.5,-0.5,0 -composite ^
  ) ^
  ( %IN_A%[1] ^
    %IN_B%[1] ^
    -compose Mathematics -define compose:args=0,0.5,-0.5,0 -composite ^
  ) ^
  +depth ^
  -depth 32 ^
  -define "quantum:format=floating-point" ^
  %OUTFILE%


call echoRestore

endlocal & set sxydOUTFILE=%OUTFILE%
