rem %1 input text file of x, v for sparse integer values of x.
rem %2 output text file of x, v for all x from first to last.
rem %3 smoothing method [mcsplines].
@rem
@rem Updated:
@rem   5-September-2021 Changed "gnuplot" to "gnuplot-base".
@rem

@rem Beware: gnuplot may duplicate x-values, and create non-integer x-values.

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

set INFILE=%1

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set MTHD=%3
if "%MTHD%"=="." set MTHD=
if "%MTHD%"=="" set MTHD=mcsplines

set TMPSCR=\temp\ss_gp_script.gp

rem type %INFILE%

:: Get first and last values from INFILE, to calculate number of samples.

set nFIRST=
set nLAST=

for /F "tokens=1,2 eol=# delims=, " %%A in (%1) do (
  if "!nFIRST!"=="" set nFIRST=%%A
  set nLAST=%%A
)

if "%nFIRST%"=="" exit /B 1

set /A nSAMPS=%nLAST%-%nFIRST%+1

rem echo %0: %nFIRST% %nLAST% %nSAMPS%

(
  echo set samples %nSAMPS%
  echo set table "%OUTFILE%"
  echo plot '%INFILE%' using 1:2 smooth %MTHD%
  echo unset table

) >%TMPSCR%

gnuplot-base %TMPSCR%

call echoRestore

@endlocal & set ssOUTFILE=%OUTFILE%
