rem %1 input text file of x, y, r, g, b for sparse integer values of x and y.
rem %2 output text files of x, y, v for all x and y from first to last.
rem %3 number of channels, 1 to 3 [default 3]

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

set INFILE=%1

set NumChan=%3
if "%NumChan%"=="." set NumChan=
if "%NumChan%"=="" set NumChan=3

:: Note: gnuplot can't handle F: etc in file path.
set OUTFILE0=%~n2_0%~x2
set OUTFILE1=%~n2_1%~x2
set OUTFILE2=%~n2_2%~x2

echo %0: %OUTFILE0% %OUTFILE1% %OUTFILE2%

set TMPSCR=\temp\ss3c_gp_script.gp

rem type %INFILE%

set nFIRSTx=
set nLASTx=
set nFIRSTy=
set nLASTy=

for /F "tokens=1,2 eol=# delims=, " %%A in (%INFILE%) do (
  if "!nFIRSTx!"=="" set nFIRSTx=%%A
  if "!nLASTx!"=="" set nLASTx=%%A
  if !nFIRSTx! GTR %%A set nFIRSTx=%%A
  if !nLASTx! LSS %%A set nLASTx=%%A
  if "!nFIRSTy!"=="" set nFIRSTy=%%B
  if "!nLASTy!"=="" set nLASTy=%%B
  if !nFIRSTy! GTR %%B set nFIRSTy=%%B
  if !nLASTy! LSS %%B set nLASTy=%%B
)

echo %0: X from %nFIRSTx% to %nLASTx%
echo %0: Y from %nFIRSTy% to %nLASTy%

if "%nFIRSTx%"=="" exit /B 1

set /A nSAMPSx=%nLASTx%-%nFIRSTx%+1
set /A nSAMPSy=%nLASTy%-%nFIRSTy%+1

echo %0: samps: %nSAMPSx% %nSAMPSy%

:: We tell gnuplot not to use decimals.
:: FIXME: gnuplot can create negative numbers, which barf IM's PNM reader.

(
  echo set format "%%.0f"
  echo set dgrid3d %nSAMPSy%,%nSAMPSx% splines
  echo set table "%OUTFILE0%"
  echo splot '%INFILE%' using 1:2:3

  if %NumChan% GTR 1 (
    echo set table "%OUTFILE1%"
    echo splot '%INFILE%' using 1:2:4

    if %NumChan% GTR 2 (
      echo set table "%OUTFILE2%"
      echo splot '%INFILE%' using 1:2:5
    )
  )
  echo unset table
  echo unset dgrid3d

) >%TMPSCR%

type %TMPSCR%

gnuplot-base %TMPSCR%

if ERRORLEVEL 1 (
  echo %0: gnuplot failed
  exit /B 1
)


call echoRestore

endlocal & set ss3cOUTFILE=%OUTFILE%& ^
set ss3cFirstX=%nFIRSTx%& ^
set ss3cLastX=%nLASTx%& ^
set ss3cFirstY=%nFIRSTy%& ^
set ss3cLastY=%nLASTy%
