rem %1 input image to be distorted (WWxHH pixels)
rem %2 horizontal slut, WWx1 pixels
rem %3 vertical slut, HHx1 pixels
rem %4 output filename
rem %5 horizontal percentage scale or "auto"
rem %6 vertical percentage scale or "auto"

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 sml

set HSLUT=%~2
if "%HSLUT%"=="." set HSLUT=

set VSLUT=%~3
if "%VSLUT%"=="." set VSLUT=

if not "%4"=="" if not "%4"=="." set OUTFILE=%4

set HSCALE=%5
if "%HSCALE%"=="." set HSCALE=
if "%HSCALE%"=="" set HSCALE=auto

set VSCALE=%6
if "%VSCALE%"=="." set VSCALE=
if "%VSCALE%"=="" set VSCALE=auto

if "%HSLUT%"=="" (
  set HS=-size %%[WW]x1 xc: -set option:HMEANPC 100 -sparse-color Bilinear 0,0,Black,%%[fx:w-1],0,White
) else (
  set HS=%HSLUT% -set option:HMEANPC %%[fx:mean*100] -process 'cumulhisto norm' -auto-level -process 'invclut' -auto-level
)

if "%VSLUT%"=="" (
  set VS=-size %%[HH]x1 xc: -set option:VMEANPC 100 -sparse-color Bilinear 0,0,Black,%%[fx:w-1],0,White
) else (
  set VS=%VSLUT% -set option:VMEANPC %%[fx:mean*100] -process 'cumulhisto norm' -auto-level -process 'invclut' -auto-level
)

echo HS=%HS%

if %HSCALE%==auto (
  set HSC=%%[HMEANPC]
) else (
  set HSC=%HSCALE%
)

if %VSCALE%==auto (
  set VSC=%%[VMEANPC]
) else (
  set VSC=%VSCALE%
)

set RESZ=
if not %HSC%==100 set RESZ=-resize "%HSC%x%VSC%%%^!"
if not %VSC%==100 set RESZ=-resize "%HSC%x%VSC%%%^!"

%IM7DEV%magick ^
  %INFILE% ^
  -set option:WW %%w ^
  -set option:HH %%h ^
  ( %HS% ^
    -scale "%%[WW]x%%[HH]^!" ^
  ) ^
  ( %VS% ^
    -rotate 90 ^
    -scale "%%[WW]x%%[HH]^!" ^
  ) ^
  ( +clone ^
    -fill #888 -colorize 100 ^
  ) ^
  ( -clone 1-3 ^
    -combine ^
  ) ^
  -delete 1-3 ^
  -compose Distort -composite ^
  %RESZ% ^
  %OUTFILE%

call echoRestore

@endlocal

