rem Search for an mp7 image.
@rem %1 is the NxM cumulative image to be searched.
@rem %2 is the Nx1 image to be searched for.
@rem %3 is prefix environment variable for returned result.
@rem %4, if not blank or . will not return that index.
@rem %5 assumed value of M.
@rem
@rem Returns result:
@rem  .ndx  number from 0
@rem  .rmse
@rem
@rem Updated:
@rem   25-September-2022 for IM v7.
@rem

@if "%3"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave



set BIG_IMG=%1
set SML_IMG=%2
set ENV_PREF=%3

set THIS_NDX=%4
if "%THIS_NDX%"=="." set THIS_NDX=

set ASSUME_Mm1=%5
if "%ASSUME_Mm1%"=="." set ASSUME_Mm1=

set TMP_BIG=sm7_big.miff

if "%THIS_NDX%"=="" (
  set WHICH=%BIG_IMG%
) else (

  if "%ASSUME_Mm1%"=="" (
    for /F "usebackq" %%L in (`%IMG7%magick identify -format "Wm1=%%[fx:w-1]" %BIG_IMG%`) do set %%L
  ) else (
    set Wm1=%ASSUME_Mm1%
  )

  %IMG7%magick ^
    %BIG_IMG% ^
    -draw "line 0,%THIS_NDX% !Wm1!,%THIS_NDX%" ^
    %TMP_BIG%

  set WHICH=%TMP_BIG%
)

for /F "usebackq tokens=2,3,4 delims=()@, " %%L in (`%IMG7%magick compare ^
  -metric RMSE ^
  -similarity-threshold 0 ^
  -dissimilarity-threshold 1 ^
  -subimage-search ^
  %WHICH% %SML_IMG% NULL: 2^>^&1`) do (
  set fwS=%%L
  set fwX=%%M
  set fwY=%%N
)
rem echo %0: %fwS% %fwX% %fwY%

call echoRestore

endlocal & set %ENV_PREF%.ndx=%fwY%& set %ENV_PREF%.rmse=%fwS%