rem Find pixels that are greater than J * local mean plus k * local standard deviation,
rem where mean and SD are of windowed pixels _excluding_ central pixel.
rem
rem %1 input
rem %2 output
rem %3 window size [3x3]
rem %4 factor J [1]
rem %5 factor K [3]
rem %6 offset L [0]
rem Returns white where  v > [J * mean(v) + K * std_dev(v) + L],
rem otherwise black.
@rem
@rem Also uses:
@rem   smmsDEBUG format of filename for debugging files.
@rem     Must contain XX.

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 smms

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set WINDIMS=%3
if "%WINDIMS%"=="." set WINDIMS=
if "%WINDIMS%"=="" set WINDIMS=3x3

call parseXxY 3 3 %WINDIMS% smms

echo %0: smms: %smms_X% %smms_Y%

set FACTJ=%4
if "%FACTJ%"=="." set FACTJ=
if "%FACTJ%"=="" set FACTJ=1

set FACTK=%5
if "%FACTK%"=="." set FACTK=
if "%FACTK%"=="" set FACTK=3

set OFFSL=%6
if "%OFFSL%"=="." set OFFSL=
if "%OFFSL%"=="" set OFFSL=0

set MFMT=^
0,^
%%[fx:%smms_X%*%smms_Y%/(%smms_X%*%smms_Y%-1)],^
%%[fx:-1/(%smms_X%*%smms_Y%-1)],^
0

echo %0: MFMT=%MFMT%

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 16 ^
  -format "%MFMT%" ^
  xc:`) do set MARGS=%%L

echo %0: MARGS=%MARGS%

if "%smmsDEBUG%"=="" (
  set WrMn=
  set WrSd=
  set WrJMnKSd=
  set WrMinus=
) else (
  set WrMn=+write %smmsDEBUG:XX=Mn%
  set WrSd=+write %smmsDEBUG:XX=Sd%
  set WrJMnKSd=+write %smmsDEBUG:XX=JMnKSd%
  set WrMinus=+write %smmsDEBUG:XX=Minus%
)

%IM7DEV%magick ^
  %INFILE% ^
  -depth 32 ^
  -define compose:clamp=off ^
  -define quantum:format=floating-point ^
  +write mpr:INP ^
  ( -clone 0 ^
    -evaluate Pow 2 ^
    ( +clone ^
      -process 'integim' ^
      -process 'deintegim window %WINDIMS%' ^
    ) ^
    -compose Mathematics -define compose:args=%MARGS% -composite ^
  ) ^
  ( -clone 0 ^
    ( +clone ^
      -process 'integim' ^
      -process 'deintegim window %WINDIMS%' ^
    ) ^
    -compose Mathematics -define compose:args=%MARGS% -composite ^
    +write mpr:MN ^
    %WrMn% ^
    -evaluate Pow 2 ^
  ) ^
  -delete 0 ^
  -alpha off ^
  -compose MinusSrc -composite ^
  -clamp ^
  -evaluate Pow 0.5 ^
  %WrSd% ^
  mpr:MN ^
  -compose Mathematics -define compose:args=0,%FACTJ%,%FACTK%,%OFFSL% -composite ^
  %WrJMnKSd% ^
  mpr:INP ^
  -compose MinusDst -composite ^
  -clamp ^
  %WrMinus% ^
  -fill White +opaque Black ^
  %OUTFILE%

if ERRORLEVEL 1 exit /B 1

call echoRestore

@endlocal
