rem To image %1, add a super-white gate at coord %2,%3.
@rem This is a horizontal super-white line at y=%3,
@rem with a gap at (%2,%3).
@rem %4 is optional output file.
@rem
@rem Updated:
@rem   14-July-2022 for IM v7.
@rem


@if "%3"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 swg

set X=%2
set Y=%3

if not "%4"=="" set OUTFILE=%4


set WW=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "WW=%%w\nHH=%%h" ^
  %INFILE%`) do set %%L
if "%WW%"=="" (
  echo %0 failed INFILE=%INFILE%
  exit /B 1
)

call xyCoord %WW% %HH% %X% %Y%

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "Wm1=%%[fx:w-1]\nXm1=%%[fx:%xycXi%-1]\nXp1=%%[fx:%xycXi%+1]\nHasL=%%[fx:%xycXi%>0?1:0]\nHasR=%%[fx:%xycXi%<w-1?1:0]" ^
  %INFILE%`) do set %%L

if %HasL%==0 (
  set DrawL=
) else (
  set DrawL=-draw "line 0,%xycYi% %Xm1%,%xycYi%"
)

if %HasR%==0 (
  set DrawR=
) else (
  set DrawR=-draw "line %Xp1%,%xycYi% %Wm1%,%xycYi%"
)

%IMG7%magick ^
  %INFILE% ^
  -stroke rgb(100000%%,100000%%,100000%%) ^
  %DrawL% ^
  %DrawR% ^
  -define quantum:format=floating-point ^
  %OUTFILE%


call echoRestore

@endlocal & set swgOUTFILE=%OUTFILE%
