rem From %1, a text file with lines of score,x0,y0,x1,y1
rem creates %2 another text file with "good" coordinate pairs.
@rem
@rem  Also uses:
@rem    tcpDEBUG  if 1, creates another text file with debugging output
@rem
@rem  Returns:
@rem    tcpNUM_GOOD
@rem
@rem Updated:
@rem   29-August-2022 for IM v7.
@rem

@rem FIXME: at present, will never reject only on grounds of badr, so the test is pointless.

@rem FIXME: allow parameter to NOT test score, ie reject is score > mean + k * SD where k=9999

@rem FIXME: what if only 1 pair? Accept it?

@rem FIXME: Improve output to separate rejects for score.

@rem FIXME: Can we sensibly use the median instead of the mean? Send values to a file, sort it, find the middle line.


@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

set INFILE=%1
set OUTFILE=%2

if "%tcpSCORE_LIMIT%"=="" set tcpSCORE_LIMIT=0.05
if "%tcpSCORE_LIMIT%"=="" set tcpSCORE_LIMIT=9999
set tcpSCORE_LIMIT=9999
if "%tcpGEO_SD_FACT%"=="" set tcpGEO_SD_FACT=2

set DEBUG_FILE=
if "%tcpDEBUG%"=="1" (
  set DEBUG_FILE=%~dpn2_dbg%~x2
  del !DEBUG_FILE! 2>nul
)

del %OUTFILE% 2>nul

rem A coord pair is bad if either:
rem   score > tcpSCORE_LIMIT
rem   score > standard_deviation(score)
rem   any of dx, dy, radius minus mean > tcpGEO_SD_FACT * standard_deviation

set sigsc=0
set sigsc2=0

set numGood=0

for /F "tokens=1-5 delims=, " %%A in (%INFILE%) do (
  set IS_BAD=0

  if "%%A" GTR "%tcpSCORE_LIMIT%" set IS_BAD=1

  if !IS_BAD!==0 (
    for /F "usebackq" %%L in (`%IMG7%magick identify ^
      -precision 16 ^
      -format "sigsc=%%[fx:!sigsc!+%%A]\nsigsc2=%%[fx:!sigsc2!+%%A*%%A]" ^
      xc:`) do set %%L

    set /A numGood+=1
  )
)

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 16 ^
  -format "meansc=%%[fx:%sigsc%/%numGood%]" ^
  xc:`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 16 ^
  -format "sdsc=%%[fx:%tcpGEO_SD_FACT%*sqrt(%sigsc2%/%numGood%-%meansc%*%meansc%)]" ^
  xc:`) do set %%L

if not "%DEBUG_FILE%"=="" (
  echo numGood=%numGood% >>%DEBUG_FILE%
  echo sigsc=%sigsc% sigsc2=%sigsc2% >>%DEBUG_FILE%
  echo meansc=%meansc% sdsc=%sdsc% >>%DEBUG_FILE%
)



set sigdx=0
set sigdy=0
set sigr=0
set sigdx2=0
set sigdy2=0
set sigr2=0

set numGood=0

for /F "tokens=1-5 delims=, " %%A in (%INFILE%) do (
  set IS_BAD=0

  if "%%A" GTR "%tcpSCORE_LIMIT%" set IS_BAD=1

  rem if "%%A" GTR "%meansc%" set IS_BAD=1

  if !IS_BAD!==0 (
    set /A dx=%%D-%%B
    set /A dy=%%E-%%C
    set /A dx2=!dx!*!dx!
    set /A dy2=!dy!*!dy!
    set /A r2=!dx2!+!dy2!

    set /A sigdx+=!dx!
    set /A sigdy+=!dy!
    set /A sigdx2+=!dx2!
    set /A sigdy2+=!dy2!
    rem set /A sigr2+=!r2!

    for /F "usebackq" %%L in (`%IMG7%magick identify ^
      -precision 16 ^
      -format "sigr=%%[fx:!sigr!+sqrt(!r2!)]\nsigr2=%%[fx:!sigr2!+!r2!]" ^
      xc:`) do set %%L

    rem echo  %%A !dx! !dy! !r2! !IS_BAD!

    set /A numGood+=1
  )
)

if not "%DEBUG_FILE%"=="" (
  echo numGood=%numGood% >>%DEBUG_FILE%
  echo sigdx=%sigdx% sigdy=%sigdy%  sigr=%sigr%  sigdx2=%sigdx2% sigdy2=%sigdy2% sigr2=%sigr2% >>%DEBUG_FILE%
  echo tcpGEO_SD_FACT=%tcpGEO_SD_FACT% >>%DEBUG_FILE%
)

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 16 ^
  -format "meandx=%%[fx:%sigdx%/%numGood%]\nmeandy=%%[fx:%sigdy%/%numGood%]" ^
  xc:`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 16 ^
  -format "meanr=%%[fx:%sigr%/%numGood%]" ^
  xc:`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 16 ^
  -format "sdx=%%[fx:%tcpGEO_SD_FACT%*sqrt(%sigdx2%/%numGood%-%meandx%*%meandx%)]" ^
  xc:`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 16 ^
  -format "sdy=%%[fx:%tcpGEO_SD_FACT%*sqrt(%sigdy2%/%numGood%-%meandy%*%meandy%)]" ^
  xc:`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 16 ^
  -format "sdr=%%[fx:%tcpGEO_SD_FACT%*sqrt(%sigr2%/%numGood%-%meanr%*%meanr%)]" ^
  xc:`) do set %%L


if not "%DEBUG_FILE%"=="" (
  echo meandx=%meandx% sdx=%sdx% meandy=%meandy% sdy=%sdy% >>%DEBUG_FILE%
  echo meanr=%meanr% sdr=%sdr% >>%DEBUG_FILE%
)

set numGood=0
set numCoord=0

for /F "tokens=1-5 delims=, " %%A in (%INFILE%) do (
  set IS_BAD=0

  if "%%A" GTR "%tcpSCORE_LIMIT%" set IS_BAD=1

  rem if "%%A" GTR "%meansc%" set IS_BAD=1

  set dx=
  set dy=
  set dx2=
  set dy2=
  set r2=
  set badx=
  set bady=
  set badr=

  rem if !IS_BAD!==0 (
    set /A dx=%%D-%%B
    set /A dy=%%E-%%C
    set /A dx2=!dx!*!dx!
    set /A dy2=!dy!*!dy!
    set /A r2=!dx2!+!dy2!

    for /F "usebackq" %%L in (`%IMG7%magick identify ^
      -precision 16 ^
      -format "badx=%%[fx:abs(!dx!-%meandx%)>%sdx%?1:0]\nbady=%%[fx:abs(!dy!-%meandy%)>%sdy%?1:0]\nbadr=%%[fx:abs(sqrt(!r2!)-%meanr%)>%sdr%?1:0]" ^
      xc:`) do set %%L

    rem set /A IS_BAD^|=!badx!||!bady!||!badr!
    rem set /A IS_BAD^|=badx||bady||badr
    if !badx!==1 set IS_BAD=1
    if !bady!==1 set IS_BAD=1
    if !badr!==1 set IS_BAD=1
  rem )

  if not "%DEBUG_FILE%"=="" (
    for /F "usebackq" %%L in (`%IMG7%magick identify ^
      -precision 16 ^
      -format "r=%%[fx:sqrt(!r2!)]" ^
      xc:`) do set %%L

    echo %%A,%%B,%%C,%%D,%%E,  !numCoord!,  !r!,  !dx!,!dy!,!r2!,  !IS_BAD!,!badx!,!bady!,!badr! >>%DEBUG_FILE%
  )

  if !IS_BAD!==0 (
    rem echo  %%A !dx! !dy! !r2! !badx! !bady! !badr!
    echo  %%A,%%B,%%C,%%D,%%E,  !numCoord! >>%OUTFILE%

    set /A numGood+=1
  )
  set /A numCoord+=1
)

if not "%DEBUG_FILE%"=="" (
  echo numGood=%numGood% >>%DEBUG_FILE%
)

@call echoRestore

@endlocal & set tcpNUM_GOOD=%numGood%& set tcpDEBUG_FILE=%DEBUG_FILE%

