rem From large image %1,
rem finds timings of operations -fft, -ift, +fft, +ift
rem at different resizes.
rem Writes results to CSV file %2, with header.

set INFILE=%1
set OUTCSV=%2

set TMP_FILE=ffft_tmp.miff

echo W,H,W*H,-fft, -ift, +fft, +ift, average >%OUTCSV%

:: Warm up the files.

%IMDEV%convert %INFILE% NULL:

%IMDEV%convert %INFILE% %TMP_FILE%
call ::CalcOneSize %TMP_FILE%

%IMDEV%convert %INFILE% -resize 50%% %TMP_FILE%
call ::CalcOneSize %TMP_FILE%

%IMDEV%convert %INFILE% -resize 25%% %TMP_FILE%
call ::CalcOneSize %TMP_FILE%

type %OUTCSV%


exit /B 0

::---------------------------------------------------------------
:: Subroutines

:CalcOneSize

set ONESZE=%1

set WW=
for /F "usebackq" %%L in (`%IM%identify ^
  -precision 15 ^
  -format "WW=%%w\nHH=%%h\nWxH=%%[fx:w*h]" ^
  %ONESZE%`) do set %%L
if "%WW%"=="" exit /B 1

for /F "usebackq tokens=2" %%L in (`timec ^
  %IMDEV%convert ^
  %ONESZE% ^
  NULL:`) do set SECS_BASE=%%L


for /F "usebackq tokens=2" %%L in (`timec ^
  %IMDEV%convert ^
  %ONESZE% ^
  -fft ^
  NULL:`) do set SECS_mFft=%%L

for /F "usebackq" %%L in (`%IM%identify ^
  -format "SECS_mFft=%%[fx:%SECS_mFft%-%SECS_BASE%]"
  xc:`) do set %%L

for /F "usebackq tokens=2" %%L in (`timec ^
  %IMDEV%convert ^
  %ONESZE% ^
  -fft -ift ^
  NULL:`) do set SECS_mIft=%%L

for /F "usebackq" %%L in (`%IM%identify ^
  -format "SECS_mIft=%%[fx:%SECS_mIft%-%SECS_mFft%]"
  xc:`) do set %%L


for /F "usebackq tokens=2" %%L in (`timec ^
  %IMDEV%convert ^
  %ONESZE% ^
  +fft ^
  NULL:`) do set SECS_pFft=%%L

for /F "usebackq" %%L in (`%IM%identify ^
  -format "SECS_pFft=%%[fx:%SECS_pFft%-%SECS_BASE%]"
  xc:`) do set %%L

for /F "usebackq tokens=2" %%L in (`timec ^
  %IMDEV%convert ^
  %ONESZE% ^
  +fft +ift ^
  NULL:`) do set SECS_pIft=%%L

for /F "usebackq" %%L in (`%IM%identify ^
  -format "SECS_pIft=%%[fx:%SECS_pIft%-%SECS_pFft%]"
  xc:`) do set %%L

for /F "usebackq" %%L in (`%IM%identify ^
  -format "SECS_AVG=%%[fx:(%SECS_mIft%+%SECS_mFft%+%SECS_pIft%+%SECS_pFft%)/4]"
  xc:`) do set %%L


echo %WW%,%HH%,%WxH%,%SECS_mFft%,%SECS_mIft%,%SECS_pFft%,%SECS_pIft%,%SECS_AVG% >>%OUTCSV%

type %OUTCSV%
