rem Given image %1, white points on black background,
rem where groups of 4- or 8-connected points form zero or more non-crossing lines,
rem traces the coordinates of one line from coord %2,%3
rem appending to text file %4, with no header.
@rem
@rem Updated:
@rem   14-September-2022 for IM v7.
@rem

@setlocal enabledelayedexpansion

set INFILE=%1
set firstX=%2
set firstY=%3
set OUTFILE=%4

%IM7DEV%magick ^
  %INFILE% ^
  -channel RGB ^
    -negate ^
    -evaluate Add 1 ^
  +channel ^
  -process 'darkestpntpnt s %firstX%,%firstY% e %firstX%,%firstY% t 0.5 no_end p f stdout data' ^
  NULL: >>%OUTFILE%

if ERRORLEVEL 1 exit /B 1

set numPts=0
for /F "tokens=1,2 delims=, " %%X in (%OUTFILE%) do (
  set lastX=%%X
  set lastY=%%Y
  set /A numPts+=1
)

@endlocal& set tlNumPts=%numPts%& set tlLastX=%lastX%& set tlLastY=%lastY%
