rem Difference of two blurs, resulting in monochrome RMS.
@rem
@rem %2 is first (smallest) blur sigma in pixels.
@rem %3 is second (largest) blur sigma in pixels.
@rem %4, if given, is final blur sigma in pixels.
@rem %5, if given, is output filename.
@rem
@rem Also uses:
@rem   tbdAUTO if 0, doesn't "-auto-level -auto-gamma"
@rem
@rem See also *BlrDiff.
@rem
@rem Updated:
@rem   2-August-2022 for IM v7 magick.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 2bd

set BLUR_SIG1=%2
if "%BLUR_SIG1%"=="." set BLUR_SIG1=
if "%BLUR_SIG1%"=="" set BLUR_SIG1=4

set BLUR_SIG2=%3
if "%BLUR_SIG2%"=="." set BLUR_SIG2=
if "%BLUR_SIG2%"=="" set BLUR_SIG2=6

if "%4"=="" (
  set FINAL_BLUR=
) else (
  if not "%4"=="." set FINAL_BLUR=-blur 0x%4
)

if not "%5"=="" set OUTFILE=%5


if "%tbdAUTO%"=="0" (
  set AUTO=
) else (
  set AUTO=-auto-level -auto-gamma
)


%IMG7%magick ^
  %INFILE% ^
  ^( -clone 0 -blur 0x%BLUR_SIG1% ^) ^
  ^( -clone 0 -blur 0x%BLUR_SIG2% ^) ^
  -delete 0 ^
  -compose Difference -composite ^
  -grayscale RMS ^
  %FINAL_BLUR% ^
  %AUTO% ^
  %OUTFILE%


call echoRestore

@endlocal & set tbdOUTFILE=%OUTFILE%
