rem From input image %1
rem find two non-clipped pixels that are distant colorimetrically.
rem
rem Specifically: find the pixel that has the highest channel closest to 90%,
rem and the lowest channel closest to 10%.

setlocal enabledelayedexpansion

set loX=

for /F "usebackq tokens=1,4,5 delims=:(), " %%A in (`%IMG7%magick ^
  %1 ^
  ^( +clone ^
     -channel RGB -separate +channel -evaluate-sequence Min ^
     -range-threshold "0,10,10,100%%" ^
     -define "identify:locate=maximum" -define "identify:limit=1" ^
     +write info: ^
     +delete ^
  ^) ^
  -channel RGB -separate +channel -evaluate-sequence Max ^
  -range-threshold "0,90,90,100%%" ^
  -define "identify:locate=maximum" -define "identify:limit=1" ^
  info:`) do (
  if /I "%%A"=="Red" (
    echo %%A %%B %%C
    if "!loX!"=="" (
      set loX=%%B
      set loY=%%C
    ) else (
      set hiX=%%B
      set hiY=%%C
    )
  )
)

echo loX=%loX% loY=%loY% hiX=%hiX% hiY=%hiY%

endlocal & set loX=%loX%& set loY=%loY%& set hiX=%hiX%& set hiY=%hiY%