rem Given %1 is text file with two numbers (coordinate and value as percentage),
rem makes %2 Nx1 grayscale image.
rem %3 desired width of output.
rem %4 "extend" or "noextend".

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 c2x

if not "%2"=="" if not "%2"=="." set OUTFILE=%2

set WW=%3
if "%WW%"=="." set WW=

set doExt=%4
if "%doExt%"=="." set doExt=
if "%doExt%"=="" set doExt=noextend

set TMPTEXT=\temp\t2c.txt
del %TMPTEXT%

set nFIRST=
set nLAST=

for /F "tokens=1,2 eol=# delims=, " %%A in (%INFILE%) do (
  if "!nFIRST!"=="" set nFIRST=%%A
  set nLAST=%%A
)

if "%nFIRST%"=="" exit /B 1

if "%WW%"=="" set /A WW=%nLAST%+1

if %doExt%==extend (
  set EXTDIST=-virtual-pixel Edge ^
-set option:distort:viewport %WW%x1-%nFIRST%+0 ^
-distort SRT 1,0 +repage
) else (
  set EXTDIST=
)

echo %0: [%INFILE%] [%OUTFILE%] [%WW%] [%doExt%] %nFIRST% %nLAST% EXTDIST=%EXTDIST%

for /F "usebackq" %%A in (`%IMG7%magick identify ^
    -precision 19 ^
    -format "%%[fx:QuantumRange]" ^
    xc:`) do set QR=%%A

set /A PrevX=%nFIRST%-1

(
  echo # ImageMagick pixel enumeration: %WW%,1,%QR%,srgba

  for /F "eol=# tokens=1,2 delims=, " %%A in (%INFILE%) do (
    for /F "usebackq" %%L in (`%IMG7%magick identify ^
      -precision 19 ^
      -format "OUTIT=%%[fx:%%A==!PrevX!+1?1:0]\nVAL=%%[fx:%%B*QuantumRange/100]" ^
      xc:`) do set %%L

    if !OUTIT!==1 (
      echo %%A,0: ^(!VAL!,!VAL!,!VAL!,%QR%^)
      set PrevX=%%A
    )
  )
) >%TMPTEXT%

rem type %TMPTEXT%

if not exist %TMPTEXT% (
  echo %0: INFILE [%INFILE%]: TMPTEXT [%TMPTEXT%] does not exist
  exit /B 1
)

%IMG7%magick ^
  TXT:%TMPTEXT% ^
+write info: ^
  -crop %%[fx:%nLAST%-%nFIRST%+1]x1+%nFIRST%+0 +repage ^
  %EXTDIST% ^
  %OUTFILE%

if ERRORLEVEL 1 (
  echo %0: error INFILE [%INFILE%]: TMPTEXT [%TMPTEXT%] crop W=%nLAST%-%nFIRST% X=%nFIRST%
  exit /B 1
)

call echoRestore

@endlocal & set c2xOUTFILE=%OUTFILE%
