rem Given same-size images %1 and %2,
rem finds angle of rotation for %1 to best match %2, and a score, by FFT.
rem Also calls whatRot.bat to disambiguate the angle and returns those results.
rem %3 is prefix for environment variables for numeric results. [wt]
@rem
@rem Also uses:
@rem   wrfDEBUG  if 1, creates image for debugging
@rem
@rem Returns:
@rem   All the returns from whatTrans.bat.


@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

set ENV_PREF=%3
if "%ENV_PREF%"=="." set ENV_PREF=
if "%ENV_PREF%"=="" set ENV_PREF=wrf.



set TMPEXT=.miff
set TMP_DIR=wrftmp

if not exist %TMP_DIR% md %TMP_DIR%

call %PICTBAT%setInOut %1 wrf
set IN_A=%INFILE%
set TEMP_A=%TMP_DIR%\%~n1_wrf_x2%TMPEXT%
set FFT_A=%TMP_DIR%\%~n1_wrf_XX_x2%TMPEXT%

call %PICTBAT%setInOut %2 wrf
set IN_B=%INFILE%
set TEMP_B=%TMP_DIR%\%~n2_wrf%TMPEXT%
if %IN_B%==%IN_A% set TEMP_B=%TMP_DIR%\%~n2_B_wrf%TMPEXT%
set FFT_B=%TMP_DIR%\%~n2_wrf_XX%TMPEXT%
if %IN_B%==%IN_A% set FFT_B=%TMP_DIR%\%~n2_B_wrf_XX%TMPEXT%

set SPEC_A=%FFT_A:XX=spec%
set SPEC_B=%FFT_B:XX=spec%

rem set DEBUG_FILE=wrf_%~n1_%~n2_dbg%EXT%

if not "%wrDELTEMP%"=="0" (
  del %TEMP_A% 2>nul
  del %TEMP_B% 2>nul
)

call %PICTBAT%deEdgeForFft3 %IN_A% %TEMP_A%
if ERRORLEVEL 1 exit /B 1

call %PICTBAT%deEdgeForFft3 %IN_B% %TEMP_B%
if ERRORLEVEL 1 exit /B 1

call %PICTBAT%fwdFft ^
  %TEMP_A% ^
  %FFT_A% ^
  wrf_s1_

if ERRORLEVEL 1 exit /B 1

call %PICTBAT%fwdFft ^
  %TEMP_B% ^
  %FFT_B% ^
  wrf_s2_ ^
  %wrf_s1__max% ^
  %wrf_s1__mean%

if ERRORLEVEL 1 exit /B 1

set siDIV_DIM=100

set wrDEBUG=0
call %PICTBAT%whatRot %SPEC_A% %SPEC_B%
if ERRORLEVEL 1 exit /B 1

set siDIV_DIM=

echo %0: wrANGLE=%wrANGLE% wrANGLE_ERR=%wrANGLE_ERR% wrSCORE=%wrSCORE% wrSCORE_SUB=%wrSCORE_SUB% wrDODGY=%wrDODGY%


for /F "usebackq" %%L in (`%IM%identify ^
  -format "angm180=%%[fx:%wrANGLE%-180]" ^
  xc:`) do set %%L


set wtDEBUG=%wrfDEBUG%
set wtDEBUG_OUTFILE=wrf_a_dbg.miff
call %PICTBAT%whatTrans %IN_A% %IN_B% 1 %wrANGLE% wrfA.
if ERRORLEVEL 1 exit /B 1


set wtDEBUG_OUTFILE=wrf_b_dbg.miff
call %PICTBAT%whatTrans %IN_A% %IN_B% 1 %angm180% out.
if ERRORLEVEL 1 exit /B 1

for /F "usebackq" %%L in (`%IM%identify ^
  -format "IsFirst=%%[fx:%wrfA.SCORE%<%out.SCORE%?1:0]" ^
  xc:`) do set %%L

rem FIXME: keep the first debug file.

if %IsFirst%==1 (
  set out.X=%wrfA.X%
  set out.Y=%wrfA.Y%
  set out.XY=%wrfA.XY%
  set out.XYneg=%wrfA.XYneg%
  set out.SCORE=%wrfA.SCORE%
  set out.DODGY=%wrfA.DODGY%
  set out.DEBUG_FILE=wrf_a_dbg.miff
  set out.ANGLE=%wrANGLE%
) else (
  set out.DEBUG_FILE=wrf_b_dbg.miff
  set out.ANGLE=%angm180%
)

set out.ANGLE_ERR=%wrANGLE_ERR%

set out.

call echoRestore

endlocal &set %ENV_PREF%X=%out.X%&^
set %ENV_PREF%Y=%out.Y%&^
set %ENV_PREF%XY=%out.XY%&^
set %ENV_PREF%XYneg=%out.XYneg%&^
set %ENV_PREF%SCORE=%out.SCORE%&^
set %ENV_PREF%DODGY=%out.DODGY%&^
set %ENV_PREF%ANGLE=%out.ANGLE%&^
set %ENV_PREF%ANGLE_ERR=%out.ANGLE_ERR%&^
set %ENV_PREF%DEBUG_FILE=%out.DEBUG_FILE%
