@rem Iterates whatScale.bat until required precision.
@rem
@rem Given same-size images %1 and %2,
@rem finds scale S in "-distort SRT S,0" for %1 to best match %2, and a score.
@rem
@rem Parameters:
@rem   %3 min scale (default 0.5)
@rem   %4 max scale (default 1.5)
@rem   %5 number of scale steps (default 100)
@rem   %6 iterates until wsFACT <= %6, eg 1.0001
@rem
@rem Updated:
@rem   10-August-2022 for IM v7.
@rem

@if "%6"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave


call %PICTBAT%whatScale %1 %2 %3 %4 %5
if not %wsDODGY%==0 (
  set wspDODGY=1
  exit /B 1
)

set wsDO_SCORE_SUB=0
set wsDEBUG=


:loop

set FINISHED=
for /F "usebackq" %%L ^
in (`%IMG7%magick identify -format "FINISHED=%%[fx:%wsFACT%<=%6?1:0]" xc:`) ^
do set %%L

if not %FINISHED%==1 (
  call %PICTBAT%whatScale %1 %2 again . %5
  echo wsSCALE=!wsSCALE!
  if not !wsDODGY!==0 (
    set wspDODGY=1
    exit /B 1
  )

  goto loop
)

call echoRestore

endlocal & set wspSCALE=%wsSCALE%& set wspFACT=%wsFACT%& set wspSCORE=%wsSCORE%& set wspDODGY=%wsDODGY%
