rem Given images %1 and %2 each with maximum values 0.5,
rem how much can we overlap them vertically?
@rem
@rem Updated:
@rem   11-August-2022 for IM v7
@rem

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 ws

set INFILE1=%1
set INFILE2=%2

set WW1=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "WW1=%%w\nHH1=%%h" ^
  %INFILE1%`) do set %%L
if "%WW1%"=="" exit /B 1

set WW2=
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "WW2=%%w\nHH2=%%h" ^
  %INFILE2%`) do set %%L
if "%WW2%"=="" exit /B 1

echo %WW1%x%HH1% %WW2%x%HH2%

set MIN_H=%HH1%
if %MIN_H% GTR %HH2% set MIN_H=%HH2%

set N=0

:loop
set /A N+=1

for /F "usebackq" %%L in (`%IMG7%magick ^
  ^( %INFILE1% ^
    -gravity South ^
    -crop %WW1%x%N%+0+0 +repage ^) ^
  ^( %INFILE2% ^
    -gravity North ^
    -crop %WW2%x%N%+0+0 +repage ^) ^
  -gravity Center ^
  -compose Add -composite ^
  -format "mx=%%[fx:maxima]\nIsWhite=%%[fx:(maxima>0.55)?1:0]" ^
  info:`) do set %%L

if %N% LSS %MIN_H% if %IsWhite%==0 goto loop

rem FIXME: Do we need a limit?

set /A N-=1

set /A gy=%HH1%-%N%
set /A gx=(%WW1%-%WW2%)/2

echo N=%N%


call echoRestore

@endlocal & set wsNover=%N%& set wsGX=%gx%& set wsGY=%gy%

