rem UNFINISHED -- it doesn't work yet.

rem Given same-sized images %1 and %2,
rem returns scale, rotate and translate parameters to best match %1 to %2.

@rem Also uses:
@rem   wsrtMETRIC        default RMSE
@rem   wsrtTUNE_CROP     if 1, crop percentage will be adjusted for the given scale
@rem   wsrtDO_SUPER      if 0, no supersampling will be done.
@rem   wsrtDEBUG         if 1, creates images for debugging
@rem   wsrtDELTEMP       if not 1, will remove temporary file.
@rem
@rem Returns:
@rem   wsrtANGLE     (degrees)
@rem   wsrtSCALE
@rem   wsrtFACT      error margin, multiple of wrsSCALE
@rem   wsrtX, wsrtY  pixel offsets. Positive values mean the first image needs moving
@rem                 down and right in order to register with the second image.
@rem   wsrtSCORE     0.0 to 1.0, more or less
@rem
@rem Updated:
@rem   10-August-2022 for IM v7.
@rem

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave


if "%wsrtMETRIC%"=="" set wsrtMETRIC=RMSE

set TMPEXT=.miff
set TMPDIR=%TEMP%

call %PICTBAT%setInOut %1 wsrt
set IN_A=%INFILE%
set IN_A_TMP=%TMPDIR%\%~n1_wsrt_inA%TMPEXT%

call %PICTBAT%setInOut %2 wsrt
set IN_B=%INFILE%
set IN_B_TMP=%TMPDIR%\%~n2_wsrt_inB%TMPEXT%

if not "%wsrtDELTEMP%"=="0" (
  del %IN_A_TMP% 2>nul
  del %IN_B_TMP% 2>nul
)

set DEBUG_FILE=wsrt_%~n1_%~n2_dbg%EXT%


for /F "usebackq" %%L in (`%IMG7%magick ^
  %IN_A% ^
  -format "WW=%%w\nHH=%%h\nWW_2=%%[fx:w/2]\nHH_2=%%[fx:h/2]" ^
  info:`) do set %%L


set /A x0=WW_2
set /A y0=HH_2
set /A x1=x0
set /A y1=y0
set wsrtANGLE=0
set wsrtSCALE=1
set wsrtX=0
set wsrtY=0

set CHANGED=0
set nIter=0

:loop

rem ---------------
rem What rotation?

rem call %PICTBAT%whatRotScale %IN_A% %IN_B%

if %nIter%==0 (
  call %PICTBAT%whatRot %IN_A% %IN_B%
) else (
  call %PICTBAT%whatRot %IN_A_TMP% %IN_B_TMP%
)

if not "%wrANGLE%"=="0" set CHANGED=1

rem Add angle to what we had before.
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "wsrtANGLE=%%[fx:%wsrtANGLE%+%wrANGLE%]" ^
  xc:`) do set %%L

rem We crop off the virtual pixels.
for /F "usebackq" %%L in (`%IMG7%magick ^
  %IN_A% ^
  -format "WW=%%w\nHH=%%h\nCropFact=%%[fx:1-abs(sin(%wrANGLE%*pi/180))]" ^
  info:`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "CW=%%[fx:int(%WW%*%CropFact%)]\nCH=%%[fx:int(%HH%*%CropFact%)]" ^
  xc:`) do set %%L

%IMG7%magick ^
  %IN_A% ^
  -distort SRT %x0%,%y0%,%wsrtSCALE%,%wsrtANGLE%,%x1%,%y1% ^
  -crop %CW%x%CH%+0+0 +repage ^
  %IN_A_TMP%

%IMG7%magick ^
  %IN_B% ^
  -crop %CW%x%CH%+0+0 +repage ^
  %IN_B_TMP%

rem ---------------
rem What scale?

call %PICTBAT%whatScaleT %IN_A_TMP% %IN_B_TMP%
rem Multiply scale by previous value
for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -format "wsrtSCALE=%%[fx:%wsrtSCALE%*%wstSCALE%]" ^
  xc:`) do set %%L

if not "%wstSCALE%"=="1" set CHANGED=1

%IMG7%magick ^
  %IN_A% ^
  -distort SRT %x0%,%y0%,%wsrtSCALE%,%wsrtANGLE%,%x1%,%y1% ^
  -crop %CW%x%CH%+0+0 +repage ^
  %IN_A_TMP%

rem ---------------
rem What translation?

call %PICTBAT%whatTrans %IN_A_TMP% %IN_B_TMP%
set /A wsrtX+=%wtX%
set /A wsrtY+=%wtY%

set /A x1=WW_2+(wsrtX)
set /A y1=HH_2+(wsrtY)

if not "%wtX%"=="0" set CHANGED=1
if not "%wtY%"=="0" set CHANGED=1


%IMG7%magick ^
  %IN_A% ^
  -distort SRT %x0%,%y0%,%wsrtSCALE%,%wsrtANGLE%,%x1%,%y1% ^
  -crop %CW%x%CH%+0+0 +repage ^
  %IN_A_TMP%

%IMG7%magick compare -metric RMSE %1 %2 NULL:

%IMG7%magick compare -metric RMSE %IN_A_TMP% %IN_B_TMP% NULL:
cmd /c exit /B 0

echo wsrtANGLE=%wsrtANGLE%  wsrtSCALE=%wsrtSCALE%  wsrtX=%wsrtX% wsrtY=%wsrtY%

set /A nIter+=1
if %CHANGED%==1 if %nIter% LSS 2 goto loop

echo nIter=%nIter%


call echoRestore

endlocal & set wsrtANGLE=%wsrtANGLE%& set wsrtSCALE=%wsrtSCALE%& set wsrtFACT=%wrsFACT%& set wsrtSCORE=%wrsCOMP_FLT%& set wsrtSCORE_SUB=%ScoreSub%& set wsrtX=%wsrtX%& set wsrtY=%wsrtY%& set wsrtDODGY=%wsrtDODGY%

