rem  From images %1 and %2, makes and applies mask.
@rem
@rem Mask is:
@rem    black where %1 is sharpest,
@rem    white where %2 is sharpest.
@rem
@rem If %3 is given, that will be the output file.
@rem
@rem Also uses:
@rem   wpDEBUG if 1, creates mask debugging image.
@rem
@rem Updated:
@rem   22-August-2022 Upgraded for IM v7.
@rem


@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

call %PICTBAT%setInOut %1 wp

if not "%3"=="" set OUTFILE=%3

set MASK=%~dpn2_wp_mask_dbg.png

if "%wpDEBUG%"=="1" (
  set SAVE_MASK=-write %MASK%
) else (
  set SAVE_MASK=
)


set METHOD=2

if "%METHOD%"=="1" (
  set tbdParams=2 3 3
  set tbdParams=1 1.5 4
  set tbdParams=4 6 8
  set tbdParams=2 3 2
  set tbdParams=4 6 6

  set tbdAUTO=0
  call %PICTBAT%twoBlrDiff %1 !tbdParams!
  set DIFF1=!tbdOUTFILE!
  call %PICTBAT%twoBlrDiff %2 !tbdParams!
  set DIFF2=!tbdOUTFILE!
  set MASK_PROC=-blur 0x2
) else if "%METHOD%"=="2" (
  call %PICTBAT%slopeMag %1
  set DIFF1=!smOUTFILE!
  call %PICTBAT%slopeMag %2
  set DIFF2=!smOUTFILE!
  set MASK_PROC=-blur 0x2
) else if "%METHOD%"=="3" (
  set STAT_TYPE=StandardDeviation 3x3
  set STAT_TYPE=Gradient 3x3
  set DIFF1=%TEMP%\stat1.miff
  set DIFF2=%TEMP%\stat2.miff
  %IMG7%magick %1 -grayscale Rec709Luminance -statistic !STAT_TYPE! !DIFF1!
  %IMG7%magick %2 -grayscale Rec709Luminance -statistic !STAT_TYPE! !DIFF2!
  set MASK_PROC=-blur 0x1 -auto-level
) else (
  echo %0: METHOD not defined
  exit /B 1
)

%IMG7%magick ^
  %DIFF1% ^
  %DIFF2% ^
  -compose MinusDst -composite ^
  -auto-level ^
  %MASK_PROC% ^
  %SAVE_MASK% ^
  %2 ^
  %1 ^
  -swap 0,2 ^
  -alpha off ^
  -compose Over -composite ^
  %OUTFILE%

rem   -fill White +opaque Black


rem   -compose Mathematics -define compose:args=0,-0.5,0.5,0.5 -composite ^
rem   -threshold 50%% ^
rem   -auto-level -sigmoidal-contrast 10,50%% ^

rem   -compose MinusDst -composite -fill White +opaque Black 
rem   -blur 0x1 
  

call echoRestore

@endlocal & set wpOUTFILE=%OUTFILE%&set wpDEBUG_MASK=%MASK%
