rem From bottom-left pixel of image %1,
rem calculates multipliers green/red and green/blue.
rem Sets environment variables prefixed by %2.
@rem
@rem Updated:
@rem   18-August-2022 for IM v7.
@rem

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

call %PICTBAT%setInOut %1 wm

set PREF=%2
if "%PREF%"=="." set PREF=
if "%PREF%"=="" set PREF=whiteMult


set r=

set FMT=^
r=%%[fx:mean.r]\n^
g=%%[fx:mean.g]\n^
b=%%[fx:mean.b]\n^
mr=%%[fx:mean.g/mean.r]\n^
mb=%%[fx:mean.g/mean.b]\n

for /F "usebackq" %%L in (`%IMG7%magick ^
  -precision 16 ^
  %INFILE% ^
  -gravity SouthWest -crop 1x1+0+0 +repage ^
  -format "%FMT%" ^
  info:`) do set %%L

if "%r%"=="" exit /B 1

echo %PREF%_r=%r% %PREF%_g=%g% %PREF%_b=%b% 
echo %PREF%_mr=%mr% %PREF%_mb=%mb%

call echoRestore

@endlocal & set %PREF%_r=%r%&set %PREF%_g=%g%&set %PREF%_b=%b%& set %PREF%_mr=%mr%&set %PREF%_mb=%mb%
