rem Distort the input so that,
rem when printed and wrapped around a pipe,
rem that would look like the input image.

rem $1 is input file
rem $2 is output file
rem $3 is half the angle of the pipe we can see, in degrees, more than 0, less than or equal to 90.
rem   The script does NOT test for valid angles.

rem See also wrapPipe.sh.

@if "%1"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

rem @call echoOffSave

call %PICTBAT%setInOut %1 wp

if not "%2"=="" if not "%2"=="."  set OUTFILE=%2

set amaxDeg=%3

if "%amaxDeg%"=="." set amaxDeg=
if "%amaxDeg%"=="" set amaxDeg=45
if "%amaxDeg%"=="0" set amaxDeg=0.0001

set ww=%%[w]
set hh=%%[h]
set hmax=%%[fx:h/2]
set halfh=%%[fx:int(h/2)]
set amax=%%[fx:%amaxDeg%*pi/180]

for /F "usebackq" %%L in (`%IMG7%magick ^
  %INFILE% ^
  -precision 15 ^
  -format "ww=%ww%\nhh=%hh%\nhmax=%hmax%\nhalfh=%halfh%\namax=%amax%\n" ^
  info:`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick ^
  xc: ^
  -precision 15 ^
  -format "rr=%%[fx:%hmax% / sin(%amax%)]\n" ^
  info:`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick ^
  xc: ^
  -precision 15 ^
  -format "ex=%%[fx:int((%rr% * (%amax%) * 2 - %hh%) / 2)]\n" ^
  info:`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick ^
  xc: ^
  -precision 15 ^
  -format "dx=%%[fx:%halfh% + %ex% - (%halfh%-%hh%/2)]\n" ^
  info:`) do set %%L

for /F "usebackq" %%L in (`%IMG7%magick ^
  xc: ^
  -precision 15 ^
  -format "dx2=%%[fx:%dx% * 2]\n" ^
  info:`) do set %%L

echo ww=%ww% hh=%hh% hmax=%hmax% amax=%amax% halfh=%halfh% rr=%rr% ex=%ex% dx=%dx% dx2=%dx2%

%IMG7%magick ^
  ( %INFILE% ^
    -background "#88f" ^
    -gravity Center ^
    -extent %ww%x%dx2% ^
  ) ^
  ( ^
    -size %dx2%x1 xc: ^
    -fx "(%rr%*sin((i-%dx%)/%rr%)+(%dx%))/w" ^
    -rotate 90 ^
    ( -size 1x%ww% gradient:Black-White -rotate -90 ) ^
    +swap ^
    ( -size 1x1 xc:"gray(50%%)" ) ^
    -scale "%ww%x%dx2%^!" ^
    -combine ^
  ) ^
  -compose Distort -composite ^
  %OUTFILE%

call echoRestore

endlocal & set wpOUTFILE=%OUTFILE%& ^
set wpDX2=%dx2%
