#ifndef WRITEFRAME_INC
#define WRITEFRAME_INC


static MagickBooleanType WriteFrame (
  char *FileName,
  Image * img,
  int frame_num,
  ExceptionInfo *exception)
{
  ImageInfo
    *ii;

  MagickBooleanType
    okay;

  Image
    *copy_img;

  ii = AcquireImageInfo ();

  copy_img = CloneImage(img, 0, 0, MagickTrue, exception);
  if (!copy_img) return(MagickFalse); // FIXME: raise error

  copy_img->scene = frame_num;

  CopyMagickString (copy_img->filename, FileName, MaxTextExtent);

  okay = WRITEIMAGE(ii, copy_img, exception);

  DestroyImageList(copy_img);

  ii = DestroyImageInfo (ii);

  return okay;
}


#endif