rem %1 input image files (quoted, space-separated)
rem %2 input weight files (quoted, space-separated)
rem %3 outfile
rem %4 pre-process input images, eg to adjust colorspace
rem %5 post-process input images, eg to adjust colorspace
rem %6 pre-process weight images

@if "%3"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal

@call echoOffSave

set INFILES=%~1
set INWEIGHTS=%~2
set OUTFILE=%3

set PREPROC=%~4
if "%PREPROC%"=="." set PREPROC=

set POSTPROC=%~5
if "%POSTPROC%"=="." set POSTPROC=

set PREWT=%~6
if "%PREWT%"=="." set PREWT=

%IM7DEV%magick ^
  -define compose:clamp=off ^
  %INFILES% ^
  %PREPROC% ^
  NULL: ^
  -set option:nWt %%n ^
  ( %INWEIGHTS% %PREWT% ) ^
  ( -clone %%[nWt]--1 ^
    -evaluate-sequence Add ^
    -write mpr:SumWt ^
    +delete ^
  ) ^
  -compose Multiply -layers Composite ^
  -evaluate-sequence Add ^
  mpr:SumWt ^
  -compose DivideSrc -composite ^
  %POSTPROC% ^
  %OUTFILE%

call echoRestore

@endlocal & set wtblOUTFILE=%OUTFILE%
