@rem %1 is image width
@rem %2 is image height
@rem %3 is an x-coord,
@rem    possibly fractional, possibly negative, possibly suffixed with c or % or p
@rem %4 is an y-coord, likewise
@rem Returns actual pixel coords, possibly fractional, as xycX and xycY
@rem and as rounded integers in xycXi and xycYi.
@rem
@rem Updated:
@rem   15-July-2022 for IM v7.

@setlocal enabledelayedexpansion

@call echoOffSave

set WW=%1
set HH=%2

set X=%3
set chX=%X:~-1%
set vX=%X:~0,-1%

set Y=%4
set chY=%Y:~-1%
set vY=%Y:~0,-1%

if "%chX%"=="%%" set chX=c
if "%chY%"=="%%" set chY=c

if "%chX%"=="c" (
  set vX=%vX%*%1/100
) else if "%chX%"=="p" (
  set vX=%vX%*%1
) else (
  set vX=%X%
)

if "%chY%"=="c" (
  set vY=%vY%*%2/100
) else if "%chY%"=="p" (
  set vY=%vY%*%2
) else (
  set vY=%Y%
)

for /F "usebackq" %%L in (`%IMG7%magick identify ^
  -precision 16 ^
  -format "vX=%%[fx:%vX%]\nvY=%%[fx:%vY%]\nvXi=%%[fx:int(%vX%+0.5)]\nvYi=%%[fx:int(%vY%+0.5)]" ^
  xc:`) do set %%L

if ERRORLEVEL 1 (
  echo %0: vX=[%vX%] vY=[%vY%]
  exit /B 1
)

call echoRestore

@endlocal & set xycX=%vX%& set xycY=%vY%& set xycXi=%vXi%& set xycYi=%vYi%
